%{
#if defined (__cplusplus)
#include <cstdio>
#else
#include <stdio.h>
#endif

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "parser.h"
#endif

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%}

%token ICONST 
%left '+' '-'
%left '*' '/'

@traversal @preorder yourTrav
@traversal @preorder yoursToo

@attributes {char *string;} ICONST
@attributes {long val;}     s expr 
%%
s       :       expr
                @{ @i @s.val@ = @expr.val@; 
                   @yoursToo printf("\n%ld\n",@s.val@);
                @}
        ;
expr    :       expr    '*'     expr 
                @{ @i @expr.0.val@ = @expr.1.val@ * @expr.2.val@; 
                   @yourTrav printf(" * "); 
                @} 
        |       expr    '/'     expr
                @{ @i @expr.0.val@ = @expr.1.val@ / @expr.2.val@; 
                   @yourTrav printf(" / "); 
                @} 
        |       expr    '+'     expr
                @{ @i @expr.val@ = @expr.1.val@ + @expr.2.val@; 
                   @yourTrav printf(" + "); 
                @} 
        |       expr    '-'     expr
                @{ @i @expr.0.val@ = @expr.1.val@ - @expr.2.val@; 
                   @yourTrav printf(" - "); 
                @} 
        |       '('     expr    ')'
                @{ @i @expr.0.val@ = @expr.1.val@; 
                @} 
        |       ICONST
                @{ @i @expr.val@ = atoi(@ICONST.string@); 
                   @yourTrav printf(" %s ",@ICONST.string@); 
                @} 
        ;
%% 
#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...)
{extern int yylineno;
 fprintf(stderr,"Near line %d: %s\n",yylineno,s); 
 yyyabort(); 
}  
#else  
void yyerror(const char *s)
{fprintf(stderr,"%s\n",s);
 yyyabort(); 
}
#endif

#ifndef YYMSTA
int yyparse(void);
#endif
int main() 
  {return(yyparse()); 
  } 
