%token REAL INT BOOL IDENT

%{
#if defined (__cplusplus)
#include <cstdio>
#include <cstdlib>
#else
#include <stdio.h>
#include <stdlib.h>
#endif

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "parser.h"
#endif

struct sym {char *str; const char *typeMark;};

struct sym *allocSym(char *cp, const char *t)
  {struct sym *pSym;
   pSym = (struct sym *) malloc(sizeof (struct sym));
   pSym->str = cp; pSym->typeMark = t; 
   return pSym;
  }

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%}

@attributes {char *string; struct sym *sym; } IDENT
@attributes {const char *tMark;             } varList
@traversal @postorder myT /* my Traversal */

%%
varDecl    :        varList ':' REAL ';'
                    @{ @i @varList.tMark@ = "real";    @}

           |        varList ':' INT ';'
                    @{ @i @varList.tMark@ = "integer"; @}

           |        varList ':' BOOL ';'
                    @{ @i @varList.tMark@ = "boolean"; @}
           ;

varList    :        IDENT
                    @{ @i @IDENT.sym@ = 
                            allocSym(@IDENT.string@,@varList.tMark@);
                       @myT printf("%s: %s;\n",@IDENT.sym@->typeMark,
                                               @IDENT.sym@->str);
                    @}
           |        varList ',' IDENT
                    @{ @i @varList.1.tMark@ = @varList.tMark@;
                       @i @IDENT.sym@ = 
                            allocSym(@IDENT.string@,@varList.tMark@);
                       @myT printf("%s: %s;\n",@IDENT.sym@->typeMark,
                                               @IDENT.sym@->str);
                    @}
           ; 
%% 
#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...)
{extern int yylineno;
 fprintf(stderr,"Near line %d: %s\n",yylineno,s); 
 yyyabort(); 
}  
#else  
void yyerror(const char *s)
{fprintf(stderr,"%s\n",s);
 yyyabort(); 
}
#endif

#ifndef YYMSTA
int yyparse(void);
#endif
int main() 
  {return(yyparse()); } 
