%{
/* L-file for translation of infix expressions */
#if defined (__cplusplus)
#include <cstdlib>
#include <cstring>
#else
#include <stdlib.h>
#include <string.h>
#endif

#include "parser.hh"

char *lexeme();

%}

%% 
[ \n\t\f]*              ;  
[0-9]+\.?[0-9]*         return(CONST); @{ @CONST.lexeme@ = lexeme(); @}   
[A-Za-z_][A-Za-z_0-9]*  return(ID);    @{ @ID.lexeme@ = lexeme();    @}
\(                      return('('); 
\)                      return(')'); 
\+                      return('+'); 
\*                      return('*'); 
\/                      return('/'); 
\-                      return('-'); 
%%
int yywrap(void){return 1;}

char *lexeme()
  {char *dum;
   dum = (char *)malloc(yyleng+1);
   strcpy(dum,yytext);
   return dum;
  }
