
/* Y-file for translation of infix expressions to prefix and postfix */
%token ID CONST  
%start s    
%left '+' '-'
%left '*' '/'

@attributes {char *lexeme;} ID CONST 
@traversal @preorder LRpre
@traversal LRpost

%{ 
#if defined (__cplusplus)
#include <cstdio>
#else
#include <stdio.h>
#endif

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "parser.h"
#endif

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%} 

%%
s       :       expr
                @{ @LRpost printf("\n"); 
                   @LRpost @revorder (1) printf("postfix:  ");
                   @LRpre  @revorder (1) printf("\n"); 
                   @LRpre  printf("prefix:   ");
                @}
        ;

expr    :       expr    '*'     expr
                @{ @LRpost printf(" * "); 
                   @LRpre  printf(" * "); 
                @}
        |       expr    '+'     expr
                @{ @LRpre  printf(" + "); 
                   @LRpost printf(" + "); 
                @}
        |       expr    '/'     expr
                @{ @LRpost printf(" / "); 
                   @LRpre  printf(" / "); 
                @}
        |       expr    '-'     expr
                @{ @LRpost printf(" - "); 
                   @LRpre  printf(" - "); 
                @}
        |       '('     expr    ')'
        |       ID
                @{ @LRpost printf(" %s ",@ID.lexeme@); 
                   @LRpre  printf(" %s ",@ID.lexeme@); 
                @}
        |       CONST
                @{ @LRpost printf(" %s ",@CONST.lexeme@); 
                   @LRpre  printf(" %s ",@CONST.lexeme@); 
                @}
        ;
%% 
#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...)
{extern int yylineno;
 fprintf(stderr,"Near line %d: %s\n",yylineno,s); 
 yyyabort(); 
}  
#else  
void yyerror(const char *s)
{fprintf(stderr,"%s\n",s);
 yyyabort(); 
}
#endif

#ifndef YYMSTA
int yyparse(void);
#endif

int main() 
  {yyparse(); 
  } 

