/* $Id: util.h 2379 2022-01-07 22:41:51Z teshields $ */ 
  
/* This file is part of Ox, an Attribute Grammar Compiling System
   that augments the specification functionality of Lex and Yacc, and
   input specification compatible lexer and parser generators.

   Copyright (C) 1992-1993  Kurt M. Bischoff
   Copyright (C) 2016-2022  Thomas E. Shields
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#if defined (__cplusplus)
#include <cstdio>
#else
#include <stdio.h>
#endif

extern int yyyinput(void);

#if YYBTYACC && !YYBYACC
extern void yyerror(const char *, ...);
#else
extern void yyerror(const char *);
#endif
extern void fatal(const char *);
extern void internal(const char *); 
extern void handleOverflow(const char *);
extern FILE *safeOpen(const char *,const char *);
extern void printStringArray(const char **,int,FILE *); 
