// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton interface for Bison GLR parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// C++ GLR parser skeleton written by Valentin Tolmer.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.

#ifndef YY_YY_AGC_YACC_HH_INCLUDED
# define YY_YY_AGC_YACC_HH_INCLUDED
// "%code requires" blocks.
#line 42 "agc-yacc.yy"
#include "location.hh"
#line 84 "agc-yacc.yy"

#include "lextypes.hh"
// attrbTriple:     lexical representation of an attribute occurrence
// numberRep:       lexical representation of a number

#include "semtypes.hh"
// attrbPair:       semantic representation of an attribute occurence
// attrbRefSeqElem: attribute occurrence w/location
// attrbRefSeq:     sequence of occurrences in an attribute definition

#include "scan.hh"

namespace AGC
{
class yaccLexer;
}
#include "agc-Yfile.hh"

#line 64 "agc-yacc.hh"

#include <algorithm>
#include <cstddef> // ptrdiff_t
#include <cstring> // memcpy
#include <iostream>
#include <iomanip>
#include <limits>
#include <stdexcept>
#include <stdint.h>
#include <string>
#include <vector>

#if defined __cplusplus
# define YY_CPLUSPLUS __cplusplus
#else
# define YY_CPLUSPLUS 199711L
#endif

// Support move semantics when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_MOVE           std::move
# define YY_MOVE_OR_COPY   move
# define YY_MOVE_REF(Type) Type&&
# define YY_RVREF(Type)    Type&&
# define YY_COPY(Type)     Type
#else
# define YY_MOVE
# define YY_MOVE_OR_COPY   copy
# define YY_MOVE_REF(Type) Type&
# define YY_RVREF(Type)    const Type&
# define YY_COPY(Type)     const Type&
#endif

// Support noexcept when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_NOEXCEPT noexcept
# define YY_NOTHROW
#else
# define YY_NOEXCEPT
# define YY_NOTHROW throw ()
#endif

// Support constexpr when possible.
#if 201703 <= YY_CPLUSPLUS
# define YY_CONSTEXPR constexpr
#else
# define YY_CONSTEXPR
#endif



/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

#line 41 "agc-yacc.yy"
namespace AGC {
#line 123 "agc-yacc.hh"




  /// A Bison parser.
  class yacc
  {
  public:
  /// A buffer to store and retrieve objects.
  ///
  /// Sort of a variant, but does not keep track of the nature
  /// of the stored data, since that knowledge is available
  /// via the current parser state.
  class value_type
  {
  public:
    /// Type of *this.
    typedef value_type self_type;

    /// Empty construction.
    value_type () YY_NOEXCEPT
      : yyraw_ ()
    {}

    /// Construct and fill.
    template <typename T>
    value_type (YY_RVREF (T) t)
    {
      new (yyas_<T> ()) T (YY_MOVE (t));
    }

#if 201103L <= YY_CPLUSPLUS
    /// Non copyable.
    value_type (const self_type&) = delete;
    /// Non copyable.
    self_type& operator= (const self_type&) = delete;
#endif

    /// Destruction, allowed only if empty.
    ~value_type () YY_NOEXCEPT
    {}

# if 201103L <= YY_CPLUSPLUS
    /// Instantiate a \a T in here from \a t.
    template <typename T, typename... U>
    T&
    emplace (U&&... u)
    {
      return *new (yyas_<T> ()) T (std::forward <U>(u)...);
    }
# else
    /// Instantiate an empty \a T in here.
    template <typename T>
    T&
    emplace ()
    {
      return *new (yyas_<T> ()) T ();
    }

    /// Instantiate a \a T in here from \a t.
    template <typename T>
    T&
    emplace (const T& t)
    {
      return *new (yyas_<T> ()) T (t);
    }
# endif

    /// Instantiate an empty \a T in here.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build ()
    {
      return emplace<T> ();
    }

    /// Instantiate a \a T in here from \a t.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build (const T& t)
    {
      return emplace<T> (t);
    }

    /// Accessor to a built \a T.
    template <typename T>
    T&
    as () YY_NOEXCEPT
    {
      return *yyas_<T> ();
    }

    /// Const accessor to a built \a T (for %printer).
    template <typename T>
    const T&
    as () const YY_NOEXCEPT
    {
      return *yyas_<T> ();
    }

    /// Swap the content with \a that, of same type.
    ///
    /// Both variants must be built beforehand, because swapping the actual
    /// data requires reading it (with as()), and this is not possible on
    /// unconstructed variants: it would require some dynamic testing, which
    /// should not be the variant's responsibility.
    /// Swapping between built and (possibly) non-built is done with
    /// self_type::move ().
    template <typename T>
    void
    swap (self_type& that) YY_NOEXCEPT
    {
      std::swap (as<T> (), that.as<T> ());
    }

    /// Move the content of \a that to this.
    ///
    /// Destroys \a that.
    template <typename T>
    void
    move (self_type& that)
    {
# if 201103L <= YY_CPLUSPLUS
      emplace<T> (std::move (that.as<T> ()));
# else
      emplace<T> ();
      swap<T> (that);
# endif
      that.destroy<T> ();
    }

# if 201103L <= YY_CPLUSPLUS
    /// Move the content of \a that to this.
    template <typename T>
    void
    move (self_type&& that)
    {
      emplace<T> (std::move (that.as<T> ()));
      that.destroy<T> ();
    }
#endif

    /// Copy the content of \a that to this.
    template <typename T>
    void
    copy (const self_type& that)
    {
      emplace<T> (that.as<T> ());
    }

    /// Destroy the stored \a T.
    template <typename T>
    void
    destroy ()
    {
      as<T> ().~T ();
    }

  private:
#if YY_CPLUSPLUS < 201103L
    /// Non copyable.
    value_type (const self_type&);
    /// Non copyable.
    self_type& operator= (const self_type&);
#endif

    /// Accessor to raw memory as \a T.
    template <typename T>
    T*
    yyas_ () YY_NOEXCEPT
    {
      void *yyp = yyraw_;
      return static_cast<T*> (yyp);
     }

    /// Const accessor to raw memory as \a T.
    template <typename T>
    const T*
    yyas_ () const YY_NOEXCEPT
    {
      const void *yyp = yyraw_;
      return static_cast<const T*> (yyp);
     }

    /// An auxiliary type to compute the largest semantic type.
    union union_type
    {
      // attrb_ref
      // attrb_occur
      char dummy1[sizeof (attrbPair)];

      // attrb_evaluation
      // attrb_evaluation_stmt
      // attrb_evaluation_expr
      // attrb_evaluation_expr_component
      // attrb_evaluation_compound_stmt
      // attrb_evaluation_stmt_seq
      // attrb_evaluation_stmt_seq_component
      // attrb_evaluation_stmt_component
      char dummy2[sizeof (attrbRefSeq)];

      // "attribute reference"
      // "attribute occurrence"
      char dummy3[sizeof (attrbTriple)];

      // "character literal"
      // "string literal"
      // "terminal literal"
      // "literal path name"
      char dummy4[sizeof (char_literal)];

      // "@attributes"
      // "@macro"
      // "@traversal"
      // "@autosyn"
      // "@autoinh"
      // "@warn"
      // "%left"
      // "%right"
      // "%nonassoc"
      // "%token"
      // "%type"
      // "%nterm"
      // "%start"
      // "%union"
      // "%expect"
      // "%expect-rr"
      // "%pure-parser"
      // "%precedence"
      // "%scanner"
      // CODE
      // LOCATION
      // "%destructor"
      // "%lex-param"
      // "%parse-param"
      // "%define"
      // "%language"
      // "%name-prefix"
      // "%param"
      // "%printer"
      // "%skeleton"
      // "%local"
      // "%export"
      // "%import"
      // "const"
      // "volatile"
      // "restrict"
      // "register"
      // "static"
      // TYPE_KEYWORD
      // ELABORATED_TYPE_KEYWORD
      // yacc_directive
      // ox_directive
      // precedence_declarer
      // nonterminal_declarer
      // attrb_modifier
      // ptr_type_qualifier
      // array_size_opt
      char dummy5[sizeof (keyword)];

      // "identifier"
      // "terminal symbol"
      // "traversal mode annunciator"
      // "nonterminal symbol"
      // "C++ qualified name"
      // "inherited attribute"
      // "bison API variable"
      // "bison API value"
      // named_token
      // terminal_symbol
      // nonterminal_symbol
      // symbol
      // nonterminal
      // left_hand_side
      // rhs_symbol
      char dummy6[sizeof (name_literal)];

      // "number"
      char dummy7[sizeof (numberRep)];

      // token_decl_list
      // precedence_decl_list
      // nonterminal_decl_list
      char dummy8[sizeof (symDeclSeq)];

      // token_list
      // token
      // terminal_list
      // nonterminal_list
      char dummy9[sizeof (symSeq)];

      // tag_opt
      // tag
      // type_specifier
      // type
      // type_component
      // type_name
      // elaborated_type_name
      // type_list
      // ptr_operator
      // ptr_type_qualifier_seq_opt
      // ptr_type_qualifier_seq
      // parameter_list_opt
      // parameter_list
      // parameter_type_list
      // parameter_type
      // formal_type_specifier
      // abstract_declarator
      // direct_abstract_declarator
      // formal_array_qualifier_list_opt
      // formal_array_qualifier_list
      // formal_array_qualifier
      char dummy10[sizeof (typeSeq)];
    };

    /// The size of the largest semantic type.
    enum { size = sizeof (union_type) };

    /// A buffer to store semantic values.
    union
    {
      /// Strongest alignment constraints.
      long double yyalign_me_;
      /// A buffer large enough to store any of the semantic values.
      char yyraw_[size];
    };
  };

    /// Symbol locations.
    typedef AGC::location location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const location_type& l, const std::string& m)
        : std::runtime_error (m)
        , location (l)
      {}

      syntax_error (const syntax_error& s)
        : std::runtime_error (s.what ())
        , location (s.location)
      {}

      ~syntax_error () YY_NOEXCEPT YY_NOTHROW;

      location_type location;
    };

    /// Token kinds.
    struct token
    {
      enum token_kind_type
      {
        YYEMPTY = -2,
    END = 0,                       // "end of file"
    YYerror = 1,                   // error
    YYUNDEF = 2,                   // "invalid token"
    OX_LBRACE = 3,                 // "@{"
    OX_RBRACE = 4,                 // "@}"
    OX_ATTRB_REF = 5,              // "attribute reference"
    ID = 6,                        // "identifier"
    LITERAL_CHAR = 7,              // "character literal"
    LITERAL_STRING = 8,            // "string literal"
    LBRACE = 9,                    // "{"
    RBRACE = 10,                   // "}"
    SEMICOLON = 11,                // ";"
    MARK = 12,                     // "%%"
    LCURL = 13,                    // "%{"
    RCURL = 14,                    // "%}"
    TERM_ID = 15,                  // "terminal symbol"
    TERM_LITERAL = 16,             // "terminal literal"
    RETURN = 17,                   // "return"
    NEWLINE = 18,                  // "\\n"
    SOSF = 19,                     // "start of generic scanner source file"
    NO_ATTRBREFSEC = 20,           // "no attribute reference section"
    OX_ATTRB_OCCUR = 21,           // "attribute occurrence"
    OX_ATTRIBUTES = 22,            // "@attributes"
    OX_MACRO = 23,                 // "@macro"
    OX_END = 24,                   // "@end"
    OX_TRAV = 25,                  // "@traversal"
    OX_PREORDER = 26,              // "@preorder"
    OX_POSTORDER = 27,             // "@postorder"
    OX_LEFTTORIGHT = 28,           // "@lefttoright"
    OX_RIGHTTOLEFT = 29,           // "@righttoleft"
    OX_REVORDER = 30,              // "@revorder"
    OX_REVDIR = 31,                // "@revdirection"
    OX_DISABLE = 32,               // "@disable"
    OX_AUTOSYN = 33,               // "@autosyn"
    OX_AUTOINH = 34,               // "@autoinh"
    OX_WARN = 35,                  // "@warn"
    OX_I = 36,                     // "@i"
    OX_M = 37,                     // "@m"
    OX_E = 38,                     // "@e"
    OX_DECORATE = 39,              // "@decorate"
    OX_VOID = 40,                  // "@void"
    OX_ID = 41,                    // "traversal mode annunciator"
    COMMA = 42,                    // ","
    LPAREN = 43,                   // "("
    RPAREN = 44,                   // ")"
    LBRACKET = 45,                 // "["
    RBRACKET = 46,                 // "]"
    AT = 47,                       // "@"
    ELLIPSIS = 48,                 // "..."
    LTARROW = 49,                  // "<-"
    DBLARROW = 50,                 // "<->"
    PREDICATE = 51,                // "%?"
    GS_ID = 52,                    // "nonterminal symbol"
    NAMESPACE_ID = 53,             // "C++ qualified name"
    LITERAL_PATH = 54,             // "literal path name"
    INHATTR_ID = 55,               // "inherited attribute"
    API_VARIABLE = 56,             // "bison API variable"
    API_VALUE = 57,                // "bison API value"
    NUM = 58,                      // "number"
    LEFT = 59,                     // "%left"
    RIGHT = 60,                    // "%right"
    NONASSOC = 61,                 // "%nonassoc"
    TOKEN = 62,                    // "%token"
    PREC = 63,                     // "%prec"
    TYPE = 64,                     // "%type"
    NTERM = 65,                    // "%nterm"
    START = 66,                    // "%start"
    UNION = 67,                    // "%union"
    EMPTY = 68,                    // "%empty"
    EXPECT = 69,                   // "%expect"
    EXPECT_RR = 70,                // "%expect-rr"
    PURE_PARSER = 71,              // "%pure-parser"
    DPREC = 72,                    // "%dprec"
    MERGE = 73,                    // "%merge"
    PRECEDENCE = 74,               // "%precedence"
    LOOKAHEAD = 75,                // "%la"
    SCANNER = 76,                  // "%scanner"
    CODE = 77,                     // CODE
    LOCATION = 78,                 // LOCATION
    DESTRUCTOR = 79,               // "%destructor"
    LEX_PARAM = 80,                // "%lex-param"
    PARSE_PARAM = 81,              // "%parse-param"
    DEFINE = 82,                   // "%define"
    LANGUAGE = 83,                 // "%language"
    NAME_PREFIX = 84,              // "%name-prefix"
    PARAM = 85,                    // "%param"
    PRINTER = 86,                  // "%printer"
    SKELETON = 87,                 // "%skeleton"
    LOCAL = 88,                    // "%local"
    EXPORT = 89,                   // "%export"
    IMPORT = 90,                   // "%import"
    CONST = 91,                    // "const"
    VOLATILE = 92,                 // "volatile"
    RESTRICT = 93,                 // "restrict"
    REGISTER = 94,                 // "register"
    STATIC = 95,                   // "static"
    TYPE_KEYWORD = 96,             // TYPE_KEYWORD
    ELABORATED_TYPE_KEYWORD = 97,  // ELABORATED_TYPE_KEYWORD
    PERIOD = 98,                   // "."
    RTARROW = 99,                  // "->"
    PLUSPLUS = 100,                // "++"
    MINUSMINUS = 101,              // "--"
    TILDE = 102,                   // "~"
    EXCLAMATION = 103,             // "!"
    MINUS = 104,                   // "-"
    PLUS = 105,                    // "+"
    AMPERSAND = 106,               // "&"
    ASTERISK = 107,                // "*"
    SLASH = 108,                   // "/"
    PERCENT = 109,                 // "%"
    LTSHIFT = 110,                 // "<<"
    RTSHIFT = 111,                 // ">>"
    LESSTHAN = 112,                // "<"
    GTRTHAN = 113,                 // ">"
    LTOREQ = 114,                  // "<="
    GTOREQ = 115,                  // ">="
    EQUAL = 116,                   // "=="
    NOTEQUAL = 117,                // "!="
    UPARROW = 118,                 // "^"
    VBAR = 119,                    // "|"
    LOGAND = 120,                  // "&&"
    LOGOR = 121,                   // "||"
    QUESTION = 122,                // "?"
    COLON = 123,                   // ":"
    ASSIGN = 124,                  // "="
    PLUSEQ = 125,                  // "+="
    MINUSEQ = 126,                 // "-="
    TIMESEQ = 127,                 // "*="
    DIVEQ = 128,                   // "/="
    REMEQ = 129,                   // "%="
    LTSHIFTEQ = 130,               // "<<="
    RTSHIFTEQ = 131,               // ">>="
    BITANDEQ = 132,                // "&="
    BITXOREQ = 133,                // "^="
    BITOREQ = 134,                 // "|="
    PTRTOMEMBER = 135,             // "->*"
    MEMBERSELECT = 136,            // ".*"
    SCOPE = 137                    // "::"
      };
    };

    /// Token kind, as returned by yylex.
    typedef token::token_kind_type token_kind_type;

    /// Symbol kinds.
    struct symbol_kind
    {
      enum symbol_kind_type
      {
        YYNTOKENS = 138, ///< Number of tokens.
        S_YYEMPTY = -2,
        S_YYEOF = 0,                             // "end of file"
        S_YYerror = 1,                           // error
        S_YYUNDEF = 2,                           // "invalid token"
        S_OX_LBRACE = 3,                         // "@{"
        S_OX_RBRACE = 4,                         // "@}"
        S_OX_ATTRB_REF = 5,                      // "attribute reference"
        S_ID = 6,                                // "identifier"
        S_LITERAL_CHAR = 7,                      // "character literal"
        S_LITERAL_STRING = 8,                    // "string literal"
        S_LBRACE = 9,                            // "{"
        S_RBRACE = 10,                           // "}"
        S_SEMICOLON = 11,                        // ";"
        S_MARK = 12,                             // "%%"
        S_LCURL = 13,                            // "%{"
        S_RCURL = 14,                            // "%}"
        S_TERM_ID = 15,                          // "terminal symbol"
        S_TERM_LITERAL = 16,                     // "terminal literal"
        S_RETURN = 17,                           // "return"
        S_NEWLINE = 18,                          // "\\n"
        S_SOSF = 19,                             // "start of generic scanner source file"
        S_NO_ATTRBREFSEC = 20,                   // "no attribute reference section"
        S_OX_ATTRB_OCCUR = 21,                   // "attribute occurrence"
        S_OX_ATTRIBUTES = 22,                    // "@attributes"
        S_OX_MACRO = 23,                         // "@macro"
        S_OX_END = 24,                           // "@end"
        S_OX_TRAV = 25,                          // "@traversal"
        S_OX_PREORDER = 26,                      // "@preorder"
        S_OX_POSTORDER = 27,                     // "@postorder"
        S_OX_LEFTTORIGHT = 28,                   // "@lefttoright"
        S_OX_RIGHTTOLEFT = 29,                   // "@righttoleft"
        S_OX_REVORDER = 30,                      // "@revorder"
        S_OX_REVDIR = 31,                        // "@revdirection"
        S_OX_DISABLE = 32,                       // "@disable"
        S_OX_AUTOSYN = 33,                       // "@autosyn"
        S_OX_AUTOINH = 34,                       // "@autoinh"
        S_OX_WARN = 35,                          // "@warn"
        S_OX_I = 36,                             // "@i"
        S_OX_M = 37,                             // "@m"
        S_OX_E = 38,                             // "@e"
        S_OX_DECORATE = 39,                      // "@decorate"
        S_OX_VOID = 40,                          // "@void"
        S_OX_ID = 41,                            // "traversal mode annunciator"
        S_COMMA = 42,                            // ","
        S_LPAREN = 43,                           // "("
        S_RPAREN = 44,                           // ")"
        S_LBRACKET = 45,                         // "["
        S_RBRACKET = 46,                         // "]"
        S_AT = 47,                               // "@"
        S_ELLIPSIS = 48,                         // "..."
        S_LTARROW = 49,                          // "<-"
        S_DBLARROW = 50,                         // "<->"
        S_PREDICATE = 51,                        // "%?"
        S_GS_ID = 52,                            // "nonterminal symbol"
        S_NAMESPACE_ID = 53,                     // "C++ qualified name"
        S_LITERAL_PATH = 54,                     // "literal path name"
        S_INHATTR_ID = 55,                       // "inherited attribute"
        S_API_VARIABLE = 56,                     // "bison API variable"
        S_API_VALUE = 57,                        // "bison API value"
        S_NUM = 58,                              // "number"
        S_LEFT = 59,                             // "%left"
        S_RIGHT = 60,                            // "%right"
        S_NONASSOC = 61,                         // "%nonassoc"
        S_TOKEN = 62,                            // "%token"
        S_PREC = 63,                             // "%prec"
        S_TYPE = 64,                             // "%type"
        S_NTERM = 65,                            // "%nterm"
        S_START = 66,                            // "%start"
        S_UNION = 67,                            // "%union"
        S_EMPTY = 68,                            // "%empty"
        S_EXPECT = 69,                           // "%expect"
        S_EXPECT_RR = 70,                        // "%expect-rr"
        S_PURE_PARSER = 71,                      // "%pure-parser"
        S_DPREC = 72,                            // "%dprec"
        S_MERGE = 73,                            // "%merge"
        S_PRECEDENCE = 74,                       // "%precedence"
        S_LOOKAHEAD = 75,                        // "%la"
        S_SCANNER = 76,                          // "%scanner"
        S_CODE = 77,                             // CODE
        S_LOCATION = 78,                         // LOCATION
        S_DESTRUCTOR = 79,                       // "%destructor"
        S_LEX_PARAM = 80,                        // "%lex-param"
        S_PARSE_PARAM = 81,                      // "%parse-param"
        S_DEFINE = 82,                           // "%define"
        S_LANGUAGE = 83,                         // "%language"
        S_NAME_PREFIX = 84,                      // "%name-prefix"
        S_PARAM = 85,                            // "%param"
        S_PRINTER = 86,                          // "%printer"
        S_SKELETON = 87,                         // "%skeleton"
        S_LOCAL = 88,                            // "%local"
        S_EXPORT = 89,                           // "%export"
        S_IMPORT = 90,                           // "%import"
        S_CONST = 91,                            // "const"
        S_VOLATILE = 92,                         // "volatile"
        S_RESTRICT = 93,                         // "restrict"
        S_REGISTER = 94,                         // "register"
        S_STATIC = 95,                           // "static"
        S_TYPE_KEYWORD = 96,                     // TYPE_KEYWORD
        S_ELABORATED_TYPE_KEYWORD = 97,          // ELABORATED_TYPE_KEYWORD
        S_PERIOD = 98,                           // "."
        S_RTARROW = 99,                          // "->"
        S_PLUSPLUS = 100,                        // "++"
        S_MINUSMINUS = 101,                      // "--"
        S_TILDE = 102,                           // "~"
        S_EXCLAMATION = 103,                     // "!"
        S_MINUS = 104,                           // "-"
        S_PLUS = 105,                            // "+"
        S_AMPERSAND = 106,                       // "&"
        S_ASTERISK = 107,                        // "*"
        S_SLASH = 108,                           // "/"
        S_PERCENT = 109,                         // "%"
        S_LTSHIFT = 110,                         // "<<"
        S_RTSHIFT = 111,                         // ">>"
        S_LESSTHAN = 112,                        // "<"
        S_GTRTHAN = 113,                         // ">"
        S_LTOREQ = 114,                          // "<="
        S_GTOREQ = 115,                          // ">="
        S_EQUAL = 116,                           // "=="
        S_NOTEQUAL = 117,                        // "!="
        S_UPARROW = 118,                         // "^"
        S_VBAR = 119,                            // "|"
        S_LOGAND = 120,                          // "&&"
        S_LOGOR = 121,                           // "||"
        S_QUESTION = 122,                        // "?"
        S_COLON = 123,                           // ":"
        S_ASSIGN = 124,                          // "="
        S_PLUSEQ = 125,                          // "+="
        S_MINUSEQ = 126,                         // "-="
        S_TIMESEQ = 127,                         // "*="
        S_DIVEQ = 128,                           // "/="
        S_REMEQ = 129,                           // "%="
        S_LTSHIFTEQ = 130,                       // "<<="
        S_RTSHIFTEQ = 131,                       // ">>="
        S_BITANDEQ = 132,                        // "&="
        S_BITXOREQ = 133,                        // "^="
        S_BITOREQ = 134,                         // "|="
        S_PTRTOMEMBER = 135,                     // "->*"
        S_MEMBERSELECT = 136,                    // ".*"
        S_SCOPE = 137,                           // "::"
        S_YYACCEPT = 138,                        // $accept
        S_AG_spec = 139,                         // AG_spec
        S_parser_spec = 140,                     // parser_spec
        S_141_1 = 141,                           // $@1
        S_142_2 = 142,                           // $@2
        S_143_3 = 143,                           // $@3
        S_parser_spec_definition_section = 144,  // parser_spec_definition_section
        S_parser_spec_rules_section = 145,       // parser_spec_rules_section
        S_tail = 146,                            // tail
        S_definition_seq = 147,                  // definition_seq
        S_definition = 148,                      // definition
        S_yacc_directive = 149,                  // yacc_directive
        S_150_4 = 150,                           // $@4
        S_ox_directive = 151,                    // ox_directive
        S_152_5 = 152,                           // $@5
        S_153_6 = 153,                           // $@6
        S_154_7 = 154,                           // $@7
        S_155_8 = 155,                           // $@8
        S_156_9 = 156,                           // $@9
        S_code_seq = 157,                        // code_seq
        S_token_decl_list = 158,                 // token_decl_list
        S_tag_opt = 159,                         // tag_opt
        S_tag = 160,                             // tag
        S_token_list = 161,                      // token_list
        S_token = 162,                           // token
        S_named_token = 163,                     // named_token
        S_NUM_opt = 164,                         // NUM_opt
        S_precedence_declarer = 165,             // precedence_declarer
        S_precedence_decl_list = 166,            // precedence_decl_list
        S_terminal_list = 167,                   // terminal_list
        S_terminal_symbol = 168,                 // terminal_symbol
        S_nonterminal_symbol = 169,              // nonterminal_symbol
        S_symbol = 170,                          // symbol
        S_nonterminal_declarer = 171,            // nonterminal_declarer
        S_nonterminal_decl_list = 172,           // nonterminal_decl_list
        S_nonterminal_list = 173,                // nonterminal_list
        S_nonterminal = 174,                     // nonterminal
        S_code_block = 175,                      // code_block
        S_autoIDseq = 176,                       // autoIDseq
        S_autoID = 177,                          // autoID
        S_attribute_decl_list = 178,             // attribute_decl_list
        S_attribute_decl = 179,                  // attribute_decl
        S_attrb_modifier_opt = 180,              // attrb_modifier_opt
        S_attrb_modifier = 181,                  // attrb_modifier
        S_182_10 = 182,                          // $@10
        S_183_11 = 183,                          // $@11
        S_atWarn_opt = 184,                      // atWarn_opt
        S_type_specifier = 185,                  // type_specifier
        S_type = 186,                            // type
        S_type_component = 187,                  // type_component
        S_type_name = 188,                       // type_name
        S_elaborated_type_name = 189,            // elaborated_type_name
        S_type_list = 190,                       // type_list
        S_id_seq = 191,                          // id_seq
        S_declarator = 192,                      // declarator
        S_direct_declarator = 193,               // direct_declarator
        S_id_seq2 = 194,                         // id_seq2
        S_attribute_id = 195,                    // attribute_id
        S_ptr_operator = 196,                    // ptr_operator
        S_ptr_type_qualifier_seq_opt = 197,      // ptr_type_qualifier_seq_opt
        S_ptr_type_qualifier_seq = 198,          // ptr_type_qualifier_seq
        S_ptr_type_qualifier = 199,              // ptr_type_qualifier
        S_field_length_spec = 200,               // field_length_spec
        S_array_size_opt = 201,                  // array_size_opt
        S_parameter_list_opt = 202,              // parameter_list_opt
        S_parameter_list = 203,                  // parameter_list
        S_parameter_type_list = 204,             // parameter_type_list
        S_parameter_type = 205,                  // parameter_type
        S_formal_type_specifier = 206,           // formal_type_specifier
        S_abstract_declarator = 207,             // abstract_declarator
        S_direct_abstract_declarator = 208,      // direct_abstract_declarator
        S_formal_array_qualifier_list_opt = 209, // formal_array_qualifier_list_opt
        S_formal_array_qualifier_list = 210,     // formal_array_qualifier_list
        S_formal_array_qualifier = 211,          // formal_array_qualifier
        S_attributed_symbol_list = 212,          // attributed_symbol_list
        S_attributed_symbol = 213,               // attributed_symbol
        S_macroFormalList = 214,                 // macroFormalList
        S_travSpecSeq = 215,                     // travSpecSeq
        S_travIDseq = 216,                       // travIDseq
        S_travID = 217,                          // travID
        S_travSpec = 218,                        // travSpec
        S_rule_seq = 219,                        // rule_seq
        S_rule_set = 220,                        // rule_set
        S_221_12 = 221,                          // $@12
        S_222_13 = 222,                          // $@13
        S_left_hand_side = 223,                  // left_hand_side
        S_right_hand_side = 224,                 // right_hand_side
        S_225_14 = 225,                          // $@14
        S_rhs_body = 226,                        // rhs_body
        S_rhs_seq = 227,                         // rhs_seq
        S_rhs_component = 228,                   // rhs_component
        S_rhs_item = 229,                        // rhs_item
        S_rhs_symbol = 230,                      // rhs_symbol
        S_rule_directive = 231,                  // rule_directive
        S_parser_action = 232,                   // parser_action
        S_attrb_ref_section = 233,               // attrb_ref_section
        S_234_15 = 234,                          // $@15
        S_attrb_ref_section_body = 235,          // attrb_ref_section_body
        S_decorate_cmd = 236,                    // decorate_cmd
        S_attrb_ref_section_seq = 237,           // attrb_ref_section_seq
        S_attrb_ref_section_item = 238,          // attrb_ref_section_item
        S_attrb_def = 239,                       // attrb_def
        S_attrb_evaluation = 240,                // attrb_evaluation
        S_attrb_evaluation_stmt = 241,           // attrb_evaluation_stmt
        S_attrb_evaluation_expr = 242,           // attrb_evaluation_expr
        S_attrb_evaluation_expr_component = 243, // attrb_evaluation_expr_component
        S_attrb_ref = 244,                       // attrb_ref
        S_attrb_evaluation_compound_stmt = 245,  // attrb_evaluation_compound_stmt
        S_attrb_evaluation_stmt_seq = 246,       // attrb_evaluation_stmt_seq
        S_attrb_evaluation_stmt_seq_component = 247, // attrb_evaluation_stmt_seq_component
        S_attrb_evaluation_stmt_component = 248, // attrb_evaluation_stmt_component
        S_dependent_name_seq = 249,              // dependent_name_seq
        S_dependent_name = 250,                  // dependent_name
        S_attrb_occur = 251,                     // attrb_occur
        S_dependee_name_seq = 252,               // dependee_name_seq
        S_dependee_name = 253,                   // dependee_name
        S_traversal_segment = 254,               // traversal_segment
        S_255_16 = 255,                          // $@16
        S_traversal_modifier_seq = 256,          // traversal_modifier_seq
        S_traversal_modifier = 257,              // traversal_modifier
        S_258_17 = 258,                          // $@17
        S_259_18 = 259,                          // $@18
        S_traversal_modifier_expr = 260,         // traversal_modifier_expr
        S_traversal_expr = 261,                  // traversal_expr
        S_traversal_expr_component = 262,        // traversal_expr_component
        S_traversal_action = 263,                // traversal_action
        S_traversal_stmt = 264,                  // traversal_stmt
        S_traversal_stmt_component = 265,        // traversal_stmt_component
        S_traversal_compound_stmt = 266,         // traversal_compound_stmt
        S_traversal_stmt_seq = 267,              // traversal_stmt_seq
        S_traversal_stmt_seq_component = 268,    // traversal_stmt_seq_component
        S_expr_value = 269,                      // expr_value
        S_expr_operator = 270                    // expr_operator
      };
    };

    /// (Internal) symbol kind.
    typedef symbol_kind::symbol_kind_type symbol_kind_type;

    /// The number of tokens.
    static const symbol_kind_type YYNTOKENS = symbol_kind::YYNTOKENS;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol kind
    /// via kind ().
    ///
    /// Provide access to semantic value and location.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol () YY_NOEXCEPT
        : value ()
        , location ()
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      basic_symbol (basic_symbol&& that)
        : Base (std::move (that))
        , value ()
        , location (std::move (that.location))
      {
        switch (this->kind ())
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        value.move< attrbPair > (std::move (that.value));
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        value.move< attrbRefSeq > (std::move (that.value));
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        value.move< attrbTriple > (std::move (that.value));
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        value.move< char_literal > (std::move (that.value));
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        value.move< keyword > (std::move (that.value));
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        value.move< name_literal > (std::move (that.value));
        break;

      case symbol_kind::S_NUM: // "number"
        value.move< numberRep > (std::move (that.value));
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        value.move< symDeclSeq > (std::move (that.value));
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        value.move< symSeq > (std::move (that.value));
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        value.move< typeSeq > (std::move (that.value));
        break;

      default:
        break;
    }

      }
#endif

      /// Copy constructor.
      basic_symbol (const basic_symbol& that);

      /// Constructors for typed symbols.
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, location_type&& l)
        : Base (t)
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const location_type& l)
        : Base (t)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, attrbPair&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const attrbPair& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, attrbRefSeq&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const attrbRefSeq& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, attrbTriple&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const attrbTriple& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, char_literal&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const char_literal& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, keyword&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const keyword& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, name_literal&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const name_literal& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, numberRep&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const numberRep& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, symDeclSeq&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const symDeclSeq& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, symSeq&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const symSeq& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, typeSeq&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const typeSeq& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

      /// Destroy the symbol.
      ~basic_symbol ()
      {
        clear ();
      }


      /// Copy assignment.
      basic_symbol& operator= (const basic_symbol& that)
      {
        Base::operator= (that);
        switch (this->kind ())
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        value.copy< attrbPair > (that.value);
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        value.copy< attrbRefSeq > (that.value);
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        value.copy< attrbTriple > (that.value);
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        value.copy< char_literal > (that.value);
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        value.copy< keyword > (that.value);
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        value.copy< name_literal > (that.value);
        break;

      case symbol_kind::S_NUM: // "number"
        value.copy< numberRep > (that.value);
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        value.copy< symDeclSeq > (that.value);
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        value.copy< symSeq > (that.value);
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        value.copy< typeSeq > (that.value);
        break;

      default:
        break;
    }
;
        location = that.location;
        return *this;
      }

      /// Move assignment.
      basic_symbol& operator= (basic_symbol&& that)
      {
        Base::operator= (std::move (that));
        switch (this->kind ())
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        value.move< attrbPair > (std::move (that.value));
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        value.move< attrbRefSeq > (std::move (that.value));
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        value.move< attrbTriple > (std::move (that.value));
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        value.move< char_literal > (std::move (that.value));
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        value.move< keyword > (std::move (that.value));
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        value.move< name_literal > (std::move (that.value));
        break;

      case symbol_kind::S_NUM: // "number"
        value.move< numberRep > (std::move (that.value));
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        value.move< symDeclSeq > (std::move (that.value));
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        value.move< symSeq > (std::move (that.value));
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        value.move< typeSeq > (std::move (that.value));
        break;

      default:
        break;
    }
;
        location = std::move (that.location);
        return *this;
      }


      /// Destroy contents, and record that is empty.
      void clear () YY_NOEXCEPT
      {
        // User destructor.
        symbol_kind_type yykind = this->kind ();
        basic_symbol<Base>& yysym = *this;
        (void) yysym;
        switch (yykind)
        {
       default:
          break;
        }

        // Value type destructor.
switch (yykind)
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        value.template destroy< attrbPair > ();
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        value.template destroy< attrbRefSeq > ();
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        value.template destroy< attrbTriple > ();
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        value.template destroy< char_literal > ();
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        value.template destroy< keyword > ();
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        value.template destroy< name_literal > ();
        break;

      case symbol_kind::S_NUM: // "number"
        value.template destroy< numberRep > ();
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        value.template destroy< symDeclSeq > ();
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        value.template destroy< symSeq > ();
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        value.template destroy< typeSeq > ();
        break;

      default:
        break;
    }

        Base::clear ();
      }

      /// The user-facing name of this symbol.
      const char *name () const YY_NOEXCEPT
      {
        return yacc::symbol_name (this->kind ());
      }

      /// Whether empty.
      bool empty () const YY_NOEXCEPT;

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      value_type value;

      /// The location.
      location_type location;

    private:
#if YY_CPLUSPLUS < 201103L
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& that);
#endif
    };

    /// Type access provider for token (enum) based symbols.
    struct by_kind
    {
      /// The symbol kind as needed by the constructor.
      typedef token_kind_type kind_type;

      /// Default constructor.
      by_kind () YY_NOEXCEPT;

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      by_kind (by_kind&& that) YY_NOEXCEPT;
#endif

      /// Copy constructor.
      by_kind (const by_kind& that) YY_NOEXCEPT;

      /// Constructor from (external) token numbers.
      by_kind (kind_type t) YY_NOEXCEPT;


      /// Copy assignment.
      by_kind& operator= (const by_kind& that);

      /// Move assignment.
      by_kind& operator= (by_kind&& that);


      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_kind& that);

      /// The (internal) type number (corresponding to \a type).
      /// \a empty when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// The symbol kind.
      /// \a S_YYEMPTY when empty.
      symbol_kind_type kind_;
    };

    /// "External" symbols: returned by the scanner.
    struct symbol_type : basic_symbol<by_kind>
    {
      /// Superclass.
      typedef basic_symbol<by_kind> super_type;

      /// Empty symbol.
      symbol_type () YY_NOEXCEPT {}

      /// Constructor for valueless symbols, and symbols from each type.
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, location_type l)
        : super_type (token_kind_type (tok), std::move (l))
#else
      symbol_type (int tok, const location_type& l)
        : super_type (token_kind_type (tok), l)
#endif
      {}
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, attrbTriple v, location_type l)
        : super_type (token_kind_type (tok), std::move (v), std::move (l))
#else
      symbol_type (int tok, const attrbTriple& v, const location_type& l)
        : super_type (token_kind_type (tok), v, l)
#endif
      {}
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, char_literal v, location_type l)
        : super_type (token_kind_type (tok), std::move (v), std::move (l))
#else
      symbol_type (int tok, const char_literal& v, const location_type& l)
        : super_type (token_kind_type (tok), v, l)
#endif
      {}
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, keyword v, location_type l)
        : super_type (token_kind_type (tok), std::move (v), std::move (l))
#else
      symbol_type (int tok, const keyword& v, const location_type& l)
        : super_type (token_kind_type (tok), v, l)
#endif
      {}
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, name_literal v, location_type l)
        : super_type (token_kind_type (tok), std::move (v), std::move (l))
#else
      symbol_type (int tok, const name_literal& v, const location_type& l)
        : super_type (token_kind_type (tok), v, l)
#endif
      {}
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, numberRep v, location_type l)
        : super_type (token_kind_type (tok), std::move (v), std::move (l))
#else
      symbol_type (int tok, const numberRep& v, const location_type& l)
        : super_type (token_kind_type (tok), v, l)
#endif
      {}
    };


    // FIXME: should be private eventually.
    class glr_stack;
    class glr_state;

    /// Build a parser object.
    yacc (AGC::yaccLexer& theLexer_yyarg, yoxControl& ctrl_yyarg, specIO& theFiles_yyarg);
    ~yacc ();

    /// Parse.  An alias for parse ().
    /// \returns  0 iff parsing succeeded.
    int operator() ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    using debug_level_type = int;
    /// The current debugging level.
    debug_level_type debug_level () const;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    void error (const location_type& loc, const std::string& msg);

    /// The user-facing name of the symbol whose (internal) number is
    /// YYSYMBOL.  No bounds checking.
    static const char *symbol_name (symbol_kind_type yysymbol);

    // Implementation of make_symbol for each token kind.
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_END (location_type l)
      {
        return symbol_type (token::END, std::move (l));
      }
#else
      static
      symbol_type
      make_END (const location_type& l)
      {
        return symbol_type (token::END, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYerror (location_type l)
      {
        return symbol_type (token::YYerror, std::move (l));
      }
#else
      static
      symbol_type
      make_YYerror (const location_type& l)
      {
        return symbol_type (token::YYerror, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYUNDEF (location_type l)
      {
        return symbol_type (token::YYUNDEF, std::move (l));
      }
#else
      static
      symbol_type
      make_YYUNDEF (const location_type& l)
      {
        return symbol_type (token::YYUNDEF, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_LBRACE (location_type l)
      {
        return symbol_type (token::OX_LBRACE, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_LBRACE (const location_type& l)
      {
        return symbol_type (token::OX_LBRACE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_RBRACE (location_type l)
      {
        return symbol_type (token::OX_RBRACE, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_RBRACE (const location_type& l)
      {
        return symbol_type (token::OX_RBRACE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_ATTRB_REF (attrbTriple v, location_type l)
      {
        return symbol_type (token::OX_ATTRB_REF, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_OX_ATTRB_REF (const attrbTriple& v, const location_type& l)
      {
        return symbol_type (token::OX_ATTRB_REF, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ID (name_literal v, location_type l)
      {
        return symbol_type (token::ID, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ID (const name_literal& v, const location_type& l)
      {
        return symbol_type (token::ID, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LITERAL_CHAR (char_literal v, location_type l)
      {
        return symbol_type (token::LITERAL_CHAR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_LITERAL_CHAR (const char_literal& v, const location_type& l)
      {
        return symbol_type (token::LITERAL_CHAR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LITERAL_STRING (char_literal v, location_type l)
      {
        return symbol_type (token::LITERAL_STRING, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_LITERAL_STRING (const char_literal& v, const location_type& l)
      {
        return symbol_type (token::LITERAL_STRING, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LBRACE (location_type l)
      {
        return symbol_type (token::LBRACE, std::move (l));
      }
#else
      static
      symbol_type
      make_LBRACE (const location_type& l)
      {
        return symbol_type (token::LBRACE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RBRACE (location_type l)
      {
        return symbol_type (token::RBRACE, std::move (l));
      }
#else
      static
      symbol_type
      make_RBRACE (const location_type& l)
      {
        return symbol_type (token::RBRACE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SEMICOLON (location_type l)
      {
        return symbol_type (token::SEMICOLON, std::move (l));
      }
#else
      static
      symbol_type
      make_SEMICOLON (const location_type& l)
      {
        return symbol_type (token::SEMICOLON, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MARK (location_type l)
      {
        return symbol_type (token::MARK, std::move (l));
      }
#else
      static
      symbol_type
      make_MARK (const location_type& l)
      {
        return symbol_type (token::MARK, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LCURL (location_type l)
      {
        return symbol_type (token::LCURL, std::move (l));
      }
#else
      static
      symbol_type
      make_LCURL (const location_type& l)
      {
        return symbol_type (token::LCURL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RCURL (location_type l)
      {
        return symbol_type (token::RCURL, std::move (l));
      }
#else
      static
      symbol_type
      make_RCURL (const location_type& l)
      {
        return symbol_type (token::RCURL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TERM_ID (name_literal v, location_type l)
      {
        return symbol_type (token::TERM_ID, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TERM_ID (const name_literal& v, const location_type& l)
      {
        return symbol_type (token::TERM_ID, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TERM_LITERAL (char_literal v, location_type l)
      {
        return symbol_type (token::TERM_LITERAL, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TERM_LITERAL (const char_literal& v, const location_type& l)
      {
        return symbol_type (token::TERM_LITERAL, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RETURN (location_type l)
      {
        return symbol_type (token::RETURN, std::move (l));
      }
#else
      static
      symbol_type
      make_RETURN (const location_type& l)
      {
        return symbol_type (token::RETURN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NEWLINE (location_type l)
      {
        return symbol_type (token::NEWLINE, std::move (l));
      }
#else
      static
      symbol_type
      make_NEWLINE (const location_type& l)
      {
        return symbol_type (token::NEWLINE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SOSF (location_type l)
      {
        return symbol_type (token::SOSF, std::move (l));
      }
#else
      static
      symbol_type
      make_SOSF (const location_type& l)
      {
        return symbol_type (token::SOSF, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NO_ATTRBREFSEC (location_type l)
      {
        return symbol_type (token::NO_ATTRBREFSEC, std::move (l));
      }
#else
      static
      symbol_type
      make_NO_ATTRBREFSEC (const location_type& l)
      {
        return symbol_type (token::NO_ATTRBREFSEC, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_ATTRB_OCCUR (attrbTriple v, location_type l)
      {
        return symbol_type (token::OX_ATTRB_OCCUR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_OX_ATTRB_OCCUR (const attrbTriple& v, const location_type& l)
      {
        return symbol_type (token::OX_ATTRB_OCCUR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_ATTRIBUTES (keyword v, location_type l)
      {
        return symbol_type (token::OX_ATTRIBUTES, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_OX_ATTRIBUTES (const keyword& v, const location_type& l)
      {
        return symbol_type (token::OX_ATTRIBUTES, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_MACRO (keyword v, location_type l)
      {
        return symbol_type (token::OX_MACRO, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_OX_MACRO (const keyword& v, const location_type& l)
      {
        return symbol_type (token::OX_MACRO, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_END (location_type l)
      {
        return symbol_type (token::OX_END, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_END (const location_type& l)
      {
        return symbol_type (token::OX_END, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_TRAV (keyword v, location_type l)
      {
        return symbol_type (token::OX_TRAV, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_OX_TRAV (const keyword& v, const location_type& l)
      {
        return symbol_type (token::OX_TRAV, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_PREORDER (location_type l)
      {
        return symbol_type (token::OX_PREORDER, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_PREORDER (const location_type& l)
      {
        return symbol_type (token::OX_PREORDER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_POSTORDER (location_type l)
      {
        return symbol_type (token::OX_POSTORDER, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_POSTORDER (const location_type& l)
      {
        return symbol_type (token::OX_POSTORDER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_LEFTTORIGHT (location_type l)
      {
        return symbol_type (token::OX_LEFTTORIGHT, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_LEFTTORIGHT (const location_type& l)
      {
        return symbol_type (token::OX_LEFTTORIGHT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_RIGHTTOLEFT (location_type l)
      {
        return symbol_type (token::OX_RIGHTTOLEFT, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_RIGHTTOLEFT (const location_type& l)
      {
        return symbol_type (token::OX_RIGHTTOLEFT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_REVORDER (location_type l)
      {
        return symbol_type (token::OX_REVORDER, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_REVORDER (const location_type& l)
      {
        return symbol_type (token::OX_REVORDER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_REVDIR (location_type l)
      {
        return symbol_type (token::OX_REVDIR, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_REVDIR (const location_type& l)
      {
        return symbol_type (token::OX_REVDIR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_DISABLE (location_type l)
      {
        return symbol_type (token::OX_DISABLE, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_DISABLE (const location_type& l)
      {
        return symbol_type (token::OX_DISABLE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_AUTOSYN (keyword v, location_type l)
      {
        return symbol_type (token::OX_AUTOSYN, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_OX_AUTOSYN (const keyword& v, const location_type& l)
      {
        return symbol_type (token::OX_AUTOSYN, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_AUTOINH (keyword v, location_type l)
      {
        return symbol_type (token::OX_AUTOINH, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_OX_AUTOINH (const keyword& v, const location_type& l)
      {
        return symbol_type (token::OX_AUTOINH, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_WARN (keyword v, location_type l)
      {
        return symbol_type (token::OX_WARN, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_OX_WARN (const keyword& v, const location_type& l)
      {
        return symbol_type (token::OX_WARN, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_I (location_type l)
      {
        return symbol_type (token::OX_I, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_I (const location_type& l)
      {
        return symbol_type (token::OX_I, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_M (location_type l)
      {
        return symbol_type (token::OX_M, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_M (const location_type& l)
      {
        return symbol_type (token::OX_M, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_E (location_type l)
      {
        return symbol_type (token::OX_E, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_E (const location_type& l)
      {
        return symbol_type (token::OX_E, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_DECORATE (location_type l)
      {
        return symbol_type (token::OX_DECORATE, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_DECORATE (const location_type& l)
      {
        return symbol_type (token::OX_DECORATE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_VOID (location_type l)
      {
        return symbol_type (token::OX_VOID, std::move (l));
      }
#else
      static
      symbol_type
      make_OX_VOID (const location_type& l)
      {
        return symbol_type (token::OX_VOID, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OX_ID (name_literal v, location_type l)
      {
        return symbol_type (token::OX_ID, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_OX_ID (const name_literal& v, const location_type& l)
      {
        return symbol_type (token::OX_ID, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COMMA (location_type l)
      {
        return symbol_type (token::COMMA, std::move (l));
      }
#else
      static
      symbol_type
      make_COMMA (const location_type& l)
      {
        return symbol_type (token::COMMA, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LPAREN (location_type l)
      {
        return symbol_type (token::LPAREN, std::move (l));
      }
#else
      static
      symbol_type
      make_LPAREN (const location_type& l)
      {
        return symbol_type (token::LPAREN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RPAREN (location_type l)
      {
        return symbol_type (token::RPAREN, std::move (l));
      }
#else
      static
      symbol_type
      make_RPAREN (const location_type& l)
      {
        return symbol_type (token::RPAREN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LBRACKET (location_type l)
      {
        return symbol_type (token::LBRACKET, std::move (l));
      }
#else
      static
      symbol_type
      make_LBRACKET (const location_type& l)
      {
        return symbol_type (token::LBRACKET, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RBRACKET (location_type l)
      {
        return symbol_type (token::RBRACKET, std::move (l));
      }
#else
      static
      symbol_type
      make_RBRACKET (const location_type& l)
      {
        return symbol_type (token::RBRACKET, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_AT (location_type l)
      {
        return symbol_type (token::AT, std::move (l));
      }
#else
      static
      symbol_type
      make_AT (const location_type& l)
      {
        return symbol_type (token::AT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ELLIPSIS (location_type l)
      {
        return symbol_type (token::ELLIPSIS, std::move (l));
      }
#else
      static
      symbol_type
      make_ELLIPSIS (const location_type& l)
      {
        return symbol_type (token::ELLIPSIS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LTARROW (location_type l)
      {
        return symbol_type (token::LTARROW, std::move (l));
      }
#else
      static
      symbol_type
      make_LTARROW (const location_type& l)
      {
        return symbol_type (token::LTARROW, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DBLARROW (location_type l)
      {
        return symbol_type (token::DBLARROW, std::move (l));
      }
#else
      static
      symbol_type
      make_DBLARROW (const location_type& l)
      {
        return symbol_type (token::DBLARROW, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PREDICATE (location_type l)
      {
        return symbol_type (token::PREDICATE, std::move (l));
      }
#else
      static
      symbol_type
      make_PREDICATE (const location_type& l)
      {
        return symbol_type (token::PREDICATE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_GS_ID (name_literal v, location_type l)
      {
        return symbol_type (token::GS_ID, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_GS_ID (const name_literal& v, const location_type& l)
      {
        return symbol_type (token::GS_ID, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NAMESPACE_ID (name_literal v, location_type l)
      {
        return symbol_type (token::NAMESPACE_ID, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_NAMESPACE_ID (const name_literal& v, const location_type& l)
      {
        return symbol_type (token::NAMESPACE_ID, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LITERAL_PATH (char_literal v, location_type l)
      {
        return symbol_type (token::LITERAL_PATH, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_LITERAL_PATH (const char_literal& v, const location_type& l)
      {
        return symbol_type (token::LITERAL_PATH, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INHATTR_ID (name_literal v, location_type l)
      {
        return symbol_type (token::INHATTR_ID, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_INHATTR_ID (const name_literal& v, const location_type& l)
      {
        return symbol_type (token::INHATTR_ID, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_API_VARIABLE (name_literal v, location_type l)
      {
        return symbol_type (token::API_VARIABLE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_API_VARIABLE (const name_literal& v, const location_type& l)
      {
        return symbol_type (token::API_VARIABLE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_API_VALUE (name_literal v, location_type l)
      {
        return symbol_type (token::API_VALUE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_API_VALUE (const name_literal& v, const location_type& l)
      {
        return symbol_type (token::API_VALUE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NUM (numberRep v, location_type l)
      {
        return symbol_type (token::NUM, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_NUM (const numberRep& v, const location_type& l)
      {
        return symbol_type (token::NUM, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LEFT (keyword v, location_type l)
      {
        return symbol_type (token::LEFT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_LEFT (const keyword& v, const location_type& l)
      {
        return symbol_type (token::LEFT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RIGHT (keyword v, location_type l)
      {
        return symbol_type (token::RIGHT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_RIGHT (const keyword& v, const location_type& l)
      {
        return symbol_type (token::RIGHT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NONASSOC (keyword v, location_type l)
      {
        return symbol_type (token::NONASSOC, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_NONASSOC (const keyword& v, const location_type& l)
      {
        return symbol_type (token::NONASSOC, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TOKEN (keyword v, location_type l)
      {
        return symbol_type (token::TOKEN, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TOKEN (const keyword& v, const location_type& l)
      {
        return symbol_type (token::TOKEN, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PREC (location_type l)
      {
        return symbol_type (token::PREC, std::move (l));
      }
#else
      static
      symbol_type
      make_PREC (const location_type& l)
      {
        return symbol_type (token::PREC, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TYPE (keyword v, location_type l)
      {
        return symbol_type (token::TYPE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TYPE (const keyword& v, const location_type& l)
      {
        return symbol_type (token::TYPE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NTERM (keyword v, location_type l)
      {
        return symbol_type (token::NTERM, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_NTERM (const keyword& v, const location_type& l)
      {
        return symbol_type (token::NTERM, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START (keyword v, location_type l)
      {
        return symbol_type (token::START, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_START (const keyword& v, const location_type& l)
      {
        return symbol_type (token::START, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UNION (keyword v, location_type l)
      {
        return symbol_type (token::UNION, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_UNION (const keyword& v, const location_type& l)
      {
        return symbol_type (token::UNION, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EMPTY (location_type l)
      {
        return symbol_type (token::EMPTY, std::move (l));
      }
#else
      static
      symbol_type
      make_EMPTY (const location_type& l)
      {
        return symbol_type (token::EMPTY, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EXPECT (keyword v, location_type l)
      {
        return symbol_type (token::EXPECT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_EXPECT (const keyword& v, const location_type& l)
      {
        return symbol_type (token::EXPECT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EXPECT_RR (keyword v, location_type l)
      {
        return symbol_type (token::EXPECT_RR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_EXPECT_RR (const keyword& v, const location_type& l)
      {
        return symbol_type (token::EXPECT_RR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PURE_PARSER (keyword v, location_type l)
      {
        return symbol_type (token::PURE_PARSER, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PURE_PARSER (const keyword& v, const location_type& l)
      {
        return symbol_type (token::PURE_PARSER, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DPREC (location_type l)
      {
        return symbol_type (token::DPREC, std::move (l));
      }
#else
      static
      symbol_type
      make_DPREC (const location_type& l)
      {
        return symbol_type (token::DPREC, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MERGE (location_type l)
      {
        return symbol_type (token::MERGE, std::move (l));
      }
#else
      static
      symbol_type
      make_MERGE (const location_type& l)
      {
        return symbol_type (token::MERGE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PRECEDENCE (keyword v, location_type l)
      {
        return symbol_type (token::PRECEDENCE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PRECEDENCE (const keyword& v, const location_type& l)
      {
        return symbol_type (token::PRECEDENCE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LOOKAHEAD (location_type l)
      {
        return symbol_type (token::LOOKAHEAD, std::move (l));
      }
#else
      static
      symbol_type
      make_LOOKAHEAD (const location_type& l)
      {
        return symbol_type (token::LOOKAHEAD, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SCANNER (keyword v, location_type l)
      {
        return symbol_type (token::SCANNER, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_SCANNER (const keyword& v, const location_type& l)
      {
        return symbol_type (token::SCANNER, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CODE (keyword v, location_type l)
      {
        return symbol_type (token::CODE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_CODE (const keyword& v, const location_type& l)
      {
        return symbol_type (token::CODE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LOCATION (keyword v, location_type l)
      {
        return symbol_type (token::LOCATION, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_LOCATION (const keyword& v, const location_type& l)
      {
        return symbol_type (token::LOCATION, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DESTRUCTOR (keyword v, location_type l)
      {
        return symbol_type (token::DESTRUCTOR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_DESTRUCTOR (const keyword& v, const location_type& l)
      {
        return symbol_type (token::DESTRUCTOR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LEX_PARAM (keyword v, location_type l)
      {
        return symbol_type (token::LEX_PARAM, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_LEX_PARAM (const keyword& v, const location_type& l)
      {
        return symbol_type (token::LEX_PARAM, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PARSE_PARAM (keyword v, location_type l)
      {
        return symbol_type (token::PARSE_PARAM, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PARSE_PARAM (const keyword& v, const location_type& l)
      {
        return symbol_type (token::PARSE_PARAM, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DEFINE (keyword v, location_type l)
      {
        return symbol_type (token::DEFINE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_DEFINE (const keyword& v, const location_type& l)
      {
        return symbol_type (token::DEFINE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LANGUAGE (keyword v, location_type l)
      {
        return symbol_type (token::LANGUAGE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_LANGUAGE (const keyword& v, const location_type& l)
      {
        return symbol_type (token::LANGUAGE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NAME_PREFIX (keyword v, location_type l)
      {
        return symbol_type (token::NAME_PREFIX, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_NAME_PREFIX (const keyword& v, const location_type& l)
      {
        return symbol_type (token::NAME_PREFIX, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PARAM (keyword v, location_type l)
      {
        return symbol_type (token::PARAM, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PARAM (const keyword& v, const location_type& l)
      {
        return symbol_type (token::PARAM, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PRINTER (keyword v, location_type l)
      {
        return symbol_type (token::PRINTER, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PRINTER (const keyword& v, const location_type& l)
      {
        return symbol_type (token::PRINTER, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SKELETON (keyword v, location_type l)
      {
        return symbol_type (token::SKELETON, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_SKELETON (const keyword& v, const location_type& l)
      {
        return symbol_type (token::SKELETON, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LOCAL (keyword v, location_type l)
      {
        return symbol_type (token::LOCAL, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_LOCAL (const keyword& v, const location_type& l)
      {
        return symbol_type (token::LOCAL, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EXPORT (keyword v, location_type l)
      {
        return symbol_type (token::EXPORT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_EXPORT (const keyword& v, const location_type& l)
      {
        return symbol_type (token::EXPORT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_IMPORT (keyword v, location_type l)
      {
        return symbol_type (token::IMPORT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_IMPORT (const keyword& v, const location_type& l)
      {
        return symbol_type (token::IMPORT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CONST (keyword v, location_type l)
      {
        return symbol_type (token::CONST, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_CONST (const keyword& v, const location_type& l)
      {
        return symbol_type (token::CONST, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_VOLATILE (keyword v, location_type l)
      {
        return symbol_type (token::VOLATILE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_VOLATILE (const keyword& v, const location_type& l)
      {
        return symbol_type (token::VOLATILE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RESTRICT (keyword v, location_type l)
      {
        return symbol_type (token::RESTRICT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_RESTRICT (const keyword& v, const location_type& l)
      {
        return symbol_type (token::RESTRICT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_REGISTER (keyword v, location_type l)
      {
        return symbol_type (token::REGISTER, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_REGISTER (const keyword& v, const location_type& l)
      {
        return symbol_type (token::REGISTER, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STATIC (keyword v, location_type l)
      {
        return symbol_type (token::STATIC, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_STATIC (const keyword& v, const location_type& l)
      {
        return symbol_type (token::STATIC, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TYPE_KEYWORD (keyword v, location_type l)
      {
        return symbol_type (token::TYPE_KEYWORD, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TYPE_KEYWORD (const keyword& v, const location_type& l)
      {
        return symbol_type (token::TYPE_KEYWORD, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ELABORATED_TYPE_KEYWORD (keyword v, location_type l)
      {
        return symbol_type (token::ELABORATED_TYPE_KEYWORD, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ELABORATED_TYPE_KEYWORD (const keyword& v, const location_type& l)
      {
        return symbol_type (token::ELABORATED_TYPE_KEYWORD, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PERIOD (location_type l)
      {
        return symbol_type (token::PERIOD, std::move (l));
      }
#else
      static
      symbol_type
      make_PERIOD (const location_type& l)
      {
        return symbol_type (token::PERIOD, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RTARROW (location_type l)
      {
        return symbol_type (token::RTARROW, std::move (l));
      }
#else
      static
      symbol_type
      make_RTARROW (const location_type& l)
      {
        return symbol_type (token::RTARROW, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PLUSPLUS (location_type l)
      {
        return symbol_type (token::PLUSPLUS, std::move (l));
      }
#else
      static
      symbol_type
      make_PLUSPLUS (const location_type& l)
      {
        return symbol_type (token::PLUSPLUS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MINUSMINUS (location_type l)
      {
        return symbol_type (token::MINUSMINUS, std::move (l));
      }
#else
      static
      symbol_type
      make_MINUSMINUS (const location_type& l)
      {
        return symbol_type (token::MINUSMINUS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TILDE (location_type l)
      {
        return symbol_type (token::TILDE, std::move (l));
      }
#else
      static
      symbol_type
      make_TILDE (const location_type& l)
      {
        return symbol_type (token::TILDE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EXCLAMATION (location_type l)
      {
        return symbol_type (token::EXCLAMATION, std::move (l));
      }
#else
      static
      symbol_type
      make_EXCLAMATION (const location_type& l)
      {
        return symbol_type (token::EXCLAMATION, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MINUS (location_type l)
      {
        return symbol_type (token::MINUS, std::move (l));
      }
#else
      static
      symbol_type
      make_MINUS (const location_type& l)
      {
        return symbol_type (token::MINUS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PLUS (location_type l)
      {
        return symbol_type (token::PLUS, std::move (l));
      }
#else
      static
      symbol_type
      make_PLUS (const location_type& l)
      {
        return symbol_type (token::PLUS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_AMPERSAND (location_type l)
      {
        return symbol_type (token::AMPERSAND, std::move (l));
      }
#else
      static
      symbol_type
      make_AMPERSAND (const location_type& l)
      {
        return symbol_type (token::AMPERSAND, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASTERISK (location_type l)
      {
        return symbol_type (token::ASTERISK, std::move (l));
      }
#else
      static
      symbol_type
      make_ASTERISK (const location_type& l)
      {
        return symbol_type (token::ASTERISK, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SLASH (location_type l)
      {
        return symbol_type (token::SLASH, std::move (l));
      }
#else
      static
      symbol_type
      make_SLASH (const location_type& l)
      {
        return symbol_type (token::SLASH, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PERCENT (location_type l)
      {
        return symbol_type (token::PERCENT, std::move (l));
      }
#else
      static
      symbol_type
      make_PERCENT (const location_type& l)
      {
        return symbol_type (token::PERCENT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LTSHIFT (location_type l)
      {
        return symbol_type (token::LTSHIFT, std::move (l));
      }
#else
      static
      symbol_type
      make_LTSHIFT (const location_type& l)
      {
        return symbol_type (token::LTSHIFT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RTSHIFT (location_type l)
      {
        return symbol_type (token::RTSHIFT, std::move (l));
      }
#else
      static
      symbol_type
      make_RTSHIFT (const location_type& l)
      {
        return symbol_type (token::RTSHIFT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LESSTHAN (location_type l)
      {
        return symbol_type (token::LESSTHAN, std::move (l));
      }
#else
      static
      symbol_type
      make_LESSTHAN (const location_type& l)
      {
        return symbol_type (token::LESSTHAN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_GTRTHAN (location_type l)
      {
        return symbol_type (token::GTRTHAN, std::move (l));
      }
#else
      static
      symbol_type
      make_GTRTHAN (const location_type& l)
      {
        return symbol_type (token::GTRTHAN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LTOREQ (location_type l)
      {
        return symbol_type (token::LTOREQ, std::move (l));
      }
#else
      static
      symbol_type
      make_LTOREQ (const location_type& l)
      {
        return symbol_type (token::LTOREQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_GTOREQ (location_type l)
      {
        return symbol_type (token::GTOREQ, std::move (l));
      }
#else
      static
      symbol_type
      make_GTOREQ (const location_type& l)
      {
        return symbol_type (token::GTOREQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EQUAL (location_type l)
      {
        return symbol_type (token::EQUAL, std::move (l));
      }
#else
      static
      symbol_type
      make_EQUAL (const location_type& l)
      {
        return symbol_type (token::EQUAL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NOTEQUAL (location_type l)
      {
        return symbol_type (token::NOTEQUAL, std::move (l));
      }
#else
      static
      symbol_type
      make_NOTEQUAL (const location_type& l)
      {
        return symbol_type (token::NOTEQUAL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UPARROW (location_type l)
      {
        return symbol_type (token::UPARROW, std::move (l));
      }
#else
      static
      symbol_type
      make_UPARROW (const location_type& l)
      {
        return symbol_type (token::UPARROW, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_VBAR (location_type l)
      {
        return symbol_type (token::VBAR, std::move (l));
      }
#else
      static
      symbol_type
      make_VBAR (const location_type& l)
      {
        return symbol_type (token::VBAR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LOGAND (location_type l)
      {
        return symbol_type (token::LOGAND, std::move (l));
      }
#else
      static
      symbol_type
      make_LOGAND (const location_type& l)
      {
        return symbol_type (token::LOGAND, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LOGOR (location_type l)
      {
        return symbol_type (token::LOGOR, std::move (l));
      }
#else
      static
      symbol_type
      make_LOGOR (const location_type& l)
      {
        return symbol_type (token::LOGOR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_QUESTION (location_type l)
      {
        return symbol_type (token::QUESTION, std::move (l));
      }
#else
      static
      symbol_type
      make_QUESTION (const location_type& l)
      {
        return symbol_type (token::QUESTION, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COLON (location_type l)
      {
        return symbol_type (token::COLON, std::move (l));
      }
#else
      static
      symbol_type
      make_COLON (const location_type& l)
      {
        return symbol_type (token::COLON, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN (location_type l)
      {
        return symbol_type (token::ASSIGN, std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN (const location_type& l)
      {
        return symbol_type (token::ASSIGN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PLUSEQ (location_type l)
      {
        return symbol_type (token::PLUSEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_PLUSEQ (const location_type& l)
      {
        return symbol_type (token::PLUSEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MINUSEQ (location_type l)
      {
        return symbol_type (token::MINUSEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_MINUSEQ (const location_type& l)
      {
        return symbol_type (token::MINUSEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TIMESEQ (location_type l)
      {
        return symbol_type (token::TIMESEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_TIMESEQ (const location_type& l)
      {
        return symbol_type (token::TIMESEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DIVEQ (location_type l)
      {
        return symbol_type (token::DIVEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_DIVEQ (const location_type& l)
      {
        return symbol_type (token::DIVEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_REMEQ (location_type l)
      {
        return symbol_type (token::REMEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_REMEQ (const location_type& l)
      {
        return symbol_type (token::REMEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LTSHIFTEQ (location_type l)
      {
        return symbol_type (token::LTSHIFTEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_LTSHIFTEQ (const location_type& l)
      {
        return symbol_type (token::LTSHIFTEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RTSHIFTEQ (location_type l)
      {
        return symbol_type (token::RTSHIFTEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_RTSHIFTEQ (const location_type& l)
      {
        return symbol_type (token::RTSHIFTEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BITANDEQ (location_type l)
      {
        return symbol_type (token::BITANDEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_BITANDEQ (const location_type& l)
      {
        return symbol_type (token::BITANDEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BITXOREQ (location_type l)
      {
        return symbol_type (token::BITXOREQ, std::move (l));
      }
#else
      static
      symbol_type
      make_BITXOREQ (const location_type& l)
      {
        return symbol_type (token::BITXOREQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BITOREQ (location_type l)
      {
        return symbol_type (token::BITOREQ, std::move (l));
      }
#else
      static
      symbol_type
      make_BITOREQ (const location_type& l)
      {
        return symbol_type (token::BITOREQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PTRTOMEMBER (location_type l)
      {
        return symbol_type (token::PTRTOMEMBER, std::move (l));
      }
#else
      static
      symbol_type
      make_PTRTOMEMBER (const location_type& l)
      {
        return symbol_type (token::PTRTOMEMBER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MEMBERSELECT (location_type l)
      {
        return symbol_type (token::MEMBERSELECT, std::move (l));
      }
#else
      static
      symbol_type
      make_MEMBERSELECT (const location_type& l)
      {
        return symbol_type (token::MEMBERSELECT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SCOPE (location_type l)
      {
        return symbol_type (token::SCOPE, std::move (l));
      }
#else
      static
      symbol_type
      make_SCOPE (const location_type& l)
      {
        return symbol_type (token::SCOPE, l);
      }
#endif


    class context
    {
    public:
      context (glr_stack& yystack, const symbol_type& yyla);
      const symbol_type& lookahead () const YY_NOEXCEPT { return yyla_; }
      symbol_kind_type token () const YY_NOEXCEPT { return yyla_.kind (); }
      const location_type& location () const YY_NOEXCEPT { return yyla_.location; }

      /// Put in YYARG at most YYARGN of the expected tokens, and return the
      /// number of tokens stored in YYARG.  If YYARG is null, return the
      /// number of expected tokens (guaranteed to be less than YYNTOKENS).
      int expected_tokens (symbol_kind_type yyarg[], int yyargn) const;

    private:
      glr_stack& yystack_;
      const symbol_type& yyla_;
    };

# if YYDEBUG
  public:
    /// \brief Report a symbol value on the debug stream.
    /// \param yykind   The symbol kind.
    /// \param yyval    Its semantic value.
    /// \param yyloc    Its location.
    void yy_symbol_value_print_ (symbol_kind_type yykind,
                                 const value_type& yyval,
                                 const location_type& yyloc) const;
    /// \brief Report a symbol on the debug stream.
    /// \param yykind   The symbol kind.
    /// \param yyval    Its semantic value.
    /// \param yyloc    Its location.
    void yy_symbol_print_ (symbol_kind_type yykind,
                           const value_type& yyval,
                           const location_type& yyloc) const;
  private:
    /// Debug stream.
    std::ostream* yycdebug_;
#endif


  private:
    /// Report a syntax error
    /// \param yyctx     the context in which the error occurred.
    void report_syntax_error (const context& yyctx) const;

    /// Convert a scanner token kind \a t to a symbol kind.
    /// In theory \a t should be a token_kind_type, but character literals
    /// are valid, yet not members of the token_kind_type enum.
    static symbol_kind_type yytranslate_ (int t) YY_NOEXCEPT;



    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yykind    The symbol kind.
    void yy_destroy_ (const char* yymsg, symbol_kind_type yykind,
                      value_type& yyval,
                      location_type& yyloc);


    // User arguments.
    AGC::yaccLexer& theLexer;
    yoxControl& ctrl;
    specIO& theFiles;
    // Needs access to yy_destroy_, report_syntax_error, etc.
    friend glr_stack;
  };


#line 41 "agc-yacc.yy"
} // AGC
#line 4022 "agc-yacc.hh"


// "%code provides" blocks.
#line 104 "agc-yacc.yy"

#if defined(WITH_REFLEX)
#include <reflex/input.h>
#endif
// called from 'main ()'
extern "C" void
agc_yacc_parse (
#if defined(WITH_REFLEX)
                          const reflex::Input&,
#elif defined(WITH_FLEX)
                          std::ifstream&,
#else
#error "missing -DWITH_FLEX or -DWITH_REFLEX compile option"
// assume -DWITH_FLEX to avoid cascading errors
                          std::ifstream&,
#endif
                          Yfile_specIO&,
                          int);

#line 4046 "agc-yacc.hh"


#endif // !YY_YY_AGC_YACC_HH_INCLUDED
