#if defined (__cplusplus)
#include <cstdlib>
#include <cstdio>
#include <cstring>
#else
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#endif

#include "types.h"
#include "util.h"

symbol *
mkSymbol(typeT t, classT c, name id) {
   symbol *newSym = (symbol *) malloc(sizeof(symbol));
   newSym->c  = c;
   newSym->t  = t;
   newSym->id = id;
   return newSym;
}

nameList *
mkNameList(symbol *sym) {
   nameList *newList = (nameList *) malloc(sizeof(nameList));
   newList->s    = sym;
   newList->next = NULL;
   return newList;
}

nameList *
append(nameList *dList, nameList *decl) {
   nameList *pNL = dList;
   while (pNL->next != NULL) pNL = pNL->next;
   pNL->next = decl;
   return dList;
}

bool
cmpYaccToOxDeclList(void) {
    bool result = true;

    nameList *pBtYaccDeclList = btYaccDeclList;
    nameList *pOxDeclList     = oxDeclList;

    while (pBtYaccDeclList != NULL && pOxDeclList != NULL) {
        if (strcmp(pBtYaccDeclList->s->id,pOxDeclList->s->id) != 0) result = false;
        if (pBtYaccDeclList->s->c != pOxDeclList->s->c) result = false;
        if (pBtYaccDeclList->s->t != pOxDeclList->s->t) result = false;
        pBtYaccDeclList = pBtYaccDeclList->next;
        pOxDeclList = pOxDeclList->next;
    }
    if (pBtYaccDeclList == NULL && pOxDeclList == NULL) return result;
    return false;
}

void
dumpDeclList(nameList *dList) {
   while (dList != NULL) {
      printf("%s: ", dList->s->id);
      switch (dList->s->c) {
         case cGLOBAL  : fputs("global ", stdout); break;
         case cLOCAL   : fputs("local ", stdout); break;
      }
      switch (dList->s->t) {
         case tREAL    : fputs("real\n", stdout); break;
         case tINTEGER : fputs("integer\n", stdout); break;
      }
      dList = dList -> next;
   }
}
