%{
/* L-file for translation of infix expressions */
#include "semtypes.h"
#include "parser.h" 
#include <stdlib.h>
#include <string.h>

extern char *lexeme();
%}

%% 
[ \n\t\f]*              ;  
[0-9]+\.?[0-9]*         return(CONST); @{ @CONST.lexeme@ = lexeme(); @}   
[A-Za-z_][A-Za-z_0-9]*  return(ID);    @{ @ID.lexeme@ = lexeme();    @}
\(                      return('('); 
\)                      return(')'); 
\+                      return('+'); 
\*                      return('*'); 
\/                      return('/'); 
\-                      return('-'); 
%%
int yywrap(void){return 1;}

char *lexeme()
  {char *dum;
   dum = (char *)malloc(yyleng+1);
   strcpy(dum,(char *)yytext);
   return dum;
  }


