/* $Id: util.c 1713 2020-06-20 22:23:30Z teshields $ */ 
 
#include "gppl_glob.h"

extern int yylineno; 

#if YYBTYACC && !YYBYACC
void yyerror(const char *cp, ...)
#else  
void yyerror(const char *cp) 
#endif
  {fprintf(stderr,"Syntax error near line %d: %s\n",yylineno,cp); 
   yyyabort(); 
  }  



void fatal(const char *cp) 
  {fprintf(stderr,"Fatal error: %s\n",cp); 
   exit(-1); 
  }



void internal(const char *s) 
  {fprintf(stderr,"gppl/gc internal error: \n\t"); 
   fatal(s);
  }



void handleOverflow(const char *cp) 
  {internal(cp); 
  } 



FILE *safeOpen(const char *name, const char *mode) 
  {FILE *dum; 
   if ((dum = fopen(name,mode)) 
       == 
       ((FILE *)NULL) 
      ) 
      {fprintf(stderr,"fatal error opening %s.\n",name); 
       exit(-1); 
      } 
      else 
      return dum; 
  } 



void printStringArray(const char **arr, int sizeofArr, FILE *fp) 
  {long i; 
   for (i=0;i<(sizeofArr/sizeof(char *));i++)  
       fputs(arr[i],fp); 
  } 



