#ifndef __name_h
#define __name_h

/* Lexer hint Name Table: name & kind for each uniquely spelled indicator */

#include "types.h"
#include "symbol.h"

/* HACK: this implementation doesn't deal with nested ranges */

typedef enum { undef_name=0, oper_name=1, mode_name=2, ident_name=3 } name_kind_type;

typedef struct _name_defn {
  S_symbol symb;
  name_kind_type kind;
  mode_defn mode;
} *name_defn;

name_defn add_name ( char * );

string g_name ( name_defn );

void s_oper_name ( name_defn );
void s_mode_name ( name_defn );
void s_ident_name ( name_defn );
bool is_oper_name ( name_defn );
bool is_mode_name ( name_defn );

void s_mode ( name_defn, mode_defn );
mode_defn g_mode ( name_defn );

void dump_name ( void );

#endif
