%s YD YDSI ADECL MH MB LVA ADSL UU CC TRDECL 
 
 
%{
/* $Id: agc1.L 2625 2022-08-02 02:07:14Z teshields $ */ 
 
/* The information in this file is the intellectual property of 
 * Kurt M. Bischoff.  It may not be used, copied, or transferred 
 * without permission from the author. 
 *
 * Copyright (c) 1992, Kurt M. Bischoff.  All rights reserved.
 *
 * Beta Test Release--not for general distribution.
 */ 

#ifdef REFLEX_VERSION
#define yyout yy1out
#define YY_SCANNER YY1_SCANNER
#endif

#include <stdlib.h>
 
#include "glob.h" 
#include "opts.h" 
#include "scan.h" 
#include "YYLENG_INT.h" 

%}
 
 
WS		[ \t\f]+
OPTWS		[ \t\f]*
NON_WS		[^ \t\f\n]

CHAR_CONST      ('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')    
DOT_NAME        ([a-zA-Z_][a-zA-Z_0-9.]*) 

GS (('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')|([a-zA-Z_][a-zA-Z_0-9.]*)) 
ATTRB_NAME (('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')?([a-zA-Z_0-9.]+)) 
 
IDENT ([a-zA-Z][a-zA-Z0-9]*)

%%
<YD>[ \t\n\f]          charOut(*yy1text,outG);          
<YD>\/\*               eatCommentAndEcho(outG,1);
<YD>{CHAR_CONST}       {stringOut(yy1text,outG); 
                        IDbuffer = stringLookup(yy1text,yy1leng,1); 
                        return(ID); 
                       }  
<YD>{DOT_NAME}         {stringOut(yy1text,outG); 
                        IDbuffer = stringLookup(yy1text,yy1leng,1); 
                        return(ID); 
                       }  
<YD>[0-9]+             {stringOut(yy1text,outG); return(NUM);} 
<YD>\%left             {stringOut(yy1text,outG); return(LEFT);} 
<YD>\%right            {stringOut(yy1text,outG); return(RIGHT);} 
<YD>\%nonassoc         {stringOut(yy1text,outG); return(NONASSOC);} 
<YD>\%token            {stringOut(yy1text,outG); return(TOKEN);} 
<YD>\%type             {stringOut(yy1text,outG); return(TYPE);} 
<YD>\%start            {stringOut(yy1text,outG); BEGIN YDSI; return(START);}  
<YDSI>[ \t\n\f]        charOut(*yy1text,outG);           
<YDSI>\/\*             eatCommentAndEcho(outG,1);
<YDSI>{DOT_NAME}       {startSymLexeme = stringLookup(yy1text,yy1leng,1); 
                        fprintf(yoxOutG,"%s",augNstr); 
                        BEGIN YD; 
                        return(ID);  
                       }  
<YD>\%union            {stringOut(yy1text,outG); nLbraces = 0;
                        BEGIN UU; return(UNION); 
                       }
<YD>@attributes        {BEGIN ADECL; return(ATTRIBUTES);} 
<YD>@macro             {BEGIN MH; return(ATMACRO);}
<YD>@traversal         {BEGIN TRDECL; return(ATTRAV);}
<MH>[ \t\n\f]          ;
<MH>\/\*               eatCommentAndEcho(outG,1); 
<MH>{IDENT}            {IDbuffer = stringLookup(yy1text,yy1leng,1); 
                        return(ID);
                       } 
<MH>\(                 return('(');
<MH>[,]                return(','); 
<MH>\)                 {BEGIN MB; return(')');}
<MH>.                  {yerror("character illegal in macro heading:");
                        fprintf(stderr," %o octal\n",*yy1text);
                       }
<MB>\/\*               eatCommentAndEcho(outMB,1); 
<MB>\"                 eatStringAndEcho(outMB); 
<MB>{CHAR_CONST}       stringOut(yy1text,outMB); 
<MB>{IDENT}            {putIDinMacroDefBody(stringLookup(yy1text,yy1leng,1));}
<MB>\\@/end            charOut('@',outMB);    
<MB>@end               {BEGIN YD; return(ATEND);}  
<MB>.|\n               charOut(*yy1text,outMB);    
<TRDECL>@postorder     return(POSTORDER); 
<TRDECL>@preorder      return(PREORDER);
<TRDECL>@lefttoright   return(LEFTTORIGHT);
<TRDECL>@righttoleft   return(RIGHTTOLEFT);
<TRDECL>@disable       return(DISABLE);
<TRDECL>{IDENT}        {IDbuffer = stringLookup(yy1text,yy1leng,1); return(ID);} 
<YD>\%\%               {afterAllAttrbDecls();  
                        compilerTextCopy5();  
                        if (!buildHeaderFile) 
                           {fprintf(yoxOutG,"\n%%{\n");  
                            appendToOutFile(yoxOutH,yoxOutFileStrH,yoxOutG); 
                            fprintf(yoxOutG,"\n%%}\n");  
                           } 
                        stringOut(yy1text,outG); 
                        scanInit2(); 
                        return(MARK); 
                       } 
<YD>\%\{               {stringOut(yy1text,outG); BEGIN CC; return(LCURL);} 
<YD>"<"                {charOut('<',outG); return('<');}   
<YD>">"                {charOut('>',outG); return('>');}   
<YD>[,]                {charOut(',',outG); return(',');}   
<YD>\{                 {charOut('{',outG); return('{');}   
<YD>.                  {charOut(*yy1text,outG); yerror("syntax error 1.\n");}
<UU>\{                 {charOut('{',outG); nLbraces++;}   
<UU>\}                 {charOut('}',outG); if (!(--nLbraces)) BEGIN YD;} 
<UU>\/\*               eatCommentAndEcho(outG,1); 
<UU>\"                 eatStringAndEcho(outG); 
<UU>{CHAR_CONST}       stringOut(yy1text,outG);  
<UU>\n                 charOut('\n',outG);    
<UU>.                  charOut(*yy1text,outG);    
<CC>\%\}               {stringOut(yy1text,outG); BEGIN YD;}    
<CC>\"                 eatStringAndEcho(outG); 
<CC>{CHAR_CONST}       stringOut(yy1text,outG);  
<CC>\/\*               eatCommentAndEcho(outG,1);  
<CC>.|\n               charOut(*yy1text,outG);    
<ADECL>[ \t\n\f]       charOut(*yy1text,outGandL);          
<ADECL>\/\*            eatCommentAndEcho(outGandL,1);
<ADECL>\{              {charOut('{',outGandL); return('{');}   
<ADECL>\}              {charOut('}',outGandL); BEGIN ADSL; return('}');}   
<ADECL>@void           {BEGIN LVA; return(VOID);} 
<LVA>{DOT_NAME}        {IDbuffer = stringLookup(yy1text,yy1leng,1); return(ID);} 
<LVA>[ \t\n\f]         charOut(*yy1text,outGandL);  
<LVA>\/\*              eatCommentAndEcho(outGandL,1); 
<LVA>[,]               return(','); 
<LVA>;                 {BEGIN ADECL; return(';');}  
<ADECL>struct          {stringOut(yy1text,outGandL); return(STRUCT);}  
<ADECL>union           {stringOut(yy1text,outGandL); return(UNIONC);}  
<ADECL>enum            {stringOut(yy1text,outGandL); return(ENUM);}  
<ADECL>char            {stringOut(yy1text,outGandL); return(CHAR);}  
<ADECL>short           {stringOut(yy1text,outGandL); return(SHORT);}  
<ADECL>int             {stringOut(yy1text,outGandL); return(INT);}  
<ADECL>long            {stringOut(yy1text,outGandL); return(LONG);}  
<ADECL>float           {stringOut(yy1text,outGandL); return(FLOAT);}  
<ADECL>double          {stringOut(yy1text,outGandL); return(DOUBLE);}  
<ADECL>signed          {stringOut(yy1text,outGandL); return(SIGNED);}  
<ADECL>unsigned        {stringOut(yy1text,outGandL); return(UNSIGNED);}  
<ADECL>{DOT_NAME}      {IDbuffer = stringLookup(yy1text,yy1leng,1); 
		        stringOut(yy1text,outGandL); 
                        return(ID);  
		       }  
<ADECL>[,]             {charOut(',',outGandL); return(',');}   
<ADECL>:               {charOut(':',outGandL); return(':');}   
<ADECL>[0-9]+          {stringOut(yy1text,outGandL); return(NUM);} 
<ADECL>;               {charOut(';',outGandL); return(';');}   
<ADECL>\*              {charOut('*',outGandL); return('*');}   
<ADECL>.               {charOut(*yy1text,outGandL); 
                        yerror("syntax error AD.\n");
                       }
<ADSL>{GS}             {IDbuffer = stringLookup(yy1text,yy1leng,1); 
                        return(ID);   
                       }
<ADSL,TRDECL>[ \t\n\f] charOut(*yy1text,outG);   
<ADSL,TRDECL>\/\*      eatCommentAndEcho(outG,1);
<ADSL,TRDECL>.         {unput(*yy1text); BEGIN YD;}   
%%   
#ifdef REFLEX_VERSION
#undef yy1text
#undef yy1leng
#undef yy1lineno
#endif

void scanInit1(void) 
  {whichScanner = 1;  
   plineno = &yy1lineno; 
#ifdef REFLEX_VERSION
   YY1_SCANNER.start(YD);
#else
   ptext = yy1text; 
   pleng = &yy1leng; 
   BEGIN YD;
#endif
   yy1in = yoxInG; 
   inFileStr = yoxInFileStrG; 
  } 

int yy1ScnState(void) {return YYSTATE;}

int yy1wrap(void) 
  {if (eatCom) {yerror("error: unterminated comment.\n");
                fprintf(stderr, "comment began at line %5d\n",line);  
                goto err1;  
               } 
   if (eatStr) {yerror("error: unterminated string.\n");
                fprintf(stderr,"string began at line %5d\n",line);  
                goto err1;  
               } 
   if (yy1ScnState() == UU) 
      {yerror("error: unterminated yacc union declaration.\n");
       fprintf(stderr,"union began at line %5d\n",line);  
       goto err1;  
      } 
   if (yy1ScnState() == CC) 
      {yerror("error: unterminated yacc C code section.\n");
       fprintf(stderr,"section began at line %5d\n",line); 
       goto err1;  
      }  
   scanInit2(); 
   return(0);  
err1:
   rmTempFiles();
   exit(-1);
  } 




/** YDSI is used to intercept the lexeme of the start symbol for the purpose 
  * of augmenting the grammar. 
  *  
  * ADSL is separate from SS to avoid echoing the grammar symbols that 
  * appear in attribute declaration sections.  In state SS, when a closing 
  * curly brace is seen, it is at the end of an attribute declaration list.  
  * The only other such braces are seen at the ends of actions or unions, 
  * but these are seen in state AA or UU.  
  *  
  * UU is for echoing unions.  Its curly-brace-balancing strategy 
  * is similar to that of AA.  
  * 
  * CC is for echoing sections of C code between "%{" and "%}". 
  * 
*/ 

#if defined(FLEX_SCANNER) || defined(REFLEX_VERSION)
#if defined(__cplusplus)
int yy1input(void) {return yyinput();} /* `flex' with C++ compiler, or `reflex' */
#else
int yy1input(void) {return input();} /* `flex' with C compiler */
#endif
#endif
