%s YR YR1 AA LAAA LAAA1 
%s DL CL CL1 TT MUI TRAV1 TRVACT TRVCOND

%{
/* $Id: agc2.L 2625 2022-08-02 02:07:14Z teshields $ */ 

/* The information in this file is the intellectual property of 
 * Kurt M. Bischoff.  It may not be used, copied, or transferred 
 * without permission from the author. 
 *
 * Copyright (c) 1992, Kurt M. Bischoff.  All rights reserved.
 *
 * Beta Test Release--not for general distribution.
 */ 

#include <stdio.h>
#if defined(FLEX_SCANNER) || defined(REFLEX_VERSION)
static char yy2tchar,yy2sbuf[BUFSIZ]={0},*yy2sptr=&yy2sbuf[0];
#endif
extern int inFromMac;
extern char inputFromMacro();

#ifdef FLEX_SCANNER
#define YY_INPUT(buf,result,max_size) \
         {  \
         int c = myinput(); \
         result = (c == EOF) ? YY_NULL : (buf[0] = c, 1); \
         }
#define myinput() (inFromMac?((yy2sptr>yy2sbuf)?(*--yy2sptr):\
                                              inputFromMacro()\
                           ):\
                           getc(yy2in)\
                )
#undef unput
#define unput(c) {if (inFromMac) \
                     {yy2tchar= (c);*yy2sptr++=yy2tchar;} \
                     else \
                     yyunput(c, (yytext_ptr)); \
                 }
#endif

#if defined(FLEX_SCANNER) || !defined(REFLEX_VERSION)
/* AT&T Lex or flex */
#define myunput unput
#endif

#ifdef REFLEX_VERSION
#define myinput() (inFromMac?((yy2sptr>yy2sbuf)?(*--yy2sptr):\
                                              inputFromMacro()\
                           ):\
                           YY2_SCANNER.matcher().input()\
                )
#define myunput(c) {if (inFromMac) \
                       {yy2tchar= (c);*yy2sptr++=yy2tchar;} \
                       else \
                       YY2_SCANNER.matcher().unput(c); \
                   }
#endif

#ifdef REFLEX_VERSION
#define YY_SCANNER YY1_SCANNER
#include "lexer1.h"
#undef YY_SCANNER
#endif

#ifdef REFLEX_VERSION
#define yyout yy2out
#define YY_SCANNER YY2_SCANNER
#endif

#include <stdlib.h>
#include <string.h> 
 
#include "glob.h" 
#include "opts.h" 
#include "scan.h" 
#include "YYLENG_INT.h" 
#include "trav.h" 
int yy2ScnState();
int done = 0; 
static int yyStartCondTemp; 
static int startCondTempT; 
static int nLparensT;
enum {oCond,dCond,action} travState;
extern void macroInterpSetup2(char *,char *);
extern void putCharInMacroActParam(char c);
extern void terminateActualParam();
extern void startTravOrderCond();
extern void startTravDirCond();
extern void startTravAction();
extern void wrapUpTravOrderCond();
extern void wrapUpTravDirCond();
extern void wrapUpTravAction();
extern void putAttrbNumPairInRefSegBuffer(int,int);
extern int macroInterpSetup1IfMacro(char *);
extern void printAugmentationProduction();
%}
 
 
WS		[ \t\f]+
OPTWS		[ \t\f]*
NON_WS		[^ \t\f\n]

CHAR_CONST      ('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')    
DOT_NAME        ([a-zA-Z_][a-zA-Z_0-9.]*) 

GS (('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')|([a-zA-Z_][a-zA-Z_0-9.]*)) 
ATTRB_NAME (('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')?([a-zA-Z_0-9.]+)) 

IDENT ([a-zA-Z][a-zA-Z0-9]*)
%%
<YR,YR1,AA,LAAA,LAAA1,DL,CL,CL1,TT,MUI,TRAV1,TRVACT,TRVCOND>\x19 {
			scanInit3(); return(EOSF);
		       }
<INITIAL>^{OPTWS}\%\%{OPTWS} {BEGIN YR;}
<INITIAL>.|\n          ;
<YR>[ \t\n\f]          {flushLAbuffer(LA1,outG); charOut(*yy2text,outG);}  
<YR>\/\*               {flushLAbuffer(LA1,outG); eatCommentAndEcho(outG,1);}
<YR>{CHAR_CONST}       {flushLAbuffer(LA1,outG); stringOut(yy2text,outG);
                        IDbuffer = stringLookup(yy2text,yy2leng,1); 
                        return(ID); 
                       }  
<YR>{DOT_NAME}         {IDbuffer = stringLookup(yy2text,yy2leng,1); 
		        stringOut(yy2text,LA1); 
		        BEGIN YR1;
		       }  
<YR1>[ \t\n\f]         charOut(*yy2text,LA1);  
<YR1>\/\*              eatCommentAndEcho(LA1,1);
<YR1>:                 {charOut(':',LA1); 
                        if (!alreadyAugmented) 
                           {printAugmentationProduction(); 
                            flushLAbuffer(LA1,outG); 
                           } 
                        BEGIN YR; 
                        return(IDCOLON); 
                       }    
<YR1>.                 {flushLAbuffer(LA1,outG);  
                        myunput(*yy2text); BEGIN YR; return(ID); 
                       }   
<YR>\%prec             {flushLAbuffer(LA1,outG); stringOut(yy2text,outG); 
                        return(PREC); 
                       } 
<YR>\%\%               {charOut('\n',LA1); 
                        stringOut(yy2text,LA1); 
			stringOut(yy2text,LA1);
			BEGIN TT;
                        return(MARK); 
                       } 
<YR>\|                 {charOut('|',LA1); return('|'); 
                       }   
<YR>\{                 {flushLAbuffer(LA1,outG); charOut('{',outG); 
			nLbraces = 1; BEGIN AA;
                        return('{'); 
		       }   
<YR>;                  {charOut(';',LA1); 
                        return(';'); 
                       }   
<YR>@\{                {BEGIN DL; line = yy2lineno; return(LBRACE);}
<YR>.                  {charOut(*yy2text,outG); 
                        yerror("syntax error in rules section.\n");
                       }
<AA>\{                 {charOut('{',outG); nLbraces++;}   
<AA>\}                 {nLbraces--; 
			if (nLbraces == 0) 
			   {BEGIN LAAA;
                            charOut('}',LA1);  
			    return('}');
			   } 
                           else 
			   charOut('}',outG); 
		       } 
<AA>'\{'               stringOut(yy2text,outG);  
<AA>'\}'               stringOut(yy2text,outG);  
<AA>\/\*               eatCommentAndEcho(outG,1); 
<AA>\"                 eatStringAndEcho(outG); 
<AA>\\\"               stringOut(yy2text,outG);   
<AA>\n                 charOut('\n',outG);    
<AA>.                  charOut(*yy2text,outG);  
<LAAA>\/\*             eatCommentAndEcho(LA1,1);  
<LAAA>[ \n\t\f]        charOut(*yy2text,LA1);  
<LAAA>{CHAR_CONST}     {IDbuffer = stringLookup(yy2text,yy2leng,1); 
                        flushLAbuffer(LA1,outG); stringOut(yy2text,outG); BEGIN YR; 
                        return(ID);  
                       }  
<LAAA>{DOT_NAME}       {IDbuffer = stringLookup(yy2text,yy2leng,1); 
		        stringOut(yy2text,LA1);  
		        BEGIN LAAA1;
		       }  
<LAAA1>\/\*            eatCommentAndEcho(LA1,1);
<LAAA1>[ \t\n\f]       charOut(*yy2text,LA1);  
<LAAA1>:               {charOut(':',LA1); BEGIN YR; return(IDCOLON); 
                       }    
<LAAA1>.               {flushLAbuffer(LA1,outG); myunput(*yy2text); 
                        BEGIN YR; return(ID);
                       }
<LAAA>@\{              {BEGIN DL; line = yy2lineno; return(LBRACE);
                       }
<LAAA>\%\%             {charOut('\n',LA1); 
			stringOut(yy2text,LA1); BEGIN TT; return(MARK); 
                       }  
<LAAA>\%prec           {flushLAbuffer(LA1,outG); 
                        stringOut(yy2text,outG); BEGIN YR; return(PREC); 
                       }  
<LAAA>;                {charOut(';',LA1); BEGIN YR; return(';');
                       }  
<LAAA>\{               {flushLAbuffer(LA1,outG); charOut('{',outG); BEGIN AA; 
			yerror("consecutive actions not permitted.\n"); 
			return('{'); 
                       }  
<LAAA>\|               {charOut('|',LA1); BEGIN YR; return('|'); 
                       }  
<LAAA>.                {flushLAbuffer(LA1,outG); 
			yerror("syntax error after action.\n");
                       }  
<DL>\/\*               eatCommentAndEcho(rsB,1); 
<DL>[ \n\t\f]+         ;   
<DL>@prune             /* return(PRUNE) */  ; 
<DL>@decorate          /* return(DECORATE) */  ;  
<DL>@\}                {BEGIN YR; return(RBRACE);}
<DL>:                  return(':');  
<DL>;                  {BEGIN CL; 
                        return(';'); 
                       }  
<DL,CL,TRVACT>@[eim]   {if (yy2ScnState() == TRVACT) wrapUpTravAction();
                        switch(yy2text[1])
                          {case 'e': BEGIN DL;
                                     return(ATE);
                                     break;  
                           case 'i': BEGIN CL; 
                                     return(ATI);
                                     break;  
                           case 'm': BEGIN DL;
                                     return(ATM);
                                     break;  
                          } 
                       }   
<DL,CL,TRVACT>@{IDENT} {if (yy2ScnState() == TRVACT) wrapUpTravAction();
                        if (!strcmp(yy2text+1,"revorder"))
                           {if (yy2ScnState() != TRVACT)
                               {yerror("misplaced @revorder\n");
                               }
                            startTravOrderCond(); nLparensT = 0; 
                            travState = oCond; BEGIN TRVCOND;
                           }
                        else if (!strcmp(yy2text+1,"revdirection"))
                           {if (yy2ScnState() != TRVACT)
                               {yerror("misplaced @revdirection\n");
                               }
                            startTravDirCond();   nLparensT = 0; 
                            travState = dCond; BEGIN TRVCOND;
                           }
                        else
                           {IDbuffer = stringLookup(yy2text+1,yy2leng-1,1);
                            currentTrav = travLookup(IDbuffer); 
                            startTravAction();
                            BEGIN TRVACT; 
                            return(ATID);
                           }
                       }
<CL>\/\*               eatCommentAndEcho(rsB,1); 
<CL>\"                 eatStringAndEcho(rsB); 
<CL>{CHAR_CONST}       stringOut(yy2text,rsB);    
<CL>@\}                {BEGIN YR; return(RBRACE);}
<CL>\$\$               {stringOut(yy2text,rsB); hasYaccPvarRefGlob = 1;} 
<CL>\$\-?[0-9]+        {stringOut(yy2text,rsB); hasYaccPvarRefGlob = 1;} 
<TRVACT>[ \n\t\f\v]+   stringOut(yy2text,rsB);
<DL,CL,TRVACT,TRVCOND>{IDENT}        {
                        IDbuffer = stringLookup(yy2text,yy2leng,1);
                        if (macroInterpSetup1IfMacro(IDbuffer)) 
                           {nLparens = 0; 
                            yyStartCondTemp = yy2ScnState(); 
                            BEGIN MUI; 
                           }
                           else 
                           {if (yy2ScnState() == DL) 
                               {yerror("misplaced identifier:\n");
                                fprintf(stderr,"  %s\n",yy2text);
                               }
                               else
                               stringOut(yy2text,rsB); 
                           }
                       }   
<CL>(\n|.)             charOut(*yy2text,rsB);  
<DL>{ATTRB_NAME}       {scanAttrbName(yy2text,yy2leng); 
                        transAttrbNameToNumPair(); 
                        return(ID); 
                       }     
<DL>.                  {yerror("syntax error in dependency expression.\n");   
                        BEGIN CL; 
                        return(';'); 
                       }  
<TRVACT>@\}            {wrapUpTravAction(); BEGIN YR; return(RBRACE);}
<TRVCOND,TRVACT>\/\*           eatCommentAndEcho(rsB,1); 
<TRVCOND,TRVACT>\"             eatStringAndEcho(rsB); 
<TRVCOND,TRVACT>{CHAR_CONST}   stringOut(yy2text,rsB);    
<TRVCOND>\(            {stringOut(yy2text,rsB); nLparensT++;
                        if (nLparensT == 1) return('(');
                       }
<TRVCOND>\)            {nLparensT--; 
                        stringOut(yy2text,rsB);
                        if (nLparensT == 0)
                           {switch(travState)
                              {case oCond : wrapUpTravOrderCond(); break;
                               case dCond : wrapUpTravDirCond(); break;
                               case action: break;
                              }
                            startTravAction();
                            BEGIN TRVACT; 
                            return(')');
                           }
                       }
<TRVCOND,TRVACT>\$\$       {
                        yerror("yacc pseudovariable in traversal mode\n"); 
                       } 
<TRVCOND,TRVACT>\$\-?[0-9]+   {
                        yerror("yacc pseudovariable in traversal mode\n"); 
                       } 
<CL,TRVACT,TRVCOND>@{ATTRB_NAME}   {
                        scanAttrbName(yy2text + 1,yy2leng - 1); 
                        transAttrbNameToNumPair(); 
                        putAttrbNumPairInRefSegBuffer(bufPosInProd,bufAttrbNum);
                        startCondTempT = yy2ScnState(); 
                        BEGIN TRAV1;
                        if (startCondTempT == CL) return (ID);
                       }     
<TRVACT>.              charOut(*yy2text,rsB);
<TRVCOND>.|\n          charOut(*yy2text,rsB);
<TRAV1>@               BEGIN startCondTempT;
<TRAV1>[ \n\t\f\v]+    {yerror("fatal: whitespace in attribute reference.\n");
                        BEGIN startCondTempT;
		       }  
<TRAV1>.               {yerror("fatal: syntax error in attribute reference.\n");
                        BEGIN startCondTempT;
		       }  
<MUI>\(                {if (++nLparens != 1) 
                           yerror("unbalanced parentheses in macro use.\n");
                       }
<MUI>\)                {if (--nLparens != 0) 
                           yerror("unbalanced parentheses in macro use.\n");
                           else 
                           {macroInterpSetup2(yy2sbuf,yy2sptr); 
                            BEGIN yyStartCondTemp;
                           }
                       }
<MUI>[,]               terminateActualParam(); 
<MUI>\\\\              putCharInMacroActParam('\\');  
<MUI>\\[,]             putCharInMacroActParam(',');  
<MUI>\\\(              putCharInMacroActParam('(');  
<MUI>\\\)              putCharInMacroActParam(')');  
<MUI>\\           yerror("misuse of \'\\\' escape character in macro use.\n"); 
<MUI>.|\n              putCharInMacroActParam(*yy2text);  
<TT>\n|.               charOut(*yy2text,outG);
%%   
#ifdef REFLEX_VERSION
#undef yy2text
#undef yy2leng
#undef yy2lineno
#endif



void scanInit2(void) 
  {whichScanner = 2; 
   yy2lineno = 1; 
   plineno = &yy2lineno; 
#ifndef REFLEX_VERSION
   ptext = yy2text; 
   pleng = &yy2leng; 
#endif
   yy2in = yoxInG; 
   rewind(yy2in);
  } 



int yy2ScnState(void) {return YYSTATE;} 

int yy2wrap(void) 
  {
   if (done) return(0); else done = 1;
   if (eatCom) {yerror("error: unterminated comment.\n");
                fprintf(stderr, "comment began at line %5d\n",line);  
                goto err1;  
               } 
   if (eatStr) {yerror("error: unterminated string.\n");
                fprintf(stderr,"string began at line %5d\n",line);  
                goto err1; 
               }  
   if (yy2ScnState() == AA)  
      {yerror("error: unterminated yacc action.\n");   
       fprintf(stderr,"action began at line %5d\n",line);  
       goto err1;  
      } 
#if !defined(FLEX_SCANNER) && !defined(REFLEX_VERSION)
   /* AT&T Lex */
   unput('\x19');
#endif
#ifdef FLEX_SCANNER
   yy_scan_string("\x19");
#endif
#ifdef REFLEX_VERSION
   YY2_SCANNER.in("\x19");
#endif
   return(0);  
err1: 
   rmTempFiles();
   exit(-1);
  } 




/** YR1 is used for looking ahead after seeing an identifier to see if it is 
  * followed by a colon.    
  * 
  * AA is used for copying a yacc action.  The main idea is to keep echoing 
  * until the opening curly brace is paired.  Curly braces in strings, 
  * comments, and character constants are ignored.   
  * 
  * After the closing curly brace is detected in state AA, it has to be 
  * decided whether the action just scanned is the last thing (grammar 
  * symbol, action, or precedence) other than an attribute definitions 
  * section,  
  * vertical bar, or semicolon, in the current rulebody (RHS).  If it is 
  * the last thing, then some code that generates a parse tree node upon 
  * reduction by the present production has to be inserted before printing the 
  * closing brace of the action.  Note that yacc doesn't permit two 
  * adjacent actions in a given rulebody.  If it isn't the last thing, 
  * then the generation of such code will appear in a later action.  If 
  * the last thing in a rulebody isn't an action, then a left curly brace, 
  * the node-generating code, and a right curly brace will be generated,  
  * while everything else is echoed.  An action could be followed by 
  * whitespace, comments, and identifier, more whitespace and comments, 
  * and finally by a colon, and it can't be known until the colon is seen 
  * that the action was the last thing in the rulebody.  So it all has to 
  * be buffered.  This is the purpose of the LAAA (lookahead after action) 
  * and LAAA1 states, and of the lookahead buffer array and file and 
  * their associated routines, LAAA1 is analogous to SS1.  
  *  
  * TT is for echoing the tail section. 
  *  
  * DL is for reading attribute dependencies (explicit, mixed, implicit). 
  * 
  * CL is entered upon leaving DL.  CL is for reading attribute reference 
  * sections. 
  * CL1 is for splitting dollars signs away from attribute names 
  * to make them easier to handle.  
  * The appropriate C reference to a 
  * C variable is substituted for the attribute name.   
  *  
*/ 

#if defined(FLEX_SCANNER) || defined(REFLEX_VERSION)
int yy2input(void) {return myinput();}
#endif
