/* $Id: ctc.c 2098 2021-02-16 02:47:30Z teshields $ */ 

/* The information in this file is the intellectual property of 
 * Kurt M. Bischoff.  It may not be used, copied, or transferred 
 * without permission from the author. 
 *
 * Copyright (c) 1992, Kurt M. Bischoff.  All rights reserved.
 *
 * Beta Test Release--not for general distribution.
 */ 

#if defined (__cplusplus)
#include <cstdio>
#include <climits>
#else
#include <stdio.h>
#include <limits.h>
#endif

#include "opts.h" 
#include "glob.h"

extern FILE *yoxOutG,*yoxOutH,*temp1Out,*tempTravOut; 
extern int buildHeaderFile; 
extern int prodNumSeq; 
extern void appendToOutFile(FILE *,const char *,FILE *); 

extern void outputUserOptsCode(void);

#define DEBCTC 0 

/* minimum (for any system) size of UCHAR_MAX  */
#define UCHAR_MAX_MIN 255 



void printStringArray(const char **arr, int sizeofArr, FILE *fp) 
  {int i; 
   for (i=0;i<(sizeofArr/sizeof(char *));i++)  
       {if ((arr[i][0] == '@') &&
            (arr[i][1] == '@')
           ) 
           {if (((arr[i][2] == 's') && showStackOps) 
                || 
                ((arr[i][2] == 'u') && showPTsizeStats) 
                ||
                ((arr[i][2] == 'c') && !suppressCycleReports) 
               ) 
               fprintf(fp,3+arr[i]); 
           }
           else 
           fprintf(fp,arr[i]); 
       }
  } 



void printStorageSizes(void) 
  { 
   fprintf(yoxOutG,
"                                                      /*custom*/  \n"
          ); 
fprintf(yoxOutG,"long yyyMaxNbytesNodeStg = %ld; \n",maxNbytesNodeStg); 
fprintf(yoxOutG,"long yyyMaxNrefCounts =    %ld; \n",maxNrefCounts); 
fprintf(yoxOutG,"long yyyMaxNchildren =     %ld; \n",maxNchildren);
fprintf(yoxOutG,"long yyyMaxStackSize =     %ld; \n",maxStackSize); 
fprintf(yoxOutG,"long yyySSALspaceSize =    %ld; \n",SSALspaceSize);
fprintf(yoxOutG,"long yyyRSmaxSize =        %ld; \n",RSmaxSize);
fprintf(yoxOutG,"long yyyTravStackMaxSize = %ld; \n",travStackMaxSize);
fprintf(yoxOutG,"\n");
  } 




const char *ct15[] = { 
"                                                      /*stock*/  \n",
"struct yyyGenNode {void *parent;  \n",
"                   struct yyyGenNode **cL; \n",
"                   yyyRCT *refCountList; \n",
"                   yyyPNT prodNum;                      \n",
"                   yyyWST whichSym; \n",
"                  }; \n",
"\n",
"typedef struct yyyGenNode yyyGNT; \n",
"\n",
"\n",
"\n",
"struct yyyTB {int isEmpty; \n", 
"              int typeNum; \n",
"              int nAttrbs; \n",
"              char *snBufPtr; \n",
"              yyyWAT *startP,*stopP; \n",
"             };  \n",
"\n",
"\n",
"\n",
}; 



const char *ct17[] = { 
/*"yyyGNT *yyyCLempty; \n",*/
/*"#define yyyclLAMBDA (&yyyCLempty)\n",*/
"\n",
"struct yyyTB yyyTermBuffer; \n",
"\n",
"char *yyyNodeAndStackSpace; \n",
"\n",
"char *yyyNodeSpace;\n",
"char *yyyNextNodeSpace; \n",
"char *yyyAfterNodeSpace; \n",
"\n",
"\n",
" \n",
"struct yyyGenNode **yyyChildListSpace;  \n",
"struct yyyGenNode **yyyNextCLspace; \n",
"struct yyyGenNode **yyyAfterChildListSpace; \n",
"\n",
"\n",
"\n",
"yyyRCT *yyyRefCountListSpace;\n",
"yyyRCT *yyyNextRCLspace;  \n",
"yyyRCT *yyyAfterRefCountListSpace;   \n",
"\n",
"\n",
"\n",
"struct yyySolvedSAlistCell {yyyWAT attrbNum; \n",
"                            long next; \n",
"                           }; \n",
"#define yyyLambdaSSAL 0 \n",
"long yyySSALCfreeList = yyyLambdaSSAL; \n",
"long yyyNewSSALC = 1; \n",
" \n",
"struct yyySolvedSAlistCell *yyySSALspace; \n",
"\n",
"\n",
" \n",
"struct yyyStackItem {struct yyyGenNode *node; \n",
"                     long solvedSAlist; \n",
"                     struct yyyGenNode *oldestNode; \n", 
"                    };  \n",
"\n",
"int yyyYok = 1; \n",
"long yyyNbytesStackStg; \n",
"struct yyyStackItem *yyyStack; \n",
"struct yyyStackItem *yyyAfterStack; \n",
"struct yyyStackItem *yyyStackTop; \n",
"yyyGNT *yyySTN; \n",
"char *yyySTsn; \n",
"\n",
"\n",
"\n",
"struct yyyRSitem {yyyGNT *node; \n",
"                  yyyWST whichSym; \n",
"                  yyyWAT wa;  \n",
"                 };  \n",
"\n",
"struct yyyRSitem *yyyRS;  \n",
"struct yyyRSitem *yyyRSTop;  \n",
"struct yyyRSitem *yyyAfterRS;  \n",
" \n",
"\n", 
}; 




void compilerTextCopy1(void) 
  {int i; 
   fprintf(yoxOutG,"\n#include <stdio.h>\n\n"); 
   if (WSmax > UCHAR_MAX_MIN)
      fprintf(yoxOutG,"#define yyyR USHRT_MAX  \n\n");
      else
      fprintf(yoxOutG,"#define yyyR UCHAR_MAX  \n\n");
   fprintf(yoxOutG,
      " /* funny type; as wide as the widest of yyyWAT,yyyWST,yyyRCT  */ \n"
          );

   if ((WAmax >= UCHAR_MAX_MIN) ||  
       (RCmax > UCHAR_MAX_MIN) ||  
       (WSmax > UCHAR_MAX_MIN)
      )  
      fprintf(yoxOutG,"typedef unsigned short yyyFT;\n");  
      else 
      fprintf(yoxOutG,"typedef unsigned char yyyFT;\n");  
   printStorageSizes(); 
   for (i=0;i<(sizeof(ct17)/sizeof(char *));i++) fprintf(yoxOutG,ct17[i]); 
  } 
/**********************************************************************/ 




const char *ct2[] = { 
"\n",
"#define yyyNSof   \'n\' \n",
"#define yyyRCof   \'r\' \n",
"#define yyyCLof   \'c\' \n",
"#define yyySof    \'s\' \n",
"#define yyySSALof \'S\' \n",
"#define yyyRSof   \'q\' \n",
"#define yyyTSof   \'t\' \n",
"\n",
"\n",
"\n",
"\nvoid yyyfatal(msg)\n",
"  char *msg; \n",
"{fprintf(stderr,msg);exit(-1);} \n",
"\n",
"\n",
"\n",
"void yyyHandleOverflow(which) \n",
"  char which; \n",
"  {char *msg1,*msg2; \n",
"   int  oldSize,newSize; \n",
"   switch(which) \n",
"     {\n",
"      case yyyNSof   : \n",
"           msg1 = \"node storage overflow: \";\n",
"           oldSize = yyyMaxNbytesNodeStg; \n", 
"           break; \n",
"      case yyyRCof   : \n",
"           msg1 = \"dependee count overflow: \";\n",
"           oldSize = yyyMaxNrefCounts; \n", 
"           break; \n",
"      case yyyCLof   : \n",
"           msg1 = \"child list overflow: \";\n",
"           oldSize = yyyMaxNchildren; \n", 
"           break; \n",
"      case yyySof    : \n",
"           msg1 = \"parse-tree stack overflow: \";\n",
"           oldSize = yyyMaxStackSize; \n", 
"           break; \n",
"      case yyySSALof : \n",
"           msg1 = \"SSAL overflow: \";\n",
"           oldSize = yyySSALspaceSize; \n", 
"           break; \n",
"      case yyyRSof   : \n",
"           msg1 = \"ready set overflow: \";\n",
"           oldSize = yyyRSmaxSize; \n", 
"           break; \n",
"      case yyyTSof   : \n",
"           msg1 = \"traversal stack overflow: \";\n",
"           oldSize = yyyTravStackMaxSize; \n", 
"           break; \n",
"      default        :;  \n",
"     }\n",
"   newSize = (5*oldSize)/4; \n", 
"   if (newSize < 100) newSize = 100; \n",
"   fprintf(stderr,msg1); \n", 
"   fprintf(stderr,\"size was %%d.\\n\",oldSize); \n", 
"   if (yyyPermitUserAlloc) \n", 
"      msg2 = \"     Try -Y%%c%%d option.\\n\"; \n", 
"      else \n", 
"      msg2 = \"     Have to modify evaluator:  -Y%%c%%d.\\n\"; \n", 
"   fprintf(stderr,msg2,which,newSize); \n", 
"   exit(-1); \n",
"  }\n",
"\n",
"\n",
"\n",
"void yyySignalEnts(node,startP,stopP) \n",
"  register yyyGNT *node; \n",
"  register yyyFT *startP,*stopP;  \n",
"  {register yyyGNT *dumNode; \n",
#if DEBCTC 
"   fprintf(stderr,\"in yyySignalEnts: node: %%x \",node);\n", 
"   fprintf(stderr,\"ent list bounds: %%d %%d;  \\n\",\n",
"                  startP-yyyEntL,stopP-yyyEntL \n",
"          ); \n",
#endif
"\n", 
"   while (startP < stopP)  \n",
"     {\n",
"      if (!(*startP)) dumNode = node;  \n",
"         else dumNode = (node->cL)[(*startP)-1];   \n",
#if DEBCTC 
"      fprintf(stderr,\"%%s %%x attrb %%d         /****/   to %%d\\n\",\n", 
"                     \"decrementing ref count of node \",\n",  
"                     dumNode,*(startP+1), \n",
"                     (dumNode->refCountList)[*(startP+1)] - 1\n",
"             );\n", 
#endif
"      if (!(--((dumNode->refCountList)[*(startP+1)]\n",
"              ) \n",
"           )\n",
"         ) \n",
"         { \n",
"          if (++yyyRSTop == yyyAfterRS) \n",
"             {yyyHandleOverflow(yyyRSof); \n",
"              break; \n",
"             }\n",
"          yyyRSTop->node = dumNode; \n",
"          yyyRSTop->whichSym = *startP;  \n",
"          yyyRSTop->wa = *(startP+1);  \n",
#if DEBCTC 
"  fprintf(stderr,\"readying:  node: %%x  whichSym: %%d  wa: %%d\\n\",\n",
"          dumNode,*startP,*(startP+1)\n",
"         ); \n",
#endif
"         }  \n",
"      startP += 2;  \n",
"     }  \n",
"  } \n",
}; 


void compilerTextCopy2(void) 
  {int i; 
   fprintf(yoxOutG,"\n#define yyyPermitUserAlloc "); 
   fprintf(yoxOutG,(genEvUserCLoptsCode?" 1 \n\n" : " 0 \n\n")); 
   for (i=0;i<(sizeof(ct2)/sizeof(char *));i++) fprintf(yoxOutG,ct2[i]); 
  } 
/**********************************************************************/ 




const char *ct3[] = { 
"int yyyInitDone = 0; \n\n\n",
"\nyyyYoxInit()                                       /*stock*/  \n",
"  { \n",
"\n",
"   yyyNodeSizeCalc(); \n",
"\n",
"   if ((yyyTermBuffer.snBufPtr = \n",
"        (char *) malloc(yyyBiggestNodeSize + sizeof(yyyCopyType))\n",
"       )  \n",
"       == \n",
"       ((char *) NULL) \n",
"      )   \n",
"      yyyfatal(\"malloc error in yyyTermBuffer allocation\\n\");  \n",
"  \n",
"  \n",
"   yyyNbytesStackStg = yyyMaxStackSize*sizeof(struct yyyStackItem); \n",
"   yyyNbytesStackStg = ",
"((yyyNbytesStackStg/yyyAlignSize)+1)*yyyAlignSize;  \n",
"   if ((yyyNodeAndStackSpace = \n",
"        (char *) malloc(yyyNbytesStackStg + \n",
"                        yyyMaxNbytesNodeStg + \n",
"                        yyyGNSz + \n",
"                        yyyBiggestNodeSize + \n",
"                        sizeof(yyyCopyType) \n",
"                       )\n",
"       )  \n",
"       == \n",
"       ((char *) NULL) \n",
"      )   \n",
"      yyyfatal(\"malloc error in ox node and stack space allocation\\n\");\n",
"   yyyStack = (struct yyyStackItem *) yyyNodeAndStackSpace; \n",
"   yyyAfterStack = yyyStack + yyyMaxStackSize;  \n",
"   yyyNodeSpace = yyyNodeAndStackSpace + yyyNbytesStackStg;\n",
"   yyyAfterNodeSpace = yyyNodeSpace + yyyMaxNbytesNodeStg;\n",
" \n",
#if DEBCTC 
"   fprintf(stderr,\"yyyNodeSpace == %%x\\n\",yyyNextNodeSpace); \n",
#endif
" \n",
"   if ((yyyRS = (struct yyyRSitem *) \n",
"         malloc((yyyRSmaxSize+1)*sizeof(struct yyyRSitem))\n",
"       )  \n",
"       == \n",
"       ((struct yyyRSitem *) NULL) \n",
"      )   \n",
"      yyyfatal(\"malloc error in ox ready set space allocation\\n\");  \n",
"   yyyRS++; \n",
"   yyyAfterRS = yyyRS + yyyRSmaxSize; \n",
"\n",
" \n",
"   if ((yyyChildListSpace = \n",
"        (yyyGNT **) malloc(yyyMaxNchildren*sizeof(yyyGNT *))\n",
"       )  \n",
"       == \n",
"       ((yyyGNT **) NULL) \n",
"      )   \n",
"      yyyfatal(\"malloc error in ox child list space allocation\\n\");  \n",
"   yyyAfterChildListSpace = yyyChildListSpace + yyyMaxNchildren; \n",
"\n",
" \n",
"   if ((yyyRefCountListSpace = \n",
"        (yyyRCT *) malloc(yyyMaxNrefCounts * sizeof(yyyRCT))\n",
"       )  \n",
"       == \n",
"       ((yyyRCT *) NULL) \n",
"      )   \n",
"      yyyfatal(\"malloc error in ox reference ",
"count list space allocation\\n\");  \n",
"   yyyAfterRefCountListSpace = yyyRefCountListSpace + yyyMaxNrefCounts;  \n",
"  \n",
" \n",
"   if ((yyySSALspace = (struct yyySolvedSAlistCell *) \n",
"          malloc((yyySSALspaceSize+1) * sizeof(struct yyySolvedSAlistCell))\n",
"       ) \n",
"       == \n",
"       ((struct yyySolvedSAlistCell *) NULL) \n",
"      ) \n",
"      yyyfatal(\"malloc error in stack solved list space allocation\\n\"); \n",
"  } /* yyyYoxInit */ \n",
"\n",
"\n",
"\n",
"void yyyYoxReset() \n",
"  { \n",
"   yyyTermBuffer.isEmpty = 1; \n",
"   yyyStackTop = yyyStack; \n",
"   while (yyyStackTop != yyyAfterStack) \n",
"     (yyyStackTop++)->solvedSAlist = yyyLambdaSSAL; \n",
"   yyyStackTop = yyyStack - 1; \n",
"   yyyNextNodeSpace = yyyNodeSpace; \n",
"   yyyRSTop = yyyRS - 1; \n",
"   yyyNextCLspace = yyyChildListSpace;\n",
"   yyyNextRCLspace = yyyRefCountListSpace; \n",
"  }  \n",
"\n",
"\n",
"\n",
"void yyyDecorate() \n",
"  { \n",
#if DEBCTC 
"   fprintf(stderr,\"\\n\\n\\ndecorating\\n\"); \n",
"   fprintf(stderr,\"/******************************************/\\n\"); \n",
#endif
"   while (yyyRSTop >= yyyRS) \n",
"@@u     { \n",
"      yyySolveAndSignal();  \n",
"@@u      yyyDecSolvedInstCount++;\n",
"@@u     } \n",
"  } \n",
"\n",
"\n",
"\n",
"int yyyProdNum,yyyRHSlength,yyyNattrbs,yyyTypeNum; \n",
"\n",
"#define yyyRSU(NUM1,NUM2,NUM3,NUM4) \\\n",
"   yyyProdNum=NUM1;yyyRHSlength=NUM2;yyyNattrbs=NUM3;yyyTypeNum=NUM4;",
"\n",
"\n",
"\n",
"\n",
"void yyyShift() \n",
"  {yyyRCT *rcPdum; \n",
"   register yyyCopyType *CTp1,*CTp2,*CTp3; \n",
"   register yyyWAT *startP,*stopP;  \n",
"\n",
"@@sint sh2,jj;\n",
"   if ((++yyyStackTop) == yyyAfterStack) \n",
"      yyyHandleOverflow(yyySof);\n",
"   CTp2 = (yyyCopyType *)(yyyStackTop->oldestNode = \n", 
"                          yyyStackTop->node = \n", 
"                          (yyyGNT *)yyyNextNodeSpace \n", 
"                         ); \n",
"   yyyTermBuffer.isEmpty = 1;\n",  
/* "   if (!yyyTermBuffer.typeNum) return; \n", */  
"   ((yyyGNT *)CTp2)->parent = (void *)yyyStackTop; \n",
"   ((yyyGNT *)CTp2)->cL = yyyNextCLspace;  \n",
"   rcPdum = ((yyyGNT *)CTp2)->refCountList = yyyNextRCLspace;  \n",
"   ((yyyGNT *)CTp2)->prodNum = 0; \n", 
"   if ((yyyNextRCLspace += yyyTermBuffer.nAttrbs) \n", 
"       > \n", 
"       yyyAfterRefCountListSpace \n", 
"      ) \n",
"      yyyHandleOverflow(yyyRCof); \n",
"   startP = yyyTermBuffer.startP;  \n",
"   stopP = yyyTermBuffer.stopP;  \n",
"   while (startP < stopP) rcPdum[*(startP++)] = 0; \n",
"   if ((yyyNextNodeSpace += yyyNdPrSz[yyyTermBuffer.typeNum]) \n", 
"       > \n", 
"       yyyAfterNodeSpace \n", 
"      ) \n",
"      yyyHandleOverflow(yyyNSof);  \n",
"   CTp1 = (yyyCopyType *)(yyyTermBuffer.snBufPtr); \n",
"   CTp2 = (yyyCopyType *)(((char *)CTp2) + yyyGNSz); \n", 
"   CTp3 = CTp2 + yyyNdCopySz[yyyTermBuffer.typeNum]; \n",
"   while (CTp2 < CTp3) *CTp2++ = *CTp1++; \n", 
"@@ssh2 = yyyStackTop-yyyStack+1; \n",
"@@sfprintf(stderr,\"Shift\"); \n",
"@@sfor (jj=0;jj<sh2;jj++) \n",
"@@s    fprintf(stderr,\"%%5d\",(yyyStack[jj].node)->prodNum); \n",
"@@sfprintf(stderr,\"\\n\"); \n",
"  } \n",
"\n",
"\n",
"\n",
"void yyyGenIntNode() \n",
"  {register yyyWST i;\n",
"   register struct yyyStackItem *stDum;  \n",
"   register yyyGNT *gnpDum; \n", 
"\n",
"@@sint sh2,jj; \n",
"@@u   yyyIntInstanceCount += yyyNattrbs; yyyIntNodeCount++;\n",
"   if ((yychar <= 0) && (!yyyTermBuffer.isEmpty)) yyyShift(); \n",
"   if ((stDum = (yyyStackTop -= (yyyRHSlength-1))) >= yyyAfterStack) \n",
"      yyyHandleOverflow(yyySof);\n",
"   yyySTsn = ((char *)(yyySTN = (yyyGNT *)yyyNextNodeSpace)) + yyyGNSz; \n",
"   yyySTN->parent       =  (void *)yyyStackTop;  \n",
"   yyySTN->cL           =  yyyNextCLspace; \n",
"   yyySTN->refCountList =  yyyNextRCLspace; \n",
"   yyySTN->prodNum      =  yyyProdNum; \n",
"   if ((yyyNextCLspace+yyyRHSlength) > yyyAfterChildListSpace) \n",
"      yyyHandleOverflow(yyyCLof); \n",
"   for (i=1;i<=yyyRHSlength;i++) \n",
"     {gnpDum = *(yyyNextCLspace++) = (stDum++)->node;  \n",
"      gnpDum->whichSym = i;  \n",
"      gnpDum->parent = (void *)yyyNextNodeSpace; \n",
"     } \n",
/* "   yyySTN->parent       =  (void *)yyyStackTop; \n", */ 
"   if ((yyyNextRCLspace += yyyNattrbs) > yyyAfterRefCountListSpace) \n",
"      yyyHandleOverflow(yyyRCof); \n",
"   if ((yyyNextNodeSpace += yyyNdPrSz[yyyTypeNum]) > yyyAfterNodeSpace) \n",
"      yyyHandleOverflow(yyyNSof);  \n",
"@@syyyStackTop->node = yyySTN;\n",
"@@ssh2 = yyyStackTop-yyyStack+1; \n",
"@@sfprintf(stderr,\"R    \",sh2); \n",
"@@sfor (jj=0;jj<sh2;jj++) \n",
"@@s    fprintf(stderr,\"%%5d\",(yyyStack[jj].node)->prodNum); \n",
"@@sfprintf(stderr,\"\\n\"); \n",
"  } \n",
"\n",
"\n",
"\n",
"#define DECORfREQ 50 \n",
"\n",
"\n",
"\n",
"void yyyAdjustINRC(startP,stopP) \n",
"  register yyyFT *startP,*stopP;\n",
"  {yyyWST i;\n",
"   long SSALptr,SSALptrHead,*cPtrPtr; \n",
"   long *pL; \n",
"   struct yyyStackItem *stDum;  \n",
"   yyyGNT *gnpDum; \n", 
"   long iTemp;\n",
"   register yyyFT *nextP;\n",
"   static unsigned short intNodeCount = DECORfREQ;\n",
"\n",
#if DEBCTC 
"   fprintf(stderr,\"initializing ref counts IN %%d %%d \\n\",\n",
"                  startP-yyyRCIL,\n",
"                  stopP-yyyRCIL\n",
"          );\n",
#endif
"   nextP = startP;\n",  
"   while (nextP < stopP) \n",
"     {if ((*nextP) == yyyR)  \n",
"         {(yyySTN->refCountList)[*(nextP+1)] = *(nextP+2);\n",
#if DEBCTC 
"   fprintf(stderr,\"      %%x %%d %%d\\n\",yyySTN,*(nextP+1),*(nextP+2)); \n",
#endif
"         } \n", 
"         else \n",
"         {(((yyySTN->cL)[*nextP])->refCountList)[*(nextP+1)] = *(nextP+2);\n",
#if DEBCTC 
"   fprintf(stderr,\"      %%x %%d %%d\\n\",(yyySTN->cL)[*nextP],\n",
"                  *(nextP+1),\n",
"                  *(nextP+2)\n",
"          );\n",
#endif
"         } \n", 
"      nextP += 3;  \n",
"     }\n",
"   pL = yyyIIEL + yyyIIIEL[yyyProdNum]; \n",
"   stDum = yyyStackTop;  \n",
"   for (i=1;i<=yyyRHSlength;i++) \n",
"     {pL++; \n",
"      SSALptrHead = SSALptr = *(cPtrPtr = &((stDum++)->solvedSAlist)); \n",
"      if (SSALptr != yyyLambdaSSAL) \n",
"         {*cPtrPtr = yyyLambdaSSAL; \n",
"          do \n",
"            {\n",
"             iTemp = (*pL+yyySSALspace[SSALptr].attrbNum);\n",
#if DEBCTC 
"             fprintf(stderr,\"%%s  %%d %%d\",\n",
"                            \"\\nsignalling ents of SSA: \\n\",\n",
"                            i,\n",
"                            yyySSALspace[SSALptr].attrbNum \n",
"                    );  \n",
#endif
"             yyySignalEnts(yyySTN,\n",
"                           yyyEntL + yyyIEL[iTemp],\n",
"                           yyyEntL + yyyIEL[iTemp+1]\n",
"                          );  \n",
"             SSALptr = *(cPtrPtr = &(yyySSALspace[SSALptr].next)); \n",
"            } \n",
"            while (SSALptr != yyyLambdaSSAL);  \n",
"          *cPtrPtr = yyySSALCfreeList;  \n",
"          yyySSALCfreeList = SSALptrHead;  \n",
"         } \n",
"     } \n",
"   nextP = startP + 2;\n",  
"   while (nextP < stopP) \n",
"     {if (!(*nextP))\n",  
"         {if ((*(nextP-2)) == yyyR)  \n",
"             {pL = &(yyyStackTop->solvedSAlist); \n",
"              if (yyySSALCfreeList == yyyLambdaSSAL) \n",
"                 {yyySSALspace[yyyNewSSALC].next = *pL; \n",
"                  if ((*pL = yyyNewSSALC++) == yyySSALspaceSize) \n",
"                     yyyHandleOverflow(yyySSALof); \n",
"                 }  \n",
"                 else\n",
"                 {iTemp = yyySSALCfreeList; \n",
"                  yyySSALCfreeList = yyySSALspace[yyySSALCfreeList].next; \n",
"                  yyySSALspace[iTemp].next = *pL; \n",
"                  *pL = iTemp;  \n",
"                 } \n",
"              yyySSALspace[*pL].attrbNum = *(nextP-1); \n",
"             } \n",
"             else \n",
"             {if ((gnpDum = (yyySTN->cL)[*(nextP-2)])->prodNum != 0)\n", 
"                 {\n", 
"                  iTemp = yyyIIEL[yyyIIIEL[gnpDum->prodNum]] + *(nextP-1);\n",
#if DEBCTC 
"                  fprintf(stderr,\"%%s\",\n",
"                                 \"\\nsignalling ents of 0-init IN: \\n\"\n",
"                         );  \n",
#endif
"                  yyySignalEnts(gnpDum, \n",
"                                yyyEntL + yyyIEL[iTemp],  \n", 
"                                yyyEntL + yyyIEL[iTemp+1] \n",
"                               );    \n",
"                 }  \n",
"             } \n",
"         } \n",
"      nextP += 3; \n", 
"     } \n",
"   yyyStackTop->node = yyySTN;\n", 
"   if (!yyyRHSlength) yyyStackTop->oldestNode = yyySTN; \n",
"   if (!--intNodeCount) \n",
"      {intNodeCount = DECORfREQ; \n",
"       yyyDecorate(); \n",
"      } \n",
"  } \n",
"\n",
"\n",
"\n",
"void yyyPrune() \n",
"  {  \n",
"   int i,n; \n",
"   register char *cp1,*cp2;  \n", 
"   register yyyRCT *rcp1,*rcp2,*rcp3;  \n", 
"   long cycleSum = 0;\n",
"   long nNZrc = 0;\n",
"   \n",
"   yyyDecorate();\n",
/* "   if ((yyyStackTop->oldestNode) == (yyyStackTop->node)) return; \n", */ 
"@@uif ((yyyTempUsed = (yyyNextRCLspace - yyyRefCountListSpace)) > \n",  
"@@u    yyyMaxNrefCountsUsed \n", 
"@@u   ) \n",  
"@@u   yyyMaxNrefCountsUsed = yyyTempUsed;  \n",  
"@@u    \n",  
"@@uif ((yyyTempUsed = (yyyNextCLspace - yyyChildListSpace)) > \n",  
"@@u    yyyMaxNchildrenUsed \n", 
"@@u   ) \n",  
"@@u   yyyMaxNchildrenUsed = yyyTempUsed;  \n",  
"@@u    \n",  
"@@uif ((yyyTempUsed = (yyyNextNodeSpace - yyyNodeSpace)) > \n",  
"@@u    yyyMaxNnodeBytesUsed \n", 
"@@u   ) \n",  
"@@u   yyyMaxNnodeBytesUsed = yyyTempUsed;  \n",  
"@@u    \n",  
"   yyyNextRCLspace = \n", 
"     (rcp1 = rcp2 = (yyyStackTop->oldestNode)->refCountList) + yyyNattrbs;\n",
"   rcp3 = (yyyStackTop->node)->refCountList; \n",
"   while (rcp2 < rcp3) \n", 
"     if (*rcp2++) {cycleSum += *(rcp2 -1); nNZrc++;} \n",
"   if (cycleSum) \n",
"      {\n",
"@@c       fprintf(stderr,\"pruning cycle: average ref count == %%f.\\n\", \n",
"@@c               (float)(cycleSum/nNZrc) \n",
"@@c              ); \n",
"       return; \n",
"      }\n",
"   for (i=0;i<yyyNattrbs;i++) rcp1[i] = rcp3[i]; \n", 
"   yyyNextCLspace = (yyyStackTop->oldestNode)->cL; \n", 
"   yyyNextNodeSpace = (char *)(yyyStackTop->oldestNode) + \n", 
"                      (n = yyyNdPrSz[yyyTypeNum]);\n", 
"   cp1 = (char *)yyyStackTop->oldestNode; \n", 
"   cp2 = (char *)yyyStackTop->node; \n", 
"   for (i=0;i<n;i++) *cp1++ = *cp2++; \n", 
"   yyyStackTop->node = yyyStackTop->oldestNode; \n", 
"   (yyyStackTop->node)->refCountList = rcp1; \n", 
"   (yyyStackTop->node)->cL = yyyNextCLspace; \n", 
"  } \n",
"\n",
"\n",
"\n",
"void yyyGenLeaf(nAttrbs,typeNum,startP,stopP) \n",
"  int nAttrbs,typeNum; \n",
"  yyyWAT *startP,*stopP; \n", 
"  {\n",
#if DEBCTC 
"   fprintf(stderr,\"\\ngenerating leaf node: %%x  type number %%d\\n\",\n",
"                  yyyNextNodeSpace,\n",
"                  typeNum\n", 
"          );\n", 
#endif
"@@u   yyyLeafInstanceCount += nAttrbs; yyyLeafNodeCount++;\n",
"@@u   if (!nAttrbs) yyyAttrblessLeafNodeCount++;\n",
"   if  (!(yyyTermBuffer.isEmpty)) yyyShift(); \n",
"   yyyTermBuffer.isEmpty = 0;\n", 
"   yyyTermBuffer.typeNum = typeNum; \n", 
"   yyyTermBuffer.nAttrbs = nAttrbs; \n", 
"   yyyTermBuffer.startP = startP; \n", 
"   yyyTermBuffer.stopP = stopP; \n", 
"   \n", 
"  } \n",
"\n",
"\n",
"\n",
"void yyyerror()\n",
"  {yyyYok = 0; \n",
"  } \n",
"\n",
"\n",
"\n",
}; 



void compilerTextCopy3(void) 
  {printStringArray(ct3,sizeof(ct3),yoxOutG); 
   outputUserOptsCode(); 
  }



const char *ct4[] = { 
"} /* switch */ \n\n", 
"if (yyyws)  /* the just-solved instance was inherited. */ \n",
"   {if (yyyRSTopN->prodNum) \n",  
"       {yyyiDum = yyyIIEL[yyyIIIEL[yyyRSTopN->prodNum]] + yyywa;\n",
#if DEBCTC 
"        fprintf(stderr,\"%%s\",\n",
"                 \"\\nsignalling ents of attrb in yyyS.A.S. trailer: \\n\"\n",
"               );  \n",
#endif
"        yyySignalEnts(yyyRSTopN,yyyEntL + yyyIEL[yyyiDum],\n", 
"                                yyyEntL + yyyIEL[yyyiDum+1]\n",
"                     );\n",
"       }\n",
"   } \n",  
"   else     /* the just-solved instance was synthesized. */ \n",
"   {if ((char *)yyyRSTopNp >= yyyNodeSpace) /* node has a parent. */ \n",
"       {yyyiDum = yyyIIEL[yyyIIIEL[((yyyGNT *)yyyRSTopNp)->prodNum] + \n",
"                          yyyRSTopN->whichSym \n", 
"                         ] + \n", 
"                  yyywa;\n",
#if DEBCTC 
"        fprintf(stderr,\"%%s\",\n",
"                 \"\\nsignalling ents of attrb in yyyS.A.S. trailer: \\n\"\n",
"               );  \n",
#endif
"        yyySignalEnts((yyyGNT *)yyyRSTopNp,\n", 
"                      yyyEntL + yyyIEL[yyyiDum],\n", 
"                      yyyEntL + yyyIEL[yyyiDum+1] \n", 
"                     );\n",
"       } \n",
"       else   /* node is still on the stack--it has no parent yet. */ \n",
"       {yyypL = &(((struct yyyStackItem *)yyyRSTopNp)->solvedSAlist); \n",
"        if (yyySSALCfreeList == yyyLambdaSSAL) \n",
"           {yyySSALspace[yyyNewSSALC].next = *yyypL; \n",
"            if ((*yyypL = yyyNewSSALC++) == yyySSALspaceSize) \n",
"               yyyHandleOverflow(yyySSALof); \n",
"           }  \n",
"           else\n",
"           {yyyiDum = yyySSALCfreeList; \n",
"            yyySSALCfreeList = yyySSALspace[yyySSALCfreeList].next; \n",
"            yyySSALspace[yyyiDum].next = *yyypL; \n",
"            *yyypL = yyyiDum;  \n",
"           } \n",
"        yyySSALspace[*yyypL].attrbNum = yyywa; \n",
"       } \n",
"   }\n", 
"\n",
"} /* yyySolveAndSignal */ \n", 
"@@u\n", 
"@@u\n", 
"@@u\n", 
"@@ulong yyyMaxNrefCountsUsed = 0; \n",
"@@ulong yyyMaxNchildrenUsed = 0; \n",
"@@ulong yyyMaxNnodeBytesUsed = 0; \n",
"@@ulong yyyTempUsed = 0; \n",
"@@ulong yyyIntInstanceCount = 0; long yyyIntNodeCount = 0;\n",
"@@ulong yyyLeafInstanceCount = 0; long yyyLeafNodeCount = 0;\n",
"@@ulong yyyAttrblessLeafNodeCount = 0;\n",
"@@ulong yyyDecSolvedInstCount = 0;\n",
"\n", 
"\n", 
"\n", 
"void yyyExecuteRRsection()  {\n",
"   int yyyi; \n", 
"   long yyynRefCounts; \n", 
"@@u long yyyTotalPTstgUsed;\n",  
"   long cycleSum = 0;\n",
"   long nNZrc = 0;\n",
"\n",
#if DEBCTC 
"  fprintf(stderr,\"\\n\\n\\nin yyyExecuteRRsection \\n\");\n",
"  fprintf(stderr,\"\\n/******************************************/ \\n\");\n",
#endif
"   if (!yyyYok) return; \n", 
"@@uif ((yyyTempUsed = (yyyNextRCLspace - yyyRefCountListSpace)) > \n",  
"@@u    yyyMaxNrefCountsUsed \n", 
"@@u   ) \n",  
"@@u   yyyMaxNrefCountsUsed = yyyTempUsed;  \n",  
"@@u    \n",  
"@@uif ((yyyTempUsed = (yyyNextCLspace - yyyChildListSpace)) > \n",  
"@@u    yyyMaxNchildrenUsed \n", 
"@@u   ) \n",  
"@@u   yyyMaxNchildrenUsed = yyyTempUsed;  \n",  
"@@u    \n",  
"@@uif ((yyyTempUsed = (yyyNextNodeSpace - yyyNodeSpace)) > \n",  
"@@u    yyyMaxNnodeBytesUsed \n", 
"@@u   ) \n",  
"@@u   yyyMaxNnodeBytesUsed = yyyTempUsed;  \n",  
"@@u    \n",  
"@@ufprintf(stderr,\"Size of input: %%8d tokens\\n\\n\",\n",
"@@u        yyyLeafNodeCount\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"Parse-tree Storage Maximum Usages:     \");\n",
"@@ufprintf(stderr,\"    used/allocated\\n\"); \n",
"@@ufprintf(stderr,\"     n: bytes of node storage:         %%8d/%%8d\\n\",\n",
"@@u        yyyMaxNnodeBytesUsed,yyyMaxNbytesNodeStg\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"     c: number of child pointers:      %%8d/%%8d\\n\",\n",
"@@u        yyyMaxNchildrenUsed,yyyMaxNchildren\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"     r: number of dependee counts:     %%8d/%%8d\\n\",\n",
"@@u        yyyMaxNrefCountsUsed,yyyMaxNrefCounts\n", 
"@@u       );\n", 
"@@u        yyyTotalPTstgUsed = yyyMaxNnodeBytesUsed +\n", 
"@@u        (yyyMaxNchildrenUsed * sizeof(yyyGNT *)) +\n", 
"@@u        yyyMaxNrefCountsUsed;\n", 
"@@ufprintf(stderr,\"Maximum Parse-tree Storage Used:       %%8d bytes\\n\",\n",
"@@u        yyyTotalPTstgUsed\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"\\n\");\n",
"@@ufprintf(stderr,\"%%8d attribute instances in %%8d leaf nodes \\n\",\n",
"@@u        yyyLeafInstanceCount,yyyLeafNodeCount\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"%%8d attribute instances in %%8d interior nodes \\n\",\n",
"@@u        yyyIntInstanceCount,yyyIntNodeCount\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"%%8d attribute instances in %%8d parse-tree nodes\\n\",\n",
"@@u        yyyIntInstanceCount + yyyLeafInstanceCount,\n", 
"@@u        yyyIntNodeCount + yyyLeafNodeCount\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\n",
"@@u        \"%%8d attribute instances solved during decorations\\n\",\n",
"@@u        yyyDecSolvedInstCount\n",
"@@u       );\n", 
"@@ufprintf(stderr,\"        %%8d/%%d = %%.3f \\n\",\n",
"@@u        yyyDecSolvedInstCount,\n",
"@@u        yyyIntInstanceCount + yyyLeafInstanceCount,\n", 
"@@u        ((float)yyyDecSolvedInstCount)/\n",
"@@u        ((float)(yyyIntInstanceCount + yyyLeafInstanceCount))\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"%%8d attributeless leaf nodes \\n\",\n",
"@@u        yyyAttrblessLeafNodeCount\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"\\n\");\n",
"@@ufprintf(stderr,\"# parse-tree nodes / # leaf nodes = %%5.2f \\n\",\n",
"@@u        (yyyIntNodeCount + yyyLeafNodeCount) /\n", 
"@@u        (float)yyyLeafNodeCount\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"# leaf attribute instances / \");\n",
"@@ufprintf(stderr,\"# leaf nodes = %%5.2f\\n\",\n",
"@@u        yyyLeafInstanceCount /\n", 
"@@u        (float)yyyLeafNodeCount\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"# interior attribute instances / \");\n",
"@@ufprintf(stderr,\"# interior nodes = %%5.2f\\n\",\n",
"@@u        yyyIntInstanceCount /\n", 
"@@u        (float)yyyIntNodeCount\n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"total # attribute instances / \");\n",
"@@ufprintf(stderr,\"# parse-tree nodes = %%5.2f\\n\",\n",
"@@u        (yyyIntInstanceCount + yyyLeafInstanceCount) /\n", 
"@@u        (float)(yyyIntNodeCount + yyyLeafNodeCount) \n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"maximum parse-tree storage used /\");\n",
"@@ufprintf(stderr,\" # parse-tree nodes = %%4.1f bytes\\n\",\n",
"@@u        (float)yyyTotalPTstgUsed / \n", 
"@@u        (yyyIntNodeCount + yyyLeafNodeCount) \n", 
"@@u       );\n", 
"@@ufprintf(stderr,\"maximum parse-tree storage used /\");\n",
"@@ufprintf(stderr,\" # tokens = %%4.1f bytes\\n\",\n",
"@@u        yyyTotalPTstgUsed / \n", 
"@@u        (float)yyyLeafNodeCount \n", 
"@@u       );\n", 
"   yyynRefCounts = yyyNextRCLspace - yyyRefCountListSpace; \n", 
"   for (yyyi=0;yyyi<yyynRefCounts;yyyi++) \n",
"     if (yyyRefCountListSpace[yyyi])\n",
"        {cycleSum += yyyRefCountListSpace[yyyi]; nNZrc++;} \n",
"   if (cycleSum) \n",
"      {\n",
"@@c       fprintf(stderr,\n",
"@@c               \"postdecoration cycle: average ref count == %%f.\\n\", \n",
"@@c               (float)(cycleSum/nNZrc) \n",
"@@c              ); \n",
"      }\n",
"   yyyDoTraversals();\n",
}; 



void printSAStrailer(void) 
  {printStringArray(ct4,sizeof(ct4),temp1Out); 
  }



const char *ct5[] = { 
"\n",
"extern struct yyyTB yyyTermBuffer; \n", 
"extern yyyWAT yyyLRCIL[]; \n",
"extern void yyyGenLeaf(); \n", 
"\n"  
}; 



void compilerTextCopy5(void) 
  {int i; 
fprintf(yoxOutH, 
"                                                      /*custom*/  \n"
       ); 
fprintf(yoxOutH,(WAmax < UCHAR_MAX_MIN)? 
                   "typedef unsigned char yyyWAT; \n":
                   "typedef unsigned short yyyWAT; \n" 
       ); 
fprintf(yoxOutH,(RCmax <= UCHAR_MAX_MIN)? 
                   "typedef unsigned char yyyRCT; \n":
                   "typedef unsigned short yyyRCT; \n" 
       ); 
fprintf(yoxOutH,(prodNumSeq <= UCHAR_MAX_MIN)? 
                   "typedef unsigned char yyyPNT; \n":
                   "typedef unsigned short yyyPNT; \n" 
       ); 
fprintf(yoxOutH,(WSmax <= UCHAR_MAX_MIN)? 
                   "typedef unsigned char yyyWST; \n":
                   "typedef unsigned short yyyWST; \n" 
       ); 
   for (i=0;i<(sizeof(ct15)/sizeof(char *));i++) fprintf(yoxOutH,ct15[i]); 
   for (i=0;i<(sizeof(ct5)/sizeof(char *));i++) fprintf(yoxOutH,ct5[i]); 
  } 
/**********************************************************************/ 


const char *ct6[] = { 
"\n\n\nyyySolveAndSignal() {\n", 
"register long yyyiDum,*yyypL;\n",
"register int yyyws,yyywa;\n",
"register yyyGNT *yyyRSTopN,*yyyRefN; \n",
"register void *yyyRSTopNp; \n",
"\n", 
"\nyyyRSTopNp = (yyyRSTopN = yyyRSTop->node)->parent;\n", 
"yyyRefN= (yyyws = (yyyRSTop->whichSym))?((yyyGNT *)yyyRSTopNp):yyyRSTopN;\n",
#if DEBCTC 
"\nfprintf(stderr,\"%%s\",\n",
"               \"\\nentering yyyS.A.S. switch: \\n\"\n",
"       );  \n\n",
#endif
"yyywa = yyyRSTop->wa; \n",
"yyyRSTop--;\n",
"switch(yyyRefN->prodNum) {\n",
};  



void printSASheader(void) 
  {int i; 
   for (i=0;i<(sizeof(ct6)/sizeof(char *));i++) fprintf(temp1Out,ct6[i]); 
  } 
/**********************************************************************/ 


