/* $Id: opts.h 689 2018-01-19 23:56:34Z Tom Shields $ */ 

/* The information in this file is the intellectual property of 
 * Kurt M. Bischoff.  It may not be used, copied, or transferred 
 * without permission from the author. 
 *
 * Copyright (c) 1992, Kurt M. Bischoff.  All rights reserved.
 *
 * Beta Test Release--not for general distribution.
 */ 

extern const char *yoxInFileStrL; 
extern char *yoxInFileStrG; 
extern const char *yoxOutFileStrH; 

extern void handleOverflow(char);

extern FILE *yoxOutG; 

extern int nLfiles; 
extern int currentLfile; 
struct LfileRec {char *inName,*outName; 
                 FILE *inPtr,*outPtr; 
                };  
extern struct LfileRec Lfile[]; 

extern int alignSize; 
extern int buildHeaderFile; 
extern int suppressPruning; 
extern int neutralizeSemActions; 
extern int stripOxConstructs; 
extern int showPTsizeStats; 
extern int showStackOps; 
extern int suppressCycleReports;
extern int genEvUserCLoptsCode; 
extern int CSCDMeqCSCM; 

extern long maxNbytesNodeStg; 
extern long maxNrefCounts   ; 
extern long maxNchildren    ; 
extern long maxStackSize    ;
extern long SSALspaceSize   ; 
extern long RSmaxSize       ; 
extern long travStackMaxSize;

extern long macTabSz        ;
extern long macFrmPrmSpSz   ; 
extern long macBodyStgSz    ;
extern long macStackSz      ;
extern long macActPrmSpSz   ; 
extern long macActPrmStgSz  ; 


extern FILE *sfopen(const char *,const char *); 


#define NPDS  'N'          /* maxNentsPerDepSpec      */  
#define EPDS  'E'          /* maxNeesPerDepSpec       */  
#define AOPP  'i'          /* maxNattrbOccrsPerProd   */  
#define LGNS  'n'          /* ldgNodeStgSize          */  
#define PRDL  'p'          /* maxProdLength           */  
#define NAPS  'a'          /* maxNattrbsPerSym        */  
#define RSBS  'r'          /* refSegBufferSize        */  
#define NTRM  't'          /* maxNterms               */  
#define NSTR  's'          /* maxNstrings             */  
#define MNGS  'g'          /* maxNgSyms               */  
#define MNST  'T'          /* maxNstructTags          */  
#define NPRD  'P'          /* maxNprods               */  

#define NMCD  'M'          /* macTabSz                */ 
#define NMFP  'F'          /* macFrmPrmSpSz           */
#define MBSS  'B'          /* macBodyStgSz            */ 
#define MSSZ  'm'          /* macStackSz              */ 
#define NMAP  'A'          /* macActPrmSpSz           */ 
#define MAPS  'S'          /* macActPrmStgSz          */ 
#define NTRV  'v'          /* maxNtravs               */ 
#define NTSB  'b'          /* maxNtravSegBufs         */ 

extern int maxNentsPerDepSpec;        
extern int maxNeesPerDepSpec;         
extern int maxNattrbOccrsPerProd;     
extern int ldgNodeStgSize;            
extern int maxProdLength;            
extern int maxNattrbsPerSym;          
extern long maxNterms;                 
extern int maxNstrings;               
extern int maxNgSyms;                 
extern int maxNstructTags;            
extern int maxNprods; 

extern int WAmax; 
extern int RCmax; 
extern int PNmax; 
extern int WSmax; 

extern void rmOutputFiles(void); 

