/*
  tiny - C
*/

/* types of identifiers */
%token TK_IDENTIFIER

/* types of constants */
%token TK_ICONSTANT

/* simple operators */
%token TK_PTR TK_INC TK_DEC TK_LE TK_GE TK_EQ TK_NE
%token TK_AND TK_OR TK_DOT


/* keywords */
%token TK_EXTERN 
%token TK_INT 
%token TK_STRUCT
%token TK_IF TK_ELSE TK_WHILE TK_DO TK_FOR TK_RETURN TK_BREAK TK_SIZEOF

/* This declares the attribute stack entry */
%union {
	double			d;
	int			i;
	char		       *s;
	struct typestruct      *t;
	unsigned int		u;
	struct sym             *y;
	struct node            *n;
	}

%type <i> TK_ICONSTANT 
%type <i> constant_expr

%start file		/* start symbol is file */
%%

file
	: external_definition
	| file external_definition
	;

external_definition
	: declaration			{ dclstate = globaldcl; }
	| function_definition		{ dclstate = globaldcl; }
	;

declaration
	/* This syntax is only permitted when declaring struct/union */
	: declaration_specifiers ';'
	| declaration_specifiers init_declarator_list ';'
	;

function_definition
	: function_head function_body
	;

function_head
	: declarator
		{ check_fstate(); }
	| declaration_specifiers declarator
		{ check_fstate(); }
	;

				/* returns a base type */
declaration_specifiers
	: ssc_specifier		/* this is only permitted when
				 *  dclstate == globaldcl
				 *  and ssc_specifier is extern
				 *  type defaults to int
				 */
		{ 
		  if (dclstate != globaldcl)
		    yyerror("illegal omission of type specifier);