%token CONST  
%left '+' 
%left '*' 

@attributes {int val[1];} CONST /* check array reference in traversal code */
@traversal @lefttoright @preorder LRpre

%{ 
#include <stdio.h>

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "parser.h"
#endif

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%} 

%%
expr    :       expr    '*'     expr                         /* rule 1 */ 
                @{ @LRpre  fprintf(stderr," * "); @}

        |       expr    '+'     expr                         /* rule 2 */ 
                @{ @LRpre  fprintf(stderr," + "); @}

        |       '('     expr    ')'                          /* rule 3 */ 

        |       CONST                                        /* rule 4 */ 
                @{ @LRpre  fprintf(stderr," %d ",@CONST.val@[0]); @}
        ;
%% 
#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...)
{extern int yylineno;
 fprintf(stderr,"Near line %d: %s\n",yylineno,s); 
 yyyabort(); 
}  
#else  
void yyerror(const char *s)
{fprintf(stderr,"%s\n",s);
 yyyabort(); 
}
#endif

int yyparse(void);

int main() 
  {yyparse(); 
   fprintf(stderr,"\n");
  } 

