// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison GLR parsers in C

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// C++ GLR parser skeleton written by Valentin Tolmer.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "glr2.cc"


// "%code top" blocks.
#line 78 "agc-byacc.yy"

// hack to avoid a 'yydebug' global in every parser
#define yydebug agc_byacc_debug

#line 56 "agc-byacc.cc"



// First part of user prologue.
#line 53 "agc-byacc.yy"

/* $Id: agc-byacc.yy 2842 2022-12-13 01:19:44Z teshields $ */

/* This file is part of Ox, an Attribute Grammar Compiling System
   that augments the specification functionality of Lex and Yacc, and
   input specification compatible lexer and parser generators.

   Copyright (C) 1992-1994  Kurt M. Bischoff
   Copyright (C) 2004-2022  Thomas E. Shields

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#line 85 "agc-byacc.cc"


# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "agc-byacc.hh"

namespace
{
  /* Default (constant) value used for initialization for null
     right-hand sides.  Unlike the standard yacc.c template, here we set
     the default value of $$ to a zeroed-out value.  Since the default
     value is undefined, this behavior is technically correct.  */
  AGC::byacc::value_type yyval_default;
}


// Unqualified %code blocks.
#line 398 "agc-byacc.yy"

#include "config.h"

#include <iomanip>
#include <ostream>
#include <sstream>

#include "codegen.hh"
#include "ctc.hh"
#include "depGs.hh"
#include "fileMgr.hh"
#include "joinTabs.hh"
#include "mac.hh"
#include "messages.hh"
#include "opts.hh"
#include "outMgr.hh"
#include "scan.hh"
#include "symTrans.hh"
#include "trav.hh"
#include "treeviz.hh"

// =true if an '@attributes' declaration has occurred
static bool oxAttrbsDecl = false;

// record whether the @autoinh or @autosyn automatic copy rule attribute
// modifier has been seen in the current attribute declaration
static enum attrbDirection autoDef = undefined;

// =true if an '@warn' automatic copy rule attribute modifier has occurred in
// the current attribute declaration
static bool autoWarning = false;

// holds attribute information unique to each 'sort' from the current
// @attributes declaration until ready to add the information to the symbol
// table for each of the grammar symbols of that 'sort'
static sort gSymSort;

// an increasing sequence of sort serial numbers representing the kind of a
// semantic node in the parse tree
static int sortTypeNumSeq = firstSortTypeNum;

// the collection of all defined attribute sorts
static sortCollection sortTable;

// The vector sortSeq holds the list of attributes for the 'sort' (@attributes)
// declaration being processed.  The i-th element of sortSeq is a structure that
// holds the name and copy rule (@autoinh or @autosym, @warn) annotation (or
// default) of the ith attribute of the @attributes declaration being processed.
static sortAttrbSeq sortSeq;

// for checking dynamic traversal modifier restrictions
struct dynTravMod
{
  std::string id;
  int orderRev;            // count the @revorder occurrences
  int dirRev;              // count the @revdirectdion occurrences
  AGC::location dirRevLoc; // @revdirection location (first, if dirRev > 1)

  dynTravMod (std::string i)
      : id (i),
        orderRev (0),
        dirRev (0)
  {}
};

static std::vector<dynTravMod> dynTravModArr;

static int dynTravModSeq;

// =true if "@attributes { ... }" are not all '@void'
static bool hasConcreteType = false;

// checking whether "%destructor { ... } <*>" or "%printer { ... } <*>" occurs
static bool hasDefaultTypedSymbol = false;

#include "agc-Yfile-lexer.hh"

namespace AGC
{
class byaccLexer : public YFILE::Lexer
{
public:

  inline byaccLexer (Yfile_specIO& fR,
#if defined(WITH_REFLEX)
                              const reflex::Input& input
#else // defined(WITH_FLEX)
                              std::ifstream& input
#endif
                             )
      : YFILE::Lexer (fR, input)
  {}

  inline int
  yylex (parser::value_type& yylval, location& yylloc)
  {
    return YFILE::Lexer::yylex (yylval, yylloc);
  }

  inline int
  yylex (parser::value_type* yylval, location* yylloc)
  {
    return YFILE::Lexer::yylex (yylval, yylloc);
  }

  // convert byacc -> Y-file parser 'value_type&'
  // lexical tokens in all parser variants are identical
  inline int
  yylex (byacc::value_type& yylval, location& yylloc)
  {
    return yylex (reinterpret_cast<parser::value_type&> (yylval), yylloc);
  }

  // convert byacc -> Y-file parser 'value_type*'
  // lexical tokens in all parser variants are identical
  inline int
  yylex (byacc::value_type* yylval, location* yylloc)
  {
    return yylex (reinterpret_cast<parser::value_type*> (yylval), yylloc);
  }

  inline int
  yylex () // should never be called
  {
    return parser::symbol_kind::S_YYerror;
  }
};
} // namespace AGC

// override Bison default
#define yylex theLexer.yylex

#line 246 "agc-byacc.cc"


#include <cstdio>
#include <cstdlib>

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#ifndef YYFREE
# define YYFREE free
#endif
#ifndef YYMALLOC
# define YYMALLOC malloc
#endif

#ifndef YYSETJMP
# include <setjmp.h>
# define YYJMP_BUF jmp_buf
# define YYSETJMP(Env) setjmp (Env)
/* Pacify Clang and ICC.  */
# define YYLONGJMP(Env, Val)                    \
 do {                                           \
   longjmp (Env, Val);                          \
   YYASSERT (0);                                \
 } while (false)
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* The _Noreturn keyword of C11.  */
#ifndef _Noreturn
# if (defined __cplusplus \
      && ((201103 <= __cplusplus && !(__GNUC__ == 4 && __GNUC_MINOR__ == 7)) \
          || (defined _MSC_VER && 1900 <= _MSC_VER)))
#  define _Noreturn [[noreturn]]
# elif ((!defined __cplusplus || defined __clang__) \
        && (201112 <= (defined __STDC_VERSION__ ? __STDC_VERSION__ : 0) \
            || (!defined __STRICT_ANSI__ \
                && (4 < __GNUC__ + (7 <= __GNUC_MINOR__) \
                    || (defined __apple_build_version__ \
                        ? 6000000 <= __apple_build_version__ \
                        : 3 < __clang_major__ + (5 <= __clang_minor__))))))
   /* _Noreturn works as-is.  */
# elif (2 < __GNUC__ + (8 <= __GNUC_MINOR__) || defined __clang__ \
        || 0x5110 <= __SUNPRO_C)
#  define _Noreturn __attribute__ ((__noreturn__))
# elif 1200 <= (defined _MSC_VER ? _MSC_VER : 0)
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#if defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_NULL_DEREFERENCE_BEGIN                               \
  _Pragma ("GCC diagnostic push")                                       \
  _Pragma ("GCC diagnostic ignored \"-Wnull-dereference\"")
# define YY_IGNORE_NULL_DEREFERENCE_END         \
  _Pragma ("GCC diagnostic pop")
#else
# define YY_IGNORE_NULL_DEREFERENCE_BEGIN
# define YY_IGNORE_NULL_DEREFERENCE_END
#endif

# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif
# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif

// FIXME: Use the same conventions as lalr1.cc.

#ifndef YYASSERT
# define YYASSERT(Condition) ((void) ((Condition) || (abort (), 0)))
#endif

#ifdef YYDEBUG
# define YYDASSERT(Condition) YYASSERT(Condition)
#else
# define YYDASSERT(Condition)
#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3254

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  138
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  145
/* YYNRULES -- Number of rules.  */
#define YYNRULES  341
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  456
/* YYMAXRHS -- Maximum number of symbols on right-hand side of rule.  */
#define YYMAXRHS 7
/* YYMAXLEFT -- Maximum number of symbols to the left of a handle
   accessed by $0, $-1, etc., in any rule.  */
#define YYMAXLEFT 0

namespace
{
#if YYDEBUG
  /* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
  const short yyrline[] =
  {
       0,   533,   533,   538,   542,   553,   537,   565,   569,   573,
     577,   585,   589,   593,   604,   605,   606,   610,   617,   626,
     625,   645,   662,   679,   700,   699,   710,   714,   718,   722,
     739,   745,   752,   752,   769,   768,   821,   820,   832,   836,
     831,   852,   856,   860,   869,   887,   892,   899,   908,   912,
     929,   949,   957,   967,   974,   975,   979,   983,   987,   994,
    1003,  1021,  1025,  1040,  1058,  1063,  1067,  1074,  1078,  1085,
    1089,  1093,  1097,  1104,  1111,  1120,  1138,  1142,  1157,  1175,
    1179,  1186,  1187,  1191,  1192,  1196,  1197,  1219,  1227,  1228,
    1232,  1233,  1234,  1238,  1242,  1243,  1247,  1254,  1255,  1259,
    1267,  1268,  1272,  1280,  1285,  1284,  1307,  1306,  1331,  1335,
    1342,  1346,  1373,  1377,  1399,  1404,  1408,  1412,  1416,  1423,
    1427,  1434,  1458,  1462,  1486,  1487,  1491,  1492,  1496,  1497,
    1498,  1499,  1503,  1504,  1508,  1546,  1565,  1572,  1576,  1583,
    1587,  1606,  1610,  1617,  1618,  1622,  1627,  1631,  1636,  1644,
    1648,  1655,  1659,  1678,  1682,  1706,  1710,  1732,  1754,  1758,
    1762,  1782,  1803,  1833,  1860,  1865,  1872,  1876,  1898,  1903,
    1908,  1913,  1921,  1922,  1926,  1939,  1943,  1954,  1955,  1959,
    1960,  1964,  1971,  1975,  1979,  1983,  1987,  1994,  1995,  2000,
    1999,  2046,  2045,  2056,  2060,  2067,  2068,  2072,  2073,  2081,
    2080,  2091,  2095,  2099,  2100,  2104,  2105,  2106,  2116,  2123,
    2136,  2140,  2155,  2159,  2163,  2164,  2165,  2166,  2167,  2174,
    2178,  2179,  2183,  2187,  2192,  2191,  2225,  2226,  2227,  2228,
    2232,  2239,  2240,  2244,  2248,  2249,  2250,  2259,  2325,  2340,
    2375,  2379,  2386,  2401,  2406,  2425,  2433,  2452,  2456,  2460,
    2465,  2472,  2479,  2494,  2499,  2518,  2526,  2530,  2534,  2541,
    2550,  2551,  2555,  2587,  2594,  2599,  2608,  2609,  2610,  2617,
    2668,  2667,  2692,  2696,  2701,  2700,  2723,  2722,  2749,  2761,
    2765,  2766,  2773,  2777,  2778,  2779,  2780,  2784,  2785,  2789,
    2793,  2797,  2809,  2813,  2817,  2818,  2819,  2823,  2824,  2825,
    2826,  2830,  2831,  2832,  2833,  2834,  2835,  2836,  2837,  2838,
    2839,  2840,  2841,  2842,  2843,  2844,  2845,  2846,  2847,  2848,
    2849,  2850,  2851,  2852,  2853,  2854,  2855,  2856,  2857,  2858,
    2859,  2860,  2861,  2862,  2863,  2864,  2865,  2866,  2867,  2868,
    2869,  2870
  };
#endif

#define YYPACT_NINF -362
#define YYTABLE_NINF -290

  // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
// STATE-NUM.
  const short yypact[] =
  {
    -362,    79,  -362,  -362,   558,  -362,    63,  -362,  -362,    74,
     122,  -362,  -362,  -362,  -362,    70,  -362,   110,  -362,   114,
     136,  -362,   200,   200,   223,   223,  -362,  -362,  -362,  -362,
     318,    28,    83,  -362,   213,  3157,  -362,  -362,   554,  2960,
     353,  -362,  -362,   292,  -362,  -362,   333,  -362,  -362,   554,
     420,  -362,   831,  -362,  -362,   306,   361,  3022,    32,  3045,
      32,  -362,  -362,   305,   316,  3122,  -362,   554,  -362,   287,
     446,  -362,  -362,  -362,  -362,  -362,   139,    72,   127,  -362,
    -362,  -362,   243,   353,  2575,  -362,  2790,  -362,  -362,   329,
     412,   355,     7,   429,  -362,   552,   552,  -362,   970,  -362,
    -362,  -362,  -362,  2598,  -362,   361,  -362,  -362,  2660,  2852,
    -362,    32,  -362,   -11,   177,    -2,   321,  -362,  -362,   156,
    -362,  -362,  -362,   105,   433,  -362,  -362,  -362,  -362,  -362,
     441,  -362,  -362,    94,  -362,   100,    72,  -362,    18,   554,
    -362,  -362,  2875,  -362,  -362,   353,  -362,  -362,  -362,  -362,
    -362,  -362,  -362,  -362,  1053,  -362,  -362,  2683,  -362,   438,
    -362,  -362,  -362,  -362,   361,  -362,  2767,   337,    32,  -362,
    2937,   226,    39,    -1,  -362,  -362,  -362,  -362,   316,   289,
     105,   163,  -362,    58,  -362,   105,  -362,    65,  -362,  1108,
    -362,   407,  -362,  -362,  -362,   193,  -362,  -362,   279,  3081,
    3055,   -21,  -362,   342,  -362,  -362,  -362,  -362,  -362,   186,
    -362,  -362,  -362,  -362,  -362,   265,  -362,  -362,    36,    36,
    -362,  -362,   696,  -362,   413,  -362,   105,   279,    52,   392,
    -362,  -362,   452,   436,  -362,  -362,  -362,   554,   415,  -362,
     291,  -362,  -362,  -362,  -362,  -362,  -362,    52,  3092,  -362,
     554,  -362,  -362,   337,  -362,    39,  -362,  -362,  -362,   289,
      22,  -362,  -362,  -362,    45,  -362,  -362,  -362,  -362,  -362,
    -362,  -362,  -362,  -362,  -362,   425,  -362,  -362,  -362,   437,
    -362,  -362,  -362,  -362,  -362,   417,   439,  -362,  3068,  -362,
    -362,    41,  -362,  -362,    15,  -362,  -362,  -362,  -362,  -362,
    -362,  -362,  1104,  -362,  -362,  -362,  -362,  -362,  -362,  -362,
    -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,
    -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,
    -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,
    -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,
    -362,  -362,  -362,  -362,  -362,  -362,  -362,   309,  1241,  -362,
    -362,   556,   310,   310,  -362,  -362,   472,   317,   325,  -362,
    -362,  -362,  -362,  -362,   282,  -362,   477,  1773,  -362,  -362,
    -362,  -362,  -362,   220,  -362,  -362,     6,  -362,  -362,   430,
    -362,  -362,  1374,  -362,   419,   693,  -362,  -362,  -362,  -362,
     556,  -362,   435,   145,  -362,  -362,  -362,  -362,  -362,  -362,
    1507,  1906,  -362,  -362,  -362,   481,   435,  -362,  -362,  -362,
    -362,  -362,  2039,  -362,   482,  -362,  -362,  -362,   556,  -362,
    1640,   451,   451,   830,   967,  -362,  -362,  -362,  -362,  -362,
    -362,  -362,  -362,  -362,  -362,  -362,  -362,   830,  -362,  -362,
    2172,  2305,  2438,  -362,  -362,  -362
  };

  // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
// Performed when YYTABLE does not specify something else to do.  Zero
// means the default is an error.
  const short yydefact[] =
  {
      11,     0,     2,     3,     0,     1,     0,    17,    41,     0,
       0,    38,    56,    57,    58,     0,    73,     0,    19,     0,
       0,    30,     0,     0,     0,     0,    12,    13,    15,    16,
       0,     0,     0,     4,     0,     0,    36,   177,     0,     0,
       0,    46,    18,     0,    26,    27,     0,    31,    24,     0,
       0,    85,     0,   104,   106,     0,     0,     0,     0,     0,
       0,    14,    42,     0,     0,     0,    97,     0,   103,     0,
       0,   119,   120,   115,   116,   114,     0,     0,     0,   112,
     117,   118,     0,     0,     0,    52,     0,    48,    51,     0,
       0,     0,     0,     0,    86,     0,     0,    96,     0,    94,
      65,    66,    64,     0,    61,     0,    68,    67,     0,     0,
      76,     0,     5,     0,     0,     0,     0,   101,   134,     0,
     132,    34,    98,     0,     0,   182,   183,   184,   185,   186,
       0,   178,   121,     0,   136,     0,     0,   157,     0,     0,
     113,    47,     0,    55,    53,     0,    49,    20,    84,    83,
      70,    71,    72,    69,     0,    91,    90,     0,    88,     0,
     109,   105,   107,    95,     0,    62,     0,     0,     0,    77,
       0,     0,     0,     0,   187,   191,   189,   100,     0,     0,
       0,     0,   124,     0,   128,     0,   175,     0,   181,     0,
     179,     0,   141,   142,   135,     0,   139,   160,     0,     0,
       0,     0,    50,     0,    93,    89,    87,    63,    81,     0,
      78,    10,     6,   198,   197,     0,   195,   188,     0,     0,
     133,   174,     0,   172,     0,    99,     0,     0,     0,     0,
     126,   127,     0,     0,   180,   161,   140,     0,     0,   150,
       0,   153,   155,   168,   169,   170,   171,     0,     0,   166,
       0,   111,    92,     0,    80,     0,   194,   208,    41,     0,
       0,   220,   192,   199,     0,   203,   205,   209,   206,   207,
     221,   190,   173,   129,   125,     0,   148,   146,   147,     0,
     144,   176,    37,   156,   163,     0,     0,   167,     0,    82,
     196,     0,   219,   212,     0,   204,   131,   130,   152,   154,
     162,   222,     0,   224,   200,   218,   297,   298,   299,   338,
     212,   211,   214,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   339,   340,   341,   213,   216,   215,     0,     0,   236,
     235,     0,     0,     0,   230,   270,     0,     0,     0,   231,
     233,   234,   217,   245,     0,   237,     0,     0,   241,   263,
     251,   264,   265,     0,   260,   262,     0,   272,   225,     0,
     232,   255,     0,   240,     0,     0,   244,   246,   248,   247,
       0,   261,     0,     0,   252,   258,   259,   257,   254,   256,
       0,     0,   238,   268,   269,     0,     0,   281,   292,   274,
     276,   273,     0,   271,     0,   288,   249,   250,     0,   267,
       0,     0,     0,     0,     0,   282,   280,   284,   283,   287,
     239,   291,   296,   290,   294,   295,   293,     0,   275,   277,
       0,     0,     0,   285,   286,   278
  };

  // YYPGOTO[NTERM-NUM].
  const short yypgoto[] =
  {
    -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,
    -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,  -362,
    -362,   -43,  -362,   406,   -37,   421,    75,   -39,  -362,  -362,
    -362,   390,   -84,   -19,   -86,  -362,  -362,   385,    40,  -362,
     -22,   473,   322,  -362,   345,  -362,   405,  -362,   440,  -362,
     476,  -362,  -362,   411,   443,  -127,   -74,   490,  -362,  -362,
    -362,   118,  -362,  -362,   -56,    27,  -362,  -362,   320,  -362,
     269,   285,  -362,  -362,   283,   -33,   169,  -362,  -362,  -362,
     324,  -362,   347,  -362,  -362,  -362,   384,  -362,  -362,   460,
    -362,  -362,  -362,  -362,   323,   356,  -362,  -362,  -362,   312,
    -362,  -362,   267,  -362,  -362,  -362,  -362,  -362,  -362,  -362,
    -362,   212,  -298,  -362,  -332,  -362,   187,  -224,   -73,  -208,
     190,  -362,  -362,   222,   -69,  -108,   170,  -362,  -362,  -362,
    -362,  -362,  -362,  -362,   157,  -361,   158,  -362,  -362,  -362,
     160,  -362,  -362,  -253,  -245
  };

  // YYDEFGOTO[NTERM-NUM].
  const short yydefgoto[] =
  {
       0,     1,     2,     6,    60,   171,     3,   112,   212,     4,
      26,    27,    43,    28,    92,    29,    30,   179,    69,    37,
     130,    34,    39,    40,    41,    86,    87,    88,   144,    31,
      57,   103,   104,   108,   260,    32,    59,   109,   110,   209,
      62,    50,    51,   157,   158,    98,    99,    65,    66,    67,
      68,    95,    96,   161,    77,    78,    79,    80,    81,   201,
     181,   182,   183,   119,   184,   185,   194,   195,   196,   230,
     279,   238,   239,   240,   241,   242,   137,   138,   247,   248,
     249,   222,   223,   187,    70,   189,   190,   131,   114,   115,
     219,   218,   116,   215,   216,   262,   294,   263,   264,   265,
     266,   267,   302,   354,   268,   269,   270,   304,   357,   366,
     367,   368,   369,   370,   375,   376,   377,   396,   382,   378,
     392,   408,   409,   383,   384,   385,   415,   416,   371,   387,
     403,   421,   431,   432,   448,   422,   436,   423,   424,   444,
     425,   430,   446,   437,   438
  };

  // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
// positive, shift that token.  If negative, reduce the rule whose
// number is the opposite.  If YYTABLE_NINF, syntax error.
  const short yytable[] =
  {
      47,    48,    83,    91,   140,    82,   156,   379,   120,   174,
     217,   380,   200,   150,   151,   152,    93,   102,   303,   165,
     105,   250,   111,  -210,  -159,  -210,  -223,   381,  -210,  -210,
    -210,  -210,   172,  -210,   -45,   -45,   -45,   257,   106,  -201,
     213,   113,   150,   151,   152,    46,   257,  -201,  -202,   355,
      46,   150,   151,   152,    46,   155,  -202,   356,   276,   153,
    -159,   198,  -159,   199,   102,   293,   102,  -210,   412,  -143,
     390,   156,   450,   451,  -210,    33,   -45,   -45,  -158,     5,
     207,   258,   165,    35,   107,  -210,   452,   301,   153,   -45,
     258,   390,   251,   221,   214,   113,   440,   153,  -145,   259,
    -143,   227,  -143,   228,   136,   355,  -137,   232,   259,   233,
     277,   118,  -193,   356,  -158,   133,  -158,   175,   175,   154,
     155,    82,   220,   288,   398,   102,   140,   102,    36,   402,
     208,  -159,   399,    71,  -223,   -45,   221,   133,  -158,   398,
      38,  -210,  -137,  -137,  -137,    71,   417,   399,   180,   169,
    -279,  -279,  -279,  -279,   418,  -201,  -279,   398,   398,   278,
     136,   146,    42,   136,  -202,   399,   399,   177,   406,  -110,
    -110,  -110,    44,   292,   225,   419,   420,    -8,   134,   135,
      72,   229,    38,   106,   407,  -158,   406,  -279,  -279,    -8,
    -279,   192,    72,   193,    45,    38,   261,   261,   178,  -138,
     134,   135,   407,  -279,   283,   226,  -137,  -137,   210,    46,
     169,   134,   135,  -137,   140,   291,   289,   146,    73,    74,
     202,   379,    46,    75,    76,   380,    -9,    61,   253,   107,
     254,   400,    49,  -110,  -110,  -138,  -138,  -138,   211,   139,
    -110,   381,   261,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,   391,   192,    71,   193,  -253,  -253,  -253,
    -253,  -253,  -253,  -253,   414,   150,   151,   152,   224,  -138,
    -138,    89,   191,   231,   397,   197,  -138,   255,   414,   256,
     359,   379,    97,  -226,   401,   380,   117,   401,   359,   397,
     360,  -228,   118,  -149,  -253,  -253,   359,  -253,   360,  -227,
     124,   381,    72,   285,    90,  -151,   360,   397,   397,   147,
    -253,   153,   -41,   -41,   274,   361,   362,   363,   364,   435,
     365,    53,    54,   361,   362,   363,   141,   435,   365,    84,
      85,   361,   362,   363,    46,   149,   365,    84,   100,   101,
      73,    74,    94,   237,    94,    75,    76,   435,   435,   435,
    -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,
    -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,
    -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,
    -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,
     391,   -28,   148,    71,  -253,  -253,  -253,  -253,  -253,    49,
    -253,   359,   -28,   -28,  -229,   159,   413,    56,    58,   186,
     380,   360,   -28,   -28,   176,   -28,  -266,   188,   206,    38,
     280,   235,   -39,   -28,   -28,   252,   381,   273,   281,   284,
     282,  -253,  -253,  -253,  -253,   298,   361,   362,   363,   296,
      72,   365,   125,   126,   127,   128,   388,  -253,   129,   -28,
     -28,   -28,   -28,   297,   -28,   300,   -28,   -28,   393,   -28,
     -28,   -28,   428,   439,   447,   166,   170,   -28,    52,   -28,
     -28,   -28,   205,   163,   142,   122,    55,   162,    73,    74,
     123,   237,   275,    75,    76,   236,   286,  -253,  -253,  -253,
    -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,
    -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,
    -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,
    -253,  -253,  -253,  -253,  -253,  -253,  -253,   373,  -108,     7,
      71,  -243,  -243,  -243,  -243,   374,   132,  -243,   299,   272,
      -7,     8,   287,   234,   173,   271,   295,   358,   290,   389,
       9,    10,   411,    11,   410,   386,   429,   160,   443,   449,
     445,   -32,   -32,     0,     0,     0,     0,     0,  -243,  -243,
       0,  -243,     0,     0,     0,  -108,     0,    72,     0,     0,
       0,     0,     0,     0,  -243,     0,     0,    12,    13,    14,
      15,     0,    16,     0,    17,    18,     0,    19,    20,    21,
       0,     0,     0,     0,     0,    22,     0,    23,    24,    25,
       0,     0,     0,  -108,  -108,    73,    74,     0,  -108,  -108,
      75,    76,     0,     0,  -243,  -243,  -243,  -243,  -243,  -243,
    -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,
    -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,
    -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,
    -243,  -243,  -243,  -243,   373,     0,     0,   -35,  -243,  -243,
    -243,  -243,   150,   151,   152,     0,     0,     0,   -35,   -35,
       0,     0,     0,     0,     0,     0,     0,     0,   -35,   -35,
       0,   -35,     0,     0,     0,     0,     0,     0,     0,   -35,
     -35,     0,     0,     0,     0,  -243,  -243,     0,  -243,  -243,
       0,     0,     0,     0,     0,     0,     0,     0,   153,     0,
       0,  -243,     0,     0,     0,   -35,   -35,   -35,   -35,     0,
     -35,     0,   -35,   -35,     0,   -35,   -35,   -35,     0,     0,
       0,     0,     0,   -35,     0,   -35,   -35,   -35,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,
    -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,
    -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,
    -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,  -243,
    -243,   417,   -29,     0,     0,  -279,  -279,  -279,  -279,     0,
      49,     0,     0,   -29,   -29,     0,     0,     0,     0,     0,
       0,     0,     0,   -29,   -29,     0,   -29,     0,     0,     0,
       0,     0,     0,     0,   -29,   -29,     0,     0,     0,     0,
       0,     0,  -279,  -279,  -279,  -279,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -279,     0,
     -29,   -29,   -29,   -29,     0,   -29,     0,   -29,   -29,     0,
     -29,   -29,   -29,     0,     0,     0,     0,     0,   -29,     0,
     -29,   -29,   -29,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,   417,     0,
       0,   -33,  -279,  -279,  -279,  -279,    97,     0,     0,     0,
       0,     0,   -33,   -33,     0,     0,     0,     0,     0,     0,
       0,     0,   -33,   -33,     0,   -33,     0,     0,     0,     0,
       0,     0,     0,   -33,   -33,     0,     0,     0,     0,  -279,
    -279,     0,  -279,  -279,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -279,     0,     0,     0,   -33,
     -33,   -33,   -33,     0,   -33,     0,   -33,   -33,     0,   -33,
     -33,   -33,     0,     0,     0,     0,     0,   -33,     0,   -33,
     -33,   -33,     0,     0,     0,     0,     0,     0,     0,    71,
       0,     0,     0,     0,     0,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,   305,    72,     0,     0,   -40,
     306,   307,   308,     0,   188,     0,     0,     0,     0,     0,
     -40,   -40,     0,     0,     0,     0,     0,     0,     0,     0,
     -40,   -40,     0,   -40,     0,     0,     0,     0,     0,     0,
       0,   -40,   -40,     0,    73,    74,   309,   310,   311,    75,
      76,     0,     0,     0,     0,     0,     0,     0,     0,   312,
     203,     0,   313,     0,     0,     0,   204,   -40,   -40,   -40,
     -40,     0,   -40,     0,   -40,   -40,     0,   -40,   -40,   -40,
       0,     0,     0,     0,     0,   -40,     0,   -40,   -40,   -40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   305,     0,     0,     0,     0,   306,   307,   308,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   309,   310,   372,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   312,     0,     0,   313,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   380,
     306,   307,   308,   374,   404,   405,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   309,   394,     0,   395,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   313,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   380,   306,   307,   308,   374,     0,   405,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   309,
     394,   426,   395,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   313,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   380,   306,   307,   308,   418,
     441,   442,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   309,   433,     0,   434,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   313,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   380,   306,
     307,   308,     0,     0,  -242,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   309,   394,     0,   395,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   380,   306,   307,   308,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   309,   394,
       0,   395,   427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   313,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   380,   306,   307,   308,     0,     0,
    -289,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   309,   433,     0,   434,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   313,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   380,   306,   307,
     308,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   309,   433,   453,   434,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     313,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     380,   306,   307,   308,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   309,   433,     0,
     434,   454,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   313,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   380,   306,   307,   308,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     309,   433,   455,   434,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   313,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   -54,     0,     0,     0,
       0,   -54,   -54,   -54,     0,     0,     0,   -54,   -54,     0,
       0,     0,     0,     0,     0,     0,     0,   -54,   -54,   -59,
     -54,     0,     0,     0,    84,   100,   101,     0,   -54,   -54,
     -59,   -59,     0,     0,     0,     0,     0,   -54,     0,     0,
     -59,   -59,     0,   -59,     0,     0,     0,     0,     0,     0,
       0,   -59,   -59,   143,   -54,   -54,   -54,   -54,     0,   -54,
     164,   -54,   -54,     0,   -54,   -54,   -54,     0,     0,     0,
       0,     0,   -54,     0,   -54,   -54,   -54,   -59,   -59,   -59,
     -59,   -79,   -59,     0,   -59,   -59,   -79,   -59,   -59,   -59,
       0,     0,   -79,   -79,     0,   -59,     0,   -59,   -59,   -59,
       0,     0,   -79,   -79,   -25,   -79,     0,   -54,     0,   150,
     151,   152,     0,   -79,   -79,   -25,   -25,     0,     0,     0,
       0,     0,   -79,   167,     0,   -25,   -25,     0,   -25,     0,
     -59,     0,   -79,     0,     0,     0,   -25,   -25,     0,   -79,
     -79,   -79,   -79,     0,   -79,     0,   -79,   -79,     0,   -79,
     -79,   -79,     0,     0,     0,   153,     0,   -79,     0,   -79,
     -79,   -79,   -25,   -25,   -25,   -25,     0,   -25,     0,   -25,
     -25,     0,   -25,   -25,   -25,     0,     0,     0,     0,     0,
     -25,     0,   -25,   -25,   -25,     0,     0,     0,   -60,     0,
       0,     0,   -79,    84,   100,   101,     0,     0,     0,   -60,
     -60,     0,     0,     0,     0,     0,     0,     0,     0,   -60,
     -60,   -43,   -60,     0,     0,   154,    84,    85,     0,     0,
     -60,   -60,   -43,   -43,     0,     0,     0,     0,     0,   164,
       0,     0,   -43,   -43,     0,   -43,     0,     0,     0,     0,
       0,     0,     0,   -43,   -43,     0,   -60,   -60,   -60,   -60,
       0,   -60,   145,   -60,   -60,     0,   -60,   -60,   -60,     0,
       0,     0,     0,     0,   -60,     0,   -60,   -60,   -60,   -43,
     -43,   -43,   -43,   -74,   -43,     0,   -43,   -43,   106,   -43,
     -43,   -43,     0,     0,   -74,   -74,     0,   -43,     0,   -43,
     -43,   -43,     0,     0,   -74,   -74,   -44,   -74,     0,   -60,
       0,    84,    85,     0,     0,   -74,   -74,   -44,   -44,     0,
       0,     0,     0,     0,   168,     0,     0,   -44,   -44,     0,
     -44,     0,   -43,     0,   107,     0,     0,     0,   -44,   -44,
       0,   -74,   -74,   -74,   -74,     0,   -74,   145,   -74,   -74,
       0,   -74,   -74,   -74,     0,     0,     0,     0,     0,   -74,
       0,   -74,   -74,   -74,   -44,   -44,   -44,   -44,   -75,   -44,
       0,   -44,   -44,   106,   -44,   -44,   -44,     0,     0,   -75,
     -75,     0,   -44,     0,   -44,   -44,   -44,     0,     0,   -75,
     -75,   -21,   -75,     0,   -74,     0,     0,     0,     0,     0,
     -75,   -75,   -21,   -21,     0,     0,     0,     0,     0,   168,
       0,     0,   -21,   -21,     0,   -21,     0,   -44,     0,   107,
       0,     0,     0,   -21,   -21,     0,   -75,   -75,   -75,   -75,
       0,   -75,     0,   -75,   -75,     0,   -75,   -75,   -75,     0,
       0,     0,     0,     0,   -75,     0,   -75,   -75,   -75,   -21,
     -21,   -21,   -21,   -22,   -21,     0,   -21,   -21,     0,   -21,
     -21,   -21,     0,     0,   -22,   -22,     0,   -21,     0,   -21,
     -21,   -21,     0,     0,   -22,   -22,   -23,   -22,     0,   -75,
       0,     0,     0,     0,     0,   -22,   -22,   -23,   -23,     0,
       0,    71,     0,     0,     0,     0,     0,   -23,   -23,     0,
     -23,     0,    38,     0,    71,     0,     0,     0,   -23,   -23,
       0,   -22,   -22,   -22,   -22,     0,   -22,  -164,   -22,   -22,
       0,   -22,   -22,   -22,     0,     0,     0,  -122,  -165,   -22,
       0,   -22,   -22,   -22,   -23,   -23,   -23,   -23,    72,   -23,
    -123,   -23,   -23,     0,   -23,   -23,   -23,     0,     0,     0,
       0,    72,   -23,    63,   -23,   -23,   -23,  -164,  -102,     0,
       0,     0,   121,     0,    38,     0,     0,     0,  -165,  -164,
       0,     0,     0,     0,     0,     0,    73,    74,     0,     0,
    -165,    75,    76,     0,     0,    53,    54,    38,    63,    73,
      74,     0,    64,  -102,    75,    76,     0,     0,  -122,     0,
       0,     0,   243,   244,   245,  -102,   246,     0,     0,     0,
       0,  -123,     0,   243,   244,   245,     0,   246,  -164,     0,
      53,    54,     0,     0,     0,     0,     0,    64,     0,  -165,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -102,     0,     0,  -102,  -102,     0,     0,     0,  -102,  -102,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -102,  -102,
       0,     0,     0,  -102,  -102
  };

  const short yycheck[] =
  {
      22,    23,    39,    46,    78,    38,    92,     1,    64,    11,
      11,     5,   139,     6,     7,     8,    49,    56,     3,   103,
      57,    42,    59,     1,     6,     3,    11,    21,     6,     7,
       8,     9,    43,    11,     6,     7,     8,     1,     6,     3,
       1,    60,     6,     7,     8,     9,     1,    11,     3,   302,
       9,     6,     7,     8,     9,    92,    11,   302,     6,    52,
      42,    43,    44,    45,   103,    43,   105,    45,   400,    11,
     368,   157,   433,   434,    52,    12,     6,     7,     6,     0,
     164,    45,   166,     9,    52,    63,   447,    46,    52,     6,
      45,   389,   113,   179,    55,   114,   428,    52,    46,    63,
      42,    43,    44,    45,    77,   358,     6,    42,    63,    44,
      58,     6,   123,   358,    42,    43,    44,   119,   119,   112,
     157,   154,   178,   250,   377,   164,   200,   166,     6,   123,
     167,   113,   377,     6,   119,    52,   222,    43,    44,   392,
     112,   119,    42,    43,    44,     6,     1,   392,    43,   109,
       5,     6,     7,     8,     9,   119,    11,   410,   411,   107,
     133,    86,    52,   136,   119,   410,   411,    11,   392,    42,
      43,    44,    58,   259,    11,    30,    31,     0,   106,   107,
      53,   123,   112,     6,   392,   113,   410,    42,    43,    12,
      45,    91,    53,    93,    58,   112,   218,   219,    42,     6,
     106,   107,   410,    58,   237,    42,   106,   107,   168,     9,
     170,   106,   107,   113,   288,   258,   253,   142,    91,    92,
     145,     1,     9,    96,    97,     5,     0,    14,    42,    52,
      44,    11,     9,   106,   107,    42,    43,    44,    12,   112,
     113,    21,   264,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,     1,    91,     6,    93,     5,     6,     7,
       8,     9,    10,    11,   402,     6,     7,     8,   180,   106,
     107,     9,   133,   185,   377,   136,   113,    42,   416,    44,
       1,     1,     6,     4,   383,     5,    11,   386,     1,   392,
      11,     4,     6,    44,    42,    43,     1,    45,    11,     4,
      43,    21,    53,    42,     1,    44,    11,   410,   411,    10,
      58,    52,     9,    10,   226,    36,    37,    38,    39,   422,
      41,    33,    34,    36,    37,    38,   113,   430,    41,     6,
       7,    36,    37,    38,     9,    10,    41,     6,     7,     8,
      91,    92,    50,    94,    52,    96,    97,   450,   451,   452,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
       1,     1,    10,     6,     5,     6,     7,     8,     9,     9,
      11,     1,    12,    13,     4,     6,     1,    31,    32,     6,
       5,    11,    22,    23,   123,    25,    11,     6,    10,   112,
      58,    44,     6,    33,    34,   113,    21,    44,     6,    44,
      24,    42,    43,    44,    45,    48,    36,    37,    38,    44,
      53,    41,    26,    27,    28,    29,     4,    58,    32,    59,
      60,    61,    62,    46,    64,    46,    66,    67,    11,    69,
      70,    71,    11,    11,    43,   105,   111,    77,    25,    79,
      80,    81,   157,    98,    83,    65,    30,    96,    91,    92,
      67,    94,   227,    96,    97,   195,   247,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,     1,     6,     1,
       6,     5,     6,     7,     8,     9,    76,    11,   285,   222,
      12,    13,   248,   189,   114,   219,   264,   310,   255,   367,
      22,    23,   395,    25,   394,   363,   416,    35,   430,   432,
     430,    33,    34,    -1,    -1,    -1,    -1,    -1,    42,    43,
      -1,    45,    -1,    -1,    -1,    53,    -1,    53,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    -1,    59,    60,    61,
      62,    -1,    64,    -1,    66,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    79,    80,    81,
      -1,    -1,    -1,    91,    92,    91,    92,    -1,    96,    97,
      96,    97,    -1,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,     1,    -1,    -1,     1,     5,     6,
       7,     8,     6,     7,     8,    -1,    -1,    -1,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    -1,    -1,    -1,    42,    43,    -1,    45,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,
      -1,    58,    -1,    -1,    -1,    59,    60,    61,    62,    -1,
      64,    -1,    66,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    79,    80,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,     1,     1,    -1,    -1,     5,     6,     7,     8,    -1,
       9,    -1,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    43,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      59,    60,    61,    62,    -1,    64,    -1,    66,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    77,    -1,
      79,    80,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,     1,    -1,
      -1,     1,     5,     6,     7,     8,     6,    -1,    -1,    -1,
      -1,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    -1,    -1,    -1,    42,
      43,    -1,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    59,
      60,    61,    62,    -1,    64,    -1,    66,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    77,    -1,    79,
      80,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,     1,    53,    -1,    -1,     1,
       6,     7,     8,    -1,     6,    -1,    -1,    -1,    -1,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    91,    92,    42,    43,    44,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,
     107,    -1,    58,    -1,    -1,    -1,   113,    59,    60,    61,
      62,    -1,    64,    -1,    66,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    79,    80,    81,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,     1,    -1,    -1,    -1,    -1,     6,     7,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,     5,
       6,     7,     8,     9,    10,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,     5,     6,     7,     8,     9,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,     5,     6,     7,     8,     9,
      10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    43,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,     5,     6,
       7,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      -1,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,     5,     6,     7,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,     5,     6,     7,
       8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    44,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
       5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,     5,     6,     7,     8,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,     1,    -1,    -1,    -1,
      -1,     6,     7,     8,    -1,    -1,    -1,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,     1,
      25,    -1,    -1,    -1,     6,     7,     8,    -1,    33,    34,
      12,    13,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      22,    23,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    58,    59,    60,    61,    62,    -1,    64,
      42,    66,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    77,    -1,    79,    80,    81,    59,    60,    61,
      62,     1,    64,    -1,    66,    67,     6,    69,    70,    71,
      -1,    -1,    12,    13,    -1,    77,    -1,    79,    80,    81,
      -1,    -1,    22,    23,     1,    25,    -1,   112,    -1,     6,
       7,     8,    -1,    33,    34,    12,    13,    -1,    -1,    -1,
      -1,    -1,    42,    43,    -1,    22,    23,    -1,    25,    -1,
     112,    -1,    52,    -1,    -1,    -1,    33,    34,    -1,    59,
      60,    61,    62,    -1,    64,    -1,    66,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    52,    -1,    77,    -1,    79,
      80,    81,    59,    60,    61,    62,    -1,    64,    -1,    66,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    79,    80,    81,    -1,    -1,    -1,     1,    -1,
      -1,    -1,   112,     6,     7,     8,    -1,    -1,    -1,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,     1,    25,    -1,    -1,   112,     6,     7,    -1,    -1,
      33,    34,    12,    13,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    22,    23,    -1,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    59,    60,    61,    62,
      -1,    64,    42,    66,    67,    -1,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    77,    -1,    79,    80,    81,    59,
      60,    61,    62,     1,    64,    -1,    66,    67,     6,    69,
      70,    71,    -1,    -1,    12,    13,    -1,    77,    -1,    79,
      80,    81,    -1,    -1,    22,    23,     1,    25,    -1,   112,
      -1,     6,     7,    -1,    -1,    33,    34,    12,    13,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    22,    23,    -1,
      25,    -1,   112,    -1,    52,    -1,    -1,    -1,    33,    34,
      -1,    59,    60,    61,    62,    -1,    64,    42,    66,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    79,    80,    81,    59,    60,    61,    62,     1,    64,
      -1,    66,    67,     6,    69,    70,    71,    -1,    -1,    12,
      13,    -1,    77,    -1,    79,    80,    81,    -1,    -1,    22,
      23,     1,    25,    -1,   112,    -1,    -1,    -1,    -1,    -1,
      33,    34,    12,    13,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    22,    23,    -1,    25,    -1,   112,    -1,    52,
      -1,    -1,    -1,    33,    34,    -1,    59,    60,    61,    62,
      -1,    64,    -1,    66,    67,    -1,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    77,    -1,    79,    80,    81,    59,
      60,    61,    62,     1,    64,    -1,    66,    67,    -1,    69,
      70,    71,    -1,    -1,    12,    13,    -1,    77,    -1,    79,
      80,    81,    -1,    -1,    22,    23,     1,    25,    -1,   112,
      -1,    -1,    -1,    -1,    -1,    33,    34,    12,    13,    -1,
      -1,     6,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,   112,    -1,     6,    -1,    -1,    -1,    33,    34,
      -1,    59,    60,    61,    62,    -1,    64,     6,    66,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    42,     6,    77,
      -1,    79,    80,    81,    59,    60,    61,    62,    53,    64,
      42,    66,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    53,    77,     1,    79,    80,    81,    46,     6,    -1,
      -1,    -1,    10,    -1,   112,    -1,    -1,    -1,    46,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    -1,    -1,
      58,    96,    97,    -1,    -1,    33,    34,   112,     1,    91,
      92,    -1,    40,     6,    96,    97,    -1,    -1,   113,    -1,
      -1,    -1,    91,    92,    93,    53,    95,    -1,    -1,    -1,
      -1,   113,    -1,    91,    92,    93,    -1,    95,   107,    -1,
      33,    34,    -1,    -1,    -1,    -1,    -1,    40,    -1,   107,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      53,    -1,    -1,    91,    92,    -1,    -1,    -1,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      -1,    -1,    -1,    96,    97
  };

  // YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
// state STATE-NUM.
  const short yystos[] =
  {
       0,   139,   140,   144,   147,     0,   141,     1,    13,    22,
      23,    25,    59,    60,    61,    62,    64,    66,    67,    69,
      70,    71,    77,    79,    80,    81,   148,   149,   151,   153,
     154,   167,   173,    12,   159,     9,     6,   157,   112,   160,
     161,   162,    52,   150,    58,    58,     9,   178,   178,     9,
     179,   180,   179,    33,    34,   188,   161,   168,   161,   174,
     142,    14,   178,     1,    40,   185,   186,   187,   188,   156,
     222,     6,    53,    91,    92,    96,    97,   192,   193,   194,
     195,   196,   213,   162,     6,     7,   163,   164,   165,     9,
       1,   159,   152,   213,   180,   189,   190,     6,   183,   184,
       7,     8,   165,   169,   170,   162,     6,    52,   171,   175,
     176,   162,   145,   171,   226,   227,   230,    11,     6,   201,
     202,    10,   186,   192,    43,    26,    27,    28,    29,    32,
     158,   225,   195,    43,   106,   107,   203,   214,   215,   112,
     194,   113,   163,    58,   166,    42,   164,    10,    10,    10,
       6,     7,     8,    52,   112,   162,   172,   181,   182,     6,
      35,   191,   191,   184,    42,   170,   169,    43,    42,   176,
     175,   143,    43,   227,    11,   119,   123,    11,    42,   155,
      43,   198,   199,   200,   202,   203,     6,   221,     6,   223,
     224,   214,    91,    93,   204,   205,   206,   214,    43,    45,
     193,   197,   164,   107,   113,   182,    10,   170,   162,   177,
     176,    12,   146,     1,    55,   231,   232,    11,   229,   228,
     202,   172,   219,   220,   199,    11,    42,    43,    45,   123,
     207,   199,    42,    44,   224,    44,   206,    94,   209,   210,
     211,   212,   213,    91,    92,    93,    95,   216,   217,   218,
      42,   113,   113,    42,    44,    42,    44,     1,    45,    63,
     172,   178,   233,   235,   236,   237,   238,   239,   242,   243,
     244,   233,   220,    44,   199,   209,     6,    58,   107,   208,
      58,     6,    24,   213,    44,    42,   208,   218,   193,   162,
     232,   159,   172,    43,   234,   237,    44,    46,    48,   212,
      46,    46,   240,     3,   245,     1,     6,     7,     8,    42,
      43,    44,    55,    58,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   241,   281,   282,   246,   240,     1,
      11,    36,    37,    38,    39,    41,   247,   248,   249,   250,
     251,   266,    44,     1,     9,   252,   253,   254,   257,     1,
       5,    21,   256,   261,   262,   263,   261,   267,     4,   249,
     250,     1,   258,    11,    43,    45,   255,   256,   281,   282,
      11,   262,   123,   268,    10,    11,   255,   257,   259,   260,
     258,   254,   252,     1,   263,   264,   265,     1,     9,    30,
      31,   269,   273,   275,   276,   278,    44,    46,    11,   264,
     279,   270,   271,    43,    45,   256,   274,   281,   282,    11,
     252,    10,    11,   274,   277,   278,   280,    43,   272,   272,
     273,   273,   273,    44,    46,    44
  };

  // YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.
  const short yyr1[] =
  {
       0,   138,   139,   141,   142,   143,   140,   144,   145,   146,
     146,   147,   147,   148,   148,   148,   148,   148,   149,   150,
     149,   149,   149,   149,   152,   151,   151,   151,   151,   151,
     151,   151,   154,   153,   155,   153,   156,   153,   157,   158,
     153,   159,   159,   160,   160,   161,   161,   162,   163,   163,
     163,   164,   164,   165,   166,   166,   167,   167,   167,   168,
     168,   169,   169,   169,   170,   170,   170,   171,   171,   172,
     172,   172,   172,   173,   174,   174,   175,   175,   175,   176,
     176,   177,   177,   178,   178,   179,   179,   180,   181,   181,
     182,   182,   182,   182,   183,   183,   184,   185,   185,   186,
     186,   186,   187,   187,   189,   188,   190,   188,   191,   191,
     192,   192,   193,   193,   194,   194,   194,   194,   194,   195,
     195,   196,   197,   197,   198,   198,   199,   199,   200,   200,
     200,   200,   201,   201,   202,   203,   203,   204,   204,   205,
     205,   206,   206,   207,   207,   208,   208,   208,   208,   209,
     209,   210,   210,   211,   211,   212,   212,   213,   214,   214,
     214,   215,   215,   215,   216,   216,   217,   217,   218,   218,
     218,   218,   219,   219,   220,   221,   221,   222,   222,   223,
     223,   224,   225,   225,   225,   225,   225,   226,   226,   228,
     227,   229,   227,   230,   230,   231,   231,   232,   232,   234,
     233,   235,   235,   236,   236,   237,   237,   237,   237,   238,
     239,   239,   240,   240,   241,   241,   241,   241,   241,   242,
     243,   243,   244,   245,   246,   245,   247,   247,   247,   247,
     248,   249,   249,   250,   250,   250,   250,   251,   251,   251,
     252,   252,   253,   254,   254,   254,   255,   255,   255,   255,
     255,   256,   257,   258,   258,   258,   259,   259,   259,   260,
     261,   261,   262,   262,   263,   263,   264,   264,   264,   265,
     267,   266,   268,   268,   270,   269,   271,   269,   272,   273,
     273,   273,   274,   274,   274,   274,   274,   275,   275,   276,
     277,   278,   279,   279,   280,   280,   280,   281,   281,   281,
     281,   282,   282,   282,   282,   282,   282,   282,   282,   282,
     282,   282,   282,   282,   282,   282,   282,   282,   282,   282,
     282,   282,   282,   282,   282,   282,   282,   282,   282,   282,
     282,   282,   282,   282,   282,   282,   282,   282,   282,   282,
     282,   282
  };

  // YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.
  const signed char yyr2[] =
  {
       0,     2,     1,     0,     0,     0,     7,     1,     1,     0,
       1,     0,     2,     1,     3,     1,     1,     1,     2,     0,
       4,     2,     2,     2,     0,     4,     2,     2,     2,     2,
       1,     2,     0,     3,     0,     6,     0,     7,     0,     0,
       5,     0,     2,     2,     3,     0,     1,     3,     1,     2,
       3,     1,     1,     2,     0,     1,     1,     1,     1,     2,
       3,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     3,     1,     2,     3,     1,
       4,     1,     3,     3,     3,     1,     2,     4,     1,     2,
       1,     1,     3,     2,     1,     2,     1,     1,     2,     4,
       3,     2,     0,     1,     0,     3,     0,     3,     0,     1,
       1,     4,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     3,     1,     3,     2,     2,     1,     3,
       4,     4,     1,     3,     1,     2,     1,     0,     1,     1,
       2,     1,     1,     0,     2,     0,     1,     1,     1,     0,
       1,     1,     3,     1,     3,     1,     2,     2,     0,     1,
       2,     3,     5,     4,     0,     1,     1,     2,     1,     1,
       1,     1,     1,     2,     1,     1,     3,     0,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     2,     3,     0,
       4,     0,     4,     1,     4,     1,     3,     1,     1,     0,
       3,     0,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     4,     0,     2,     1,     1,     1,     3,     1,     2,
       1,     1,     3,     0,     0,     4,     0,     1,     1,     2,
       1,     1,     2,     1,     1,     1,     1,     2,     4,     6,
       2,     1,     1,     0,     2,     1,     1,     1,     1,     3,
       3,     1,     3,     0,     2,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     0,     2,     1,     1,
       0,     4,     0,     2,     0,     3,     0,     3,     3,     0,
       2,     1,     1,     1,     1,     3,     3,     2,     1,     1,
       1,     3,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
  };


  /* YYDPREC[RULE-NUM] -- Dynamic precedence of rule #RULE-NUM (0 if none).  */
  const signed char yydprec[] =
  {
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0
  };

  /* YYMERGER[RULE-NUM] -- Index of merging function for rule #RULE-NUM.  */
  const signed char yymerger[] =
  {
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0
  };

  /* YYIMMEDIATE[RULE-NUM] -- True iff rule #RULE-NUM is not to be deferred, as
     in the case of predicates.  */
  const bool yyimmediate[] =
  {
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0
  };

  /* YYCONFLP[YYPACT[STATE-NUM]] -- Pointer into YYCONFL of start of
     list of conflicting reductions corresponding to action entry for
     state STATE-NUM in yytable.  0 means no conflicts.  The list in
     yyconfl is terminated by a rule number of 0.  */
  const signed char yyconflp[] =
  {
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0
  };

  /* YYCONFL[I] -- lists of conflicting rule numbers, each terminated by
     0, pointed into by YYCONFLP.  */
        const short yyconfl[] =
  {
       0,   110,     0
  };
} // namespace


/* Error token number */
#define YYTERROR 1


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif

# define YYRHSLOC(Rhs, K) ((Rhs)[K].getState().yyloc)


enum YYRESULTTAG { yyok, yyaccept, yyabort, yyerr };

#define YYCHK(YYE)                              \
  do {                                          \
    YYRESULTTAG yychk_flag = YYE;               \
    if (yychk_flag != yyok)                     \
      return yychk_flag;                        \
  } while (false)

#if YYDEBUG

#define YYCDEBUG if (!yydebug) {} else std::cerr

# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                  \
  do {                                                                  \
    if (yydebug)                                                        \
      {                                                                 \
        std::cerr << Title << ' ';                                      \
        yyparser.yy_symbol_print_ (Kind, Value, Location); \
        std::cerr << '\n';                                              \
      }                                                                 \
  } while (false)

# define YY_REDUCE_PRINT(Args)                  \
  do {                                          \
    if (yydebug)                                \
      yystateStack.yy_reduce_print Args;        \
  } while (false)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;

namespace
{
  using glr_stack = AGC::byacc::glr_stack;
  using glr_state = AGC::byacc::glr_state;

  void yypstack (const glr_stack& yystack, size_t yyk)
    YY_ATTRIBUTE_UNUSED;
  void yypdumpstack (const glr_stack& yystack)
    YY_ATTRIBUTE_UNUSED;
}

#else /* !YYDEBUG */

# define YYCDEBUG if (true) {} else std::cerr
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location) {}
# define YY_REDUCE_PRINT(Args) {}

#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYMAXDEPTH * sizeof (GLRStackItem)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Minimum number of free items on the stack allowed after an
   allocation.  This is to allow allocation and initialization
   to be completed by functions that call yyexpandGLRStack before the
   stack is expanded, thus insuring that all necessary pointers get
   properly redirected to new data.  */
#define YYHEADROOM 2

#ifndef YYSTACKEXPANDABLE
# define YYSTACKEXPANDABLE 1
#endif

namespace
{
  template <typename Parameter>
  class strong_index_alias
  {
  public:
    static strong_index_alias create (std::ptrdiff_t value)
    {
      strong_index_alias result;
      result.value_ = value;
      return result;
    }

    std::ptrdiff_t const& get () const { return value_; }

    size_t uget () const { return static_cast<size_t> (value_); }

    strong_index_alias operator+ (std::ptrdiff_t other) const
    {
      return strong_index_alias (get () + other);
    }

    void operator+= (std::ptrdiff_t other)
    {
      value_ += other;
    }

    strong_index_alias operator- (std::ptrdiff_t other)
    {
      return strong_index_alias (get () - other);
    }

    void operator-= (std::ptrdiff_t other)
    {
      value_ -= other;
    }

    size_t operator- (strong_index_alias other)
    {
      return strong_index_alias (get () - other.get ());
    }

    strong_index_alias& operator++ ()
    {
      ++value_;
      return *this;
    }

    bool isValid () const
    {
      return value_ != INVALID_INDEX;
    }

    void setInvalid()
    {
      value_ = INVALID_INDEX;
    }

    bool operator== (strong_index_alias other)
    {
      return get () == other.get ();
    }

    bool operator!= (strong_index_alias other)
    {
      return get () != other.get ();
    }

    bool operator< (strong_index_alias other)
    {
      return get () < other.get ();
    }

  private:
    static const std::ptrdiff_t INVALID_INDEX;

    // WARNING: 0-initialized.
    std::ptrdiff_t value_;
  }; // class strong_index_alias

  template<typename T>
  const std::ptrdiff_t strong_index_alias<T>::INVALID_INDEX =
    std::numeric_limits<std::ptrdiff_t>::max ();

  using state_set_index = strong_index_alias<struct glr_state_set_tag>;

  state_set_index create_state_set_index (std::ptrdiff_t value)
  {
    return state_set_index::create (value);
  }

  /** State numbers, as in LALR(1) machine */
  using state_num = int;

  /** Rule numbers, as in LALR(1) machine */
  using rule_num = int;

  using parser_type = AGC::byacc;
  using glr_state = parser_type::glr_state;
  using symbol_kind = parser_type::symbol_kind;
  using symbol_kind_type = parser_type::symbol_kind_type;
  using symbol_type = parser_type::symbol_type;
  using value_type = parser_type::value_type;
  using location_type = parser_type::location_type;

  // Forward declarations.
  class glr_stack_item;
  class semantic_option;
} // namespace

namespace
{
  /** Accessing symbol of state YYSTATE.  */
  inline symbol_kind_type
  yy_accessing_symbol (state_num yystate)
  {
    return YY_CAST (symbol_kind_type, yystos[yystate]);
  }

  /** Left-hand-side symbol for rule #YYRULE.  */
  inline symbol_kind_type
  yylhsNonterm (rule_num yyrule)
  {
    return static_cast<symbol_kind_type>(yyr1[yyrule]);
  }

  /** Number of symbols composing the right hand side of rule #RULE.  */
  inline int
  yyrhsLength (rule_num yyrule)
  {
    return yyr2[yyrule];
  }
}

namespace AGC
{
  class byacc::glr_state
  {
  public:
    glr_state ()
      : yyresolved (false)
      , yylrState (0)
      , yyposn (0)
      , yypred (0)
      , yyfirstVal (0)
      , yyloc ()
    {}

    /// Build with a semantic value.
    glr_state (state_num lrState, size_t posn, const value_type& val, const location_type& loc)
      : yyresolved (true)
      , yylrState (lrState)
      , yyposn (posn)
      , yypred (0)
      , yyval ()
      , yyloc (loc)
    {
      switch (yy_accessing_symbol (lrState))
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        yyval.copy< attrbPair > (val);
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        yyval.copy< attrbRefSeq > (val);
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        yyval.copy< attrbTriple > (val);
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        yyval.copy< char_literal > (val);
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        yyval.copy< keyword > (val);
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        yyval.copy< name_literal > (val);
        break;

      case symbol_kind::S_NUM: // "number"
        yyval.copy< numberRep > (val);
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        yyval.copy< symDeclSeq > (val);
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        yyval.copy< symSeq > (val);
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        yyval.copy< typeSeq > (val);
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        yyval.copy< userArgSeq > (val);
        break;

      default:
        break;
    }
}

    /// Build with a semantic option.
    glr_state (state_num lrState, size_t posn)
      : yyresolved (false)
      , yylrState (lrState)
      , yyposn (posn)
      , yypred (0)
      , yyfirstVal (0)
      , yyloc ()
    {}

    glr_state (const glr_state& other)
      : yyresolved (other.yyresolved)
      , yylrState (other.yylrState)
      , yyposn (other.yyposn)
      , yypred (0)
      , yyloc (other.yyloc)
    {
      setPred (other.pred ());
      if (other.yyresolved)
        {
          new (&yyval) value_type ();
          switch (yy_accessing_symbol (other.yylrState))
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        yyval.copy< attrbPair > (other.value ());
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        yyval.copy< attrbRefSeq > (other.value ());
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        yyval.copy< attrbTriple > (other.value ());
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        yyval.copy< char_literal > (other.value ());
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        yyval.copy< keyword > (other.value ());
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        yyval.copy< name_literal > (other.value ());
        break;

      case symbol_kind::S_NUM: // "number"
        yyval.copy< numberRep > (other.value ());
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        yyval.copy< symDeclSeq > (other.value ());
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        yyval.copy< symSeq > (other.value ());
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        yyval.copy< typeSeq > (other.value ());
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        yyval.copy< userArgSeq > (other.value ());
        break;

      default:
        break;
    }

        }
      else
        {
          yyfirstVal = 0;
          setFirstVal (other.firstVal ());
        }
    }

    ~glr_state ()
    {
      if (yyresolved)
        {
          symbol_kind_type yykind = yy_accessing_symbol (yylrState);
          // FIXME: User destructors.
          // Value type destructor.
          switch (yykind)
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        yyval.template destroy< attrbPair > ();
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        yyval.template destroy< attrbRefSeq > ();
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        yyval.template destroy< attrbTriple > ();
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        yyval.template destroy< char_literal > ();
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        yyval.template destroy< keyword > ();
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        yyval.template destroy< name_literal > ();
        break;

      case symbol_kind::S_NUM: // "number"
        yyval.template destroy< numberRep > ();
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        yyval.template destroy< symDeclSeq > ();
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        yyval.template destroy< symSeq > ();
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        yyval.template destroy< typeSeq > ();
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        yyval.template destroy< userArgSeq > ();
        break;

      default:
        break;
    }

          yyval.~value_type ();
        }
    }

    glr_state& operator= (const glr_state& other)
    {
      if (!yyresolved && other.yyresolved)
        new (&yyval) value_type;
      yyresolved = other.yyresolved;
      yylrState = other.yylrState;
      yyposn = other.yyposn;
      setPred (other.pred ());
      if (other.yyresolved)
        switch (yy_accessing_symbol (other.yylrState))
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        yyval.copy< attrbPair > (other.value ());
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        yyval.copy< attrbRefSeq > (other.value ());
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        yyval.copy< attrbTriple > (other.value ());
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        yyval.copy< char_literal > (other.value ());
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        yyval.copy< keyword > (other.value ());
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        yyval.copy< name_literal > (other.value ());
        break;

      case symbol_kind::S_NUM: // "number"
        yyval.copy< numberRep > (other.value ());
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        yyval.copy< symDeclSeq > (other.value ());
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        yyval.copy< symSeq > (other.value ());
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        yyval.copy< typeSeq > (other.value ());
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        yyval.copy< userArgSeq > (other.value ());
        break;

      default:
        break;
    }

      else
        setFirstVal (other.firstVal ());
      yyloc = other.yyloc;
      return *this;
    }

    /** Type tag for the semantic value.  If true, yyval applies, otherwise
     *  yyfirstVal applies.  */
    bool yyresolved;
    /** Number of corresponding LALR(1) machine state.  */
    state_num yylrState;
    /** Source position of the last token produced by my symbol */
    size_t yyposn;

    /// Only call pred() and setPred() on objects in yyitems, not temporaries.
    glr_state* pred ();
    const glr_state* pred () const;
    void setPred (const glr_state* state);

    /// Only call firstVal() and setFirstVal() on objects in yyitems, not
    /// temporaries.
    semantic_option* firstVal ();
    const semantic_option* firstVal () const;
    void setFirstVal (const semantic_option* option);

    value_type& value ()
    {
      return yyval;
    }

    const value_type& value () const
    {
      return yyval;
    }

    void
    destroy (char const *yymsg, AGC::byacc& yyparser);

    /* DEBUGGING ONLY */
  #if YYDEBUG
    void yy_yypstack () const
    {
      if (pred () != YY_NULLPTR)
        {
          pred ()->yy_yypstack ();
          std::cerr << " -> ";
        }
      std::cerr << yylrState << "@" << yyposn;
    }
  #endif

    std::ptrdiff_t indexIn (const glr_stack_item* array) const YY_ATTRIBUTE_UNUSED;

    glr_stack_item* asItem ()
    {
      return asItem(this);
    }

    const glr_stack_item* asItem () const
    {
      return asItem (this);
    }

  private:
    template <typename T>
    static const glr_stack_item* asItem (const T* state)
    {
      return reinterpret_cast<const glr_stack_item*>(state);
    }
    template <typename T>
    static glr_stack_item* asItem (T* state)
    {
      return reinterpret_cast<glr_stack_item*> (state);
    }
    static const char *as_pointer_ (const glr_state *state)
    {
      return reinterpret_cast<const char *> (state);
    }
    static char *as_pointer_ (glr_state *state)
    {
      return reinterpret_cast<char *> (state);
    }
    /** Preceding state in this stack */
    std::ptrdiff_t yypred;
    union {
      /** First in a chain of alternative reductions producing the
       *  nonterminal corresponding to this state, threaded through
       *  yyfirstVal.  Value "0" means empty.  */
      std::ptrdiff_t yyfirstVal;
      /** Semantic value for this state.  */
      value_type yyval;
    };
   // FIXME: Why public?
   public:
    /** Source location for this state.  */
    location_type yyloc;


  }; // class byacc::glr_state
} // namespace AGC


namespace
{
  /** A stack of GLRState representing the different heads during
    * nondeterministic evaluation. */
  class glr_state_set
  {
  public:
    /** Initialize YYSET to a singleton set containing an empty stack.  */
    glr_state_set ()
      : yylastDeleted (YY_NULLPTR)
    {
      yystates.push_back (YY_NULLPTR);
      yylookaheadNeeds.push_back (false);
    }

    // Behave like a vector of states.
    glr_state*& operator[] (state_set_index index)
    {
      return yystates[index.uget()];
    }

    glr_state* operator[] (state_set_index index) const
    {
      return yystates[index.uget()];
    }

    size_t size () const
    {
      return yystates.size ();
    }

    std::vector<glr_state*>::iterator begin ()
    {
      return yystates.begin ();
    }

    std::vector<glr_state*>::iterator end ()
    {
      return yystates.end ();
    }

    bool lookaheadNeeds (state_set_index index) const
    {
      return yylookaheadNeeds[index.uget ()];
    }

    bool setLookaheadNeeds (state_set_index index, bool value)
    {
      return yylookaheadNeeds[index.uget ()] = value;
    }

    /** Invalidate stack #YYK.  */
    void
    yymarkStackDeleted (state_set_index yyk)
    {
      size_t k = yyk.uget ();
      if (yystates[k] != YY_NULLPTR)
        yylastDeleted = yystates[k];
      yystates[k] = YY_NULLPTR;
    }

    /** Undelete the last stack in *this that was marked as deleted.  Can
        only be done once after a deletion, and only when all other stacks have
        been deleted.  */
    void
    yyundeleteLastStack ()
    {
      if (yylastDeleted == YY_NULLPTR || !yystates.empty ())
        return;
      yystates.push_back (yylastDeleted);
      YYCDEBUG << "Restoring last deleted stack as stack #0.\n";
      clearLastDeleted ();
    }

    /** Remove the dead stacks (yystates[i] == YY_NULLPTR) and shift the later
     * ones.  */
    void
    yyremoveDeletes ()
    {
      size_t newsize = yystates.size ();
      /* j is the number of live stacks we have seen.  */
      for (size_t i = 0, j = 0; j < newsize; ++i)
        {
          if (yystates[i] == YY_NULLPTR)
            {
              if (i == j)
                {
                  YYCDEBUG << "Removing dead stacks.\n";
                }
              newsize -= 1;
            }
          else
            {
              yystates[j] = yystates[i];
              /* In the current implementation, it's unnecessary to copy
                 yylookaheadNeeds[i] since, after
                 yyremoveDeletes returns, the parser immediately either enters
                 deterministic operation or shifts a token.  However, it doesn't
                 hurt, and the code might evolve to need it.  */
              yylookaheadNeeds[j] = yylookaheadNeeds[i];
              if (j != i)
                {
                  YYCDEBUG << "Rename stack " << i << " -> " << j << ".\n";
                }
              j += 1;
            }
        }
      yystates.resize (newsize);
      yylookaheadNeeds.resize (newsize);
    }


    state_set_index
    yysplitStack (state_set_index yyk)
    {
      const size_t k = yyk.uget ();
      yystates.push_back (yystates[k]);
      yylookaheadNeeds.push_back (yylookaheadNeeds[k]);
      return create_state_set_index (static_cast<std::ptrdiff_t> (yystates.size () - 1));
    }

    void clearLastDeleted ()
    {
      yylastDeleted = YY_NULLPTR;
    }

  private:

    std::vector<glr_state*> yystates;
    /** During nondeterministic operation, yylookaheadNeeds tracks which
     *  stacks have actually needed the current lookahead.  During deterministic
     *  operation, yylookaheadNeeds[0] is not maintained since it would merely
     *  duplicate !yyla.empty ().  */
    std::vector<bool> yylookaheadNeeds;

    /** The last stack we invalidated.  */
    glr_state* yylastDeleted;
  }; // class glr_state_set
} // namespace

namespace
{
  class semantic_option
  {
  public:
    semantic_option ()
      : yyrule (0)
      , yystate (0)
      , yynext (0)
      , yyla ()
    {}

    semantic_option (rule_num rule)
      : yyrule (rule)
      , yystate (0)
      , yynext (0)
      , yyla ()
    {}

    semantic_option (const semantic_option& that)
      : yyrule (that.yyrule)
      , yystate (that.yystate)
      , yynext (that.yynext)
      , yyla (that.yyla)
    {
    }

    // Needed for the assignment in yynewSemanticOption.
    semantic_option& operator= (const semantic_option& that)
    {
      yyrule = that.yyrule;
      yystate = that.yystate;
      yynext = that.yynext;
      yyla = that.yyla;
      return *this;
    }

    /// Only call state() and setState() on objects in yyitems, not temporaries.
    glr_state* state();
    const glr_state* state() const;
    void setState(const glr_state* s);

    const semantic_option* next () const YY_ATTRIBUTE_UNUSED;
    semantic_option* next ();
    void setNext (const semantic_option* s);

    std::ptrdiff_t indexIn (const glr_stack_item* array) const YY_ATTRIBUTE_UNUSED;

    /** True iff YYY0 and YYY1 represent identical options at the top level.
     *  That is, they represent the same rule applied to RHS symbols
     *  that produce the same terminal symbols.  */
    bool
    isIdenticalTo (const semantic_option& yyy1) const
    {
      if (this->yyrule == yyy1.yyrule)
        {
          const glr_state *yys0, *yys1;
          int yyn;
          for (yys0 = this->state(),
               yys1 = yyy1.state(),
               yyn = yyrhsLength (this->yyrule);
               yyn > 0;
               yys0 = yys0->pred(),
               yys1 = yys1->pred(), yyn -= 1)
            if (yys0->yyposn != yys1->yyposn)
              return false;
          return true;
        }
      else
        return false;
    }

    /** Assuming identicalOptions (YYY0,YYY1), destructively merge the
     *  alternative semantic values for the RHS-symbols of YYY1 and YYY0.  */
    void
    mergeWith (semantic_option& yyy1)
    {
      glr_state *yys0 = this->state ();
      glr_state *yys1 = yyy1.state ();
      for (int yyn = yyrhsLength (this->yyrule);
           yyn > 0;
           yyn -= 1, yys0 = yys0->pred (), yys1 = yys1->pred ())
        {
          if (yys0 == yys1)
            break;
          else if (yys0->yyresolved)
            {
              yys1->yyresolved = true;
              YYASSERT (yys1->yylrState == yys0->yylrState);
              switch (yy_accessing_symbol (yys0->yylrState))
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        yys1->value ().copy< attrbPair > (yys0->value ());
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        yys1->value ().copy< attrbRefSeq > (yys0->value ());
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        yys1->value ().copy< attrbTriple > (yys0->value ());
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        yys1->value ().copy< char_literal > (yys0->value ());
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        yys1->value ().copy< keyword > (yys0->value ());
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        yys1->value ().copy< name_literal > (yys0->value ());
        break;

      case symbol_kind::S_NUM: // "number"
        yys1->value ().copy< numberRep > (yys0->value ());
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        yys1->value ().copy< symDeclSeq > (yys0->value ());
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        yys1->value ().copy< symSeq > (yys0->value ());
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        yys1->value ().copy< typeSeq > (yys0->value ());
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        yys1->value ().copy< userArgSeq > (yys0->value ());
        break;

      default:
        break;
    }

            }
          else if (yys1->yyresolved)
            {
              yys0->yyresolved = true;
              YYASSERT (yys0->yylrState == yys1->yylrState);
              switch (yy_accessing_symbol (yys1->yylrState))
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        yys0->value ().copy< attrbPair > (yys1->value ());
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        yys0->value ().copy< attrbRefSeq > (yys1->value ());
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        yys0->value ().copy< attrbTriple > (yys1->value ());
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        yys0->value ().copy< char_literal > (yys1->value ());
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        yys0->value ().copy< keyword > (yys1->value ());
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        yys0->value ().copy< name_literal > (yys1->value ());
        break;

      case symbol_kind::S_NUM: // "number"
        yys0->value ().copy< numberRep > (yys1->value ());
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        yys0->value ().copy< symDeclSeq > (yys1->value ());
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        yys0->value ().copy< symSeq > (yys1->value ());
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        yys0->value ().copy< typeSeq > (yys1->value ());
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        yys0->value ().copy< userArgSeq > (yys1->value ());
        break;

      default:
        break;
    }

            }
          else
            {
              semantic_option* yyz0prev = YY_NULLPTR;
              semantic_option* yyz0 = yys0->firstVal();
              semantic_option* yyz1 = yys1->firstVal();
              while (true)
                {
                  if (yyz1 == yyz0 || yyz1 == YY_NULLPTR)
                    break;
                  else if (yyz0 == YY_NULLPTR)
                    {
                      if (yyz0prev != YY_NULLPTR)
                        yyz0prev->setNext (yyz1);
                      else
                        yys0->setFirstVal (yyz1);
                      break;
                    }
                  else if (yyz0 < yyz1)
                    {
                      semantic_option* yyz = yyz0;
                      if (yyz0prev != YY_NULLPTR)
                        yyz0prev->setNext(yyz1);
                      else
                        yys0->setFirstVal(yyz1);
                      yyz1 = yyz1->next();
                      yyz0->setNext(yyz);
                    }
                  yyz0prev = yyz0;
                  yyz0 = yyz0->next();
                }
              yys1->setFirstVal(yys0->firstVal());
            }
        }
    }

#if YYDEBUG
    void yyreportTree (size_t yyindent = 2) const
    {
      int yynrhs = yyrhsLength (this->yyrule);
      const glr_state* yystates[1 + YYMAXRHS];
      glr_state yyleftmost_state;

      {
        const glr_state* yys = this->state();
        for (int yyi = yynrhs; 0 < yyi; yyi -= 1)
          {
            yystates[yyi] = yys;
            yys = yys->pred();
          }
        if (yys == YY_NULLPTR)
          {
            yyleftmost_state.yyposn = 0;
            yystates[0] = &yyleftmost_state;
          }
        else
          yystates[0] = yys;
      }

      std::string yylhs = AGC::byacc::symbol_name (yylhsNonterm (this->yyrule));
      YYASSERT(this->state());
      if (this->state()->yyposn < yystates[0]->yyposn + 1)
        std::cerr << std::string(yyindent, ' ') << yylhs << " -> <Rule "
                  << this->yyrule - 1 << ", empty>\n";
      else
        std::cerr << std::string(yyindent, ' ') << yylhs << " -> <Rule "
                  << this->yyrule - 1 << ", tokens "
                  << yystates[0]->yyposn + 1 << " .. "
                  << this->state()->yyposn << ">\n";
      for (int yyi = 1; yyi <= yynrhs; yyi += 1)
        {
          if (yystates[yyi]->yyresolved)
            {
              std::string yysym = AGC::byacc::symbol_name (yy_accessing_symbol (yystates[yyi]->yylrState));
              if (yystates[yyi-1]->yyposn+1 > yystates[yyi]->yyposn)
                std::cerr << std::string(yyindent + 2, ' ') << yysym
                          << " <empty>\n";
              else
                std::cerr << std::string(yyindent + 2, ' ') << yysym
                          << " <tokens " << yystates[yyi-1]->yyposn + 1
                          << " .. " << yystates[yyi]->yyposn << ">\n";
            }
          else
            yystates[yyi]->firstVal ()->yyreportTree (yyindent+2);
        }
    }
#endif

    /** Rule number for this reduction */
    rule_num yyrule;

  private:
    template <typename T>
    static const glr_stack_item* asItem(const T* state)
    {
      return reinterpret_cast<const glr_stack_item*>(state);
    }
    template <typename T>
    static glr_stack_item* asItem(T* state)
    {
      return reinterpret_cast<glr_stack_item*>(state);
    }
    /** The last RHS state in the list of states to be reduced.  */
    std::ptrdiff_t yystate;
    /** Next sibling in chain of options.  To facilitate merging,
     *  options are chained in decreasing order by address.  */
    std::ptrdiff_t yynext;

  public:
    /** The lookahead for this reduction.  */
    symbol_type yyla;


  }; // class semantic_option
} // namespace

namespace
{
  /** Type of the items in the GLR stack.
   *  It can be either a glr_state or a semantic_option. The is_state_ field
   *  indicates which item of the union is valid.  */
  class glr_stack_item
  {
  public:
    glr_stack_item (bool state = true)
      : is_state_ (state)
    {
      if (is_state_)
        new (&raw_) glr_state;
      else
        new (&raw_) semantic_option;
    }

    glr_stack_item (const glr_stack_item& other) YY_NOEXCEPT YY_NOTHROW
      : is_state_ (other.is_state_)
    {
      std::memcpy (raw_, other.raw_, union_size);
    }

    glr_stack_item& operator= (glr_stack_item other)
    {
      std::swap (is_state_, other.is_state_);
      std::swap (raw_, other.raw_);
      return *this;
    }

    ~glr_stack_item ()
    {
      if (is_state ())
        getState ().~glr_state ();
      else
        getOption ().~semantic_option ();
    }

    void setState (const glr_state &state)
    {
      if (this != state.asItem ())
        {
          if (is_state_)
            getState ().~glr_state ();
          else
            getOption ().~semantic_option ();
          new (&raw_) glr_state (state);
          is_state_ = true;
        }
    }

    glr_state& getState ()
    {
      YYDASSERT (is_state ());
      void *yyp = raw_;
      glr_state& res = *static_cast<glr_state*> (yyp);
      return res;
    }

    const glr_state& getState () const
    {
      YYDASSERT (is_state ());
      const void *yyp = raw_;
      const glr_state& res = *static_cast<const glr_state*> (yyp);
      return res;
    }

    semantic_option& getOption ()
    {
      YYDASSERT (!is_state ());
      void *yyp = raw_;
      return *static_cast<semantic_option*> (yyp);
    }
    const semantic_option& getOption () const
    {
      YYDASSERT (!is_state ());
      const void *yyp = raw_;
      return *static_cast<const semantic_option*> (yyp);
    }
    bool is_state () const
    {
      return is_state_;
    }

  private:
    /// The possible contents of raw_. Since they have constructors, they cannot
    /// be directly included in the union.
    union contents
    {
      char yystate[sizeof (glr_state)];
      char yyoption[sizeof (semantic_option)];
    };
    enum { union_size = sizeof (contents) };
    union {
      /// Strongest alignment constraints.
      long double yyalign_me;
      /// A buffer large enough to store the contents.
      char raw_[union_size];
    };
    /** Type tag for the union. */
    bool is_state_;

  }; // class glr_stack_item
} // namespace

glr_state* glr_state::pred ()
{
  YY_IGNORE_NULL_DEREFERENCE_BEGIN
  return yypred ? &asItem (as_pointer_ (this) - yypred)->getState () : YY_NULLPTR;
  YY_IGNORE_NULL_DEREFERENCE_END
}

const glr_state* glr_state::pred () const
{
  YY_IGNORE_NULL_DEREFERENCE_BEGIN
  return yypred ? &asItem (as_pointer_ (this) - yypred)->getState () : YY_NULLPTR;
  YY_IGNORE_NULL_DEREFERENCE_END
}

void glr_state::setPred (const glr_state* state)
{
  yypred = state ? as_pointer_ (this) - as_pointer_ (state) : 0;
}

semantic_option* glr_state::firstVal ()
{
  return yyfirstVal ? &(asItem(this) - yyfirstVal)->getOption() : YY_NULLPTR;
}

const semantic_option* glr_state::firstVal () const
{
  return yyfirstVal ? &(asItem(this) - yyfirstVal)->getOption() : YY_NULLPTR;
}

void glr_state::setFirstVal (const semantic_option* option)
{
  yyfirstVal = option ? asItem(this) - asItem(option) : 0;
}

std::ptrdiff_t glr_state::indexIn (const glr_stack_item* array) const
{
  return asItem(this) - array;
}

std::ptrdiff_t semantic_option::indexIn (const glr_stack_item* array) const
{
  return asItem(this) - array;
}

glr_state* semantic_option::state ()
{
  YY_IGNORE_NULL_DEREFERENCE_BEGIN
  return yystate ? &(asItem(this) - yystate)->getState() : YY_NULLPTR;
  YY_IGNORE_NULL_DEREFERENCE_END
}

const glr_state* semantic_option::state () const
{
  return yystate ? &(asItem(this) - yystate)->getState() : YY_NULLPTR;
}

void semantic_option::setState (const glr_state* s)
{
  yystate = s ? asItem(this) - asItem(s) : 0;
}

const semantic_option* semantic_option::next () const
{
  return yynext ? &(asItem(this) - yynext)->getOption() : YY_NULLPTR;
}

semantic_option* semantic_option::next ()
{
  return yynext ? &(asItem(this) - yynext)->getOption() : YY_NULLPTR;
}

void semantic_option::setNext (const semantic_option* s)
{
  yynext = s ? asItem(this) - asItem(s) : 0;
}

void glr_state::destroy (char const* yymsg, AGC::byacc& yyparser)
{
  if (yyresolved)
    yyparser.yy_destroy_ (yymsg, yy_accessing_symbol(yylrState),
                          value (), yyloc);
  else
    {
#if YYDEBUG
      YYCDEBUG << yymsg
               << (firstVal() ? " unresolved " : " incomplete ")
               << (yy_accessing_symbol (yylrState) < YYNTOKENS ? "token" : "nterm")
               << ' ' << yyparser.symbol_name (yy_accessing_symbol (yylrState))
               << " ("
               << yyloc << ": "
               << ")\n";
#endif
      if (firstVal() != YY_NULLPTR)
        {
          semantic_option& yyoption = *firstVal ();
          glr_state *yyrh = yyoption.state ();
          for (int yyn = yyrhsLength (yyoption.yyrule); yyn > 0; yyn -= 1)
            {
              yyrh->destroy (yymsg, yyparser);
              yyrh = yyrh->pred();
            }
        }
    }
}


#undef YYFILL
#define YYFILL(N) yyfill (yyvsp, yylow, (N), yynormal)

namespace
{
  class state_stack
  {
  public:
    using parser_type = AGC::byacc;
    using symbol_kind = parser_type::symbol_kind;
    using value_type = parser_type::value_type;
    using location_type = parser_type::location_type;

    /** Initialize to a single empty stack, with total maximum
     *  capacity for all stacks of YYSIZE.  */
    state_stack (size_t yysize)
      : yysplitPoint (YY_NULLPTR)
    {
      yyitems.reserve (yysize);
    }

#if YYSTACKEXPANDABLE
    /** Returns false if it tried to expand but could not. */
    bool
    yyexpandGLRStackIfNeeded ()
    {
      return YYHEADROOM <= spaceLeft () || yyexpandGLRStack ();
    }

  private:
    /** If *this is expandable, extend it.  WARNING: Pointers into the
        stack from outside should be considered invalid after this call.
        We always expand when there are 1 or fewer items left AFTER an
        allocation, so that we can avoid having external pointers exist
        across an allocation.  */
    bool
    yyexpandGLRStack ()
    {
      const size_t oldsize = yyitems.size();
      if (YYMAXDEPTH - YYHEADROOM < oldsize)
        return false;
      const size_t yynewSize = YYMAXDEPTH < 2 * oldsize ? YYMAXDEPTH : 2 * oldsize;
      const glr_stack_item *oldbase = &yyitems[0];

      yyitems.reserve (yynewSize);
      const glr_stack_item *newbase = &yyitems[0];

      // Adjust the pointers.  Perform raw pointer arithmetic, as there
      // is no reason for objects to be aligned on their size.
      const ptrdiff_t disp
        = reinterpret_cast<const char*> (newbase) - reinterpret_cast<const char*> (oldbase);
      if (yysplitPoint)
        const_cast<glr_state*&> (yysplitPoint)
          = reinterpret_cast<glr_state*> (reinterpret_cast<char*> (const_cast<glr_state*> (yysplitPoint)) + disp);

      for (std::vector<glr_state*>::iterator
             i = yytops.begin (),
             yyend = yytops.end ();
           i != yyend; ++i)
        if (glr_state_not_null (*i))
          *i = reinterpret_cast<glr_state*>(reinterpret_cast<char*>(*i) + disp);

      return true;
    }

  public:
#else
    bool yyexpandGLRStackIfNeeded ()
    {
      return YYHEADROOM <= spaceLeft ();
    }
#endif
#undef YYSTACKEXPANDABLE

    static bool glr_state_not_null (glr_state* s)
    {
      return s != YY_NULLPTR;
    }

    bool
    reduceToOneStack ()
    {
      using iterator = std::vector<glr_state*>::iterator;
      const iterator yybegin = yytops.begin();
      const iterator yyend = yytops.end();
      const iterator yyit = std::find_if(yybegin, yyend, glr_state_not_null);
      if (yyit == yyend)
        return false;
      for (state_set_index yyk = create_state_set_index(yyit + 1 - yybegin);
           yyk.uget() != numTops(); ++yyk)
        yytops.yymarkStackDeleted (yyk);
      yytops.yyremoveDeletes ();
      yycompressStack ();
      return true;
    }

    /** Called when returning to deterministic operation to clean up the extra
     * stacks. */
    void
    yycompressStack ()
    {
      if (yytops.size() != 1 || !isSplit())
        return;

      // yyr is the state after the split point.
      glr_state* yyr = YY_NULLPTR;
      for (glr_state *yyp = firstTop(), *yyq = yyp->pred();
           yyp != yysplitPoint;
           yyr = yyp, yyp = yyq, yyq = yyp->pred())
        yyp->setPred(yyr);

      // This const_cast is okay, since anyway we have access to the mutable
      // yyitems into which yysplitPoint points.
      glr_stack_item* nextFreeItem
        = const_cast<glr_state*> (yysplitPoint)->asItem () + 1;
      yysplitPoint = YY_NULLPTR;
      yytops.clearLastDeleted ();

      while (yyr != YY_NULLPTR)
        {
          nextFreeItem->setState (*yyr);
          glr_state& nextFreeState = nextFreeItem->getState();
          yyr = yyr->pred();
          nextFreeState.setPred(&(nextFreeItem - 1)->getState());
          setFirstTop (&nextFreeState);
          ++nextFreeItem;
        }
      yyitems.resize(static_cast<size_t>(nextFreeItem - yyitems.data()));
    }

    bool isSplit() const {
      return yysplitPoint != YY_NULLPTR;
    }

    // Present the interface of a vector of glr_stack_item.
    std::vector<glr_stack_item>::const_iterator begin () const
    {
      return yyitems.begin ();
    }

    std::vector<glr_stack_item>::const_iterator end () const
    {
      return yyitems.end ();
    }

    size_t size() const
    {
      return yyitems.size ();
    }

    glr_stack_item& operator[] (size_t i)
    {
      return yyitems[i];
    }

    glr_stack_item& stackItemAt (size_t index)
    {
      return yyitems[index];
    }

    size_t numTops () const
    {
      return yytops.size ();
    }

    glr_state* firstTop () const
    {
      return yytops[create_state_set_index (0)];
    }

    glr_state* topAt (state_set_index i) const
    {
      return yytops[i];
    }

    void setFirstTop (glr_state* value)
    {
      yytops[create_state_set_index (0)] = value;
    }

    void setTopAt (state_set_index i, glr_state* value)
    {
      yytops[i] = value;
    }

    void pop_back ()
    {
      yyitems.pop_back ();
    }

    void pop_back (size_t n)
    {
      yyitems.resize (yyitems.size () - n);
    }

    state_set_index
    yysplitStack (state_set_index yyk)
    {
      if (!isSplit ())
        {
          YYASSERT (yyk.get () == 0);
          yysplitPoint = topAt (yyk);
        }
      return yytops.yysplitStack (yyk);
    }

    /** Assuming that YYS is a GLRState somewhere on *this, update the
     *  splitpoint of *this, if needed, so that it is at least as deep as
     *  YYS.  */
    void
    yyupdateSplit (glr_state& yys)
    {
      if (isSplit() && &yys < yysplitPoint)
        yysplitPoint = &yys;
    }

    /** Return a fresh GLRState.
     * Callers should call yyreserveStack afterwards to make sure there is
     * sufficient headroom.  */
    glr_state& yynewGLRState (const glr_state& newState)
    {
      glr_state& state = yyitems[yynewGLRStackItem (true)].getState ();
#if false && 201103L <= YY_CPLUSPLUS
      state = std::move (newState);
#else
      state = newState;
#endif
      return state;
    }

    /** Return a fresh SemanticOption.
     * Callers should call yyreserveStack afterwards to make sure there is
     * sufficient headroom.  */
    semantic_option& yynewSemanticOption (semantic_option newOption)
    {
      semantic_option& option = yyitems[yynewGLRStackItem (false)].getOption ();
      option = std::move (newOption);
      return option;
    }

    /* Do nothing if YYNORMAL or if *YYLOW <= YYLOW1.  Otherwise, fill in
     * YYVSP[YYLOW1 .. *YYLOW-1] as in yyfillin and set *YYLOW = YYLOW1.
     * For convenience, always return YYLOW1.  */
    int
    yyfill (glr_stack_item *yyvsp, int &yylow, int yylow1, bool yynormal)
    {
      if (!yynormal && yylow1 < yylow)
        {
          yyfillin (yyvsp, yylow, yylow1);
          yylow = yylow1;
        }
      return yylow1;
    }

    /** Fill in YYVSP[YYLOW1 .. YYLOW0-1] from the chain of states starting
     *  at YYVSP[YYLOW0].getState().pred().  Leaves YYVSP[YYLOW1].getState().pred()
     *  containing the pointer to the next state in the chain.  */
    void
    yyfillin (glr_stack_item *yyvsp, int yylow0, int yylow1)
    {
      glr_state* s = yyvsp[yylow0].getState().pred();
      YYASSERT(s != YY_NULLPTR);
      for (int i = yylow0-1; i >= yylow1; i -= 1, s = s->pred())
        {
          glr_state& yys = yyvsp[i].getState();
#if YYDEBUG
          yys.yylrState = s->yylrState;
#endif
          yys.yyresolved = s->yyresolved;
          if (s->yyresolved)
            {
              new (&yys.value ()) value_type ();
              switch (yy_accessing_symbol (s->yylrState))
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        yys.value ().copy< attrbPair > (s->value ());
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        yys.value ().copy< attrbRefSeq > (s->value ());
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        yys.value ().copy< attrbTriple > (s->value ());
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        yys.value ().copy< char_literal > (s->value ());
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        yys.value ().copy< keyword > (s->value ());
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        yys.value ().copy< name_literal > (s->value ());
        break;

      case symbol_kind::S_NUM: // "number"
        yys.value ().copy< numberRep > (s->value ());
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        yys.value ().copy< symDeclSeq > (s->value ());
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        yys.value ().copy< symSeq > (s->value ());
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        yys.value ().copy< typeSeq > (s->value ());
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        yys.value ().copy< userArgSeq > (s->value ());
        break;

      default:
        break;
    }

            }
          else
            /* The effect of using yyval or yyloc (in an immediate
             * rule) is undefined.  */
            yys.setFirstVal (YY_NULLPTR);
          yys.yyloc = s->yyloc;
          yys.setPred(s->pred());
        }
    }

#if YYDEBUG

    /*----------------------------------------------------------------------.
    | Report that stack #YYK of *YYSTACKP is going to be reduced by YYRULE. |
    `----------------------------------------------------------------------*/

    void
    yy_reduce_print (bool yynormal, glr_stack_item* yyvsp, state_set_index yyk,
                     rule_num yyrule, parser_type& yyparser)
    {
      int yynrhs = yyrhsLength (yyrule);
      int yylow = 1;
      int yyi;
      std::cerr << "Reducing stack " << yyk.get() << " by rule " << yyrule - 1
                << " (line " << int (yyrline[yyrule]) << "):\n";
      if (! yynormal)
        yyfillin (yyvsp, 1, -yynrhs);
      /* The symbols being reduced.  */
      for (yyi = 0; yyi < yynrhs; yyi++)
        {
          std::cerr << "   $" << yyi + 1 << " = ";
          yyparser.yy_symbol_print_
            (yy_accessing_symbol (yyvsp[yyi - yynrhs + 1].getState().yylrState),
             yyvsp[yyi - yynrhs + 1].getState().value (),
             ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL ((yyi + 1) - (yynrhs))].getState().yyloc));
          if (!yyvsp[yyi - yynrhs + 1].getState().yyresolved)
            std::cerr << " (unresolved)";
          std::cerr << '\n';
        }
    }


#define YYINDEX(YYX)                                                         \
      ((YYX) == YY_NULLPTR ? -1 : (YYX)->indexIn (yyitems.data ()))

    void
    dumpStack () const
    {
      for (size_t yyi = 0; yyi < size(); ++yyi)
        {
          const glr_stack_item& item = yyitems[yyi];
          std::cerr << std::setw(3) << yyi << ". ";
          if (item.is_state())
            {
              std::cerr << "Res: " << item.getState().yyresolved
                        << ", LR State: " << item.getState().yylrState
                        << ", posn: " << item.getState().yyposn
                        << ", pred: " << YYINDEX(item.getState().pred());
              if (! item.getState().yyresolved)
                std::cerr << ", firstVal: "
                          << YYINDEX(item.getState().firstVal());
            }
          else
            {
              std::cerr << "Option. rule: " << item.getOption().yyrule - 1
                        << ", state: " << YYINDEX(item.getOption().state())
                        << ", next: " << YYINDEX(item.getOption().next());
            }
          std::cerr << '\n';
        }
      std::cerr << "Tops:";
      for (state_set_index yyi = create_state_set_index(0); yyi.uget() < numTops(); ++yyi) {
        std::cerr << yyi.get() << ": " << YYINDEX(topAt(yyi)) << "; ";
      }
      std::cerr << '\n';
    }

#undef YYINDEX
#endif

    YYRESULTTAG
    yyreportAmbiguity (const semantic_option& yyx0,
                       const semantic_option& yyx1, parser_type& yyparser, const location_type& yyloc)
    {
      YY_USE (yyx0);
      YY_USE (yyx1);

#if YYDEBUG
      std::cerr << "Ambiguity detected.\n"
        "Option 1,\n";
      yyx0.yyreportTree ();
      std::cerr << "\nOption 2,\n";
      yyx1.yyreportTree ();
      std::cerr << '\n';
#endif

      yyparser.error (yyloc, YY_("syntax is ambiguous"));
      return yyabort;
    }

#if YYDEBUG
    /* Print YYS (possibly NULL) and its predecessors. */
    void
    yypstates (const glr_state* yys) const
    {
      if (yys != YY_NULLPTR)
        yys->yy_yypstack();
      else
        std::cerr << "<null>";
      std::cerr << '\n';
    }
#endif

  private:
    size_t spaceLeft() const
    {
      return yyitems.capacity() - yyitems.size();
    }

    /** Return a fresh GLRStackItem in this.  The item is an LR state
     *  if YYIS_STATE, and otherwise a semantic option.  Callers should call
     *  yyreserveStack afterwards to make sure there is sufficient
     *  headroom.  */
    size_t
    yynewGLRStackItem (bool yyis_state)
    {
      YYDASSERT(yyitems.size() < yyitems.capacity());
      yyitems.push_back(glr_stack_item(yyis_state));
      return yyitems.size() - 1;
    }


  public:
    std::vector<glr_stack_item> yyitems;
    // Where the stack splits. Anything below this address is deterministic.
    const glr_state* yysplitPoint;
    glr_state_set yytops;
  }; // class state_stack
} // namespace

#undef YYFILL
#define YYFILL(N) yystateStack.yyfill (yyvsp, yylow, (N), yynormal)

namespace AGC
{
  class byacc::glr_stack
  {
  public:

    // Needs access to yypact_value_is_default, etc.
    friend context;


    glr_stack (size_t yysize, parser_type& yyparser_yyarg, AGC::byaccLexer& theLexer_yyarg, yoxControl& ctrl_yyarg, specIO& theFiles_yyarg)
      : yyerrState (0)
      , yystateStack (yysize)
      , yyerrcnt (0)
      , yyla ()
      , yyparser (yyparser_yyarg),
      theLexer (theLexer_yyarg),
      ctrl (ctrl_yyarg),
      theFiles (theFiles_yyarg)
    {}

    ~glr_stack ()
    {
      if (!this->yyla.empty ())
        yyparser.yy_destroy_ ("Cleanup: discarding lookahead",
                              this->yyla.kind (), this->yyla.value, this->yyla.location);
      popall_ ();
    }

    int yyerrState;
  /* To compute the location of the error token.  */
    glr_stack_item yyerror_range[3];
    state_stack yystateStack;
    int yyerrcnt;
    symbol_type yyla;
    YYJMP_BUF yyexception_buffer;
    parser_type& yyparser;

  #define YYCHK1(YYE)                                                          \
    do {                                                                       \
      switch (YYE) {                                                           \
      case yyok:                                                               \
        break;                                                                 \
      case yyabort:                                                            \
        goto yyabortlab;                                                       \
      case yyaccept:                                                           \
        goto yyacceptlab;                                                      \
      case yyerr:                                                              \
        goto yyuser_error;                                                     \
      default:                                                                 \
        goto yybuglab;                                                         \
      }                                                                        \
    } while (false)

    int
    parse ()
    {
      int yyresult;
      size_t yyposn;

      YYCDEBUG << "Starting parse\n";

      this->yyla.clear ();

      // User initialization code.
#line 19 "agc-byacc.yy"
{
  yyla.location.initialize (&theFiles.inName);

  yoxOutGdefs.setCurPos (yyla.location.begin);
  yoxOutG.setCurPos (yyla.location.begin);
  yoxOutGimport.setCurPos (yyla.location.begin);

  yoxOutH.setCurPos (yyla.location.begin);
  yoxOutHrequires.setCurPos (yyla.location.begin);
  yoxOutHprovides.setCurPos (yyla.location.begin);

  actionCLOSER.setCurPos (yyla.location.begin);
  attrDECL.setCurPos (yyla.location.begin);
  possibleLHS.setCurPos (yyla.location.begin);
  ruleDIRECTIVE.setCurPos (yyla.location.begin);
  unionBODY.setCurPos (yyla.location.begin);
  yaccCODE.setCurPos (yyla.location.begin);

  separatorMARK.setCurPos (yyla.location.begin);
}

#line 4412 "agc-byacc.cc"


      switch (YYSETJMP (this->yyexception_buffer))
        {
        case 0: break;
        case 1: goto yyabortlab;
        case 2: goto yyexhaustedlab;
        default: goto yybuglab;
        }
      this->yyglrShift (create_state_set_index(0), 0, 0, this->yyla.value, this->yyla.location);
      yyposn = 0;

      while (true)
        {
          /* For efficiency, we have two loops, the first of which is
             specialized to deterministic operation (single stack, no
             potential ambiguity).  */
          /* Standard mode */
          while (true)
            {
              const state_num yystate = this->firstTopState()->yylrState;
              YYCDEBUG << "Entering state " << yystate << '\n';
              if (yystate == YYFINAL)
                goto yyacceptlab;
              if (yy_is_defaulted_state (yystate))
                {
                  const rule_num yyrule = yy_default_action (yystate);
                  if (yyrule == 0)
                    {
                      this->yyerror_range[1].getState().yyloc = this->yyla.location;
                      this->yyreportSyntaxError ();
                      goto yyuser_error;
                    }
                  YYCHK1 (this->yyglrReduce (create_state_set_index(0), yyrule, true));
                }
              else
                {
                  yyget_token ();
                  const short* yyconflicts;
                  const int yyaction = yygetLRActions (yystate, this->yyla.kind (), yyconflicts);
                  if (*yyconflicts != 0)
                    break;
                  if (yy_is_shift_action (yyaction))
                    {
                      YY_SYMBOL_PRINT ("Shifting", this->yyla.kind (), this->yyla.value, this->yyla.location);
                      yyposn += 1;
                      // FIXME: we should move yylval.
                      this->yyglrShift (create_state_set_index(0), yyaction, yyposn, this->yyla.value, this->yyla.location);
                      yyla.clear ();
                      if (0 < this->yyerrState)
                        this->yyerrState -= 1;
                    }
                  else if (yy_is_error_action (yyaction))
                    {
                      this->yyerror_range[1].getState().yyloc = this->yyla.location;
                      /* Don't issue an error message again for exceptions
                         thrown from the scanner.  */
                      if (this->yyla.kind () != symbol_kind::S_YYerror)
                        this->yyreportSyntaxError ();
                      goto yyuser_error;
                    }
                  else
                    YYCHK1 (this->yyglrReduce (create_state_set_index(0), -yyaction, true));
                }
            }

          while (true)
            {
              for (state_set_index yys = create_state_set_index(0); yys.uget() < this->yystateStack.numTops(); ++yys)
                this->yystateStack.yytops.setLookaheadNeeds(yys, !this->yyla.empty ());

              /* yyprocessOneStack returns one of three things:

                  - An error flag.  If the caller is yyprocessOneStack, it
                    immediately returns as well.  When the caller is finally
                    yyparse, it jumps to an error label via YYCHK1.

                  - yyok, but yyprocessOneStack has invoked yymarkStackDeleted
                    (yys), which sets the top state of yys to NULL.  Thus,
                    yyparse's following invocation of yyremoveDeletes will remove
                    the stack.

                  - yyok, when ready to shift a token.

                 Except in the first case, yyparse will invoke yyremoveDeletes and
                 then shift the next token onto all remaining stacks.  This
                 synchronization of the shift (that is, after all preceding
                 reductions on all stacks) helps prevent double destructor calls
                 on yylval in the event of memory exhaustion.  */

              for (state_set_index yys = create_state_set_index (0); yys.uget () < this->yystateStack.numTops (); ++yys)
                YYCHK1 (this->yyprocessOneStack (yys, yyposn, &this->yyla.location));
              this->yystateStack.yytops.yyremoveDeletes ();
              if (this->yystateStack.yytops.size() == 0)
                {
                  this->yystateStack.yytops.yyundeleteLastStack ();
                  if (this->yystateStack.yytops.size() == 0)
                    this->yyFail (&this->yyla.location, YY_("syntax error"));
                  YYCHK1 (this->yyresolveStack ());
                  YYCDEBUG << "Returning to deterministic operation.\n";
                  this->yyerror_range[1].getState ().yyloc = this->yyla.location;
                  this->yyreportSyntaxError ();
                  goto yyuser_error;
                }

              /* If any yyglrShift call fails, it will fail after shifting.  Thus,
                 a copy of yylval will already be on stack 0 in the event of a
                 failure in the following loop.  Thus, yyla is emptied
                 before the loop to make sure the user destructor for yylval isn't
                 called twice.  */
              symbol_kind_type yytoken_to_shift = this->yyla.kind ();
              this->yyla.kind_ = symbol_kind::S_YYEMPTY;
              yyposn += 1;
              for (state_set_index yys = create_state_set_index (0); yys.uget () < this->yystateStack.numTops (); ++yys)
                {
                  const state_num yystate = this->topState (yys)->yylrState;
                  const short* yyconflicts;
                  const int yyaction = yygetLRActions (yystate, yytoken_to_shift, yyconflicts);
                  /* Note that yyconflicts were handled by yyprocessOneStack.  */
                  YYCDEBUG << "On stack " << yys.get() << ", ";
                  YY_SYMBOL_PRINT ("shifting", yytoken_to_shift, this->yyla.value, this->yyla.location);
                  this->yyglrShift (yys, yyaction, yyposn, this->yyla.value, this->yyla.location);
                  YYCDEBUG << "Stack " << yys.get() << " now in state "
                           << this->topState(yys)->yylrState << '\n';
                }

                // FIXME: User destructors.
                // Value type destructor.
                switch (yytoken_to_shift)
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        this->yyla.value.template destroy< attrbPair > ();
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        this->yyla.value.template destroy< attrbRefSeq > ();
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        this->yyla.value.template destroy< attrbTriple > ();
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        this->yyla.value.template destroy< char_literal > ();
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        this->yyla.value.template destroy< keyword > ();
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        this->yyla.value.template destroy< name_literal > ();
        break;

      case symbol_kind::S_NUM: // "number"
        this->yyla.value.template destroy< numberRep > ();
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        this->yyla.value.template destroy< symDeclSeq > ();
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        this->yyla.value.template destroy< symSeq > ();
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        this->yyla.value.template destroy< typeSeq > ();
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        this->yyla.value.template destroy< userArgSeq > ();
        break;

      default:
        break;
    }


              if (this->yystateStack.yytops.size () == 1)
                {
                  YYCHK1 (this->yyresolveStack ());
                  YYCDEBUG << "Returning to deterministic operation.\n";
                  this->yystateStack.yycompressStack ();
                  break;
                }
            }
          continue;
        yyuser_error:
          this->yyrecoverSyntaxError (&this->yyla.location);
          yyposn = this->firstTopState()->yyposn;
        }

    yyacceptlab:
      yyresult = 0;
      goto yyreturn;

    yybuglab:
      YYASSERT (false);
      goto yyabortlab;

    yyabortlab:
      yyresult = 1;
      goto yyreturn;

    yyexhaustedlab:
      yyparser.error (this->yyla.location, YY_("memory exhausted"));
      yyresult = 2;
      goto yyreturn;

    yyreturn:
      return yyresult;
    }
  #undef YYCHK1

    void yyreserveGlrStack ()
    {
      if (!yystateStack.yyexpandGLRStackIfNeeded ())
        yyMemoryExhausted ();
    }

    _Noreturn void
    yyMemoryExhausted ()
    {
      YYLONGJMP (yyexception_buffer, 2);
    }

    _Noreturn void
    yyFail (location_type* yylocp, const char* yymsg)
    {
      if (yymsg != YY_NULLPTR)
        yyparser.error (*yylocp, yymsg);
      YYLONGJMP (yyexception_buffer, 1);
    }

                                  /* GLRStates */


    /** Add a new semantic action that will execute the action for rule
     *  YYRULE on the semantic values in YYRHS to the list of
     *  alternative actions for YYSTATE.  Assumes that YYRHS comes from
     *  stack #YYK of *this. */
    void
    yyaddDeferredAction (state_set_index yyk, glr_state* yystate,
                         glr_state* yyrhs, rule_num yyrule)
    {
      semantic_option& yyopt = yystateStack.yynewSemanticOption (semantic_option (yyrule));
      yyopt.setState (yyrhs);
      yyopt.setNext (yystate->firstVal ());
      if (yystateStack.yytops.lookaheadNeeds (yyk))
        yyopt.yyla = this->yyla;
      yystate->setFirstVal (&yyopt);

      yyreserveGlrStack ();
    }

  #if YYDEBUG
    void yypdumpstack () const
    {
      yystateStack.dumpStack();
    }
  #endif

    void
    yyreportSyntaxError ()
    {
      if (yyerrState != 0)
        return;

      context yyctx (*this, yyla);
      yyparser.report_syntax_error (yyctx);
      yyerrcnt += 1;
    }

    /* Recover from a syntax error on this, assuming that yytoken,
       yylval, and yylloc are the syntactic category, semantic value, and location
       of the lookahead.  */
    void
    yyrecoverSyntaxError (location_type* yylocp)
    {
      if (yyerrState == 3)
        /* We just shifted the error token and (perhaps) took some
           reductions.  Skip tokens until we can proceed.  */
        while (true)
          {
            if (this->yyla.kind () == symbol_kind::S_YYEOF)
              yyFail (yylocp, YY_NULLPTR);
            if (this->yyla.kind () != symbol_kind::S_YYEMPTY)
              {
                /* We throw away the lookahead, but the error range
                   of the shifted error token must take it into account.  */
                glr_state *yys = firstTopState();
                yyerror_range[1].getState().yyloc = yys->yyloc;
                yyerror_range[2].getState().yyloc = this->yyla.location;
                YYLLOC_DEFAULT ((yys->yyloc), yyerror_range, 2);
                yyparser.yy_destroy_ ("Error: discarding",
                                      this->yyla.kind (), this->yyla.value, this->yyla.location);
                // Value type destructor.
                switch (this->yyla.kind ())
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        this->yyla.value.template destroy< attrbPair > ();
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        this->yyla.value.template destroy< attrbRefSeq > ();
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        this->yyla.value.template destroy< attrbTriple > ();
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        this->yyla.value.template destroy< char_literal > ();
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        this->yyla.value.template destroy< keyword > ();
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        this->yyla.value.template destroy< name_literal > ();
        break;

      case symbol_kind::S_NUM: // "number"
        this->yyla.value.template destroy< numberRep > ();
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        this->yyla.value.template destroy< symDeclSeq > ();
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        this->yyla.value.template destroy< symSeq > ();
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        this->yyla.value.template destroy< typeSeq > ();
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        this->yyla.value.template destroy< userArgSeq > ();
        break;

      default:
        break;
    }

                this->yyla.kind_ = symbol_kind::S_YYEMPTY;
              }
            yyget_token ();
            int yyj = yypact[firstTopState()->yylrState];
            if (yypact_value_is_default (yyj))
              return;
            yyj += this->yyla.kind ();
            if (yyj < 0 || YYLAST < yyj || yycheck[yyj] != this->yyla.kind ())
              {
                if (yydefact[firstTopState()->yylrState] != 0)
                  return;
              }
            else if (! yytable_value_is_error (yytable[yyj]))
              return;
          }

      if (!yystateStack.reduceToOneStack())
        yyFail (yylocp, YY_NULLPTR);

      /* Now pop stack until we find a state that shifts the error token.  */
      yyerrState = 3;
      while (firstTopState () != YY_NULLPTR)
        {
          glr_state *yys = firstTopState ();
          int yyj = yypact[yys->yylrState];
          if (! yypact_value_is_default (yyj))
            {
              yyj += YYTERROR;
              if (0 <= yyj && yyj <= YYLAST && yycheck[yyj] == YYTERROR
                  && yy_is_shift_action (yytable[yyj]))
                {
                  /* Shift the error token.  */
                  /* First adjust its location.*/
                  location_type yyerrloc;
                  yyerror_range[2].getState().yyloc = this->yyla.location;
                  YYLLOC_DEFAULT (yyerrloc, (yyerror_range), 2);
                  YY_SYMBOL_PRINT ("Shifting", yy_accessing_symbol (yytable[yyj]),
                                   this->yyla.value, yyerrloc);
                  yyglrShift (create_state_set_index(0), yytable[yyj],
                              yys->yyposn, yyla.value, yyerrloc);
                  yys = firstTopState();
                  break;
                }
            }
          yyerror_range[1].getState().yyloc = yys->yyloc;
          if (yys->pred() != YY_NULLPTR)
            yys->destroy ("Error: popping", yyparser);
          yystateStack.setFirstTop(yys->pred());
          yystateStack.pop_back();
        }
      if (firstTopState() == YY_NULLPTR)
        yyFail (yylocp, YY_NULLPTR);
    }

    YYRESULTTAG
    yyprocessOneStack (state_set_index yyk,
                       size_t yyposn, location_type* yylocp)
    {
      while (yystateStack.topAt(yyk) != YY_NULLPTR)
        {
          const state_num yystate = topState(yyk)->yylrState;
          YYCDEBUG << "Stack " << yyk.get()
                   << " Entering state " << yystate << '\n';

          YYASSERT (yystate != YYFINAL);

          if (yy_is_defaulted_state (yystate))
            {
              const rule_num yyrule = yy_default_action (yystate);
              if (yyrule == 0)
                {
                  YYCDEBUG << "Stack " << yyk.get() << " dies.\n";
                  yystateStack.yytops.yymarkStackDeleted (yyk);
                  return yyok;
                }
              const YYRESULTTAG yyflag
                = yyglrReduce (yyk, yyrule, yyimmediate[yyrule]);
              if (yyflag == yyerr)
                {
                  YYCDEBUG << "Stack " << yyk.get() << " dies"
                    " (predicate failure or explicit user error).\n";
                  yystateStack.yytops.yymarkStackDeleted (yyk);
                  return yyok;
                }
              if (yyflag != yyok)
                return yyflag;
            }
          else
            {
              yystateStack.yytops.setLookaheadNeeds(yyk, true);
              yyget_token ();
              const short* yyconflicts;
              const int yyaction = yygetLRActions (yystate, this->yyla.kind (), yyconflicts);

              for (; *yyconflicts != 0; ++yyconflicts)
                {
                  state_set_index yynewStack = yystateStack.yysplitStack (yyk);
                  YYCDEBUG << "Splitting off stack " << yynewStack.get()
                           << " from " << yyk.get() << ".\n";
                  YYRESULTTAG yyflag =
                    yyglrReduce (yynewStack, *yyconflicts, yyimmediate[*yyconflicts]);
                  if (yyflag == yyok)
                    YYCHK (yyprocessOneStack (yynewStack,
                                              yyposn, yylocp));
                  else if (yyflag == yyerr)
                    {
                      YYCDEBUG << "Stack " << yynewStack.get() << " dies.\n";
                      yystateStack.yytops.yymarkStackDeleted (yynewStack);
                    }
                  else
                    return yyflag;
                }

              if (yy_is_shift_action (yyaction))
                break;
              else if (yy_is_error_action (yyaction))
                {
                  YYCDEBUG << "Stack " << yyk.get() << " dies.\n";
                  yystateStack.yytops.yymarkStackDeleted (yyk);
                  break;
                }
              else
                {
                  YYRESULTTAG yyflag
                    = yyglrReduce (yyk, -yyaction, yyimmediate[-yyaction]);
                  if (yyflag == yyerr)
                    {
                      YYCDEBUG << "Stack " << yyk.get() << " dies"
                        " (predicate failure or explicit user error).\n";
                      yystateStack.yytops.yymarkStackDeleted (yyk);
                      break;
                    }
                  else if (yyflag != yyok)
                    return yyflag;
                }
            }
        }
      return yyok;
    }

    /** Perform user action for rule number YYN, with RHS length YYRHSLEN,
     *  and top stack item YYVSP.  YYVALP points to place to put semantic
     *  value ($$), and yylocp points to place for location information
     *  (@$).  Returns yyok for normal return, yyaccept for YYACCEPT,
     *  yyerr for YYERROR, yyabort for YYABORT.  */
    YYRESULTTAG
    yyuserAction (rule_num yyrule, int yyrhslen, glr_stack_item* yyvsp, state_set_index yyk,
                  value_type* yyvalp, location_type* yylocp)
    {
      bool yynormal YY_ATTRIBUTE_UNUSED = !yystateStack.isSplit();
      int yylow = 1;
  YY_USE (yyvalp);
  YY_USE (yylocp);
  YY_USE (theLexer);
  YY_USE (ctrl);
  YY_USE (theFiles);
      YY_USE (yyk);
      YY_USE (yyrhslen);
    # undef yyerrok
    # define yyerrok (yyerrState = 0)
    # undef YYACCEPT
    # define YYACCEPT return yyaccept
    # undef YYABORT
    # define YYABORT return yyabort
    # undef YYERROR
    # define YYERROR return yyerrok, yyerr
    # undef YYRECOVERING
    # define YYRECOVERING() (yyerrState != 0)
    # undef yytoken
    # define yytoken this->yyla.kind_
    # undef yyclearin
    # define yyclearin (yytoken = symbol_kind::S_YYEMPTY)
    # undef YYBACKUP
    # define YYBACKUP(Token, Value)                                              \
      return yyparser.error (*yylocp, YY_("syntax error: cannot back up")),     \
             yyerrok, yyerr


      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      // However we really need to prepare yyvsp now if we want to get
      // correct locations, so invoke YYFILL for $1 anyway.
      (void) YYFILL (1-yyrhslen);
      switch (yylhsNonterm (yyrule))
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        (*yyvalp).emplace< attrbPair > ();
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        (*yyvalp).emplace< attrbRefSeq > ();
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        (*yyvalp).emplace< attrbTriple > ();
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        (*yyvalp).emplace< char_literal > ();
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        (*yyvalp).emplace< keyword > ();
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        (*yyvalp).emplace< name_literal > ();
        break;

      case symbol_kind::S_NUM: // "number"
        (*yyvalp).emplace< numberRep > ();
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        (*yyvalp).emplace< symDeclSeq > ();
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        (*yyvalp).emplace< symSeq > ();
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        (*yyvalp).emplace< typeSeq > ();
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        (*yyvalp).emplace< userArgSeq > ();
        break;

      default:
        break;
    }

      /* Default location. */
      YYLLOC_DEFAULT ((*yylocp), (yyvsp - yyrhslen), yyrhslen);
      yyerror_range[1].getState().yyloc = *yylocp;

    /* If yyk == -1, we are running a deferred action on a temporary
       stack.  In that case, YY_REDUCE_PRINT must not play with YYFILL,
       so pretend the stack is "normal". */
    YY_REDUCE_PRINT ((yynormal || yyk == create_state_set_index (-1), yyvsp, yyk, yyrule, yyparser));
    #if YY_EXCEPTIONS
      try
      {
    #endif // YY_EXCEPTIONS
      switch (yyrule)
        {
      case 3: // $@1: %empty
#line 538 "agc-byacc.yy"
      {
        finishYfileDefinitionSection (sortTable);
      }
#line 5311 "agc-byacc.cc"
    break;

  case 4: // $@2: %empty
#line 542 "agc-byacc.yy"
      {
        yoxOutG.append (separatorMARK); // holds the 1st "%%" line
        separatorMARK.clear ();

        // add the 'omitted Lexer return' token & memoize its index
        setupOmittedRetSym ();

        // add the 'error' token & memoize its index
        setupErrorSym ();
      }
#line 5326 "agc-byacc.cc"
    break;

  case 5: // $@3: %empty
#line 553 "agc-byacc.yy"
      {
        temp1Out.putSolveAndSignalTrailer ();
        temp1Out.putTravCode ();
        temp1Out.putRootAttrbRefSection ();
      }
#line 5336 "agc-byacc.cc"
    break;

  case 6: // parser_spec: parser_spec_definition_section $@1 "%%" $@2 parser_spec_rules_section $@3 tail
#line 559 "agc-byacc.yy"
      {
        finishYfileRulesSection ();
      }
#line 5344 "agc-byacc.cc"
    break;

  case 9: // tail: %empty
#line 574 "agc-byacc.yy"
      {
        yoxOutG.gen ().put ("\n%%\n");
      }
#line 5352 "agc-byacc.cc"
    break;

  case 10: // tail: "%%"
#line 578 "agc-byacc.yy"
      {
        yoxOutG.append (separatorMARK); // holds the 2nd "%%" line
        separatorMARK.clear ();
      }
#line 5361 "agc-byacc.cc"
    break;

  case 11: // definition_seq: %empty
#line 586 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
      }
#line 5369 "agc-byacc.cc"
    break;

  case 13: // definition: yacc_directive
#line 594 "agc-byacc.yy"
      {
        if (oxAttrbsDecl)
          {
            agc_syntax_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                              "syntax error, "
                              "\"" + (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > () + "\""
                              " directive follows an Ox declaration.");
            yyerrcnt++;
          }
      }
#line 5384 "agc-byacc.cc"
    break;

  case 16: // definition: ox_directive
#line 607 "agc-byacc.yy"
      {
        oxAttrbsDecl = true;
      }
#line 5392 "agc-byacc.cc"
    break;

  case 17: // definition: error
#line 611 "agc-byacc.yy"
      {
        yyclearin;
      }
#line 5400 "agc-byacc.cc"
    break;

  case 18: // yacc_directive: "%start" "nonterminal symbol"
#line 618 "agc-byacc.yy"
      {
        yoxOutGdefs.gen ().put (yoxPrefix (augNstr));

        installStartSym (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ());

        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > ();
      }
#line 5412 "agc-byacc.cc"
    break;

  case 19: // $@4: %empty
#line 626 "agc-byacc.yy"
      {
        if (yaccUnionDefined++ == 0)
          yoxOutGdefs.gen ()
              .put ("/* `%union\' declaration was here */\n");
        else
          yoxOutGdefs.gen ()
              .put ("/* `%union\' "
                    "#" + std::to_string (yaccUnionDefined) +
                    " declaration was here */\n");
      }
#line 5427 "agc-byacc.cc"
    break;

  case 20: // yacc_directive: "%union" $@4 "{" "}"
#line 639 "agc-byacc.yy"
      {
        if (yaccUnionDefined > 1)
          multipleYYSTYPEdefinitions ((*yylocp), "%union");

        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-3)].getState().value ().as < keyword > ();
      }
#line 5438 "agc-byacc.cc"
    break;

  case 21: // yacc_directive: "%token" token_decl_list
#line 646 "agc-byacc.yy"
      {
        const symDeclSeq& token_decl_list = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symDeclSeq > ();

        try
          {
            global_symDeclSeq.insert (global_symDeclSeq.end (),
                                      token_decl_list.cbegin (),
                                      token_decl_list.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > ();
      }
#line 5459 "agc-byacc.cc"
    break;

  case 22: // yacc_directive: precedence_declarer precedence_decl_list
#line 663 "agc-byacc.yy"
      {
        const symDeclSeq& precedence_decl_list = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symDeclSeq > ();

        try
          {
            global_symDeclSeq.insert (global_symDeclSeq.end (),
                                      precedence_decl_list.cbegin (),
                                      precedence_decl_list.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > ();
      }
#line 5480 "agc-byacc.cc"
    break;

  case 23: // yacc_directive: nonterminal_declarer nonterminal_decl_list
#line 680 "agc-byacc.yy"
      {
        const symDeclSeq& nonterminal_decl_list = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symDeclSeq > ();

        try
          {
            global_symDeclSeq.insert (global_symDeclSeq.end (),
                                      nonterminal_decl_list.cbegin (),
                                      nonterminal_decl_list.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > ();
      }
#line 5501 "agc-byacc.cc"
    break;

  case 24: // $@5: %empty
#line 700 "agc-byacc.yy"
      {
        hasDefaultTypedSymbol = false;
      }
#line 5509 "agc-byacc.cc"
    break;

  case 25: // bison_or_byacc_directive: "%destructor" code_block $@5 destructor_symbol_list
#line 704 "agc-byacc.yy"
      {
        if (hasDefaultTypedSymbol)
          needDestructorForStartSymbol = true;

        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-3)].getState().value ().as < keyword > ();
      }
#line 5520 "agc-byacc.cc"
    break;

  case 26: // bison_or_byacc_directive: "%expect" "number"
#line 711 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > ();
      }
#line 5528 "agc-byacc.cc"
    break;

  case 27: // bison_or_byacc_directive: "%expect-rr" "number"
#line 715 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > ();
      }
#line 5536 "agc-byacc.cc"
    break;

  case 28: // bison_or_byacc_directive: "%lex-param" user_argument_seq
#line 719 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > ();
      }
#line 5544 "agc-byacc.cc"
    break;

  case 29: // bison_or_byacc_directive: "%parse-param" user_argument_seq
#line 723 "agc-byacc.yy"
      {
        const userArgSeq& user_argument_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < userArgSeq > ();

        try
          {
            global_userArgSeq.insert (global_userArgSeq.end (),
                                      user_argument_seq.cbegin (),
                                      user_argument_seq.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > ();
      }
#line 5565 "agc-byacc.cc"
    break;

  case 30: // bison_or_byacc_directive: "%pure-parser"
#line 740 "agc-byacc.yy"
      {
        ctrl.allLfilesForReentrantParser = true;

        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > ();
      }
#line 5575 "agc-byacc.cc"
    break;

  case 31: // bison_or_byacc_directive: CODE code_block
#line 746 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > ();
      }
#line 5583 "agc-byacc.cc"
    break;

  case 32: // $@6: %empty
#line 752 "agc-byacc.yy"
      {
        // Y-file lexer hack: suppress copying attribute names onto the output
        // file when processing a global automatic copy rule attribute modifier
        // declaration
        ctrl.process_autoSynOrInh = true;
      }
#line 5594 "agc-byacc.cc"
    break;

  case 33: // ox_directive: $@6 attrb_modifier autoIDseq
#line 759 "agc-byacc.yy"
      {
        // reset globals for the next autoIDseq
        autoDef = undefined;
        autoWarning = false;
        ctrl.process_autoSynOrInh = false;

        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > ();
        (*yylocp).begin = ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().yyloc).begin;
      }
#line 5608 "agc-byacc.cc"
    break;

  case 34: // $@7: %empty
#line 769 "agc-byacc.yy"
      {
        gSymSort.typeNum = sortTypeNumSeq; // sort serial #

        if (hasConcreteType)
          {
            // create a unique C/C++ type name for the new sort
            gSymSort.typeName =
                yoxPrefix ("T") + std::to_string (sortTypeNumSeq);
          }

        sortTypeNumSeq++;

        yoxOutHrequires.putAttrbTypeDecl (gSymSort.typeNum,
                                          gSymSort.typeName,
                                          hasConcreteType);

        try
          {
            // Allocate a permanent list of attributes for the completed
            // @attributes declaration, to be pointed to by the grammar symbol
            // table entry of each grammar symbol of the sort.
            gSymSort.attrbSeq = new sortAttrbSeq (sortSeq);
          }
        catch (std::bad_alloc const&)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        gSymSort.nAttrbs = sortSeq.size ();

        try
          {
            // keep track of all of the attribute sorts
            sortTable.push_back (gSymSort);
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        putAttrbSort (gSymSort);
      }
#line 5655 "agc-byacc.cc"
    break;

  case 35: // ox_directive: "@attributes" "{" attribute_decl_list "}" $@7 attributed_symbol_list
#line 812 "agc-byacc.yy"
      {
        // reset globals for the next @attributes declaration
        gSymSort = sort ();      // undefined
        sortSeq.clear ();        // empty
        hasConcreteType = false; // all attributes are '@void'

        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-5)].getState().value ().as < keyword > ();
      }
#line 5668 "agc-byacc.cc"
    break;

  case 36: // $@8: %empty
#line 821 "agc-byacc.yy"
      {
        if (!initMacroDef ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ()))
          yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), "macro multiply defined: \"" + (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > () + "\".\n");
      }
#line 5677 "agc-byacc.cc"
    break;

  case 37: // ox_directive: "@macro" "identifier" $@8 "(" macroFormalList ")" "@end"
#line 828 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-6)].getState().value ().as < keyword > ();
      }
#line 5685 "agc-byacc.cc"
    break;

  case 38: // $@9: %empty
#line 832 "agc-byacc.yy"
      {
        clearTravBuf ();
      }
#line 5693 "agc-byacc.cc"
    break;

  case 39: // $@10: %empty
#line 836 "agc-byacc.yy"
      {
        if (travSpecConflict ())
          yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                     "contradictory traversal declaration.\n");
      }
#line 5703 "agc-byacc.cc"
    break;

  case 40: // ox_directive: "@traversal" $@9 travSpecSeq $@10 travIDseq
#line 842 "agc-byacc.yy"
      {
        // suppress pruning if any @traversal is enabled
        ctrl.suppressPruning |= (!travDisabled ());

        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-4)].getState().value ().as < keyword > ();
      }
#line 5714 "agc-byacc.cc"
    break;

  case 41: // code_seq: %empty
#line 853 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
      }
#line 5722 "agc-byacc.cc"
    break;

  case 43: // token_decl_list: tag_opt token_list
#line 861 "agc-byacc.yy"
      {
        const typeSeq& tag_opt = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();

        if (tag_opt.empty ())
          (*yyvalp).as < symDeclSeq > () = symDeclSeq ();
        else
          (*yyvalp).as < symDeclSeq > () = symDeclSeq (1, symDeclSeqElem (tag_opt, (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symSeq > ()));
      }
#line 5735 "agc-byacc.cc"
    break;

  case 44: // token_decl_list: token_decl_list tag token_list
#line 870 "agc-byacc.yy"
      {
        symDeclSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < symDeclSeq > ();

        try
          {
            new_seq.push_back (symDeclSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > (), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symSeq > ()));
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < symDeclSeq > () = new_seq;
      }
#line 5754 "agc-byacc.cc"
    break;

  case 45: // tag_opt: %empty
#line 888 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
        (*yyvalp).as < typeSeq > () = typeSeq (); // empty sequence
      }
#line 5763 "agc-byacc.cc"
    break;

  case 46: // tag_opt: tag
#line 893 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 5771 "agc-byacc.cc"
    break;

  case 47: // tag: "<" formal_type_specifier ">"
#line 900 "agc-byacc.yy"
      {
        // Bison expects a C/C++ type if "%define api.value.type variant",
        // however Ox doesn't currently support code generation for this
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();
      }
#line 5781 "agc-byacc.cc"
    break;

  case 48: // token_list: token
#line 909 "agc-byacc.yy"
      {
        (*yyvalp).as < symSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symSeq > ();
      }
#line 5789 "agc-byacc.cc"
    break;

  case 49: // token_list: token_list token
#line 913 "agc-byacc.yy"
      {
        symSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < symSeq > ();

        const symSeq& token = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symSeq > ();

        try
          {
            new_seq.insert (new_seq.end (), token.cbegin (), token.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < symSeq > () = new_seq;
      }
#line 5810 "agc-byacc.cc"
    break;

  case 50: // token_list: token_list "," token
#line 930 "agc-byacc.yy"
      {
        symSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < symSeq > ();

        const symSeq& token = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symSeq > ();

        try
          {
            new_seq.insert (new_seq.end (), token.cbegin (), token.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < symSeq > () = new_seq;
      }
#line 5831 "agc-byacc.cc"
    break;

  case 51: // token: named_token
#line 950 "agc-byacc.yy"
      {
        // Yacc will report an error if 'named_token' is a nonterminal
        const std::string& named_token = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();

        installGsymAsTokenIfNew (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), named_token);
        (*yyvalp).as < symSeq > () = symSeq (1, named_token);
      }
#line 5843 "agc-byacc.cc"
    break;

  case 52: // token: "character literal"
#line 958 "agc-byacc.yy"
      {
        const std::string& LITERAL_CHAR = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < char_literal > ();

        installGsymAsTokenIfNew (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), LITERAL_CHAR);
        (*yyvalp).as < symSeq > () = symSeq (1, LITERAL_CHAR);
      }
#line 5854 "agc-byacc.cc"
    break;

  case 53: // named_token: "identifier" NUM_opt
#line 968 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < name_literal > ();
      }
#line 5862 "agc-byacc.cc"
    break;

  case 56: // precedence_declarer: "%left"
#line 980 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > ();
      }
#line 5870 "agc-byacc.cc"
    break;

  case 57: // precedence_declarer: "%right"
#line 984 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > ();
      }
#line 5878 "agc-byacc.cc"
    break;

  case 58: // precedence_declarer: "%nonassoc"
#line 988 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > ();
      }
#line 5886 "agc-byacc.cc"
    break;

  case 59: // precedence_decl_list: tag_opt terminal_list
#line 995 "agc-byacc.yy"
      {
        const typeSeq& tag_opt = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();

        if (tag_opt.empty ())
          (*yyvalp).as < symDeclSeq > () = symDeclSeq ();
        else
          (*yyvalp).as < symDeclSeq > () = symDeclSeq (1, symDeclSeqElem (tag_opt, (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symSeq > ()));
      }
#line 5899 "agc-byacc.cc"
    break;

  case 60: // precedence_decl_list: precedence_decl_list tag terminal_list
#line 1004 "agc-byacc.yy"
      {
        symDeclSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < symDeclSeq > ();

        try
          {
            new_seq.push_back (symDeclSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > (), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symSeq > ()));
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < symDeclSeq > () = new_seq;
      }
#line 5918 "agc-byacc.cc"
    break;

  case 61: // terminal_list: terminal_symbol
#line 1022 "agc-byacc.yy"
      {
        (*yyvalp).as < symSeq > () = symSeq (1, (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ());
      }
#line 5926 "agc-byacc.cc"
    break;

  case 62: // terminal_list: terminal_list terminal_symbol
#line 1026 "agc-byacc.yy"
      {
        symSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < symSeq > ();

        try
          {
            new_seq.push_back ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
    }

        (*yyvalp).as < symSeq > () = new_seq;
      }
#line 5945 "agc-byacc.cc"
    break;

  case 63: // terminal_list: terminal_list "," terminal_symbol
#line 1041 "agc-byacc.yy"
      {
        symSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < symSeq > ();

        try
          {
            new_seq.push_back ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < symSeq > () = new_seq;
      }
#line 5964 "agc-byacc.cc"
    break;

  case 64: // terminal_symbol: named_token
#line 1059 "agc-byacc.yy"
      {
        // Yacc will report an error if 'named_token' is a nonterminal
        installGsymAsTokenIfNew (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ());
      }
#line 5973 "agc-byacc.cc"
    break;

  case 65: // terminal_symbol: "character literal"
#line 1064 "agc-byacc.yy"
      {
        installGsymAsTokenIfNew (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < char_literal > ());
      }
#line 5981 "agc-byacc.cc"
    break;

  case 66: // terminal_symbol: "string literal"
#line 1068 "agc-byacc.yy"
      {
        installGsymAsTokenIfNew (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < char_literal > ());
      }
#line 5989 "agc-byacc.cc"
    break;

  case 67: // nonterminal_symbol: "nonterminal symbol"
#line 1075 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();
      }
#line 5997 "agc-byacc.cc"
    break;

  case 68: // nonterminal_symbol: "identifier"
#line 1079 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();
      }
#line 6005 "agc-byacc.cc"
    break;

  case 69: // symbol: "nonterminal symbol"
#line 1086 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();
      }
#line 6013 "agc-byacc.cc"
    break;

  case 70: // symbol: "identifier"
#line 1090 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();
      }
#line 6021 "agc-byacc.cc"
    break;

  case 71: // symbol: "character literal"
#line 1094 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < char_literal > ();
      }
#line 6029 "agc-byacc.cc"
    break;

  case 72: // symbol: "string literal"
#line 1098 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < char_literal > ();
      }
#line 6037 "agc-byacc.cc"
    break;

  case 73: // nonterminal_declarer: "%type"
#line 1105 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > ();
      }
#line 6045 "agc-byacc.cc"
    break;

  case 74: // nonterminal_decl_list: tag_opt nonterminal_list
#line 1112 "agc-byacc.yy"
      {
        const typeSeq& tag_opt = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();

        if (tag_opt.empty ())
          (*yyvalp).as < symDeclSeq > () = symDeclSeq ();
        else
          (*yyvalp).as < symDeclSeq > () = symDeclSeq (1, symDeclSeqElem (tag_opt, (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symSeq > ()));
      }
#line 6058 "agc-byacc.cc"
    break;

  case 75: // nonterminal_decl_list: nonterminal_decl_list tag nonterminal_list
#line 1121 "agc-byacc.yy"
      {
        symDeclSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < symDeclSeq > ();

        try
          {
            new_seq.push_back (symDeclSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > (), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < symSeq > ()));
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < symDeclSeq > () = new_seq;
      }
#line 6077 "agc-byacc.cc"
    break;

  case 76: // nonterminal_list: nonterminal
#line 1139 "agc-byacc.yy"
      {
        (*yyvalp).as < symSeq > () = symSeq (1, (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ());
      }
#line 6085 "agc-byacc.cc"
    break;

  case 77: // nonterminal_list: nonterminal_list nonterminal
#line 1143 "agc-byacc.yy"
      {
        symSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < symSeq > ();

        try
          {
            new_seq.push_back ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < symSeq > () = new_seq;
      }
#line 6104 "agc-byacc.cc"
    break;

  case 78: // nonterminal_list: nonterminal_list "," nonterminal
#line 1158 "agc-byacc.yy"
      {
        symSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < symSeq > ();

        try
          {
            new_seq.push_back ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < symSeq > () = new_seq;
      }
#line 6123 "agc-byacc.cc"
    break;

  case 79: // nonterminal: nonterminal_symbol
#line 1176 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();
      }
#line 6131 "agc-byacc.cc"
    break;

  case 80: // nonterminal: nonterminal_symbol "(" tagList ")"
#line 1180 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-3)].getState().value ().as < name_literal > ();
      }
#line 6139 "agc-byacc.cc"
    break;

  case 85: // user_argument_seq: user_argument
#line 1196 "agc-byacc.yy"
      { (*yyvalp).as < userArgSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < userArgSeq > (); }
#line 6145 "agc-byacc.cc"
    break;

  case 86: // user_argument_seq: user_argument_seq user_argument
#line 1198 "agc-byacc.yy"
      {
        userArgSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < userArgSeq > ();

        const userArgSeq& user_argument = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < userArgSeq > ();

        try
          {
            new_seq.insert (new_seq.end (),
                            user_argument.cbegin (),
                            user_argument.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < userArgSeq > () = new_seq;
      }
#line 6168 "agc-byacc.cc"
    break;

  case 87: // user_argument: "{" formal_type_specifier "identifier" "}"
#line 1220 "agc-byacc.yy"
      {
        (*yyvalp).as < userArgSeq > () =
            userArgSeq (1, userArgSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < typeSeq > (), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < name_literal > ()));
      }
#line 6177 "agc-byacc.cc"
    break;

  case 92: // destructor_symbol: "<" "*" ">"
#line 1235 "agc-byacc.yy"
      {
        hasDefaultTypedSymbol = true;
      }
#line 6185 "agc-byacc.cc"
    break;

  case 96: // autoID: "identifier"
#line 1248 "agc-byacc.yy"
      {
        attrbAutoDef (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > (), autoDef, autoWarning);
      }
#line 6193 "agc-byacc.cc"
    break;

  case 99: // attribute_decl: attrb_modifier_opt type_specifier id_seq ";"
#line 1260 "agc-byacc.yy"
      {
        hasConcreteType = true; // at least one attribute is not '@void'

        // reset globals for the next autoIDseq
        autoDef = undefined;
        autoWarning = false;
      }
#line 6205 "agc-byacc.cc"
    break;

  case 102: // attrb_modifier_opt: %empty
#line 1273 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;

        // no automatic copy rule attribute modifier declaration
        autoDef = undefined;
        autoWarning = false;
      }
#line 6217 "agc-byacc.cc"
    break;

  case 104: // $@11: %empty
#line 1285 "agc-byacc.yy"
      {
        switch (autoDef)
          {
          case inherited:
            yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                       "@autosyn conflicts with preceding @autoinh.\n");
            break;

          case synthesized:
            yox_warning (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), "repeated @autosyn (ignored).\n");
            break;

          case undefined:
            autoDef = synthesized;
            break;
          }
      }
#line 6239 "agc-byacc.cc"
    break;

  case 105: // attrb_modifier: "@autosyn" $@11 atWarn_opt
#line 1303 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < keyword > ();
      }
#line 6247 "agc-byacc.cc"
    break;

  case 106: // $@12: %empty
#line 1307 "agc-byacc.yy"
      {
        switch (autoDef)
          {
          case inherited:
            yox_warning (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), "repeated @autoinh (ignored).\n");
            break;

          case synthesized:
            yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                       "@autoihn conflicts with preceding @autosyn.\n");
            break;

          case undefined:
            autoDef = inherited;
            break;
          }
      }
#line 6269 "agc-byacc.cc"
    break;

  case 107: // attrb_modifier: "@autoinh" $@12 atWarn_opt
#line 1325 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < keyword > ();
      }
#line 6277 "agc-byacc.cc"
    break;

  case 108: // atWarn_opt: %empty
#line 1332 "agc-byacc.yy"
      {
        autoWarning = false;
      }
#line 6285 "agc-byacc.cc"
    break;

  case 109: // atWarn_opt: "@warn"
#line 1336 "agc-byacc.yy"
      {
        autoWarning = true;
      }
#line 6293 "agc-byacc.cc"
    break;

  case 110: // type_specifier: type
#line 1343 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6301 "agc-byacc.cc"
    break;

  case 111: // type_specifier: type "<" type_list ">"
#line 1348 "agc-byacc.yy"
      {
        typeSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-3)].getState().value ().as < typeSeq > ();

        const typeSeq& type_list = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.push_back (typeSeqElem ("<"));

            new_seq.insert (new_seq.end (),
                            type_list.cbegin (),
                            type_list.cend ());

            new_seq.push_back (typeSeqElem (">"));
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6328 "agc-byacc.cc"
    break;

  case 112: // type: type_component
#line 1374 "agc-byacc.yy"
      {
       (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6336 "agc-byacc.cc"
    break;

  case 113: // type: type type_component
#line 1378 "agc-byacc.yy"
      {
        typeSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();

        const typeSeq& type_component = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.insert (new_seq.end (),
                            type_component.cbegin (),
                            type_component.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6359 "agc-byacc.cc"
    break;

  case 114: // type_component: TYPE_KEYWORD
#line 1400 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () =
            typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > (), is_TYPE_KEYWORD));
      }
#line 6368 "agc-byacc.cc"
    break;

  case 115: // type_component: "const"
#line 1405 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > (), is_TYPE_KEYWORD));
      }
#line 6376 "agc-byacc.cc"
    break;

  case 116: // type_component: "volatile"
#line 1409 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > (), is_TYPE_KEYWORD));
      }
#line 6384 "agc-byacc.cc"
    break;

  case 117: // type_component: type_name
#line 1413 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6392 "agc-byacc.cc"
    break;

  case 118: // type_component: elaborated_type_name
#line 1417 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6400 "agc-byacc.cc"
    break;

  case 119: // type_name: "identifier"
#line 1424 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > (), is_ID));
      }
#line 6408 "agc-byacc.cc"
    break;

  case 120: // type_name: "C++ qualified name"
#line 1428 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > (), is_NAMESPACE_ID));
      }
#line 6416 "agc-byacc.cc"
    break;

  case 121: // elaborated_type_name: ELABORATED_TYPE_KEYWORD type_name
#line 1435 "agc-byacc.yy"
      {
        typeSeq new_seq =
            typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > (),
                                     is_TYPE_KEYWORD));

        const typeSeq& type_name = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.insert (new_seq.end (),
                            type_name.cbegin (),
                            type_name.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6441 "agc-byacc.cc"
    break;

  case 122: // type_list: type
#line 1459 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6449 "agc-byacc.cc"
    break;

  case 123: // type_list: type_list "," type
#line 1463 "agc-byacc.yy"
      {
        typeSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < typeSeq > ();

        const typeSeq& type = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.push_back (typeSeqElem (","));

            new_seq.insert (new_seq.end (),
                            type.cbegin (),
                            type.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6474 "agc-byacc.cc"
    break;

  case 134: // attribute_id: "identifier"
#line 1509 "agc-byacc.yy"
      {
        const sortAttrb attribute_id =
            newAttrbID (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > (), autoDef, autoWarning);

        bool add_OK = true;

        // The original order of appearance of each attribute in the
        // declaration list is preserved, with the exception that
        // duplicates are deleted.

        // check for duplicated attribute name in the sort
        const std::string& attrbName = attribute_id.id;

        for (const sortAttrb& attrb : sortSeq)
          if (attrb.id == attrbName)
            {
              yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                         "duplicated attribute: \"" + attrbName + "\""
                         ".\n");
              add_OK = false;
              break;
            }

        if (add_OK)
          try
            {
              // if attribute isn't duplicate, add it to the list
              sortSeq.push_back (attribute_id);
            }
          catch (...)
            {
              yox_alloc_fail (__FILE__, __LINE__);
            }
      }
#line 6513 "agc-byacc.cc"
    break;

  case 135: // ptr_operator: "*" ptr_type_qualifier_seq_opt
#line 1547 "agc-byacc.yy"
      {
        typeSeq new_seq = typeSeq (1, typeSeqElem ("*"));

        const typeSeq& ptr_type_qualifier_seq_opt = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.insert (new_seq.end (),
                            ptr_type_qualifier_seq_opt.cbegin (),
                            ptr_type_qualifier_seq_opt.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6536 "agc-byacc.cc"
    break;

  case 136: // ptr_operator: "&"
#line 1566 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = typeSeq (1, typeSeqElem ("&"));
      }
#line 6544 "agc-byacc.cc"
    break;

  case 137: // ptr_type_qualifier_seq_opt: %empty
#line 1573 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = typeSeq (); // empty sequence
      }
#line 6552 "agc-byacc.cc"
    break;

  case 138: // ptr_type_qualifier_seq_opt: ptr_type_qualifier_seq
#line 1577 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6560 "agc-byacc.cc"
    break;

  case 139: // ptr_type_qualifier_seq: ptr_type_qualifier
#line 1584 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > (), is_TYPE_KEYWORD));
      }
#line 6568 "agc-byacc.cc"
    break;

  case 140: // ptr_type_qualifier_seq: ptr_type_qualifier_seq ptr_type_qualifier
#line 1588 "agc-byacc.yy"
      {
        typeSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.push_back (typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > (),
                                            is_TYPE_KEYWORD));
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6588 "agc-byacc.cc"
    break;

  case 141: // ptr_type_qualifier: "const"
#line 1607 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > ();
      }
#line 6596 "agc-byacc.cc"
    break;

  case 142: // ptr_type_qualifier: "restrict"
#line 1611 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > ();
      }
#line 6604 "agc-byacc.cc"
    break;

  case 145: // array_size_opt: %empty
#line 1623 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
        (*yyvalp).as < keyword > () = nullptr;
      }
#line 6613 "agc-byacc.cc"
    break;

  case 146: // array_size_opt: "number"
#line 1628 "agc-byacc.yy"
      {
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < numberRep > ().spelling;
      }
#line 6621 "agc-byacc.cc"
    break;

  case 147: // array_size_opt: "*"
#line 1632 "agc-byacc.yy"
      {
        // treat it like a 'type_keyword' for the moment
        (*yyvalp).as < keyword > () = const_cast<char*> ("*");
      }
#line 6630 "agc-byacc.cc"
    break;

  case 148: // array_size_opt: "identifier"
#line 1637 "agc-byacc.yy"
      {
        // treat it like a 'type_keyword' for the moment
        (*yyvalp).as < keyword > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();
      }
#line 6639 "agc-byacc.cc"
    break;

  case 149: // parameter_list_opt: %empty
#line 1645 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = typeSeq (); // empty sequence
      }
#line 6647 "agc-byacc.cc"
    break;

  case 150: // parameter_list_opt: parameter_list
#line 1649 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6655 "agc-byacc.cc"
    break;

  case 151: // parameter_list: parameter_type_list
#line 1656 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6663 "agc-byacc.cc"
    break;

  case 152: // parameter_list: parameter_type_list "," "..."
#line 1660 "agc-byacc.yy"
      {
        typeSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.push_back (typeSeqElem (","));
            new_seq.push_back (typeSeqElem ("..."));
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6683 "agc-byacc.cc"
    break;

  case 153: // parameter_type_list: parameter_type
#line 1679 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6691 "agc-byacc.cc"
    break;

  case 154: // parameter_type_list: parameter_type_list "," parameter_type
#line 1683 "agc-byacc.yy"
      {
        typeSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < typeSeq > ();

        const typeSeq& parameter_type = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.push_back (typeSeqElem (","));

            new_seq.insert (new_seq.end (),
                            parameter_type.cbegin (),
                            parameter_type.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6716 "agc-byacc.cc"
    break;

  case 155: // parameter_type: formal_type_specifier
#line 1707 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6724 "agc-byacc.cc"
    break;

  case 156: // parameter_type: "register" formal_type_specifier
#line 1711 "agc-byacc.yy"
      {
        typeSeq new_seq = typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > (), is_TYPE_KEYWORD));

        const typeSeq& formal_type_specifier = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.insert (new_seq.end (),
                            formal_type_specifier.cbegin (),
                            formal_type_specifier.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6747 "agc-byacc.cc"
    break;

  case 157: // formal_type_specifier: type_specifier abstract_declarator
#line 1733 "agc-byacc.yy"
      {
        typeSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();

        const typeSeq& abstract_declarator = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.insert (new_seq.end (),
                            abstract_declarator.cbegin (),
                            abstract_declarator.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6770 "agc-byacc.cc"
    break;

  case 158: // abstract_declarator: %empty
#line 1755 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = typeSeq (); // empty sequence
      }
#line 6778 "agc-byacc.cc"
    break;

  case 159: // abstract_declarator: direct_abstract_declarator
#line 1759 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6786 "agc-byacc.cc"
    break;

  case 160: // abstract_declarator: ptr_operator abstract_declarator
#line 1763 "agc-byacc.yy"
      {
        typeSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();

        const typeSeq& right = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.insert (new_seq.end (), right.cbegin (), right.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6807 "agc-byacc.cc"
    break;

  case 161: // direct_abstract_declarator: "(" abstract_declarator ")"
#line 1783 "agc-byacc.yy"
      {
        typeSeq new_seq = typeSeq (1, typeSeqElem ("(" /*)*/));

        const typeSeq& abstract_declarator = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.insert (new_seq.end (),
                            abstract_declarator.cbegin (),
                            abstract_declarator.cend ());

            new_seq.push_back (typeSeqElem (/*(*/ ")"));
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6832 "agc-byacc.cc"
    break;

  case 162: // direct_abstract_declarator: direct_abstract_declarator "[" formal_array_qualifier_list_opt array_size_opt "]"
#line 1805 "agc-byacc.yy"
      {
        typeSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-4)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.push_back (typeSeqElem ("["));

            const typeSeq& formal_array_qualifier_list_opt =
                (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-2)].getState().value ().as < typeSeq > ();

            new_seq.insert (new_seq.end (),
                            formal_array_qualifier_list_opt.cbegin (),
                            formal_array_qualifier_list_opt.cend ());

            const std::string& array_size = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < keyword > ();

            if (!array_size.empty ())
              new_seq.push_back (typeSeqElem (array_size));

            new_seq.push_back (typeSeqElem ("]"));
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6865 "agc-byacc.cc"
    break;

  case 163: // direct_abstract_declarator: direct_abstract_declarator "(" parameter_list_opt ")"
#line 1834 "agc-byacc.yy"
      {
        typeSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-3)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.push_back (typeSeqElem ("(" /*)*/));

            const typeSeq& parameter_list_opt = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();

            new_seq.insert (new_seq.end (),
                            parameter_list_opt.cbegin (),
                            parameter_list_opt.cend ());

            new_seq.push_back (typeSeqElem (/*(*/ ")"));
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6892 "agc-byacc.cc"
    break;

  case 164: // formal_array_qualifier_list_opt: %empty
#line 1861 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
        (*yyvalp).as < typeSeq > () = typeSeq (); // empty sequence
      }
#line 6901 "agc-byacc.cc"
    break;

  case 165: // formal_array_qualifier_list_opt: formal_array_qualifier_list
#line 1866 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6909 "agc-byacc.cc"
    break;

  case 166: // formal_array_qualifier_list: formal_array_qualifier
#line 1873 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();
      }
#line 6917 "agc-byacc.cc"
    break;

  case 167: // formal_array_qualifier_list: formal_array_qualifier_list formal_array_qualifier
#line 1877 "agc-byacc.yy"
      {
        typeSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < typeSeq > ();

        const typeSeq& formal_array_qualifier = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < typeSeq > ();

        try
          {
            new_seq.insert (new_seq.end (),
                            formal_array_qualifier.cbegin (),
                            formal_array_qualifier.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < typeSeq > () = new_seq;
      }
#line 6940 "agc-byacc.cc"
    break;

  case 168: // formal_array_qualifier: "const"
#line 1899 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () =
            typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > (), is_TYPE_KEYWORD));
      }
#line 6949 "agc-byacc.cc"
    break;

  case 169: // formal_array_qualifier: "volatile"
#line 1904 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () =
            typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > (), is_TYPE_KEYWORD));
      }
#line 6958 "agc-byacc.cc"
    break;

  case 170: // formal_array_qualifier: "restrict"
#line 1909 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () =
            typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > (), is_TYPE_KEYWORD));
      }
#line 6967 "agc-byacc.cc"
    break;

  case 171: // formal_array_qualifier: "static"
#line 1914 "agc-byacc.yy"
      {
        (*yyvalp).as < typeSeq > () =
            typeSeq (1, typeSeqElem ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < keyword > (), is_TYPE_KEYWORD));
      }
#line 6976 "agc-byacc.cc"
    break;

  case 174: // attributed_symbol: symbol
#line 1927 "agc-byacc.yy"
      {
        std::string symbol = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();

        installGsymIfNew (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), symbol);
        // if 'symbol' is an alias, 'installGsymIfNew ()' replaced it
        // with the base symbol

        addAttrbsToGsym (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), symbol, gSymSort);
      }
#line 6990 "agc-byacc.cc"
    break;

  case 175: // macroFormalList: "identifier"
#line 1940 "agc-byacc.yy"
      {
        (void)macro.installMacroFormal ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ());
      }
#line 6998 "agc-byacc.cc"
    break;

  case 176: // macroFormalList: macroFormalList "," "identifier"
#line 1944 "agc-byacc.yy"
      {
        const std::string& ID = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();
        if (!macro.installMacroFormal (ID))
          yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                     "duplicated macro formal parameter: "
                     "\"" + ID + "\".\n");
      }
#line 7010 "agc-byacc.cc"
    break;

  case 181: // travID: "identifier"
#line 1965 "agc-byacc.yy"
      {
        newTrav (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ());
      }
#line 7018 "agc-byacc.cc"
    break;

  case 182: // travSpec: "@preorder"
#line 1972 "agc-byacc.yy"
      {
        travSetPreorder ();
      }
#line 7026 "agc-byacc.cc"
    break;

  case 183: // travSpec: "@postorder"
#line 1976 "agc-byacc.yy"
      {
        travSetPostorder ();
      }
#line 7034 "agc-byacc.cc"
    break;

  case 184: // travSpec: "@lefttoright"
#line 1980 "agc-byacc.yy"
      {
        travSetLeftToRight ();
      }
#line 7042 "agc-byacc.cc"
    break;

  case 185: // travSpec: "@righttoleft"
#line 1984 "agc-byacc.yy"
      {
        travSetRightToLeft ();
      }
#line 7050 "agc-byacc.cc"
    break;

  case 186: // travSpec: "@disable"
#line 1988 "agc-byacc.yy"
      {
        travSetDisable ();
      }
#line 7058 "agc-byacc.cc"
    break;

  case 189: // $@13: %empty
#line 2000 "agc-byacc.yy"
      {
        const std::string& left_hand_side = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < name_literal > ();

        static bool alreadyAugmented = false;

        if (!alreadyAugmented)
          {
            if (startSymLexeme.empty ())
              installStartSym (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().yyloc), left_hand_side);

            // Yacc pseudo variable '$1' is the original user-defined
            // start symbol; use '$<yyyOxAttrbs>1' since the Yacc
            // semantic type may be unknown

            const std::string rootNodeReference =
                "$<" + yoxPrefix ("OxAttrbs") + ">1.semEl->node";

            yoxOutG.gen ()
                .put ("\n" + yoxPrefix (augNstr) + "\n"
                      "\t:\t\t" + startSymLexeme + "\n"
                      "\t\t{if(" + yoxPrefix ("Yok") + ")\n"
                      "\t\t   {").putDecorateCall ("true") // -> pruning
                .put ("\t\t    " +
                      yoxPrefix ("ExecuteRRsection") +
                      "(" + rootNodeReference + ");\n")
                .putDoTraversals (rootNodeReference)
                .put ("\t\t   }\n"
                      "\t\t}\n\t;\n");

            alreadyAugmented = true;
          }

        yoxOutG.append (possibleLHS); // dump the pending LHS text
        possibleLHS.clear ();

        prodBufferPointer2 = 0;
        incProdNumSeq ();

        yaccSemIndex = 0; // 0 for LHS symbol; ignored

        installGsymAsNontermIfNew (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().yyloc), left_hand_side);

        putSymbolInProdBuffer2 (left_hand_side);
      }
#line 7107 "agc-byacc.cc"
    break;

  case 191: // $@14: %empty
#line 2046 "agc-byacc.yy"
      {
        prodBufferPointer2 = 1; // keep LHS from prior rule
        incProdNumSeq ();

        yaccSemIndex = 1; // 1st RHS symbol
      }
#line 7118 "agc-byacc.cc"
    break;

  case 193: // left_hand_side: nonterminal_symbol
#line 2057 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();
      }
#line 7126 "agc-byacc.cc"
    break;

  case 194: // left_hand_side: nonterminal_symbol "(" inherited_attrID_list ")"
#line 2061 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-3)].getState().value ().as < name_literal > ();
      }
#line 7134 "agc-byacc.cc"
    break;

  case 198: // inherited_attrID: error
#line 2074 "agc-byacc.yy"
      {
        yyclearin;
      }
#line 7142 "agc-byacc.cc"
    break;

  case 199: // $@15: %empty
#line 2081 "agc-byacc.yy"
      {
        initLDG ();
      }
#line 7150 "agc-byacc.cc"
    break;

  case 200: // right_hand_side: rhs_body $@15 attrb_ref_section
#line 2085 "agc-byacc.yy"
      {
        finishYfileAttrbRefSection ((*yylocp));
      }
#line 7158 "agc-byacc.cc"
    break;

  case 201: // rhs_body: %empty
#line 2092 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
      }
#line 7166 "agc-byacc.cc"
    break;

  case 207: // rhs_component: parser_action
#line 2107 "agc-byacc.yy"
      {
        // Yacc will generate a nonterminal here and a corresponding empty rule
        // with the semantic action for that nonterminal; Ox semantic action
        // processing doesn't know about this rule, and so doesn't know about
        // this entry on the Yacc semantic stack; this offset calculation keeps
        // track of where RHS symbols occur in the Yacc semantic stack

        yaccSemIndex++; // account for the fake RHS symbol
      }
#line 7180 "agc-byacc.cc"
    break;

  case 208: // rhs_component: error
#line 2117 "agc-byacc.yy"
      {
        yyclearin;
      }
#line 7188 "agc-byacc.cc"
    break;

  case 209: // rhs_item: rhs_symbol
#line 2124 "agc-byacc.yy"
      {
        std::string rhs_symbol = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();

        installGsymIfNew (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), rhs_symbol);
        // if 'rhs_symbol' is an alias, 'installGsymIfNew ()' replaced it
        // with the base symbol

        putSymbolInProdBuffer2 (rhs_symbol);
      }
#line 7202 "agc-byacc.cc"
    break;

  case 210: // rhs_symbol: symbol
#line 2137 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ();
      }
#line 7210 "agc-byacc.cc"
    break;

  case 211: // rhs_symbol: symbol "(" inherited_attr_expr ")"
#line 2141 "agc-byacc.yy"
      {
        (*yyvalp).as < name_literal > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-3)].getState().value ().as < name_literal > ();
      }
#line 7218 "agc-byacc.cc"
    break;

  case 212: // inherited_attr_expr: %empty
#line 2156 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
      }
#line 7226 "agc-byacc.cc"
    break;

  case 218: // inherited_attr_expr_component: error
#line 2168 "agc-byacc.yy"
      {
        yyclearin;
      }
#line 7234 "agc-byacc.cc"
    break;

  case 223: // attrb_ref_section: %empty
#line 2188 "agc-byacc.yy"
      {
        (*yylocp) = AGC::location (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL ((-1) - (0))].getState().yyloc).end); // @rhs_body.end
      }
#line 7242 "agc-byacc.cc"
    break;

  case 224: // $@16: %empty
#line 2192 "agc-byacc.yy"
      {
        // setup for checking dynamic traversal modifier restrictions
        dynTravModSeq = -1;
        dynTravModArr.clear ();

        decorationRequested = false; // default: no decoration
      }
#line 7254 "agc-byacc.cc"
    break;

  case 225: // attrb_ref_section: "@{" $@16 attrb_ref_section_body "@}"
#line 2201 "agc-byacc.yy"
      {
        // if @revdirection occurs in multiple actions, the actions must have
        // different annunciators

        for (int i = 0; i <= dynTravModSeq; i++)
          {
            for (int j = i + 1; j <= dynTravModSeq; j++)
              {
                if (dynTravModArr[i].id == dynTravModArr[j].id &&
                    dynTravModArr[i].dirRev > 0 &&
                    dynTravModArr[j].dirRev > 0)
                  {
                    if (dynTravModArr[dynTravModSeq].id != errTravID)
                      yox_error (dynTravModArr[j].dirRevLoc,
                                 "multiple @revdirection modifiers for "
                                 "traversal "
                                 "\"" + dynTravModArr[j].id + "\".\n");
                  }
              }
          }
      }
#line 7280 "agc-byacc.cc"
    break;

  case 230: // decorate_cmd: "@decorate"
#line 2233 "agc-byacc.yy"
      {
        decorationRequested = true;
      }
#line 7288 "agc-byacc.cc"
    break;

  case 233: // attrb_ref_section_item: attrb_def
#line 2245 "agc-byacc.yy"
      {
        processAdepSpec ();
      }
#line 7296 "agc-byacc.cc"
    break;

  case 236: // attrb_ref_section_item: error
#line 2251 "agc-byacc.yy"
      {
        yyclearin;
      }
#line 7304 "agc-byacc.cc"
    break;

  case 237: // attrb_def: "@i" attrb_evaluation
#line 2260 "agc-byacc.yy"
      {
        const attrbRefSeq& attrbRefs = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbRefSeq > ();

        if (attrbRefs.empty ()) // no attribute occurrences
          yox_warning (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                       "attribute definition doesn\'t define an attribute");
        else
          {
            // find the first non-NIO attribute occurrence => the dependent
            attrbRefSeq::const_iterator it = attrbRefs.cbegin ();
            while (it != attrbRefs.cend () &&
                   it->attrbRef.num == NIOsymAttrbNum)
              ++it;

            if (it == attrbRefs.cend ())
              {
                // only NIO pseudo attribute occurrences were found, none of
                // which can be the dependent attribute; issue an error message
                // for the first occurrence

                const attrbPair& attref = attrbRefs.front ().attrbRef;

                const prodSymbol& symbol = prodBuffer2[attref.pos];

                yox_error (attrbRefs.front ().loc,
                           "\"" +
                               symbol.lexeme + "." +
                               std::to_string (symbol.symOccr) + "." +
                               NIOsym +
                           "\""
                           " cannot be a dependent.\n");
              }
            else
              {
                // register the dependent occurrence
                (void)memberDepend (it->attrbRef, true, true);
              }

            // remaining non-NIO attribute occurrences are the dependees
            while (++it != attrbRefs.cend ())
              {
                const attrbPair& attref = it->attrbRef;

                if (attref.num == NIOsymAttrbNum)
                  continue; // skip any NIO pseudo attribute occurrences

                if (!memberDepend (attref, true, false))
                  {
                    (void)memberDepend (attref, false, true);
                    continue;
                  }

                const prodSymbol& symbol = prodBuffer2[attref.pos];

                yox_error (it->loc,
                           "\"" +
                               symbol.lexeme + "." +
                               std::to_string (symbol.symOccr) + "." +
                               (*(gSymTable[symbol.lexeme]
                                      .symSort.attrbSeq))[attref.num].id +
                           "\""
                           " depends on itself.\n");
              }
          }
      }
#line 7374 "agc-byacc.cc"
    break;

  case 238: // attrb_def: "@m" dependent_name_seq ";" attrb_evaluation
#line 2326 "agc-byacc.yy"
      {
        const attrbRefSeq& attrbRefs = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbRefSeq > ();

        for (const attrbRefSeqElem& it : attrbRefs)
          {
            const attrbPair& attref = it.attrbRef;

            if (attref.num == NIOsymAttrbNum)
              continue; // skip any NIO pseudo attribute occurrences

            if (!memberDepend (attref, true, false))
              (void)memberDepend (attref, false, true);
          }
      }
#line 7393 "agc-byacc.cc"
    break;

  case 239: // attrb_def: "@e" dependent_name_seq ":" dependee_name_seq ";" attrb_evaluation
#line 2341 "agc-byacc.yy"
      {
        const attrbRefSeq& attrbRefs = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbRefSeq > ();

        for (const attrbRefSeqElem& it : attrbRefs)
          {
            const attrbPair& attref = it.attrbRef;

            if (attref.num == NIOsymAttrbNum)
              continue; // skip any NIO pseudo attribute occurrences

            // attribute is explicitly named as a dependent or a dependee
            if (memberDepend (attref, false, false)
                || memberDepend (attref, true, false))
              continue;

            // attribute is already known to be bogus
            if (attref.pos == -1 || attref.num == -1)
              continue;

            const prodSymbol& symbol = prodBuffer2[attref.pos];

            yox_error (it.loc,
                       "\"" +
                           symbol.lexeme + "." +
                           std::to_string (symbol.symOccr) + "." +
                           (*(gSymTable[symbol.lexeme]
                                  .symSort.attrbSeq))[attref.num].id +
                       "\""
                       " is not explicitly named.\n");
          }
      }
#line 7429 "agc-byacc.cc"
    break;

  case 240: // attrb_evaluation: attrb_evaluation_stmt ";"
#line 2376 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbRefSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < attrbRefSeq > ();
      }
#line 7437 "agc-byacc.cc"
    break;

  case 241: // attrb_evaluation: attrb_evaluation_compound_stmt
#line 2380 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbRefSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbRefSeq > ();
      }
#line 7445 "agc-byacc.cc"
    break;

  case 242: // attrb_evaluation_stmt: attrb_evaluation_expr
#line 2387 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbRefSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbRefSeq > ();
      }
#line 7453 "agc-byacc.cc"
    break;

  case 243: // attrb_evaluation_expr: %empty
#line 2402 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
        (*yyvalp).as < attrbRefSeq > () = attrbRefSeq (); // empty sequence
      }
#line 7462 "agc-byacc.cc"
    break;

  case 244: // attrb_evaluation_expr: attrb_evaluation_expr attrb_evaluation_expr_component
#line 2407 "agc-byacc.yy"
      {
        attrbRefSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < attrbRefSeq > ();

        const attrbRefSeq& component = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbRefSeq > ();

        try
          {
            new_seq.insert (new_seq.end (),
                            component.cbegin (),
                            component.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < attrbRefSeq > () = new_seq;
      }
#line 7485 "agc-byacc.cc"
    break;

  case 245: // attrb_evaluation_expr: error
#line 2426 "agc-byacc.yy"
      {
        yyclearin;
        (*yyvalp).as < attrbRefSeq > () = attrbRefSeq (); // empty sequence
      }
#line 7494 "agc-byacc.cc"
    break;

  case 246: // attrb_evaluation_expr_component: attrb_ref
#line 2434 "agc-byacc.yy"
      {
        const attrbPair& attrb_ref = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbPair > ();

        rsBuffer.putAttrbPair (attrb_ref);

        attrbRefSeq new_seq = attrbRefSeq (); // empty sequence

        try
          {
            new_seq.push_front (attrbRefSeqElem (attrb_ref, ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc)));
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < attrbRefSeq > () = new_seq;
      }
#line 7517 "agc-byacc.cc"
    break;

  case 247: // attrb_evaluation_expr_component: expr_operator
#line 2453 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbRefSeq > () = attrbRefSeq (); // empty sequence
      }
#line 7525 "agc-byacc.cc"
    break;

  case 248: // attrb_evaluation_expr_component: expr_value
#line 2457 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbRefSeq > () = attrbRefSeq (); // empty sequence
      }
#line 7533 "agc-byacc.cc"
    break;

  case 249: // attrb_evaluation_expr_component: "(" attrb_evaluation_stmt_seq ")"
#line 2462 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbRefSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < attrbRefSeq > ();
      }
#line 7541 "agc-byacc.cc"
    break;

  case 250: // attrb_evaluation_expr_component: "[" attrb_evaluation_expr "]"
#line 2466 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbRefSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < attrbRefSeq > ();
      }
#line 7549 "agc-byacc.cc"
    break;

  case 251: // attrb_ref: "attribute reference"
#line 2473 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbPair > () = transAttrbTripleToAttrbPair (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc), (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbTriple > ());
      }
#line 7557 "agc-byacc.cc"
    break;

  case 252: // attrb_evaluation_compound_stmt: "{" attrb_evaluation_stmt_seq "}"
#line 2480 "agc-byacc.yy"
      {
  (*yyvalp).as < attrbRefSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < attrbRefSeq > ();
      }
#line 7565 "agc-byacc.cc"
    break;

  case 253: // attrb_evaluation_stmt_seq: %empty
#line 2495 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
        (*yyvalp).as < attrbRefSeq > () = attrbRefSeq (); // empty sequence
      }
#line 7574 "agc-byacc.cc"
    break;

  case 254: // attrb_evaluation_stmt_seq: attrb_evaluation_stmt_seq attrb_evaluation_stmt_seq_component
#line 2500 "agc-byacc.yy"
      {
        attrbRefSeq new_seq = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (-1)].getState().value ().as < attrbRefSeq > ();

        const attrbRefSeq& component = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbRefSeq > ();

        try
          {
            new_seq.insert (new_seq.end (),
                            component.cbegin (),
                            component.cend ());
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        (*yyvalp).as < attrbRefSeq > () = new_seq;
      }
#line 7597 "agc-byacc.cc"
    break;

  case 255: // attrb_evaluation_stmt_seq: error
#line 2519 "agc-byacc.yy"
      {
        yyclearin;
        (*yyvalp).as < attrbRefSeq > () = attrbRefSeq (); // empty sequence
      }
#line 7606 "agc-byacc.cc"
    break;

  case 256: // attrb_evaluation_stmt_seq_component: attrb_evaluation_stmt_component
#line 2527 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbRefSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbRefSeq > ();
      }
#line 7614 "agc-byacc.cc"
    break;

  case 257: // attrb_evaluation_stmt_seq_component: attrb_evaluation_compound_stmt
#line 2531 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbRefSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbRefSeq > ();
      }
#line 7622 "agc-byacc.cc"
    break;

  case 258: // attrb_evaluation_stmt_seq_component: ";"
#line 2535 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbRefSeq > () = attrbRefSeq (); // empty sequence
      }
#line 7630 "agc-byacc.cc"
    break;

  case 259: // attrb_evaluation_stmt_component: attrb_evaluation_expr_component
#line 2542 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbRefSeq > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbRefSeq > ();
      }
#line 7638 "agc-byacc.cc"
    break;

  case 262: // dependent_name: attrb_occur
#line 2556 "agc-byacc.yy"
      {
        const attrbPair& attref = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbPair > ();

        if (attref.num == NIOsymAttrbNum)
          {
            // NIO pseudo attribute reference

            const prodSymbol& symbol = prodBuffer2[attref.pos];

            yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                       "\"" +
                           symbol.lexeme + "." +
                           std::to_string (symbol.symOccr) + "." +
                           NIOsym +
                       "\""
                       " cannot be a dependent.\n");
          }
        else if (memberDepend (attref, true, true))
          {
            const prodSymbol& symbol = prodBuffer2[attref.pos];

            yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                       "duplicate dependent "
                       "\"" +
                           symbol.lexeme + "." +
                           std::to_string (symbol.symOccr) + "." +
                           (*(gSymTable[symbol.lexeme]
                                  .symSort.attrbSeq))[attref.num].id +
                       "\".\n");
          }
      }
#line 7674 "agc-byacc.cc"
    break;

  case 263: // dependent_name: error
#line 2588 "agc-byacc.yy"
      {
        yyclearin;
      }
#line 7682 "agc-byacc.cc"
    break;

  case 264: // attrb_occur: "attribute occurrence"
#line 2595 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbPair > () = transAttrbTripleToAttrbPair (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                                                    (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbTriple > ());
      }
#line 7691 "agc-byacc.cc"
    break;

  case 265: // attrb_occur: attrb_ref
#line 2600 "agc-byacc.yy"
      {
        (*yyvalp).as < attrbPair > () = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbPair > ();
      }
#line 7699 "agc-byacc.cc"
    break;

  case 268: // dependee_name_seq: error
#line 2611 "agc-byacc.yy"
      {
        yyclearin;
      }
#line 7707 "agc-byacc.cc"
    break;

  case 269: // dependee_name: attrb_occur
#line 2618 "agc-byacc.yy"
      {
        const attrbPair& attref = (static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbPair > ();

        if (attref.num == NIOsymAttrbNum)
          {
            // NIO pseudo attribute reference

            const prodSymbol& symbol = prodBuffer2[attref.pos];

            yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                       "\"" +
                           symbol.lexeme + "." +
                           std::to_string (symbol.symOccr) + "." +
                           NIOsym +
                       "\""
                       " cannot be a dependee.\n");
          }
        else if (memberDepend (attref, true, false))
          {
            const prodSymbol& symbol = prodBuffer2[attref.pos];

            yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                       "\"" +
                           symbol.lexeme + "." +
                           std::to_string (symbol.symOccr) + "." +
                           (*(gSymTable[symbol.lexeme]
                                  .symSort.attrbSeq))[attref.num].id +
                       "\""
                       " depends immediately on itself.\n");
          }
        else if (memberDepend (attref, false, true))
          {
            const prodSymbol& symbol = prodBuffer2[attref.pos];

            yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                       "duplicate dependee "
                       "\"" +
                           symbol.lexeme + "." +
                           std::to_string (symbol.symOccr) + "." +
                           (*(gSymTable[symbol.lexeme]
                                  .symSort.attrbSeq))[attref.num] .id +
                       "\".\n");
          }
      }
#line 7756 "agc-byacc.cc"
    break;

  case 270: // $@17: %empty
#line 2668 "agc-byacc.yy"
      {
        ++dynTravModSeq;

        try
          {
            dynTravModArr.push_back (dynTravMod ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < name_literal > ()));
          }
        catch (...)
          {
            yox_alloc_fail (__FILE__, __LINE__);
          }

        // throw away any pending comments & white space

        startTravAction (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc)); // overwritten if next is a traversal modifier
      }
#line 7777 "agc-byacc.cc"
    break;

  case 271: // traversal_segment: "traversal mode annunciator" $@17 traversal_modifier_seq traversal_action
#line 2686 "agc-byacc.yy"
      {
        wrapUpTravAction ();
      }
#line 7785 "agc-byacc.cc"
    break;

  case 272: // traversal_modifier_seq: %empty
#line 2693 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
      }
#line 7793 "agc-byacc.cc"
    break;

  case 274: // $@18: %empty
#line 2701 "agc-byacc.yy"
      {
        // @revorder may occur once per traversal action

        if (++dynTravModArr[dynTravModSeq].orderRev > 1)
          yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                     "multiple @revorder modifiers for traversal "
                     "\"" + dynTravModArr[dynTravModSeq].id + "\".\n");

        // throw away any pending comments & white space

        startTravCondition (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc));
      }
#line 7810 "agc-byacc.cc"
    break;

  case 275: // traversal_modifier: "@revorder" $@18 traversal_modifier_expr
#line 2714 "agc-byacc.yy"
      {
        wrapUpTravOrderCond ();

        // throw away any pending comments & white space

        startTravAction (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc));
        // overwritten if next is a traversal modifier
      }
#line 7823 "agc-byacc.cc"
    break;

  case 276: // $@19: %empty
#line 2723 "agc-byacc.yy"
      {
        // @revdirection may occur once per traversal action

        if (++dynTravModArr[dynTravModSeq].dirRev == 1)
          dynTravModArr[dynTravModSeq].dirRevLoc = ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc);
        else if (dynTravModArr[dynTravModSeq].id != errTravID)
          yox_error (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc),
                     "multiple @revdirection modifiers for traversal "
                     "\"" + dynTravModArr[dynTravModSeq].id + "\".\n");

        // throw away any pending comments & white space

        startTravCondition (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc));
      }
#line 7842 "agc-byacc.cc"
    break;

  case 277: // traversal_modifier: "@revdirection" $@19 traversal_modifier_expr
#line 2738 "agc-byacc.yy"
      {
        wrapUpTravDirCond ();

        // throw away any pending comments & white space

        startTravAction (((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().yyloc));
        // overwritten if next is a traversal modifier
      }
#line 7855 "agc-byacc.cc"
    break;

  case 279: // traversal_expr: %empty
#line 2762 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
      }
#line 7863 "agc-byacc.cc"
    break;

  case 281: // traversal_expr: error
#line 2767 "agc-byacc.yy"
      {
        yyclearin;
      }
#line 7871 "agc-byacc.cc"
    break;

  case 282: // traversal_expr_component: attrb_ref
#line 2774 "agc-byacc.yy"
      {
        rsBuffer.putAttrbPair ((static_cast<glr_stack_item const *>(yyvsp))[YYFILL (0)].getState().value ().as < attrbPair > ());
      }
#line 7879 "agc-byacc.cc"
    break;

  case 292: // traversal_stmt_seq: %empty
#line 2810 "agc-byacc.yy"
      {
        (*yylocp) = yyla.location;
      }
#line 7887 "agc-byacc.cc"
    break;


#line 7891 "agc-byacc.cc"

          default: break;
        }
    #if YY_EXCEPTIONS
      }
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          *yylocp = yyexc.location;
          yyparser.error (*yylocp, yyexc.what ());
          YYERROR;
        }
    #endif // YY_EXCEPTIONS
    YY_SYMBOL_PRINT ("-> $$ =", yylhsNonterm (yyrule), *yyvalp, *yylocp);

      return yyok;
    # undef yyerrok
    # undef YYABORT
    # undef YYACCEPT
    # undef YYERROR
    # undef YYBACKUP
    # undef yytoken
    # undef yyclearin
    # undef YYRECOVERING
    }

    YYRESULTTAG
    yyresolveStack ()
    {
      if (yystateStack.isSplit ())
        {
          int yyn = 0;
          for (glr_state* yys = firstTopState ();
               yys != yystateStack.yysplitPoint;
               yys = yys->pred ())
            yyn += 1;
          YYCHK (yyresolveStates (*firstTopState (), yyn));
        }
      return yyok;
    }

    /** Pop the symbols consumed by reduction #YYRULE from the top of stack
     *  #YYK of *YYSTACKP, and perform the appropriate semantic action on their
     *  semantic values.  Assumes that all ambiguities in semantic values
     *  have been previously resolved.  Set *YYVALP to the resulting value,
     *  and *YYLOCP to the computed location (if any).  Return value is as
     *  for userAction.  */
    YYRESULTTAG
    yydoAction (state_set_index yyk, rule_num yyrule,
                value_type* yyvalp, location_type* yylocp)
    {
      const int yynrhs = yyrhsLength (yyrule);

      if (!yystateStack.isSplit())
        {
          /* Standard special case: single stack.  */
          YYASSERT (yyk.get() == 0);
          glr_stack_item* yyrhs = yystateStack.firstTop()->asItem();
          const YYRESULTTAG res
            = yyuserAction (yyrule, yynrhs, yyrhs, yyk, yyvalp, yylocp);
          yystateStack.pop_back(static_cast<size_t>(yynrhs));
          yystateStack.setFirstTop(&yystateStack[yystateStack.size() - 1].getState());
          return res;
        }
      else
        {
          glr_stack_item yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
          glr_state* yys = yystateStack.topAt(yyk);
          yyrhsVals[YYMAXRHS + YYMAXLEFT].getState().setPred(yys);
          if (yynrhs == 0)
            /* Set default location.  */
            yyrhsVals[YYMAXRHS + YYMAXLEFT - 1].getState().yyloc = yys->yyloc;
          for (int yyi = 0; yyi < yynrhs; yyi += 1)
            {
              yys = yys->pred();
              YYASSERT (yys != YY_NULLPTR);
            }
          yystateStack.yyupdateSplit (*yys);
          yystateStack.setTopAt(yyk, yys);
          return yyuserAction (yyrule, yynrhs, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
                               yyk,
                               yyvalp, yylocp);
        }
    }

    /** Pop items off stack #YYK of *YYSTACKP according to grammar rule YYRULE,
     *  and push back on the resulting nonterminal symbol.  Perform the
     *  semantic action associated with YYRULE and store its value with the
     *  newly pushed state, if YYFORCEEVAL or if *YYSTACKP is currently
     *  unambiguous.  Otherwise, store the deferred semantic action with
     *  the new state.  If the new state would have an identical input
     *  position, LR state, and predecessor to an existing state on the stack,
     *  it is identified with that existing state, eliminating stack #YYK from
     *  *YYSTACKP.  In this case, the semantic value is
     *  added to the options for the existing state's semantic value.
     */
    YYRESULTTAG
    yyglrReduce (state_set_index yyk, rule_num yyrule, bool yyforceEval)
    {
      size_t yyposn = topState(yyk)->yyposn;

      if (yyforceEval || !yystateStack.isSplit())
        {
          value_type val;
          location_type loc;

          YYRESULTTAG yyflag = yydoAction (yyk, yyrule, &val, &loc);
          if (yyflag == yyerr && yystateStack.isSplit())
            {
              YYCDEBUG << "Parse on stack " << yyk.get ()
                       << " rejected by rule " << yyrule - 1
                       << " (line " << int (yyrline[yyrule]) << ").\n";
            }
          if (yyflag != yyok)
            return yyflag;
          yyglrShift (yyk,
                      yyLRgotoState (topState(yyk)->yylrState,
                                     yylhsNonterm (yyrule)),
                      yyposn, val, loc);
          // FIXME: User destructors.
          // Value type destructor.
          switch (yylhsNonterm (yyrule))
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        val.template destroy< attrbPair > ();
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        val.template destroy< attrbRefSeq > ();
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        val.template destroy< attrbTriple > ();
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        val.template destroy< char_literal > ();
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        val.template destroy< keyword > ();
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        val.template destroy< name_literal > ();
        break;

      case symbol_kind::S_NUM: // "number"
        val.template destroy< numberRep > ();
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        val.template destroy< symDeclSeq > ();
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        val.template destroy< symSeq > ();
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        val.template destroy< typeSeq > ();
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        val.template destroy< userArgSeq > ();
        break;

      default:
        break;
    }

        }
      else
        {
          glr_state *yys = yystateStack.topAt(yyk);
          glr_state *yys0 = yys;
          for (int yyn = yyrhsLength (yyrule); 0 < yyn; yyn -= 1)
            {
              yys = yys->pred();
              YYASSERT (yys != YY_NULLPTR);
            }
          yystateStack.yyupdateSplit (*yys);
          state_num yynewLRState = yyLRgotoState (yys->yylrState, yylhsNonterm (yyrule));
          YYCDEBUG << "Reduced stack " << yyk.get ()
                   << " by rule " << yyrule - 1 << " (line " << int (yyrline[yyrule])
                   << "); action deferred.  Now in state " << yynewLRState
                   << ".\n";
          for (state_set_index yyi = create_state_set_index(0); yyi.uget() < yystateStack.numTops(); ++yyi)
            if (yyi != yyk && yystateStack.topAt(yyi) != YY_NULLPTR)
              {
                const glr_state* yysplit = yystateStack.yysplitPoint;
                glr_state* yyp = yystateStack.topAt(yyi);
                while (yyp != yys && yyp != yysplit
                       && yyp->yyposn >= yyposn)
                  {
                    if (yyp->yylrState == yynewLRState
                        && yyp->pred() == yys)
                      {
                        yyaddDeferredAction (yyk, yyp, yys0, yyrule);
                        yystateStack.yytops.yymarkStackDeleted (yyk);
                        YYCDEBUG << "Merging stack " << yyk.get ()
                                 << " into stack " << yyi.get () << ".\n";
                        return yyok;
                      }
                    yyp = yyp->pred();
                  }
              }
          yystateStack.setTopAt(yyk, yys);
          yyglrShiftDefer (yyk, yynewLRState, yyposn, yys0, yyrule);
        }
      return yyok;
    }

    /** Shift stack #YYK of *YYSTACKP, to a new state corresponding to LR
     *  state YYLRSTATE, at input position YYPOSN, with the (unresolved)
     *  semantic value of YYRHS under the action for YYRULE.  */
    void
    yyglrShiftDefer (state_set_index yyk, state_num yylrState,
                     size_t yyposn, glr_state* yyrhs, rule_num yyrule)
    {
      glr_state& yynewState = yystateStack.yynewGLRState (
        glr_state (yylrState, yyposn));
      yynewState.setPred (yystateStack.topAt (yyk));
      yystateStack.setTopAt (yyk, &yynewState);

      /* Invokes yyreserveStack.  */
      yyaddDeferredAction (yyk, &yynewState, yyrhs, yyrule);
    }

    /** Shift to a new state on stack #YYK of *YYSTACKP, corresponding to LR
     * state YYLRSTATE, at input position YYPOSN, with (resolved) semantic
     * value YYVAL_ARG and source location YYLOC_ARG.  */
    void
    yyglrShift (state_set_index yyk, state_num yylrState,
                size_t yyposn,
                const value_type& yyval_arg, const location_type& yyloc_arg)
    {
      glr_state& yynewState = yystateStack.yynewGLRState (
        glr_state (yylrState, yyposn, yyval_arg, yyloc_arg));
      yynewState.setPred (yystateStack.topAt(yyk));
      yystateStack.setTopAt (yyk, &yynewState);
      yyreserveGlrStack ();
    }

#if YYDEBUG
    void
    yypstack (state_set_index yyk) const
    {
      yystateStack.yypstates (yystateStack.topAt (yyk));
    }
#endif

    glr_state* topState(state_set_index i) {
      return yystateStack.topAt(i);
    }

    glr_state* firstTopState() {
      return yystateStack.firstTop();
    }

  private:

    void popall_ ()
    {
      /* If the stack is well-formed, pop the stack until it is empty,
         destroying its entries as we go.  But free the stack regardless
         of whether it is well-formed.  */
      for (state_set_index k = create_state_set_index(0); k.uget() < yystateStack.numTops(); k += 1)
        if (yystateStack.topAt(k) != YY_NULLPTR)
          {
            while (yystateStack.topAt(k) != YY_NULLPTR)
              {
                glr_state* state = topState(k);
                yyerror_range[1].getState().yyloc = state->yyloc;
                if (state->pred() != YY_NULLPTR)
                  state->destroy ("Cleanup: popping", yyparser);
                yystateStack.setTopAt(k, state->pred());
                yystateStack.pop_back();
              }
              break;
          }
    }

    /** Resolve the previous YYN states starting at and including state YYS
     *  on *YYSTACKP. If result != yyok, some states may have been left
     *  unresolved possibly with empty semantic option chains.  Regardless
     *  of whether result = yyok, each state has been left with consistent
     *  data so that destroy can be invoked if necessary.  */
    YYRESULTTAG
    yyresolveStates (glr_state& yys, int yyn)
    {
      if (0 < yyn)
        {
          YYASSERT (yys.pred() != YY_NULLPTR);
          YYCHK (yyresolveStates (*yys.pred(), yyn-1));
          if (! yys.yyresolved)
            YYCHK (yyresolveValue (yys));
        }
      return yyok;
    }

    static void
    yyuserMerge (int yyn, value_type& yy0, value_type& yy1)
    {
      YY_USE (yy0);
      YY_USE (yy1);

      switch (yyn)
        {

          default: break;
        }
    }

    /** Resolve the ambiguity represented in state YYS in *YYSTACKP,
     *  perform the indicated actions, and set the semantic value of YYS.
     *  If result != yyok, the chain of semantic options in YYS has been
     *  cleared instead or it has been left unmodified except that
     *  redundant options may have been removed.  Regardless of whether
     *  result = yyok, YYS has been left with consistent data so that
     *  destroy can be invoked if necessary.  */
    YYRESULTTAG
    yyresolveValue (glr_state& yys)
    {
      semantic_option* yybest = yys.firstVal();
      YYASSERT(yybest != YY_NULLPTR);
      bool yymerge = false;
      YYRESULTTAG yyflag;
      location_type *yylocp = &yys.yyloc;

      semantic_option* yypPrev = yybest;
      for (semantic_option* yyp = yybest->next();
           yyp != YY_NULLPTR; )
        {
          if (yybest->isIdenticalTo (*yyp))
            {
              yybest->mergeWith (*yyp);
              yypPrev->setNext(yyp->next());
              yyp = yypPrev->next();
            }
          else
            {
              switch (yypreference (*yybest, *yyp))
                {
                case 0:
                  yyresolveLocations (yys, 1);
                  return yystateStack.yyreportAmbiguity (*yybest, *yyp, yyparser, *yylocp);
                  break;
                case 1:
                  yymerge = true;
                  break;
                case 2:
                  break;
                case 3:
                  yybest = yyp;
                  yymerge = false;
                  break;
                default:
                  /* This cannot happen so it is not worth a YYASSERT (false),
                     but some compilers complain if the default case is
                     omitted.  */
                  break;
                }
              yypPrev = yyp;
              yyp = yyp->next();
            }
        }

      value_type val;
      if (yymerge)
        {
          int yyprec = yydprec[yybest->yyrule];
          yyflag = yyresolveAction (*yybest, &val, yylocp);
          if (yyflag == yyok)
            for (semantic_option* yyp = yybest->next();
                 yyp != YY_NULLPTR;
                 yyp = yyp->next())
              {
                if (yyprec == yydprec[yyp->yyrule])
                  {
                    value_type yyval_other;
                    location_type yydummy;
                    yyflag = yyresolveAction (*yyp, &yyval_other, &yydummy);
                    if (yyflag != yyok)
                      {
                        yyparser.yy_destroy_ ("Cleanup: discarding incompletely merged value for",
                                              yy_accessing_symbol (yys.yylrState),
                                              this->yyla.value, *yylocp);
                        break;
                      }
                    yyuserMerge (yymerger[yyp->yyrule], val, yyval_other);
                    // FIXME: User destructors.
                    // Value type destructor.
                    switch (yy_accessing_symbol (yys.yylrState))
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        yyval_other.template destroy< attrbPair > ();
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        yyval_other.template destroy< attrbRefSeq > ();
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        yyval_other.template destroy< attrbTriple > ();
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        yyval_other.template destroy< char_literal > ();
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        yyval_other.template destroy< keyword > ();
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        yyval_other.template destroy< name_literal > ();
        break;

      case symbol_kind::S_NUM: // "number"
        yyval_other.template destroy< numberRep > ();
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        yyval_other.template destroy< symDeclSeq > ();
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        yyval_other.template destroy< symSeq > ();
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        yyval_other.template destroy< typeSeq > ();
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        yyval_other.template destroy< userArgSeq > ();
        break;

      default:
        break;
    }

                  }
              }
        }
      else
        yyflag = yyresolveAction (*yybest, &val, yylocp);

      if (yyflag == yyok)
        {
          yys.yyresolved = true;
          YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
          new (&yys.value ()) value_type ();
          switch (yy_accessing_symbol (yys.yylrState))
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        yys.value ().copy< attrbPair > (val);
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        yys.value ().copy< attrbRefSeq > (val);
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        yys.value ().copy< attrbTriple > (val);
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        yys.value ().copy< char_literal > (val);
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        yys.value ().copy< keyword > (val);
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        yys.value ().copy< name_literal > (val);
        break;

      case symbol_kind::S_NUM: // "number"
        yys.value ().copy< numberRep > (val);
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        yys.value ().copy< symDeclSeq > (val);
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        yys.value ().copy< symSeq > (val);
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        yys.value ().copy< typeSeq > (val);
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        yys.value ().copy< userArgSeq > (val);
        break;

      default:
        break;
    }


          YY_IGNORE_MAYBE_UNINITIALIZED_END
        }
      else
        yys.setFirstVal(YY_NULLPTR);

      // FIXME: User destructors.
      // Value type destructor.
      switch (yy_accessing_symbol (yys.yylrState))
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        val.template destroy< attrbPair > ();
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        val.template destroy< attrbRefSeq > ();
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        val.template destroy< attrbTriple > ();
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        val.template destroy< char_literal > ();
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        val.template destroy< keyword > ();
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        val.template destroy< name_literal > ();
        break;

      case symbol_kind::S_NUM: // "number"
        val.template destroy< numberRep > ();
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        val.template destroy< symDeclSeq > ();
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        val.template destroy< symSeq > ();
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        val.template destroy< typeSeq > ();
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        val.template destroy< userArgSeq > ();
        break;

      default:
        break;
    }

      return yyflag;
    }

    /** Resolve the states for the RHS of YYOPT on *YYSTACKP, perform its
     *  user action, and return the semantic value and location in *YYVALP
     *  and *YYLOCP.  Regardless of whether result = yyok, all RHS states
     *  have been destroyed (assuming the user action destroys all RHS
     *  semantic values if invoked).  */
    YYRESULTTAG
    yyresolveAction (semantic_option& yyopt, value_type* yyvalp, location_type* yylocp)
    {
      glr_state* yyoptState = yyopt.state();
      YYASSERT(yyoptState != YY_NULLPTR);
      int yynrhs = yyrhsLength (yyopt.yyrule);
      YYRESULTTAG yyflag = yyresolveStates (*yyoptState, yynrhs);
      if (yyflag != yyok)
        {
          for (glr_state *yys = yyoptState; yynrhs > 0; yys = yys->pred(), yynrhs -= 1)
            yys->destroy ("Cleanup: popping", yyparser);
          return yyflag;
        }

      glr_stack_item yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
      yyrhsVals[YYMAXRHS + YYMAXLEFT].getState().setPred(yyopt.state());
      if (yynrhs == 0)
        /* Set default location.  */
        yyrhsVals[YYMAXRHS + YYMAXLEFT - 1].getState().yyloc = yyoptState->yyloc;
      {
        symbol_type yyla_current = std::move (this->yyla);
        this->yyla = std::move (yyopt.yyla);
        yyflag = yyuserAction (yyopt.yyrule, yynrhs,
                               yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
                               create_state_set_index (-1),
                               yyvalp, yylocp);
        this->yyla = std::move (yyla_current);
      }
      return yyflag;
    }

    /** Resolve the locations for each of the YYN1 states in *YYSTACKP,
     *  ending at YYS1.  Has no effect on previously resolved states.
     *  The first semantic option of a state is always chosen.  */
    void
    yyresolveLocations (glr_state &yys1, int yyn1)
    {
      if (0 < yyn1)
        {
          yyresolveLocations (*yys1.pred(), yyn1 - 1);
          if (!yys1.yyresolved)
            {
              glr_stack_item yyrhsloc[1 + YYMAXRHS];
              YYASSERT (yys1.firstVal() != YY_NULLPTR);
              semantic_option& yyoption = *yys1.firstVal();
              const int yynrhs = yyrhsLength (yyoption.yyrule);
              if (0 < yynrhs)
                {
                  yyresolveLocations (*yyoption.state(), yynrhs);
                  const glr_state *yys = yyoption.state();
                  for (int yyn = yynrhs; yyn > 0; yyn -= 1)
                  {
                    yyrhsloc[yyn].getState().yyloc = yys->yyloc;
                    yys = yys->pred();
                  }
                }
              else
                {
                  /* Both yyresolveAction and yyresolveLocations traverse the GSS
                     in reverse rightmost order.  It is only necessary to invoke
                     yyresolveLocations on a subforest for which yyresolveAction
                     would have been invoked next had an ambiguity not been
                     detected.  Thus the location of the previous state (but not
                     necessarily the previous state itself) is guaranteed to be
                     resolved already.  */
                  YY_IGNORE_NULL_DEREFERENCE_BEGIN
                  yyrhsloc[0].getState().yyloc = yyoption.state()->yyloc;
                  YY_IGNORE_NULL_DEREFERENCE_END
                }
              YYLLOC_DEFAULT ((yys1.yyloc), yyrhsloc, yynrhs);
            }
        }
    }

    /** If yytoken is empty, fetch the next token.  */
    void
    yyget_token ()
    {
  YY_USE (theLexer);
  YY_USE (ctrl);
  YY_USE (theFiles);
      if (this->yyla.empty ())
        {
          YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
          try
#endif // YY_EXCEPTIONS
            {
              yyla.kind_ = yyparser.yytranslate_ (yylex (&this->yyla.value, &this->yyla.location));
            }
#if YY_EXCEPTIONS
          catch (const parser_type::syntax_error& yyexc)
            {
              YYCDEBUG << "Caught exception: " << yyexc.what () << '\n';
              this->yyla.location = yyexc.location;
              yyparser.error (this->yyla.location, yyexc.what ());
              // Map errors caught in the scanner to the error token, so that error
              // handling is started.
              this->yyla.kind_ = symbol_kind::S_YYerror;
            }
        }
#endif // YY_EXCEPTIONS
      if (this->yyla.kind () == symbol_kind::S_YYEOF)
        YYCDEBUG << "Now at end of input.\n";
      else
        YY_SYMBOL_PRINT ("Next token is", this->yyla.kind (), this->yyla.value, this->yyla.location);
    }


                                /* Bison grammar-table manipulation.  */

    /** The action to take in YYSTATE on seeing YYTOKEN.
     *  Result R means
     *    R < 0:  Reduce on rule -R.
     *    R = 0:  Error.
     *    R > 0:  Shift to state R.
     *  Set *YYCONFLICTS to a pointer into yyconfl to a 0-terminated list
     *  of conflicting reductions.
     */
    static int
    yygetLRActions (state_num yystate, symbol_kind_type yytoken, const short*& yyconflicts)
    {
      int yyindex = yypact[yystate] + yytoken;
      if (yytoken == symbol_kind::S_YYerror)
        {
          // This is the error token.
          yyconflicts = yyconfl;
          return 0;
        }
      else if (yy_is_defaulted_state (yystate)
               || yyindex < 0 || YYLAST < yyindex || yycheck[yyindex] != yytoken)
        {
          yyconflicts = yyconfl;
          return -yydefact[yystate];
        }
      else if (! yytable_value_is_error (yytable[yyindex]))
        {
          yyconflicts = yyconfl + yyconflp[yyindex];
          return yytable[yyindex];
        }
      else
        {
          yyconflicts = yyconfl + yyconflp[yyindex];
          return 0;
        }
    }

    /** Compute post-reduction state.
     * \param yystate   the current state
     * \param yysym     the nonterminal to push on the stack
     */
    static state_num
    yyLRgotoState (state_num yystate, symbol_kind_type yysym)
    {
      const int yyr = yypgoto[yysym - YYNTOKENS] + yystate;
      if (0 <= yyr && yyr <= YYLAST && yycheck[yyr] == yystate)
        return yytable[yyr];
      else
        return yydefgoto[yysym - YYNTOKENS];
    }

    static bool
    yypact_value_is_default (state_num yystate)
    {
      return ((yystate) == YYPACT_NINF);
    }

    static bool
    yytable_value_is_error (int yytable_value YY_ATTRIBUTE_UNUSED)
    {
      return 0;
    }

    static bool
    yy_is_shift_action (int yyaction) YY_NOEXCEPT
    {
      return 0 < yyaction;
    }

    static bool
    yy_is_error_action (int yyaction) YY_NOEXCEPT
    {
      return yyaction == 0;
    }

    /** Whether LR state YYSTATE has only a default reduction
     *  (regardless of token).  */
    static bool
    yy_is_defaulted_state (state_num yystate)
    {
      return yypact_value_is_default (yypact[yystate]);
    }

    /** The default reduction for YYSTATE, assuming it has one.  */
    static rule_num
    yy_default_action (state_num yystate)
    {
      return yydefact[yystate];
    }

                                    /* GLRStacks */

    /** Y0 and Y1 represent two possible actions to take in a given
     *  parsing state; return 0 if no combination is possible,
     *  1 if user-mergeable, 2 if Y0 is preferred, 3 if Y1 is preferred.  */
    static int
    yypreference (const semantic_option& y0, const semantic_option& y1)
    {
      const rule_num r0 = y0.yyrule, r1 = y1.yyrule;
      const int p0 = yydprec[r0], p1 = yydprec[r1];

      if (p0 == p1)
        {
          if (yymerger[r0] == 0 || yymerger[r0] != yymerger[r1])
            return 0;
          else
            return 1;
        }
      else if (p0 == 0 || p1 == 0)
        return 0;
      else if (p0 < p1)
        return 3;
      else if (p1 < p0)
        return 2;
      else
        return 0;
    }


    // User arguments.
    AGC::byaccLexer& theLexer;
    yoxControl& ctrl;
    specIO& theFiles;
  }; // class byacc::glr_stack
} // namespace AGC


#if YYDEBUG
namespace
{
  void
  yypstack (const glr_stack& yystack, size_t yyk)
  {
    yystack.yypstack (create_state_set_index (static_cast<std::ptrdiff_t> (yyk)));
  }

  void
  yypdumpstack (const glr_stack& yystack)
  {
    yystack.yypdumpstack ();
  }
}
#endif

#line 41 "agc-byacc.yy"
namespace AGC {
#line 9114 "agc-byacc.cc"

  /// Build a parser object.
  byacc::byacc (AGC::byaccLexer& theLexer_yyarg, yoxControl& ctrl_yyarg, specIO& theFiles_yyarg)
    :
#if YYDEBUG
      yycdebug_ (&std::cerr),
#endif
      theLexer (theLexer_yyarg),
      ctrl (ctrl_yyarg),
      theFiles (theFiles_yyarg)
  {}

  byacc::~byacc ()
  {}

  byacc::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  int
  byacc::operator() ()
  {
    return parse ();
  }

  int
  byacc::parse ()
  {
    glr_stack yystack(YYINITDEPTH, *this, theLexer, ctrl, theFiles);
    return yystack.parse ();
  }

  const char *
  byacc::symbol_name (symbol_kind_type yysymbol)
  {
    static const char *const yy_sname[] =
    {
    "end of file", "error", "invalid token", "@{", "@}",
  "attribute reference", "identifier", "character literal",
  "string literal", "{", "}", ";", "%%", "%{", "%}", "terminal symbol",
  "terminal literal", "return", "\\n",
  "start of generic scanner source file", "no attribute reference section",
  "attribute occurrence", "@attributes", "@macro", "@end", "@traversal",
  "@preorder", "@postorder", "@lefttoright", "@righttoleft", "@revorder",
  "@revdirection", "@disable", "@autosyn", "@autoinh", "@warn", "@i", "@m",
  "@e", "@decorate", "@void", "traversal mode annunciator", ",", "(", ")",
  "[", "]", "@", "...", "<-", "<->", "%?", "nonterminal symbol",
  "C++ qualified name", "literal path name", "inherited attribute",
  "bison API variable", "bison API value", "number", "%left", "%right",
  "%nonassoc", "%token", "%prec", "%type", "%nterm", "%start", "%union",
  "%empty", "%expect", "%expect-rr", "%pure-parser", "%dprec", "%merge",
  "%precedence", "%la", "%scanner", "CODE", "LOCATION", "%destructor",
  "%lex-param", "%parse-param", "%define", "%language", "%name-prefix",
  "%param", "%printer", "%skeleton", "%local", "%export", "%import",
  "const", "volatile", "restrict", "register", "static", "TYPE_KEYWORD",
  "ELABORATED_TYPE_KEYWORD", ".", "->", "++", "--", "~", "!", "-", "+",
  "&", "*", "/", "%", "<<", ">>", "<", ">", "<=", ">=", "==", "!=", "^",
  "|", "&&", "||", "?", ":", "=", "+=", "-=", "*=", "/=", "%=", "<<=",
  ">>=", "&=", "^=", "|=", "->*", ".*", "::", "$accept", "AG_spec",
  "parser_spec", "$@1", "$@2", "$@3", "parser_spec_definition_section",
  "parser_spec_rules_section", "tail", "definition_seq", "definition",
  "yacc_directive", "$@4", "bison_or_byacc_directive", "$@5",
  "ox_directive", "$@6", "$@7", "$@8", "$@9", "$@10", "code_seq",
  "token_decl_list", "tag_opt", "tag", "token_list", "token",
  "named_token", "NUM_opt", "precedence_declarer", "precedence_decl_list",
  "terminal_list", "terminal_symbol", "nonterminal_symbol", "symbol",
  "nonterminal_declarer", "nonterminal_decl_list", "nonterminal_list",
  "nonterminal", "tagList", "code_block", "user_argument_seq",
  "user_argument", "destructor_symbol_list", "destructor_symbol",
  "autoIDseq", "autoID", "attribute_decl_list", "attribute_decl",
  "attrb_modifier_opt", "attrb_modifier", "$@11", "$@12", "atWarn_opt",
  "type_specifier", "type", "type_component", "type_name",
  "elaborated_type_name", "type_list", "id_seq", "declarator",
  "direct_declarator", "id_seq2", "attribute_id", "ptr_operator",
  "ptr_type_qualifier_seq_opt", "ptr_type_qualifier_seq",
  "ptr_type_qualifier", "field_length_spec", "array_size_opt",
  "parameter_list_opt", "parameter_list", "parameter_type_list",
  "parameter_type", "formal_type_specifier", "abstract_declarator",
  "direct_abstract_declarator", "formal_array_qualifier_list_opt",
  "formal_array_qualifier_list", "formal_array_qualifier",
  "attributed_symbol_list", "attributed_symbol", "macroFormalList",
  "travSpecSeq", "travIDseq", "travID", "travSpec", "rule_seq", "rule_set",
  "$@13", "$@14", "left_hand_side", "inherited_attrID_list",
  "inherited_attrID", "right_hand_side", "$@15", "rhs_body", "rhs_seq",
  "rhs_component", "rhs_item", "rhs_symbol", "inherited_attr_expr",
  "inherited_attr_expr_component", "rule_directive", "parser_action",
  "bt_action", "attrb_ref_section", "$@16", "attrb_ref_section_body",
  "decorate_cmd", "attrb_ref_section_seq", "attrb_ref_section_item",
  "attrb_def", "attrb_evaluation", "attrb_evaluation_stmt",
  "attrb_evaluation_expr", "attrb_evaluation_expr_component", "attrb_ref",
  "attrb_evaluation_compound_stmt", "attrb_evaluation_stmt_seq",
  "attrb_evaluation_stmt_seq_component", "attrb_evaluation_stmt_component",
  "dependent_name_seq", "dependent_name", "attrb_occur",
  "dependee_name_seq", "dependee_name", "traversal_segment", "$@17",
  "traversal_modifier_seq", "traversal_modifier", "$@18", "$@19",
  "traversal_modifier_expr", "traversal_expr", "traversal_expr_component",
  "traversal_action", "traversal_stmt", "traversal_stmt_component",
  "traversal_compound_stmt", "traversal_stmt_seq",
  "traversal_stmt_seq_component", "expr_value", "expr_operator", YY_NULLPTR
    };
    return yy_sname[yysymbol];
  }





  // byacc::context.
  byacc::context::context (glr_stack& yystack, const symbol_type& yyla)
    : yystack_ (yystack)
    , yyla_ (yyla)
  {}

  int
  byacc::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;
    const int yyn = yypact[yystack_.firstTopState()->yylrState];
    if (!yystack_.yypact_value_is_default (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for this
           state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        /* Stay within bounds of both yycheck and yytname.  */
        const int yychecklim = YYLAST - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yystack_.yytable_value_is_error (yytable[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }
    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }





  void
  byacc::yy_destroy_ (const char* yymsg, symbol_kind_type yykind,
                           value_type& yyval,
                           location_type& yyloc)
  {
    YY_USE (yyval);
    YY_USE (yyloc);
    if (!yymsg)
      yymsg = "Deleting";
    byacc& yyparser = *this;
    YY_USE (yyparser);
    YY_SYMBOL_PRINT (yymsg, yykind, yyval, yyloc);

    YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
    YY_USE (yykind);
    YY_IGNORE_MAYBE_UNINITIALIZED_END
  }

#if YYDEBUG
  /*--------------------.
  | Print this symbol.  |
  `--------------------*/

  void
  byacc::yy_symbol_value_print_ (symbol_kind_type yykind,
                           const value_type& yyval,
                           const location_type& yyloc) const
  {
    YY_USE (yyloc);
    YY_USE (yyval);
    std::ostream& yyo = debug_stream ();
    YY_USE (yyo);
    switch (yykind)
    {
      case symbol_kind::S_ID: // "identifier"
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9302 "agc-byacc.cc"
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
#line 356 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < char_literal > () + "\"";
}
#line 9310 "agc-byacc.cc"
        break;

      case symbol_kind::S_LITERAL_STRING: // "string literal"
#line 356 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < char_literal > () + "\"";
}
#line 9318 "agc-byacc.cc"
        break;

      case symbol_kind::S_TERM_ID: // "terminal symbol"
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9326 "agc-byacc.cc"
        break;

      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
#line 356 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < char_literal > () + "\"";
}
#line 9334 "agc-byacc.cc"
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9342 "agc-byacc.cc"
        break;

      case symbol_kind::S_OX_MACRO: // "@macro"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9350 "agc-byacc.cc"
        break;

      case symbol_kind::S_OX_TRAV: // "@traversal"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9358 "agc-byacc.cc"
        break;

      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9366 "agc-byacc.cc"
        break;

      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9374 "agc-byacc.cc"
        break;

      case symbol_kind::S_OX_WARN: // "@warn"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9382 "agc-byacc.cc"
        break;

      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9390 "agc-byacc.cc"
        break;

      case symbol_kind::S_GS_ID: // "nonterminal symbol"
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9398 "agc-byacc.cc"
        break;

      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9406 "agc-byacc.cc"
        break;

      case symbol_kind::S_LITERAL_PATH: // "literal path name"
#line 356 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < char_literal > () + "\"";
}
#line 9414 "agc-byacc.cc"
        break;

      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9422 "agc-byacc.cc"
        break;

      case symbol_kind::S_API_VARIABLE: // "bison API variable"
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9430 "agc-byacc.cc"
        break;

      case symbol_kind::S_API_VALUE: // "bison API value"
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9438 "agc-byacc.cc"
        break;

      case symbol_kind::S_LEFT: // "%left"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9446 "agc-byacc.cc"
        break;

      case symbol_kind::S_RIGHT: // "%right"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9454 "agc-byacc.cc"
        break;

      case symbol_kind::S_NONASSOC: // "%nonassoc"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9462 "agc-byacc.cc"
        break;

      case symbol_kind::S_TOKEN: // "%token"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9470 "agc-byacc.cc"
        break;

      case symbol_kind::S_TYPE: // "%type"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9478 "agc-byacc.cc"
        break;

      case symbol_kind::S_NTERM: // "%nterm"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9486 "agc-byacc.cc"
        break;

      case symbol_kind::S_START: // "%start"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9494 "agc-byacc.cc"
        break;

      case symbol_kind::S_UNION: // "%union"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9502 "agc-byacc.cc"
        break;

      case symbol_kind::S_EXPECT: // "%expect"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9510 "agc-byacc.cc"
        break;

      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9518 "agc-byacc.cc"
        break;

      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9526 "agc-byacc.cc"
        break;

      case symbol_kind::S_PRECEDENCE: // "%precedence"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9534 "agc-byacc.cc"
        break;

      case symbol_kind::S_SCANNER: // "%scanner"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9542 "agc-byacc.cc"
        break;

      case symbol_kind::S_CODE: // CODE
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9550 "agc-byacc.cc"
        break;

      case symbol_kind::S_LOCATION: // LOCATION
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9558 "agc-byacc.cc"
        break;

      case symbol_kind::S_DESTRUCTOR: // "%destructor"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9566 "agc-byacc.cc"
        break;

      case symbol_kind::S_LEX_PARAM: // "%lex-param"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9574 "agc-byacc.cc"
        break;

      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9582 "agc-byacc.cc"
        break;

      case symbol_kind::S_DEFINE: // "%define"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9590 "agc-byacc.cc"
        break;

      case symbol_kind::S_LANGUAGE: // "%language"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9598 "agc-byacc.cc"
        break;

      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9606 "agc-byacc.cc"
        break;

      case symbol_kind::S_PARAM: // "%param"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9614 "agc-byacc.cc"
        break;

      case symbol_kind::S_PRINTER: // "%printer"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9622 "agc-byacc.cc"
        break;

      case symbol_kind::S_SKELETON: // "%skeleton"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9630 "agc-byacc.cc"
        break;

      case symbol_kind::S_LOCAL: // "%local"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9638 "agc-byacc.cc"
        break;

      case symbol_kind::S_EXPORT: // "%export"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9646 "agc-byacc.cc"
        break;

      case symbol_kind::S_IMPORT: // "%import"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9654 "agc-byacc.cc"
        break;

      case symbol_kind::S_CONST: // "const"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9662 "agc-byacc.cc"
        break;

      case symbol_kind::S_VOLATILE: // "volatile"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9670 "agc-byacc.cc"
        break;

      case symbol_kind::S_RESTRICT: // "restrict"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9678 "agc-byacc.cc"
        break;

      case symbol_kind::S_REGISTER: // "register"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9686 "agc-byacc.cc"
        break;

      case symbol_kind::S_STATIC: // "static"
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9694 "agc-byacc.cc"
        break;

      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9702 "agc-byacc.cc"
        break;

      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9710 "agc-byacc.cc"
        break;

      case symbol_kind::S_yacc_directive: // yacc_directive
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9718 "agc-byacc.cc"
        break;

      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9726 "agc-byacc.cc"
        break;

      case symbol_kind::S_ox_directive: // ox_directive
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9734 "agc-byacc.cc"
        break;

      case symbol_kind::S_named_token: // named_token
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9742 "agc-byacc.cc"
        break;

      case symbol_kind::S_precedence_declarer: // precedence_declarer
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9750 "agc-byacc.cc"
        break;

      case symbol_kind::S_terminal_symbol: // terminal_symbol
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9758 "agc-byacc.cc"
        break;

      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9766 "agc-byacc.cc"
        break;

      case symbol_kind::S_symbol: // symbol
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9774 "agc-byacc.cc"
        break;

      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9782 "agc-byacc.cc"
        break;

      case symbol_kind::S_nonterminal: // nonterminal
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9790 "agc-byacc.cc"
        break;

      case symbol_kind::S_attrb_modifier: // attrb_modifier
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9798 "agc-byacc.cc"
        break;

      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9806 "agc-byacc.cc"
        break;

      case symbol_kind::S_array_size_opt: // array_size_opt
#line 360 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < keyword > () + "\"";
}
#line 9814 "agc-byacc.cc"
        break;

      case symbol_kind::S_left_hand_side: // left_hand_side
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9822 "agc-byacc.cc"
        break;

      case symbol_kind::S_rhs_symbol: // rhs_symbol
#line 352 "agc-byacc.yy"
        {
  yyo << "\"" + yyval.as < name_literal > () + "\"";
}
#line 9830 "agc-byacc.cc"
        break;

      default:
        break;
    }
  }

  void
  byacc::yy_symbol_print_ (symbol_kind_type yykind,
                           const value_type& yyval,
                           const location_type& yyloc) const
  {
    *yycdebug_ << (yykind < YYNTOKENS ? "token" : "nterm")
               << ' ' << symbol_name (yykind) << " ("
               << yyloc << ": ";
    yy_symbol_value_print_ (yykind, yyval, yyloc);
    *yycdebug_ << ')';
  }

  std::ostream&
  byacc::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  byacc::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  byacc::debug_level_type
  byacc::debug_level () const
  {
    return yydebug;
  }

  void
  byacc::set_debug_level (debug_level_type l)
  {
    // Actually, it is yydebug which is really used.
    yydebug = l;
  }
#endif // YYDEBUG

  byacc::symbol_kind_type
  byacc::yytranslate_ (int t) YY_NOEXCEPT
  {
    return static_cast<symbol_kind_type> (t);
  }



  /*---------.
  | symbol.  |
  `---------*/
  // basic_symbol.
  template <typename Base>
  byacc::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        value.copy< attrbPair > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        value.copy< attrbRefSeq > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        value.copy< attrbTriple > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        value.copy< char_literal > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        value.copy< keyword > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        value.copy< name_literal > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_NUM: // "number"
        value.copy< numberRep > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        value.copy< symDeclSeq > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        value.copy< symSeq > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        value.copy< typeSeq > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        value.copy< userArgSeq > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }





  template <typename Base>
  bool
  byacc::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  byacc::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_attrb_ref: // attrb_ref
      case symbol_kind::S_attrb_occur: // attrb_occur
        value.move< attrbPair > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_attrb_evaluation: // attrb_evaluation
      case symbol_kind::S_attrb_evaluation_stmt: // attrb_evaluation_stmt
      case symbol_kind::S_attrb_evaluation_expr: // attrb_evaluation_expr
      case symbol_kind::S_attrb_evaluation_expr_component: // attrb_evaluation_expr_component
      case symbol_kind::S_attrb_evaluation_compound_stmt: // attrb_evaluation_compound_stmt
      case symbol_kind::S_attrb_evaluation_stmt_seq: // attrb_evaluation_stmt_seq
      case symbol_kind::S_attrb_evaluation_stmt_seq_component: // attrb_evaluation_stmt_seq_component
      case symbol_kind::S_attrb_evaluation_stmt_component: // attrb_evaluation_stmt_component
        value.move< attrbRefSeq > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_OX_ATTRB_REF: // "attribute reference"
      case symbol_kind::S_OX_ATTRB_OCCUR: // "attribute occurrence"
        value.move< attrbTriple > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_LITERAL_CHAR: // "character literal"
      case symbol_kind::S_LITERAL_STRING: // "string literal"
      case symbol_kind::S_TERM_LITERAL: // "terminal literal"
      case symbol_kind::S_LITERAL_PATH: // "literal path name"
        value.move< char_literal > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_OX_ATTRIBUTES: // "@attributes"
      case symbol_kind::S_OX_MACRO: // "@macro"
      case symbol_kind::S_OX_TRAV: // "@traversal"
      case symbol_kind::S_OX_AUTOSYN: // "@autosyn"
      case symbol_kind::S_OX_AUTOINH: // "@autoinh"
      case symbol_kind::S_OX_WARN: // "@warn"
      case symbol_kind::S_LEFT: // "%left"
      case symbol_kind::S_RIGHT: // "%right"
      case symbol_kind::S_NONASSOC: // "%nonassoc"
      case symbol_kind::S_TOKEN: // "%token"
      case symbol_kind::S_TYPE: // "%type"
      case symbol_kind::S_NTERM: // "%nterm"
      case symbol_kind::S_START: // "%start"
      case symbol_kind::S_UNION: // "%union"
      case symbol_kind::S_EXPECT: // "%expect"
      case symbol_kind::S_EXPECT_RR: // "%expect-rr"
      case symbol_kind::S_PURE_PARSER: // "%pure-parser"
      case symbol_kind::S_PRECEDENCE: // "%precedence"
      case symbol_kind::S_SCANNER: // "%scanner"
      case symbol_kind::S_CODE: // CODE
      case symbol_kind::S_LOCATION: // LOCATION
      case symbol_kind::S_DESTRUCTOR: // "%destructor"
      case symbol_kind::S_LEX_PARAM: // "%lex-param"
      case symbol_kind::S_PARSE_PARAM: // "%parse-param"
      case symbol_kind::S_DEFINE: // "%define"
      case symbol_kind::S_LANGUAGE: // "%language"
      case symbol_kind::S_NAME_PREFIX: // "%name-prefix"
      case symbol_kind::S_PARAM: // "%param"
      case symbol_kind::S_PRINTER: // "%printer"
      case symbol_kind::S_SKELETON: // "%skeleton"
      case symbol_kind::S_LOCAL: // "%local"
      case symbol_kind::S_EXPORT: // "%export"
      case symbol_kind::S_IMPORT: // "%import"
      case symbol_kind::S_CONST: // "const"
      case symbol_kind::S_VOLATILE: // "volatile"
      case symbol_kind::S_RESTRICT: // "restrict"
      case symbol_kind::S_REGISTER: // "register"
      case symbol_kind::S_STATIC: // "static"
      case symbol_kind::S_TYPE_KEYWORD: // TYPE_KEYWORD
      case symbol_kind::S_ELABORATED_TYPE_KEYWORD: // ELABORATED_TYPE_KEYWORD
      case symbol_kind::S_yacc_directive: // yacc_directive
      case symbol_kind::S_bison_or_byacc_directive: // bison_or_byacc_directive
      case symbol_kind::S_ox_directive: // ox_directive
      case symbol_kind::S_precedence_declarer: // precedence_declarer
      case symbol_kind::S_nonterminal_declarer: // nonterminal_declarer
      case symbol_kind::S_attrb_modifier: // attrb_modifier
      case symbol_kind::S_ptr_type_qualifier: // ptr_type_qualifier
      case symbol_kind::S_array_size_opt: // array_size_opt
        value.move< keyword > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_TERM_ID: // "terminal symbol"
      case symbol_kind::S_OX_ID: // "traversal mode annunciator"
      case symbol_kind::S_GS_ID: // "nonterminal symbol"
      case symbol_kind::S_NAMESPACE_ID: // "C++ qualified name"
      case symbol_kind::S_INHATTR_ID: // "inherited attribute"
      case symbol_kind::S_API_VARIABLE: // "bison API variable"
      case symbol_kind::S_API_VALUE: // "bison API value"
      case symbol_kind::S_named_token: // named_token
      case symbol_kind::S_terminal_symbol: // terminal_symbol
      case symbol_kind::S_nonterminal_symbol: // nonterminal_symbol
      case symbol_kind::S_symbol: // symbol
      case symbol_kind::S_nonterminal: // nonterminal
      case symbol_kind::S_left_hand_side: // left_hand_side
      case symbol_kind::S_rhs_symbol: // rhs_symbol
        value.move< name_literal > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_NUM: // "number"
        value.move< numberRep > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_token_decl_list: // token_decl_list
      case symbol_kind::S_precedence_decl_list: // precedence_decl_list
      case symbol_kind::S_nonterminal_decl_list: // nonterminal_decl_list
        value.move< symDeclSeq > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_token_list: // token_list
      case symbol_kind::S_token: // token
      case symbol_kind::S_terminal_list: // terminal_list
      case symbol_kind::S_nonterminal_list: // nonterminal_list
        value.move< symSeq > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tag_opt: // tag_opt
      case symbol_kind::S_tag: // tag
      case symbol_kind::S_type_specifier: // type_specifier
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_component: // type_component
      case symbol_kind::S_type_name: // type_name
      case symbol_kind::S_elaborated_type_name: // elaborated_type_name
      case symbol_kind::S_type_list: // type_list
      case symbol_kind::S_ptr_operator: // ptr_operator
      case symbol_kind::S_ptr_type_qualifier_seq_opt: // ptr_type_qualifier_seq_opt
      case symbol_kind::S_ptr_type_qualifier_seq: // ptr_type_qualifier_seq
      case symbol_kind::S_parameter_list_opt: // parameter_list_opt
      case symbol_kind::S_parameter_list: // parameter_list
      case symbol_kind::S_parameter_type_list: // parameter_type_list
      case symbol_kind::S_parameter_type: // parameter_type
      case symbol_kind::S_formal_type_specifier: // formal_type_specifier
      case symbol_kind::S_abstract_declarator: // abstract_declarator
      case symbol_kind::S_direct_abstract_declarator: // direct_abstract_declarator
      case symbol_kind::S_formal_array_qualifier_list_opt: // formal_array_qualifier_list_opt
      case symbol_kind::S_formal_array_qualifier_list: // formal_array_qualifier_list
      case symbol_kind::S_formal_array_qualifier: // formal_array_qualifier
        value.move< typeSeq > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_user_argument_seq: // user_argument_seq
      case symbol_kind::S_user_argument: // user_argument
        value.move< userArgSeq > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  byacc::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  byacc::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  byacc::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  byacc::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}


  byacc::by_kind&
  byacc::by_kind::by_kind::operator= (const by_kind& that)
  {
    kind_ = that.kind_;
    return *this;
  }

  byacc::by_kind&
  byacc::by_kind::by_kind::operator= (by_kind&& that)
  {
    kind_ = that.kind_;
    that.clear ();
    return *this;
  }


  void
  byacc::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  byacc::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  byacc::symbol_kind_type
  byacc::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }



#line 41 "agc-byacc.yy"
} // AGC
#line 10275 "agc-byacc.cc"
#line 2873 "agc-byacc.yy"


// called from 'main ()'
extern "C" void
agc_byacc_parse (
#if defined(WITH_REFLEX)
                          const reflex::Input& yoxIn,
#else // defined(WITH_FLEX)
                          std::ifstream& yoxIn,
#endif
                          Yfile_specIO& Yfile,
                          int debug)
{
  AGC::byaccLexer agc_Yfile_lexer (Yfile, yoxIn);
  agc_Yfile_lexer.set_debug (debug >> 1);
  AGC::byacc parser (agc_Yfile_lexer, outMgr::ctrl, Yfile);
  parser.set_debug_level (debug & 0x1);
  (void)parser ();
}

void
AGC::byacc::error (const AGC::location& locp, const std::string& msg)
{
  agc_syntax_error (locp, msg);
}

void
AGC::byacc::report_syntax_error (const context& yyctx) const
{
  // # of expected tokens
  enum
  {
    YYARGS_MAX = 4
  };

  symbol_kind_type yyarg[YYARGS_MAX] = { symbol_kind::S_YYEMPTY };

  // Actual size of yyarg[]
  int yycount = yyctx.expected_tokens (yyarg, YYARGS_MAX);

  if (yycount < 0)
    return;
  if ((yycount == 0) && (yyarg[0] != (symbol_kind_type)symbol_kind::S_YYEMPTY))
    yycount = YYARGS_MAX;

  const std::string token_name = std::string (symbol_name (yyctx.token ()));

  std::ostringstream yymsg;

  yymsg << "syntax error";

  if (yycount > 0)
    {
      yymsg << ", unexpected ";

      switch (yyctx.token ())
        {
        case symbol_kind::S_ID:             // identifier
        case symbol_kind::S_GS_ID:          // Yacc symbol name
        case symbol_kind::S_OX_ID:          // traversal mode annunciator
        case symbol_kind::S_NAMESPACE_ID:   // C++ qualified name
        case symbol_kind::S_INHATTR_ID:     // inherited attribute
        case symbol_kind::S_API_VALUE:      // API value
        case symbol_kind::S_API_VARIABLE:   // API variable
          yymsg << "\'" + token_name + "\' "
                       "[" +
                       yyctx.lookahead ().value.as<name_literal> () +
                       "]";
          break;

        case symbol_kind::S_LITERAL_CHAR:
        case symbol_kind::S_LITERAL_STRING:
        case symbol_kind::S_LITERAL_PATH:   // literal path name
          yymsg << "\'" + token_name + "\' "
                       "[" +
                       yyctx.lookahead ().value.as<char_literal> () +
                       "]";
          break;

        case symbol_kind::S_NUM:            // number
          yymsg << "\'" + token_name + "\' "
                       "[" +
                       yyctx.lookahead ().value.as<numberRep> ().spelling +
                       "]";
          break;

        case symbol_kind::S_OX_ATTRB_REF:   // attribute reference
        case symbol_kind::S_OX_ATTRB_OCCUR: // attribute occurrence
          yymsg << "\'" + token_name + "\' "
                       "[" +
                       yyctx.lookahead ().value.as<attrbTriple> ().gsName +
                       "." +
                       std::to_string (yyctx.lookahead ()
                                           .value.as<attrbTriple> ()
                                           .occurrence) +
                       "." +
                       yyctx.lookahead ().value.as<attrbTriple> ().atName +
                       "]";
          break;

        case symbol_kind::S_CODE:           // %code, %initial-action
        case symbol_kind::S_DESTRUCTOR:     // %destructor
        case symbol_kind::S_EXPECT:         // %expect
        case symbol_kind::S_EXPECT_RR:      // %expect_rr
        case symbol_kind::S_LEX_PARAM:      // %lex-param
        case symbol_kind::S_PARSE_PARAM:    // %parse-param
        case symbol_kind::S_PURE_PARSER:    // %pure-parser
        case symbol_kind::S_DEFINE:         // %define
        case symbol_kind::S_DPREC:          // %dprec
        case symbol_kind::S_EMPTY:          // %empty
        case symbol_kind::S_LANGUAGE:       // %language
        case symbol_kind::S_MERGE:          // %merge
        case symbol_kind::S_NAME_PREFIX:    // %name-prefix
        case symbol_kind::S_NTERM:          // %nterm
        case symbol_kind::S_PARAM:          // %param
        case symbol_kind::S_PRECEDENCE:     // %precedence
        case symbol_kind::S_PRINTER:        // %printer
        case symbol_kind::S_SKELETON:       // %skeleton
        case symbol_kind::S_LOCATION:       // %location, %position, %@
        case symbol_kind::S_EXPORT:         // %export
        case symbol_kind::S_IMPORT:         // %import
        case symbol_kind::S_LOCAL:          // %local
        case symbol_kind::S_LOOKAHEAD:      // %lookahead
          yymsg << "\'" + token_name + "\'";
          break;

        default:
          yymsg << "\'" + token_name + "\'";
          break;
        }

      std::string trailing_list;
      for (int i = yycount; --i > 0;)
        {
          std::string temp;

          if (i + 1 == yycount)
            temp = " or";
          else
            temp = ",";

          trailing_list =
              temp + " \'" + symbol_name (yyarg[i]) + "\'" + trailing_list;
        }

      yymsg << ", expecting \'" << symbol_name (yyarg[0]) << "\'"
            << trailing_list;
    }
  yymsg << ".";

  AGC::location loc = yyctx.location ();
  agc_syntax_error (loc, yymsg);
}
