#line 1 "flex/agc-Yfile-lexer.cc"
#include <fstream>

#include "agc-Yfile.hh"
#include "mac.hh"
#include "macutil.hh"
#include "messages.hh"
#include "opts.hh"
#include "outMgr.hh"
#include "scan.hh"

#define YY_DECL \
  int AGC::YFILE::Lexer::yylex (AGC::parser::value_type& yylval, \
                                AGC::location& yylloc)

// inhibit the Flex builtin definition of 'struct yy_buffer_state'
#define YY_STRUCT_YY_BUFFER_STATE

#line 19 "flex/agc-Yfile-lexer.cc"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

/* %not-for-header */
/* %if-c-only */
/* %if-not-reentrant */
/* %endif */
/* %endif */
/* %ok-for-header */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 4
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* %if-c++-only */
    /* The c++ scanner is a mess. The FlexLexer.h header file relies on the
     * following macro. This is required in order to pass the c++-multiple-scanners
     * test in the regression suite. We get reports that it breaks inheritance.
     * We will address this in a future release of flex, or omit the C++ scanner
     * altogether.
     */
    #define yyFlexLexer Yfile_FlexLexer
/* %endif */

/* %if-c-only */
/* %endif */

#ifdef yyalloc
#define Yfile_alloc_ALREADY_DEFINED
#else
#define yyalloc Yfile_alloc
#endif

#ifdef yyrealloc
#define Yfile_realloc_ALREADY_DEFINED
#else
#define yyrealloc Yfile_realloc
#endif

#ifdef yyfree
#define Yfile_free_ALREADY_DEFINED
#else
#define yyfree Yfile_free
#endif

/* %if-c-only */
/* %endif */

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
/* %if-c-only */
/* %endif */

/* %if-tables-serialization */
/* %endif */
/* end standard C headers. */

/* %if-c-or-c++ */
/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#ifndef SIZE_MAX
#define SIZE_MAX               (~(size_t)0)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

/* %endif */

/* begin standard C++ headers. */
/* %if-c++-only */
#include <iostream>
#include <errno.h>
#include <cstdlib>
#include <cstdio>
#include <cstring>
/* end standard C++ headers. */
/* %endif */

/* TODO: this is always defined, so inline it */
#define yyconst const

#if defined(__GNUC__) && __GNUC__ >= 3
#define yynoreturn __attribute__((__noreturn__))
#else
#define yynoreturn
#endif

/* %not-for-header */
/* Returned upon end-of-file. */
#define YY_NULL 0
/* %ok-for-header */

/* %not-for-header */
/* Promotes a possibly negative, possibly signed char to an
 *   integer in range [0..255] for use as an array index.
 */
#define YY_SC_TO_UI(c) ((YY_CHAR) (c))
/* %ok-for-header */

/* %if-reentrant */
/* %endif */

/* %if-not-reentrant */

/* %endif */

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *
/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START
/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin  )
#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

/* %if-not-reentrant */
extern int yyleng;
/* %endif */

/* %if-c-only */
/* %if-not-reentrant */
/* %endif */
/* %endif */

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2
    
    #define YY_LESS_LINENO(n)
    #define YY_LINENO_REWIND_TO(ptr)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )
#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
/* %if-c-only */
/* %endif */

/* %if-c++-only */
	std::streambuf* yy_input_file;
/* %endif */

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* %if-c-only Standard (non-C++) definition */
/* %not-for-header */
/* %if-not-reentrant */
/* %endif */
/* %ok-for-header */

/* %endif */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)
/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* %if-c-only Standard (non-C++) definition */
/* %if-not-reentrant */
/* %not-for-header */
/* %ok-for-header */

/* %endif */
/* %endif */

void *yyalloc ( yy_size_t  );
void *yyrealloc ( void *, yy_size_t  );
void yyfree ( void *  );

#define yy_new_buffer yy_create_buffer
#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}
#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}
#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* %% [1.0] yytext/yyin/yyout/yy_state_type/yylineno etc. def's & init go here */
/* Begin user sect3 */
#define YY_SKIP_YYWRAP

#define FLEX_DEBUG
typedef flex_uint8_t YY_CHAR;

#define yytext_ptr yytext

#include <FlexLexer.h>

int yyFlexLexer::yywrap() { return 1; }

/* %% [1.5] DFA */

/* %if-c-only Standard (non-C++) definition */
/* %endif */

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
/* %% [2.0] code to fiddle yytext and yyleng for yymore() goes here \ */\
	yyleng = (int) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
/* %% [3.0] code to copy yytext_ptr to yytext[] goes here, if %array \ */\
	(yy_c_buf_p) = yy_cp;
/* %% [4.0] data tables for the DFA and the user's section 1 definitions go here */
#define YY_NUM_RULES 328
#define YY_END_OF_BUFFER 329
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static const flex_int16_t yy_accept[1258] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      329,  328,   21,   20,   19,    4,   21,   21,   13,   14,
       15,   21,   21,    5,    5,   11,   12,   21,    6,    6,
        6,   16,   17,   20,   21,   37,   37,   37,   35,   43,

       39,   39,   43,   42,   40,   41,   48,   47,   48,   47,
       45,   46,  129,  127,  128,  123,  129,  129,  129,  127,
      127,  127,  127,  124,  125,   27,   26,   23,   27,   27,
       26,   26,   26,   26,   24,   25,   33,   32,   29,   33,
       33,   32,   32,   32,   32,   30,   31,   61,   58,   60,
       59,   65,   62,   64,   65,   57,   55,   56,   57,   50,
       57,   49,   49,   49,   49,   53,   54,   92,   90,   91,
       80,   81,   82,   79,   76,   92,   92,   72,   72,   78,
       77,   85,   86,   73,   83,   84,   88,   89,   70,   68,
       69,   66,   67,  188,  185,  187,  160,  188,  188,  168,

      169,  171,  173,  172,  188,  170,  161,  161,  184,  167,
      178,  179,  174,  162,  162,  176,  177,  162,  175,  166,
      185,  188,  268,  265,  267,  268,  261,  262,  263,  268,
      260,  264,  291,  290,  288,  291,  291,  291,  290,  290,
      290,  290,  280,  282,  311,  315,  314,  313,  315,  315,
      314,  314,  314,  314,  290,  283,  284,  285,  286,  278,
      275,  277,  278,  278,  270,  270,  273,  274,  271,  271,
      279,  275,  279,  279,  270,  270,  273,  274,  271,  271,
      317,  318,  318,  320,  320,  320,  322,  323,  321,  324,
      327,  326,  327,  145,  143,  144,  139,  141,  140,  145,

      138,  154,  153,  147,  154,  154,  148,  148,  154,  101,
       99,  100,   80,   81,   82,   79,   76,  101,  101,   72,
       72,   78,   77,   85,   86,  101,   73,   83,   84,   97,
       98,  136,  135,  132,  136,  133,  131,  121,  118,  120,
      121,  121,  121,  121,  117,  118,  121,  113,  110,  112,
      113,  113,  108,  110,  113,  298,  297,  293,  298,  294,
      295,  296,  298,  297,  297,  297,  297,  310,  309,  300,
      310,  301,  302,  303,  310,  309,  309,  309,  309,  308,
      256,  202,  255,  219,  190,  256,  225,  222,  256,  207,
      208,  223,  221,  251,  220,  214,  224,  205,  205,  239,

      213,  228,  240,  229,  238,  256,  191,  191,  209,  210,
      234,  211,  235,  212,  218,  202,  256,  225,  190,  256,
      214,  191,  191,  191,   20,    0,    3,    0,    8,    8,
       10,    0,    0,    0,    7,    1,    0,    5,    5,    5,
        5,    0,    8,    7,    6,    4,    6,    6,    6,   20,
        0,    0,    0,   35,   34,    0,   35,   39,   38,    0,
       42,   40,   40,   41,   41,   47,   44,    0,   47,  127,
      126,    0,    0,  122,    0,  127,  127,  127,  127,    0,
      127,  123,    0,   26,    0,    0,   22,    0,   26,   26,
       26,   26,    0,   26,   23,    0,   32,    0,    0,   28,

        0,   32,   32,   32,   32,    0,   32,   29,    0,   31,
       31,   58,   59,   62,    0,   63,    0,   55,    0,   51,
        0,   50,    0,    0,   49,    0,   49,   49,   90,    0,
        0,   71,    0,   72,   72,   72,   72,    0,    0,    0,
       73,   68,  185,    0,    0,  159,    0,  164,  183,  164,
        0,    0,  181,    0,  163,  157,    0,  161,  161,  161,
      161,    0,  180,  164,  156,  163,  162,  160,  162,  162,
      162,  185,    0,    0,  265,    0,  264,    0,  264,    0,
      264,    0,  259,    0,  264,  290,  281,  289,    0,  289,
        0,  289,    0,    0,    0,  287,    0,  290,  290,  290,

      290,    0,  290,  288,    0,  282,  282,  314,    0,    0,
      312,    0,  314,  314,  314,  314,    0,  314,  313,    0,
      290,  275,    0,  272,  269,    0,  270,  270,  270,  270,
        0,  272,  271,  271,  271,  271,  317,  316,  320,  319,
      322,  322,  325,  143,  141,  141,  137,    0,  138,  146,
        0,    0,  148,  147,    0,   99,   97,    0,    0,    0,
      130,    0,  131,  118,    0,  116,    0,    0,    0,    0,
      117,  114,    0,  117,  118,    0,  119,  110,  102,    0,
        0,    0,    0,    0,  108,  110,    0,  111,  297,    0,
        0,  292,    0,  297,  297,  297,  297,    0,  297,  293,

        0,  309,    0,    0,  299,    0,  309,  309,  309,  309,
        0,  309,  300,    0,  306,  307,  305,  304,  202,  233,
        0,  204,    0,  199,    0,  199,    0,  199,    0,  245,
      236,  248,    0,    0,  243,  216,  241,  217,  242,  215,
      253,  189,    0,  244,  205,  205,  205,  205,    0,  254,
      226,  230,  232,  231,  227,    0,    0,  200,    0,    0,
        0,  200,  198,    0,  198,  198,  198,  193,  194,  191,
      190,    0,  249,  250,  237,  202,    0,    0,    0,    0,
        0,    0,    0,    0,  204,    0,    0,    0,    0,    0,
        0,    0,    0,  191,  191,  191,    0,    0,    8,    2,

        0,    0,    0,   18,    5,    5,    5,    5,    0,    9,
        0,   36,    0,   39,    0,   47,  127,    0,    0,    0,
      127,  127,  127,  127,  127,   26,    0,    0,    0,   26,
       26,   26,   26,   26,   32,    0,    0,    0,   32,   32,
       32,   32,   32,    0,    0,    0,    0,    0,   52,    0,
       49,   49,   75,    0,   87,   72,   72,   72,   72,    0,
       74,  155,    0,    0,  164,  158,    0,    0,    0,  186,
      161,  161,  161,  161,  182,    0,  165,  258,    0,  264,
        0,    0,  266,    0,  289,    0,  290,    0,    0,    0,
      290,  290,  290,  290,  290,  314,    0,    0,    0,  314,

      314,  314,  314,  314,    0,  276,  270,  270,  270,  270,
        0,  142,    0,  152,    0,    0,    0,    0,    0,    0,
        0,  134,    0,    0,  115,    0,    0,    0,  118,    0,
      109,    0,    0,    0,    0,    0,  297,    0,    0,    0,
      297,  297,  297,  297,  297,  309,    0,    0,    0,  309,
      309,  309,  309,  309,    0,    0,    0,  199,    0,  203,
        0,    0,  252,    0,  202,  205,  205,  205,  205,  246,
      247,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      198,    0,  198,  198,  198,  198,  198,    0,    0,    0,
        0,    0,  206,    0,    0,    0,  203,    0,    0,    0,

        0,  257,    0,    0,    0,    0,    5,    0,    0,  127,
        0,    0,   26,    0,    0,   32,    0,    0,    0,    0,
       49,   49,   72,   74,    0,    0,    0,    0,  161,    0,
        0,    0,    0,    0,    0,    0,    0,  290,    0,    0,
      314,  270,  151,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  297,
        0,    0,  309,    0,    0,    0,    0,    0,    0,    0,
      205,    0,    0,    0,    0,    0,    0,    0,  201,    0,
      198,  198,    0,    0,    0,    0,    0,  192,    0,    0,
        0,    0,  257,    0,    0,    0,    0,    0,  257,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,   49,
       49,    0,    0,    0,    0,    0,  151,  150,    0,    0,
       93,   96,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  201,    0,    0,
        0,    0,    0,    0,  201,  201,  198,  198,  198,    0,
        0,    0,    0,    0,    0,  257,    0,    0,    0,    0,
       49,   50,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  201,    0,    0,    0,    0,  198,  198,  198,
        0,    0,    0,    0,    0,   49,   50,  149,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  198,  198,  198,

        0,    0,   49,   50,   95,   94,  107,    0,    0,    0,
        0,    0,    0,  198,  198,  198,    0,    0,   49,   50,
        0,    0,  104,    0,    0,    0,  195,  198,  196,    0,
        0,   50,   50,    0,  103,    0,    0,    0,  198,    0,
       50,   50,    0,    0,    0,  198,    0,   49,   50,  105,
      106,    0,  198,   50,  197,   50,    0
    } ;

static const YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        2,    2,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    4,    5,    6,    7,    8,    9,   10,   11,
       12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
       20,   20,   20,   20,   20,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   30,   30,   30,   30,   30,
       31,   31,   31,   31,   31,   32,   31,   31,   33,   34,
       31,   31,   35,   36,   37,   31,   38,   39,   31,   31,
       40,   41,   42,   43,   44,    1,   45,   46,   47,   48,

       49,   50,   51,   52,   53,   54,   54,   55,   56,   57,
       58,   59,   54,   60,   61,   62,   63,   64,   65,   66,
       67,   54,   68,   69,   70,   71,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static const YY_CHAR yy_meta[72] =
    {   0,
        1,    2,    3,    1,    4,    1,    5,    1,    1,    6,
        1,    1,    7,    1,    1,    8,    9,   10,   11,   12,
       11,   12,   13,    1,   14,    1,   15,   16,   17,   18,
       19,   20,   19,   19,   19,   19,   20,   19,   19,    5,
       21,   22,    1,   23,   24,   24,   24,   24,   24,   24,
       25,   25,   25,   25,   26,   25,   25,   25,   25,   25,
       25,   25,   26,   25,   25,   25,   25,   27,    1,   28,
        1
    } ;

static const flex_int16_t yy_base[1587] =
    {   0,
        0,    0,    0,   70,   78,    0,  149,    0,  220,    0,
      291,    0,  362,    0,  433,    0,  503,  507,   71,  509,
      529,    0,  600,    0,  670,  673,  743,  505,  814,    0,
      885,    0,    0,    0,  956,    0, 1026, 1027, 1097,    0,
     1168,    0,  505,  671,  674,  675,  676,  677,  680,  682,
     1239,    0, 1310,    0, 1381,    0, 1452,    0, 1523,  513,
     1594,  684, 1665,    0, 1736,    0, 1807,  687, 1878,  688,
     5123,10956,10956, 5120,10956,  686, 1011, 5043,10956,10956,
    10956,  680,  685, 1022, 1026,10956,10956,    0,  500,  694,
      685,10956,10956,  706, 1942,10956,  684,  702,    0,10956,

     5065,10956,  712,    0,  517,  710,10956, 5064,  713,    0,
    10956,10956,10956, 5040,10956,10956, 4968, 4973,  719, 1933,
     1954,    0,  729,10956,10956,10956, 5008,10956, 4962, 1021,
     1958, 1982,    0, 1045,10956,10956,10956, 5000,10956, 4957,
     1038, 1986, 2007,    0, 1047,10956,  733,10956, 4995,10956,
     1051,10956, 4994,10956, 1946,10956, 4993,10956, 1951,    0,
     4977, 1048, 1070, 1966, 1941,10956,10956,10956, 1051,10956,
    10956,10956,10956,10956,10956, 4974, 1065, 2011, 2035, 4962,
    10956,10956,10956, 1958,10956,10956,10956,10956,10956, 4982,
    10956,10956,10956,10956, 1031,10956, 1959, 2054, 4939,10956,

    10956,10956,10956, 4952, 1018, 1971, 2039, 2067,10956,10956,
     4962,10956, 4909, 1074, 2030,10956,10956, 2089,10956,10956,
     2034, 2099,10956, 1047,10956, 2116,10956,10956,10956, 2002,
    10956,    0,10956, 1964,10956, 2124, 4935, 2051, 2131, 2140,
        0, 2075,10956, 1090,10956,10956, 4971,10956, 4925, 2078,
     2159, 2168,    0, 2087, 4963,10956,10956,10956,10956,10956,
     4959,10956, 1968, 2082, 2187, 2196,10956,10956, 1977, 2095,
    10956, 4958, 2021, 2116, 2215, 2224,10956,10956, 2131, 2245,
        0,10956, 4941,    0,10956, 4940,    0,10956,10956,    0,
    10956,10956, 4954,10956, 4954,10956,10956, 2152,10956, 2153,

        0,10956,10956,10956, 2156, 4906,    0, 4949, 4919,10956,
     2181,10956,10956,10956,10956,10956,10956, 4930, 2214, 2253,
     2274, 4920,10956,10956,10956, 2120, 2119,10956,10956,10956,
    10956,10956,10956,10956, 2242,10956,    0,10956, 4940,10956,
     2152, 4900, 2158, 2245,    0,  714, 4932,10956, 4937,10956,
     2258, 2243,    0, 1029, 4906,10956, 4909,10956, 4863,10956,
    10956,10956, 2264, 2293, 2302,    0, 2278,10956, 4901,10956,
     4858,10956,10956,10956, 2286, 2321, 2330,    0, 2295, 2357,
    10956, 4896,10956, 4871, 2171, 2370, 4870, 2042, 4854,10956,
    10956, 4844, 2087,10956, 2194, 4854, 2318, 2380, 2384, 4836,

    10956, 2204, 4829, 2212,10956, 2446,    0, 2323,10956,10956,
     4827,10956, 2132,10956,10956, 2278, 2325, 2014, 2304, 4810,
     2353, 2392, 2413, 2405, 4843, 2305,10956, 2362,10956,    0,
    10956, 4827, 2412, 2196,    0,10956, 4830, 2438, 2452, 2432,
      687,    0,    0,    0, 2252,10956,    0, 2301, 2460, 1960,
     4822, 4826, 2303,    0,10956, 4818,    0, 4815,10956, 4808,
        0, 2352,10956, 2361,10956, 4811,10956, 4800,    0, 4797,
    10956, 4785, 2417,10956, 4785, 2489, 2498, 2468, 2306,    0,
        0,10956, 2043, 4789, 4771, 2477,10956, 4770, 2517, 2526,
     2496, 2356,    0,    0,10956, 2403, 4772, 4763, 2521,10956,

     4763, 2545, 2554, 2547, 2444,    0,    0,10956, 2404, 2377,
    10956, 4761, 2549, 4760, 2330,10956, 2573, 4756, 2447,10956,
     2576,    0,  682, 2423, 2438, 2486, 2587, 2582, 2373, 4734,
     4739,10956, 4752, 2592, 2599, 2590, 2470,    0, 4752, 2490,
     2501, 4751, 2405, 4684, 2585,10956, 2586,10956,10956,    0,
     4741, 2613,10956, 2468,    0,10956, 4724, 2629, 2638, 2609,
     2500,    0, 4697,    0,10956,    0, 2540,10956,    0, 2599,
     2661, 2661, 4710, 4714, 2599, 4648,10956, 2666, 2675,    0,
        0,    0,10956, 4712,    0, 2171,10956,10956, 2687, 2691,
        0,    0,    0, 4704, 2679,10956, 4706, 2695, 2699, 2692,

     2528,    0,    0,10956, 2615, 2635,10956, 4706, 4697, 2683,
    10956, 4673, 2719, 2744, 2698, 2530,    0,    0,10956, 2630,
     4671, 4666, 2708,    0,10956, 4664, 2748, 2768, 2741, 2636,
        0,    0, 2657,    0, 2660, 2793,    0,10956,    0,10956,
        0,10956,10956, 4663, 2720,10956,10956, 4658,    0,10956,
     4655, 4600,    0,10956, 2143, 2770,10956, 4593, 4597, 4602,
    10956, 4640,    0, 4638, 2738,10956, 2797, 4629, 2800, 2716,
        0,10956, 4629,    0, 2117, 4607,10956, 4606,10956, 4598,
     4547, 4547,   17, 4542,    0, 2299, 4586,10956, 4591, 4582,
     2805,10956, 4582, 2813, 2820, 2814, 2702,    0,    0,10956,

     2718, 4559, 4523, 2808,10956, 4519, 2859, 2865, 2827, 2716,
        0,    0,10956, 2734,10956,10956,10956,10956, 4523,10956,
     2781,10956, 2828,10956, 2834, 2879,    0,    0,    0,10956,
    10956,10956, 4511, 2841,10956,10956,10956,10956,10956, 4507,
    10956,10956, 4512,10956, 2884, 2904, 2856, 2751,    0,10956,
     4492,10956,10956,10956, 4491, 2792, 2803,10956, 4451, 2910,
     2932, 2924, 2775,    0, 2931, 2938, 2954,10956,10956,    0,
     2867, 2848,10956,10956,10956, 2907, 2915, 4481, 2925, 4433,
     1025, 4431, 4474, 2928, 2165, 2941, 4466, 2960, 2826, 2893,
     2955, 2975, 2980, 2988, 2992, 2993, 3001, 3038,    0,10956,

     3008, 4465, 4471,10956, 2855,10956, 2880, 2956, 4470,10956,
     4445,10956, 4438, 4431, 4430, 4426,10956, 3013, 4422, 4424,
     4423, 2921,10956, 2934, 2993,10956, 3025, 4419, 4397, 4394,
     2928,10956, 2984, 2999,10956, 3030, 4384, 4386, 4382, 2961,
    10956, 3006, 3015, 3061, 3098, 3070, 3144, 2968,10956, 4370,
     3047, 3055,10956, 4384,10956, 3004,10956, 3021, 3037, 4384,
     2527,10956, 3088, 3190,    0,10956, 3102, 4375, 4375,10956,
     3036,10956, 3069, 3078,10956, 4374,10956,10956, 4346,    0,
     4330, 4368,10956, 4343,    0, 4327,10956, 3106, 4352, 4354,
     4350, 3067,10956, 3082, 3099,10956, 3132, 4346, 4348, 4347,

     3069,10956, 3102, 3118, 4350,10956, 3098,10956, 3124, 3143,
     4347,10956, 4340,10956, 4294, 4281, 4292, 4274, 4282, 4274,
     4330,10956, 3163, 3236,10956, 3150, 4322, 4317, 4313, 4314,
    10956, 4255, 4256, 4241, 4250, 4247,10956, 3157, 4285, 4281,
     4280, 3150,10956, 3164, 3170,10956, 3195, 4273, 4275, 4274,
     3160,10956, 3167, 3171, 3223, 3282, 4253,    0, 4237,10956,
     3240, 4268,10956, 4270, 4269, 3164,10956, 3192, 3216,10956,
    10956, 3215, 3213, 3228, 3248, 4242, 3253, 3261, 3263, 3273,
     3289, 4207,    0, 3294, 3296, 3305, 3318, 4192, 2812, 4193,
     3285, 4237,10956, 3075, 3334, 3378, 3307, 3326, 4229, 3339,

     3346, 3355, 3365, 3424, 3368, 4228,10956, 3371, 4227,10956,
     3383, 4225,10956, 3391, 4222,10956, 3375, 3470, 3412, 3516,
     3281, 3357,10956, 3136, 3415, 3562, 3420, 4221,10956, 4177,
     3441, 3905, 3919, 3486, 3903, 3457, 3934,10956, 3475, 3931,
    10956,10956, 3936, 3885, 3885, 3868, 3854, 3844, 3463, 3608,
     3478, 3890, 3851, 3822, 3799, 3800, 3804, 3493, 3844,10956,
     3512, 3826,10956, 3504, 3654, 3804, 3532, 3788, 3539, 3818,
    10956, 3508, 3550, 3700, 3558, 3817, 3578, 3599, 3435, 3784,
     3360, 3588, 3770, 3770, 3759, 3754, 3796,10956, 2208, 2575,
     3554, 3604,    0, 3642, 3746, 3621, 3779, 3600, 3405, 3303,

     3364, 3776, 3770, 3752, 3747, 3408, 3445, 3545, 3609, 3627,
     3235, 3610, 3628, 3723, 3722, 3684, 3670,10956, 3579, 3168,
    10956,10956, 3630, 3640, 3596, 3550, 3523, 3489, 3484, 3481,
     3491, 3470, 3647, 3655, 3469, 3646, 3690, 3247, 3672, 3792,
     3687, 3456, 3722, 3714, 3742,10956, 3712, 3662, 3738, 3402,
     3455, 3405, 2734, 2640, 3413,    0, 3677, 3684, 3432, 3725,
     3670, 3390, 3357, 3352, 3284, 3288, 3267, 3240, 3222, 3200,
     3212, 3297, 3335, 3685, 3693, 3190, 3767, 3736, 3758, 3761,
     3139, 3183, 3484, 3136, 3762, 3577, 3105,10956, 3088, 3041,
     3016, 2995, 2969, 2946, 2925, 2902, 3768, 3788, 3799, 3808,

     2829, 3800, 3766, 2770,10956,10956,10956, 2748, 2749, 2735,
     2691, 2704, 3817, 3827, 3830, 3843, 2691, 3668, 3333, 2618,
     2614, 2570,10956, 2539, 2499, 3771, 3847, 3849, 3851, 2505,
     3853, 2406, 2395, 2368,10956, 2276, 2280, 3869, 3876, 3860,
     2188, 2041, 2031, 1954, 3885, 3881, 3893,    0, 1906,10956,
    10956, 3897, 3892, 1020, 3908,  684,10956, 3949, 3977, 4005,
     4033, 4061, 4089, 4117, 4145, 4173, 4201, 4219, 4246, 4266,
     3516, 4285, 4303, 4321, 4340, 4356, 4372, 4398, 4416, 4442,
     4460, 4486, 4504, 4530, 4558, 4579, 4605, 4626, 4651, 4677,
     4695, 4721, 4741, 3896, 4760, 4778, 4800, 4816, 4838, 4864,

     4882, 4908, 4926, 4944, 4963, 4981, 5007, 5035, 5063, 5091,
     5109, 5125, 5141, 5167, 5195, 5215, 5234, 5250, 5276, 5294,
     5320, 5338, 5364, 5388, 5414, 5441, 5459, 5485, 5513, 5535,
     5560, 5578, 5604, 5625, 5651, 5671, 5690, 5716, 3916, 3563,
     5737, 5753, 5771, 5797, 5817, 5836, 5862, 5890, 5908, 5934,
     5952, 5978, 6006, 3919, 6024, 6050, 6078, 3924, 6096, 6122,
     6150, 4289, 6168, 6194, 6222, 6243, 6262, 6288, 4307, 6315,
     6340, 6366, 6387, 6413, 6433, 6452, 6478, 4630, 3711, 6499,
     6515, 6533, 6559, 6570, 6586, 6595, 6621, 6639, 6648, 6664,
     6673, 6699, 6727, 4648, 6745, 6771, 6799, 4764, 6817, 6835,

     6854, 6880, 4782, 6901, 6917, 6935, 6961, 6989, 7017, 7045,
     7063, 7089, 7107, 7133, 7151, 7177, 7205, 7225, 7244, 7270,
     7298, 7316, 7342, 7370, 4798, 7388, 7414, 7442, 4820, 7460,
     7486, 7497, 7513, 7522, 7548, 7576, 4836, 7603, 7629, 7657,
     7684, 7693, 7711, 7727, 7753, 7781, 7809, 7829, 7854, 7879,
     7904, 7922, 7948, 7969, 7990, 8014, 8032, 8058, 8086, 8114,
     8142, 8165, 8189, 8207, 8228, 8252, 8270, 8291, 8315, 8333,
     8359, 8387, 8415, 8436, 8462, 8480, 8505, 8530, 8556, 8577,
     8598, 8622, 8640, 8666, 8684, 8700, 8716, 8742, 8760, 8776,
     8792, 8813, 8837, 8855, 8876, 8900, 8918, 8944, 8962, 8988,

     9016, 9044, 9072, 9095, 9119, 9147, 9170, 9194, 9212, 9233,
     9257, 9275, 9301, 9319, 9335, 9351, 9372, 9396, 9414, 9439,
     9465, 9493, 9520, 9545, 9561, 9577, 9595, 9621, 9649, 9676,
     9702, 9725, 9748, 9773, 9799, 9822, 9841, 9860, 9879, 9903,
     9931, 9952, 9977,10003,10026,10040,10062,10078,10094,10116,
    10132,10153,10172,10196,10219,10238,10257,10281,10299,10321,
    10337,10358,10381,10407,10430,10453,10478,10494,10519,10545,
    10572,10588,10614,10637,10660,10685,10711,10739,10767,10788,
    10814,10841,10862,10879,10904,10929
    } ;

static const flex_int16_t yy_def[1587] =
    {   0,
     1258, 1258, 1257,    3, 1257,    5, 1257,    7, 1257,    9,
     1257,   11, 1257,   13, 1257,   15, 1259, 1259, 1260, 1260,
     1257,   21, 1257,   23, 1261, 1261, 1257,   27, 1257,   29,
     1257,   31, 1262, 1262, 1257,   35,   31,   31, 1257,   39,
     1257,   41, 1263, 1263, 1264, 1264, 1265, 1265, 1266, 1266,
     1257,   51, 1257,   53, 1257,   55, 1257,   57, 1257,   59,
     1257,   61, 1257,   63, 1257,   65, 1257,   67, 1257,   69,
     1257, 1257, 1257, 1257, 1257, 1267, 1268, 1269, 1257, 1257,
     1257, 1270, 1257, 1257, 1257, 1257, 1257, 1271, 1272, 1272,
     1273, 1257, 1257, 1257, 1268, 1257, 1274, 1257, 1275, 1257,

     1257, 1257, 1257, 1276, 1257, 1257, 1257, 1257, 1257, 1277,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1278, 1257, 1257,
     1257, 1279, 1279, 1257, 1257, 1257, 1257, 1257, 1280, 1257,
     1257, 1257, 1281, 1281, 1257, 1257, 1257, 1257, 1257, 1282,
     1257, 1257, 1257, 1283, 1283, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1284, 1257, 1257, 1257, 1285, 1286,
     1287, 1288, 1288, 1288, 1288, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1289, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1290, 1291, 1292, 1257,

     1257, 1257, 1257, 1257, 1293, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1294, 1295, 1295, 1257, 1257, 1296, 1257, 1257,
     1257, 1291, 1257, 1257, 1257, 1297, 1257, 1257, 1257, 1257,
     1257, 1298, 1257, 1257, 1257, 1299, 1300, 1257, 1257, 1257,
     1301, 1301, 1257, 1257, 1257, 1257, 1257, 1257, 1302, 1257,
     1257, 1257, 1303, 1303, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1304, 1257, 1257, 1257, 1257, 1257, 1305, 1306,
     1257, 1257, 1304, 1257, 1257, 1257, 1257, 1257, 1305, 1306,
     1307, 1257, 1257, 1308, 1257, 1257, 1309, 1257, 1257, 1310,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,

     1311, 1257, 1257, 1257, 1257, 1257, 1312, 1312, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1289, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1313, 1257, 1257, 1257,
     1314, 1315, 1316, 1257, 1317, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1318, 1257, 1257, 1257, 1257, 1257, 1319, 1257,
     1257, 1257, 1257, 1257, 1257, 1320, 1320, 1257, 1257, 1257,
     1321, 1257, 1257, 1257, 1257, 1257, 1257, 1322, 1322, 1257,
     1257, 1257, 1257, 1257, 1323, 1324, 1257, 1257, 1325, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,

     1257, 1257, 1257, 1257, 1257, 1326, 1327, 1327, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1328, 1329,
     1330, 1331, 1331, 1332, 1257, 1333, 1257, 1333, 1257, 1334,
     1257, 1257, 1335, 1336, 1337, 1257, 1338, 1257, 1257, 1257,
     1257, 1339, 1340, 1337, 1341, 1257, 1342, 1341, 1343, 1257,
     1257, 1344, 1345, 1346, 1257, 1347, 1346, 1257, 1257, 1348,
     1349, 1257, 1257, 1257, 1257, 1257, 1257, 1350, 1351, 1257,
     1257, 1257, 1352, 1257, 1353, 1257, 1257, 1257, 1257, 1354,
     1355, 1257, 1352, 1257, 1257, 1356, 1257, 1357, 1257, 1257,
     1257, 1257, 1358, 1359, 1257, 1356, 1257, 1257, 1360, 1257,

     1361, 1257, 1257, 1257, 1257, 1362, 1363, 1257, 1360, 1257,
     1257, 1257, 1257, 1257, 1364, 1257, 1364, 1257, 1365, 1257,
     1365, 1366, 1257, 1257, 1367, 1365, 1367, 1367, 1257, 1257,
     1257, 1257, 1368, 1257, 1257, 1257, 1257, 1369, 1370, 1257,
     1371, 1257, 1257, 1257, 1372, 1257, 1372, 1257, 1257, 1373,
     1257, 1374, 1257, 1375, 1376, 1257, 1377, 1257, 1257, 1257,
     1257, 1378, 1257, 1379, 1257, 1376, 1380, 1257, 1381, 1380,
     1382, 1257, 1257, 1383, 1257, 1257, 1257, 1257, 1257, 1384,
     1385, 1386, 1257, 1387, 1388, 1257, 1257, 1257, 1257, 1257,
     1389, 1390, 1391, 1257, 1392, 1257, 1393, 1257, 1257, 1257,

     1257, 1394, 1395, 1257, 1392, 1257, 1257, 1257, 1257, 1396,
     1257, 1397, 1257, 1257, 1257, 1257, 1398, 1399, 1257, 1396,
     1257, 1257, 1400, 1401, 1257, 1402, 1257, 1257, 1257, 1257,
     1403, 1401, 1404, 1405, 1404, 1406, 1407, 1257, 1408, 1257,
     1409, 1257, 1257, 1257, 1257, 1257, 1257, 1410, 1411, 1257,
     1412, 1257, 1413, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1414, 1415, 1257, 1416, 1257, 1416, 1257, 1417, 1418,
     1419, 1257, 1420, 1419, 1257, 1257, 1257, 1257, 1257, 1421,
     1257, 1257, 1257, 1257, 1422, 1257, 1257, 1257, 1257, 1257,
     1423, 1257, 1424, 1257, 1257, 1257, 1257, 1425, 1426, 1257,

     1423, 1257, 1257, 1427, 1257, 1428, 1257, 1257, 1257, 1257,
     1429, 1430, 1257, 1427, 1257, 1257, 1257, 1257, 1257, 1257,
     1431, 1257, 1431, 1257, 1257, 1257, 1432, 1433, 1434, 1257,
     1257, 1257, 1257, 1435, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1436, 1257, 1257, 1257, 1257, 1257, 1437, 1257,
     1257, 1257, 1257, 1257, 1257, 1438, 1439, 1257, 1440, 1257,
     1438, 1257, 1441, 1442, 1443, 1441, 1441, 1257, 1257, 1444,
     1431, 1435, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1445, 1446, 1257, 1446, 1257, 1447, 1448, 1449,
     1257, 1449, 1450, 1451, 1451, 1452, 1453, 1453, 1454, 1257,

     1257, 1455, 1456, 1257, 1257, 1257, 1257, 1457, 1458, 1257,
     1459, 1257, 1460, 1460, 1461, 1461, 1257, 1257, 1462, 1463,
     1463, 1257, 1257, 1257, 1464, 1257, 1257, 1465, 1466, 1466,
     1257, 1257, 1257, 1467, 1257, 1257, 1468, 1469, 1469, 1257,
     1257, 1257, 1470, 1471, 1471, 1472, 1472, 1473, 1257, 1257,
     1474, 1474, 1257, 1475, 1257, 1257, 1257, 1257, 1476, 1477,
     1478, 1257, 1479, 1479, 1480, 1257, 1257, 1481, 1482, 1257,
     1257, 1257, 1257, 1483, 1257, 1484, 1257, 1257, 1485, 1486,
     1487, 1488, 1257, 1489, 1490, 1491, 1257, 1257, 1492, 1493,
     1493, 1257, 1257, 1257, 1494, 1257, 1257, 1495, 1496, 1496,

     1257, 1257, 1257, 1497, 1498, 1257, 1257, 1257, 1257, 1499,
     1500, 1257, 1501, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1502, 1257, 1503, 1503, 1257, 1257, 1504, 1505, 1505, 1506,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1507, 1508,
     1508, 1257, 1257, 1257, 1509, 1257, 1257, 1510, 1511, 1511,
     1257, 1257, 1257, 1512, 1513, 1513, 1514, 1515, 1516, 1257,
     1257, 1517, 1257, 1518, 1518, 1257, 1257, 1257, 1519, 1257,
     1257, 1520, 1521, 1257, 1521, 1257, 1522, 1257, 1520, 1523,
     1524, 1525, 1526, 1524, 1527, 1524, 1524, 1257, 1257, 1257,
     1528, 1529, 1257, 1530, 1531, 1531, 1257, 1257, 1532, 1530,

     1533, 1534, 1535, 1535, 1257, 1536, 1257, 1257, 1537, 1257,
     1257, 1538, 1257, 1257, 1539, 1257, 1540, 1540, 1541, 1541,
     1542, 1542, 1257, 1543, 1544, 1544, 1257, 1545, 1257, 1546,
     1547, 1548, 1549, 1550, 1551, 1257, 1552, 1257, 1257, 1553,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1554, 1554,
     1257, 1555, 1257, 1257, 1257, 1257, 1257, 1257, 1556, 1257,
     1257, 1557, 1257, 1558, 1558, 1559, 1560, 1561, 1257, 1562,
     1257, 1563, 1564, 1564, 1257, 1565, 1563, 1566, 1567, 1568,
     1569, 1569, 1257, 1257, 1257, 1257, 1570, 1257, 1570, 1570,
     1571, 1257, 1572, 1573, 1573, 1257, 1574, 1575, 1576, 1577,

     1577, 1257, 1257, 1257, 1257, 1578, 1578, 1579, 1579, 1580,
     1580, 1581, 1581, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1554, 1554, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1558, 1558, 1257, 1563, 1257, 1582, 1564, 1564,
     1257, 1583, 1566, 1257, 1567, 1257, 1569, 1569, 1569, 1257,
     1570, 1257, 1570, 1570, 1257, 1572, 1573, 1573, 1257, 1575,
     1580, 1584, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1582, 1564, 1564, 1257, 1566, 1569, 1569, 1569,
     1257, 1570, 1570, 1257, 1575, 1580, 1584, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1566, 1569, 1569, 1569,

     1257, 1575, 1580, 1584, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1566, 1569, 1569, 1569, 1257, 1575, 1580, 1584,
     1257, 1257, 1257, 1257, 1257, 1566, 1569, 1569, 1569, 1257,
     1585, 1584, 1584, 1257, 1257, 1257, 1257, 1586, 1569, 1571,
     1584, 1584, 1257, 1257, 1563, 1569, 1571, 1584, 1584, 1257,
     1257, 1563, 1569, 1584, 1569, 1584,    0, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,

     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,

     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,

     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257
    } ;

static const flex_int16_t yy_nxt[11028] =
    {   0,
       73,   74,   75,   73,   76,   73,   73,   77,   73,   78,
       79,   80,   73,   73,   81,   73,   82,   83,   84,   85,
       85,   85,   73,   73,   86,   73,   87,   73,   88,   89,
       89,   90,   89,   89,   89,   89,   89,   89,   89,   73,
       73,   73,   73,   91,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   92,   73,   93,
       73,   94,  153,  154,  934,  155,  935,   95,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   97,   98,   96,   96,   96,   96,

       96,   96,   96,   96,   96,   96,   96,   99,   99,   99,
       99,   99,   99,   99,   99,   99,   99,   96,   96,   96,
       96,   97,   99,   99,   99,   99,   99,   99,   99,   99,
       99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
       99,   99,   99,   99,   99,   96,   96,   96,   96,  100,
      101,  102,  100,  100,  100,  100,  100,  100,  100,  100,
      100,  100,  100,  100,  100,  100,  103,  100,  100,  100,
      100,  100,  100,  100,  100,  100,  100,  100,  104,  104,
      104,  104,  104,  104,  104,  104,  104,  104,  100,  100,
      100,  100,  104,  104,  104,  104,  104,  104,  104,  104,

      104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  105,  100,  106,  100,
      107,  108,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  109,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  110,
      110,  110,  110,  110,  110,  110,  110,  110,  110,  107,
      107,  107,  107,  110,  110,  110,  110,  110,  110,  110,
      110,  110,  110,  110,  110,  110,  110,  110,  110,  110,
      110,  110,  110,  110,  110,  110,  110,  111,  107,  112,
      107,  113,  114,  115,  113,  116,  113,  113,  117,  113,

      118,  113,  113,  113,  113,  113,  113,  113,  119,  120,
      121,  121,  121,  113,  113,  113,  113,  113,  113,  113,
      122,  122,  123,  122,  122,  122,  122,  122,  122,  122,
      113,  113,  113,  113,  122,  122,  122,  122,  122,  122,
      122,  122,  122,  122,  122,  122,  122,  122,  122,  122,
      122,  122,  122,  122,  122,  122,  122,  122,  124,  113,
      125,  113,  126,  127,  126,  126,  128,  126,  126,  126,
      126,  129,  126,  126,  126,  126,  126,  126,  126,  130,
      131,  132,  132,  132,  126,  126,  126,  126,  126,  126,
      126,  133,  133,  134,  133,  133,  133,  133,  133,  133,

      133,  126,  126,  126,  126,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  135,
      126,  136,  126,  137,  138,  137,  137,  139,  137,  137,
      137,  137,  140,  137,  137,  137,  137,  137,  137,  137,
      141,  142,  143,  143,  143,  137,  137,  137,  137,  137,
      137,  137,  144,  144,  145,  144,  144,  144,  144,  144,
      144,  144,  137,  137,  137,  137,  144,  144,  144,  144,
      144,  144,  144,  144,  144,  144,  144,  144,  144,  144,
      144,  144,  144,  144,  144,  144,  144,  144,  144,  144,

      146,  137,  147,  137,  149,  150,  221,  282,  149,  150,
      153,  154,  222,  155,  346,  444,  444,  283,  462,  463,
      347,  151,  151,  151,  151,  151,  151,  151,  151,  156,
      157,  158,  156,  159,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  160,  156,  156,  156,  156,  156,
      156,  156,  156,  161,  156,  156,  156,  156,  162,  162,
      163,  162,  162,  162,  162,  162,  162,  162,  156,  156,
      156,  156,  162,  162,  162,  164,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  165,  162,  162,  162,  162,  166,  156,  167,  156,

      168,  169,  170,  168,  168,  168,  168,  168,  171,  168,
      172,  173,  174,  168,  175,  168,  176,  177,  178,  179,
      179,  179,  180,  181,  182,  168,  183,  168,  168,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  185,
      168,  186,  168,  184,  184,  184,  184,  184,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  187,  168,  188,
      168,  190,  191,  282,  190,  191,  285,  285,  288,  288,
      289,  289,  292,  283,  292,  354,  286,  286,  416,  416,
      427,  355,  417,  417,  418,  418,  434,  436,  446,  848,

      453,  434,  437,  447,  447,  447,  447,  450,  849,  444,
      444,  464,  465,  451,  455,  675,  290,  290,  807,  456,
      293,  676,  293,  434,  459,  467,  428,  453,  449,  460,
      468,  474, 1248,  482,  510,  511,  475,  192,  483,  193,
      192,  807,  193,  194,  195,  196,  194,  197,  194,  194,
      198,  194,  199,  200,  201,  202,  203,  194,  204,  205,
      206,  207,  208,  208,  208,  209,  210,  211,  194,  212,
      194,  213,  214,  214,  215,  214,  214,  214,  214,  214,
      214,  214,  216,  194,  217,  194,  218,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,

      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      219,  220,  194,  194,  223,  224,  225,  223,  223,  223,
      226,  223,  223,  223,  227,  228,  223,  223,  229,  223,
      223,  230,  223,  223,  223,  223,  231,  223,  223,  223,
      223,  223,  223,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  223,  223,  223,  223,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  223,  223,  223,  223,  233,  234,  233,  233,  235,
      233,  236,  233,  233,  237,  233,  233,  233,  233,  233,

      233,  233,  238,  239,  240,  240,  240,  233,  233,  233,
      233,  233,  233,  233,  241,  241,  242,  241,  241,  241,
      241,  241,  241,  241,  233,  233,  233,  233,  241,  241,
      241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
      241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
      241,  241,  243,  233,  244,  233,  246,  247,  246,  246,
      248,  246,  246,  246,  246,  249,  246,  246,  246,  246,
      246,  246,  246,  250,  251,  252,  252,  252,  246,  246,
      246,  246,  246,  246,  246,  253,  253,  254,  253,  253,
      253,  253,  253,  253,  253,  246,  246,  246,  246,  253,

      253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
      253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
      253,  253,  253,  246,  246,  246,  246,  255,  255,  429,
      686,  429,  543,  487,  554,  429,  687,  429,  488,  429,
      438,  438,  438,  439,  439,  439,  439,  439,  575,  495,
      500,  508,  529,  440,  496,  501,  509,  440,  441,  544,
      442,  554,  441,  522,  522,  256,  256,  257,  257,  513,
      513,  513,  513,  530,  526,  576,  440,  532,  431,  989,
      440,  990,  533, 1256,  441,  522,  522,  442,  441,  566,
      566,  606,  607,  258,  258,  259,  259,  260,  261,  262,

      260,  260,  260,  260,  260,  260,  260,  260,  260,  260,
      260,  260,  260,  263,  264,  265,  266,  266,  266,  260,
      260,  267,  260,  268,  260,  260,  269,  269,  269,  269,
      269,  269,  269,  269,  269,  269,  260,  260,  260,  260,
      270,  269,  269,  269,  269,  269,  269,  269,  269,  269,
      269,  269,  269,  269,  269,  269,  269,  269,  269,  269,
      269,  269,  269,  269,  260,  260,  260,  260,  271,  272,
      262,  271,  271,  271,  271,  271,  271,  271,  271,  271,
      271,  271,  271,  271,  273,  274,  275,  276,  276,  276,
      271,  271,  277,  271,  278,  271,  271,  279,  279,  279,

      279,  279,  279,  279,  279,  279,  279,  271,  271,  271,
      271,  280,  279,  279,  279,  279,  279,  279,  279,  279,
      279,  279,  279,  279,  279,  279,  279,  279,  279,  279,
      279,  279,  279,  279,  279,  271,  271,  271,  271,  294,
      295,  296,  294,  294,  294,  294,  294,  294,  294,  297,
      298,  294,  294,  299,  294,  294,  300,  294,  294,  294,
      294,  294,  294,  294,  294,  294,  294,  294,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  294,  294,
      294,  294,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,

      301,  301,  301,  301,  301,  301,  294,  294,  294,  294,
      302,  302,  303,  302,  304,  302,  302,  302,  302,  302,
      302,  302,  302,  302,  302,  302,  302,  305,  302,  302,
      302,  302,  302,  302,  302,  302,  302,  302,  306,  307,
      307,  308,  307,  307,  307,  307,  307,  307,  307,  302,
      309,  302,  302,  307,  307,  307,  307,  307,  307,  307,
      307,  307,  307,  307,  307,  307,  307,  307,  307,  307,
      307,  307,  307,  307,  307,  307,  307,  302,  302,  302,
      302,  310,  311,  312,  310,  310,  310,  310,  310,  313,
      310,  314,  315,  316,  310,  317,  310,  318,  319,  320,

      321,  321,  321,  322,  323,  324,  310,  325,  310,  326,
      327,  327,  327,  327,  327,  327,  327,  327,  327,  327,
      328,  310,  329,  310,  327,  327,  327,  327,  327,  327,
      327,  327,  327,  327,  327,  327,  327,  327,  327,  327,
      327,  327,  327,  327,  327,  327,  327,  327,  330,  310,
      331,  310,  332,  332,  333,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  334,  332,  332,  335,
      332,  332,  332,  332,  332,  336,  332,  332,  332,  332,
      332,  337,  337,  337,  337,  337,  337,  337,  337,  337,
      337,  332,  332,  332,  332,  337,  337,  337,  337,  337,

      337,  337,  337,  337,  337,  337,  337,  337,  337,  337,
      337,  337,  337,  337,  337,  337,  337,  337,  337,  332,
      332,  332,  332,  338,  339,  340,  338,  341,  338,  338,
      338,  338,  342,  338,  338,  338,  338,  338,  338,  343,
      344,  338,  338,  338,  338,  338,  338,  338,  338,  338,
      338,  338,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  338,  338,  338,  338,  343,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      338,  338,  338,  338,  348,  349,  350,  348,  348,  348,

      348,  348,  348,  348,  348,  348,  348,  348,  348,  348,
      348,  351,  348,  348,  348,  348,  348,  348,  348,  348,
      348,  348,  352,  353,  353,  353,  353,  353,  353,  353,
      353,  353,  353,  348,  348,  348,  348,  353,  353,  353,
      353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
      353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
      353,  348,  348,  348,  348,  356,  357,  356,  356,  358,
      356,  356,  356,  356,  359,  360,  361,  356,  356,  362,
      356,  356,  363,  364,  365,  365,  365,  356,  356,  356,
      356,  356,  356,  356,  366,  366,  367,  366,  366,  366,

      366,  366,  366,  366,  356,  356,  356,  356,  366,  366,
      366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
      366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
      366,  366,  356,  356,  356,  356,  368,  369,  368,  368,
      370,  368,  368,  368,  368,  371,  372,  373,  368,  368,
      374,  368,  368,  375,  376,  377,  377,  377,  368,  368,
      368,  368,  368,  368,  368,  378,  378,  379,  378,  378,
      378,  378,  378,  378,  378,  368,  380,  368,  368,  378,
      378,  378,  378,  378,  378,  378,  378,  378,  378,  378,
      378,  378,  378,  378,  378,  378,  378,  378,  378,  378,

      378,  378,  378,  368,  368,  368,  368,  381,  382,  383,
      384,  385,  381,  386,  387,  388,  389,  390,  391,  392,
      393,  394,  395,  396,  397,  398,  399,  399,  399,  400,
      401,  402,  403,  404,  405,  406,  407,  407,  408,  407,
      407,  407,  407,  407,  407,  407,  409,  381,  410,  411,
      407,  407,  407,  407,  407,  407,  407,  407,  407,  407,
      407,  407,  407,  407,  407,  407,  407,  407,  407,  407,
      407,  407,  407,  407,  412,  413,  414,  415,  381,  382,
      383,  384,  419,  381,  386,  387,  388,  420,  390,  391,
      392,  393,  394,  395,  421,  397,  398,  399,  399,  399,

      400,  401,  402,  403,  404,  405,  406,  422,  422,  423,
      422,  422,  422,  422,  422,  422,  422,  409,  381,  410,
      411,  424,  422,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  422,  422,  412,  413,  414,  415,  452,
      516,  476,  476,  476,  477,  520,  522,  522, 1254,  540,
      429,  450,  429,  546,  478,  586,  429,  451,  429,  479,
      429,  480,  477,  477,  477,  477,  489,  489,  489,  490,
      530,  522,  522,  556,  623,  478,  517,  478,  557,  491,
      479,  521,  632,  632,  492,  479,  493,  528,  480,  547,

      490,  490,  490,  490,  502,  502,  502,  503,  478,  431,
      527,  623,  491,  491,  583, 1251,  479,  504,  492,  584,
      492,  783,  505,  493,  506,  503,  503,  503,  503,  534,
      534,  534,  535,  587,  568,  572,  491,  623,  504,  730,
      504,  573,  536,  505,  492,  566,  566,  537,  505,  538,
      731,  506, 1257,  535,  535,  535,  535,  558,  558,  558,
      559,  504,  544,  596,  623,  536,  536,  732,  597,  505,
      560,  537,  548,  537,  548,  561,  538,  562,  548,  604,
      548,  549,  548,  473,  605,  559,  559,  559,  559,  536,
      611,  619, 1250,  560,  625,  612,  620,  537,  560,  626,

      736,  561, 1249,  561,  562,  554,  574,  569,  569,  569,
      569,  623,  737,  634,  634,  634,  634,  548,  675,  548,
      540,  560,  577,  548,  676,  548,  549,  548,  625,  561,
      588,  578,  571,  626,  579,  579,  579,  579,  636,  589,
      580,  530,  590,  590,  590,  590,  632,  632,  591,  598,
      598,  598,  599,  645,  646,  582,  666,  774,  599,  599,
      599,  599,  600,  593,  658,  647,  791,  601,  650,  602,
      648,  600,  586,  651,  670,  722,  601,  613,  613,  613,
      614,  994,  656,  659,  660,  600,  614,  614,  614,  614,
      615,  916,  667,  601,  600,  616,  602,  617,  917,  615,

      775,  670,  601,  530,  616,  627,  627,  627,  628,  738,
     1088,  723,  434,  615,  628,  628,  628,  628,  629,  739,
      740,  616,  615,  630,  617,  631,  532,  629,  751,  752,
      616,  533,  630,  627,  627,  627,  628,  754,  755,  434,
      587,  629,  628,  628,  628,  628,  629, 1248,  657,  630,
      629,  630,  631,  631,  661,  629, 1153,  672,  630,  662,
      630,  623,  673,  634,  634,  634,  634,  444,  444,  629,
      679,  534,  534,  534,  535,  680,  692,  630,  629,  776,
      631,  693,  700,  777,  536,  778,  630,  701,  636,  537,
      681,  538,  535,  535,  535,  535, 1245,  682,  705,  713,

      686,  683,  684,  706,  714,  536,  687,  536,  785,  427,
      537,  694,  694,  694,  695,  537,  444,  444,  538,  453,
      695,  695,  695,  695,  696, 1244,  779,  771,  536,  697,
      742,  698,  772,  696,  516,  743,  537,  824,  697,  707,
      707,  707,  708,  744,  786,  428,  453,  696,  708,  708,
      708,  708,  709,  462,  463,  697,  696,  710,  698,  711,
      824,  709,  464,  465,  697,  741,  710,  715,  716,  789,
      517,  717,  780,  781,  529,  709,  724,  782,  510,  511,
      797,  797,  797,  710,  709,  725,  711,  833,  726,  726,
      726,  726,  710,  791,  727,  530,  789,  718,  745,  745,

      745,  746,  746,  746,  746,  746,  543,  792,  793,  729,
      833,  747, 1257, 1257,  791,  747,  748,  771,  749, 1243,
      748,  789,  772,  770,  770,  770,  770,  798,  792,  793,
      801,  801,  801,  544,  747,  818,  818,  818,  747,  850,
      848, 1242,  748,  486,  499,  749,  748,  756,  796,  849,
      757,  520,  758,  522,  522,  759,  438,  438,  438,  439,
     1241,  760,  761,  805,  762,  762,  762,  762,  806,  440,
      439,  439,  439,  439,  441,  842,  434,  802,  447,  447,
      447,  447,  819,  440,  554,  764,  805,  521,  441,  765,
      520,  540,  440,  766,  806,  827,  827,  827,  842,  822,

      441,  858,  540,  449,  823,  767,  440,  476,  476,  476,
      477,  554,  530,  768,  441,  769,  477,  477,  477,  477,
      478, 1240,  822,  530,  858,  479,  521,  831,  540,  478,
      823,  873,  832, 1237,  479,  489,  489,  489,  490,  836,
      836,  836,  828,  478,  490,  490,  490,  490,  491,  530,
      831,  479,  478,  492,  873,  566,  566,  491,  832,  894,
      479,  903,  492,  502,  502,  502,  503,  513,  513,  513,
      513,  491,  503,  503,  503,  503,  504, 1088,  840,  492,
      491,  505,  894,  841,  903,  504,  837, 1236,  492,  546,
      505,  844,  844,  844,  846,  846,  846,  522,  522,  504,

      575,  840,  522,  522,  863,  863,  863,  505,  504,  841,
      534,  534,  534,  535,  566,  566,  505,  535,  535,  535,
      535,  856, 1154,  536, 1257,  547,  857,  576,  537, 1235,
      536,  867,  867,  867,  852,  537,  606,  607,  845, 1257,
      871,  847, 1088,  851,  856,  872,  536,  558,  558,  558,
      559,  864,  857,  536,  537,  595,  559,  559,  559,  559,
      560,  537,  572,  871, 1234,  561, 1233,  909,  573,  560,
      610,  872,  632,  632,  561,  632,  632,  554,  868,  569,
      569,  569,  569,  560,  579,  579,  579,  579, 1183,  544,
      909,  561,  560,  579,  579,  579,  579,  888,  888,  888,

      561,  897,  897,  897,  571,  590,  590,  590,  590,  590,
      590,  590,  590,  598,  598,  598,  599,  599,  599,  599,
      599,  645,  646,  892,  623, 1230,  600, 1257,  893,  901,
      600,  601,  670,  944,  902,  601, 1088,  613,  613,  613,
      614, 1225,  666, 1257,  889, 1224,  892,  953,  898,  600,
      615,  623,  901,  600,  893,  616,  944,  601,  691,  670,
      902,  601,  614,  614,  614,  614,  627,  627,  627,  628,
      953,  656,  907,  615,  704,  615,  978,  908,  667,  629,
      616,  616,  968, 1182,  630,  722,  628,  628,  628,  628,
      979,  980,  530,  756, 1223,  907,  757, 1222,  615,  629,

     1221,  759,  629,  908,  630,  968,  616,  974,  761,  623,
      630,  634,  634,  634,  634,  923,  923,  923,  926,  926,
      926,  723,  629,  938,  938,  938,  947,  947,  947, 1220,
      630,  694,  694,  694,  695,  761,  636,  657,  695,  695,
      695,  695,  789,  975,  696,  942,  955,  955,  955,  697,
      943,  696,  726,  726,  726,  726,  697, 1257,  951,  961,
      961,  961,  924,  952, 1084,  927, 1217,  696,  942,  789,
      939,  722, 1085,  948,  696,  697,  943,  707,  707,  707,
      708,  951,  697,  708,  708,  708,  708,  966,  734,  952,
      709,  806,  967,  956,  791,  710,  709,  726,  726,  726,

      726,  710,  745,  745,  745,  746,  962,  723,  776,  793,
      966, 1007,  777,  709,  778,  747,  779,  806,  967,  709,
      748,  710,  746,  746,  746,  746,  779,  710,  762,  762,
      762,  762,  785, 1257, 1007,  747, 1257, 1212,  747,  978,
      748, 1257,  762,  762,  762,  762,  748,  761,  761,  983,
      983,  983,  983,  979,  980,  978,  791,  823,  747,  995,
      995,  995,  780,  781,  832, 1010,  748,  782,  786,  979,
      980,  994,  780,  781,  985,  761,  791,  782,  998,  998,
      998, 1000, 1211,  823,  524,  848,  986,  440, 1010,  791,
      832,  793,  441,  791, 1210,  792,  793,  841, 1001, 1001,

     1001, 1001,  987,  792,  793,  427,  996,  792,  793,  789,
      440,  770,  770,  770,  770, 1013, 1209,  800,  441, 1003,
     1003, 1003,  817,  841,  478,  999, 1005, 1005, 1005,  479,
      491, 1008, 1008, 1008,  826,  492,  796, 1016, 1013,  835,
      857,  428,  427, 1011, 1011, 1011,  504,  478, 1014, 1014,
     1014,  505, 1023,  491, 1208,  479, 1004, 1004, 1004, 1004,
     1016,  492,  522,  522, 1207,  516,  857, 1004,  536,  504,
      522,  522,  872,  537,  520, 1023, 1091,  505,  428, 1017,
     1017, 1017, 1004, 1004, 1004, 1004, 1004, 1004, 1019, 1019,
     1019,  536,  546, 1092, 1092, 1092, 1092, 1206,  872,  537,

     1029,  517,  516,  893, 1021,  902, 1025, 1025, 1025,  560,
      521,  866, 1022, 1038,  561,  887, 1018, 1018, 1018, 1018,
     1027, 1027, 1027, 1029, 1036, 1036, 1036, 1018,  547,  893,
      600,  902,  560, 1041,  908,  601, 1038,  540,  517, 1205,
      561,  896, 1018, 1018, 1018, 1018, 1018, 1018,  520,  615,
     1039, 1039, 1039,  600,  616, 1042, 1041, 1204,  530,  925,
      908,  601, 1020, 1020, 1020, 1020,  937,  666, 1051, 1051,
     1051, 1201,  615, 1020,  629, 1058, 1058, 1058, 1042,  630,
      616, 1049, 1049, 1049,  521, 1088,  943, 1151, 1020, 1020,
     1020, 1020, 1020, 1020,  546, 1060,  952,  629, 1063,  974,

      967,  696,  709,  667,  946,  630,  697,  710, 1026, 1026,
     1026, 1026,  943, 1061, 1061, 1061,  978,  974, 1060, 1026,
     1164, 1063,  952, 1071,  696,  709,  967,  722, 1165,  978,
      547,  980,  697,  710, 1026, 1026, 1026, 1026, 1026, 1026,
      666, 1064, 1064, 1064, 1072, 1196, 1071,  747, 1172,  960,
     1162,  522,  748,  975, 1050, 1050, 1050, 1050, 1069, 1069,
     1069, 1195,  978,  723,  978, 1050, 1073, 1073, 1073, 1194,
      747, 1075, 1075, 1075, 1077, 1146,  667, 1072,  748,  980,
     1050, 1050, 1050, 1050, 1050, 1050,  722, 1088,  979,  980,
      978, 1078, 1078, 1078, 1078,  978,  522,  522, 1172, 1193,

     1065, 1065, 1065, 1065,  979,  980,  978,  427,  791,  979,
      980, 1065,  761, 1074,  983,  983,  983,  983, 1076,  978,
      979,  980,  723,  994, 1192, 1146, 1065, 1065, 1065, 1065,
     1065, 1065, 1089,  979,  980,  997, 1172, 1110,  785,  985,
     1000, 1090, 1191,  428, 1096, 1096, 1096,  791, 1232,  522,
     1190, 1081, 1094, 1094, 1094,  994,  791, 1092, 1092, 1092,
     1092,  978,  793, 1146, 1001, 1001, 1001, 1001,  427,  427,
      792,  793,  522,  522,  786,  979,  980,  800, 1098,  516,
      817, 1082,  785, 1100, 1100, 1100,  432,  432,  432,  472,
      472,  472,  826, 1106, 1106, 1106, 1095, 1095, 1095, 1095,

      835,  485,  485,  485,  428,  428,  791, 1095, 1189,  498,
      498,  498,  516, 1111, 1188,  517,  520, 1147,  786,  546,
      792,  793, 1095, 1095, 1095, 1095, 1095, 1095,  427,  866,
     1108, 1108, 1108, 1112, 1112, 1112, 1144, 1187,  551,  551,
      551,  997, 1101, 1101, 1101, 1101, 1184,  577,  517,  516,
      979,  980,  521, 1101, 1151,  547,  578, 1088, 1181,  579,
      579,  579,  579, 1146,  428,  974,  887,  666, 1101, 1101,
     1101, 1101, 1101, 1101,  516,  594,  594,  594,  960,  946,
      582, 1123, 1123, 1123,  896,  517, 1088,  925, 1107, 1107,
     1107, 1107,  588,  609,  609,  609,  668,  668,  668, 1107,

      937,  589,  937,  667,  590,  590,  590,  590,  722, 1136,
      517,  690,  690,  690, 1107, 1107, 1107, 1107, 1107, 1107,
      520,  946, 1133, 1133, 1133,  593, 1137, 1137, 1137, 1137,
      703,  703,  703, 1182, 1109, 1109, 1109, 1109,  724,  443,
      443,  443, 1170, 1169,  723, 1109, 1168,  725,  960,  520,
      726,  726,  726,  726,  974, 1091,  521,  733,  733,  733,
     1109, 1109, 1109, 1109, 1109, 1109,  546,  974, 1139, 1139,
     1139,  729, 1092, 1092, 1092, 1092, 1141, 1141, 1141, 1077,
     1113, 1113, 1113, 1113, 1167,  521,  443,  443,  443,  978,
      975, 1113,  522,  522, 1072, 1166, 1137, 1137, 1137, 1137,

      978,  791,  547,  979,  980,  925, 1113, 1113, 1113, 1113,
     1113, 1113,  666,  520,  546,  980,  793, 1078, 1078, 1078,
     1078, 1203, 1092, 1092, 1092, 1092, 1124, 1124, 1124, 1124,
      997, 1143,  546, 1160,  666, 1148, 1155, 1124, 1163,  787,
      787,  787,  522,  522,  666, 1149,  785, 1136,  667,  521,
      547,  722, 1124, 1124, 1124, 1124, 1124, 1124,  722,  722,
     1157, 1157, 1157,  978, 1137, 1137, 1137, 1137,  547,  791,
      667, 1117, 1134, 1134, 1134, 1134,  974,  979,  980, 1161,
      667,  785,  786, 1134, 1231,  522,  522,  723,  785,  974,
     1174, 1174, 1174,  896,  723,  723,  974,  974, 1134, 1134,

     1134, 1134, 1134, 1134,  974,  976,  976,  976, 1137, 1137,
     1137, 1137,  975,  978, 1179, 1144, 1186,  786, 1140, 1140,
     1140, 1140, 1171,  978,  786,  975,  791,  979,  980, 1140,
     1072,  887,  866,  975,  564,  564,  564,  978,  980,  978,
      975,  793, 1146, 1144, 1140, 1140, 1140, 1140, 1140, 1140,
      785,  979,  980,  979,  980, 1177,  835,  979,  980,  978,
     1185,  826,  978,  791, 1158, 1158, 1158, 1158,  978,  978,
     1146, 1178,  978,  979,  980, 1158,  979,  980,  793,  817,
     1198,  522,  522,  980,  980,  800,  786, 1238,  997,  978,
     1158, 1158, 1158, 1158, 1158, 1158,  974, 1180, 1088, 1202,

      978,  791, 1197,  979,  980, 1213, 1152, 1151, 1200,  978,
     1175, 1175, 1175, 1175,  979,  980,  793, 1199,  978, 1151,
     1219, 1175, 1150,  979,  980,  758,  974,  960,  978,  724,
     1067,  978,  975,  980, 1218,  946, 1175, 1175, 1175, 1175,
     1175, 1175,  979,  980,  978,  979,  980, 1215,  978, 1214,
      978, 1226,  978,  937, 1000, 1130, 1216, 1129,  979,  980,
     1128, 1247,  979,  980,  979,  980,  979,  980,  792,  793,
     1077, 1001, 1001, 1001, 1001, 1227, 1228,  978, 1257, 1257,
     1257, 1257,  978, 1127,  979,  980, 1252, 1078, 1078, 1078,
     1078,  979,  980,  978, 1247, 1126,  979,  980, 1252,  925,

     1122, 1121, 1229, 1257, 1257, 1257, 1257,  979,  980,  978,
     1239, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,  564,
      564,  564,  564,  979,  980, 1120,  808,  808, 1246,  825,
      825, 1119, 1118,  808,  834,  834,  825, 1117, 1253,  808,
      896,  834,  825,  887,  588, 1034,  577,  834, 1255,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,  148,  148,  148,
      148,  148,  148,  148,  148,  148,  148,  148,  148,  148,
      148,  148,  148,  148,  148,  148,  148,  148,  148,  148,

      148,  148,  148,  148,  148,  152,  152,  152,  152,  152,
      152,  152,  152,  152,  152,  152,  152,  152,  152,  152,
      152,  152,  152,  152,  152,  152,  152,  152,  152,  152,
      152,  152,  152,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  245,  245,  245,  245,  245,  245,  245,  245,  245,
      245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
      245,  245,  245,  245,  245,  245,  245,  245,  245,  281,
      281,  281,  281,  281,  281,  281,  281,  281,  281,  281,

      281,  281,  281,  281,  281,  281,  281,  281,  281,  281,
      281,  281,  281,  281,  281,  281,  281,  284,  284,  284,
      284,  284,  284,  284,  284,  284,  284,  284,  284,  284,
      284,  284,  284,  284,  284,  284,  284,  284,  284,  284,
      284,  284,  284,  284,  284,  287,  287,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  287,  291,  291,  291,  291,  291,  291,  291,
      291,  291,  291,  291,  291,  291,  291,  291,  291,  291,
      291,  291,  291,  291,  291,  291,  291,  291,  291,  291,

      291,  426,  426, 1031,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  430,
      866,  835,  430,  430,  826,  430,  817,  800,  997,  993,
     1086, 1083,  430,  430,  430,  430,  432,  432,  758,  432,
      432,  974,  432,  432,  432,  432,  432,  432,  432,  432,
      432,  432,  432,  432,  432,  432,  432,  432,  432,  432,
      432,  432,  432,  432,  435,  965,  965,  960,  724, 1067,
      950,  950,  946,  435,  435,  435,  941,  941,  435,  435,
      435,  435,  445,  445,  937,  445,  445, 1057, 1056,  843,

      843, 1055,  445,  445,  445, 1054,  843,  445,  445,  445,
      445,  448,  843,  448,  448, 1053,  931,  859,  859,  929,
      448,  448,  448,  929,  859,  448,  448,  448,  448,  454,
      859,  925,  922, 1048, 1047, 1046, 1045, 1044,  454,  454,
      454, 1043,  914,  454,  454,  454,  454,  457,  457,  912,
      457,  457,  906,  900,  900,  896,  891,  457,  457,  457,
      891,  887,  457,  457,  457,  457,  461,  461,  588, 1034,
      883,  577, 1031,  461,  461,  461,  877,  870,  461,  461,
      461,  461,  469,  469,  866,  860,  855,  848,  839,  469,
      469,  469,  839,  835,  469,  469,  469,  469,  472,  472,

      830,  472,  472,  830,  472,  472,  472,  472,  472,  472,
      472,  472,  472,  472,  472,  472,  472,  472,  472,  472,
      472,  472,  472,  472,  472,  472,  481,  481,  826,  821,
      821,  817,  816,  481,  481,  481,  816,  814,  481,  481,
      481,  481,  485,  485,  814,  485,  485,  812,  485,  485,
      485,  485,  485,  485,  485,  485,  485,  485,  485,  485,
      485,  485,  485,  485,  485,  485,  485,  485,  485,  485,
      494,  494,  810,  804,  800,  997,  993,  494,  494,  494,
      991,  988,  494,  494,  494,  494,  498,  498,  783,  498,
      498,  977,  498,  498,  498,  498,  498,  498,  498,  498,

      498,  498,  498,  498,  498,  498,  498,  498,  498,  498,
      498,  498,  498,  498,  507,  507,  971,  970,  965,  963,
      960,  507,  507,  507,  719,  950,  507,  507,  507,  507,
      515,  515,  946,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  519,  519,
      702,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  522,  522,  941,  522,
      522,  937,  689,  688,  936,  933,  522,  522,  522,  932,

      931,  522,  522,  522,  522,  523,  523,  678,  523,  523,
      523,  523,  523,  523,  677,  523,  523,  523,  523,  523,
      523,  523,  523,  523,  523,  523,  523,  523,  523,  523,
      523,  523,  523,  525,  525,  929,  525,  525,  925,  664,
      874,  874,  922,  525,  525,  525,  920,  874,  525,  525,
      525,  525,  541,  874,  919,  918,  915,  914,  895,  895,
      912,  541,  541,  541,  644,  895,  906,  622,  541,  541,
      541,  895,  621,  541,  541,  541,  541,  545,  545,  900,
      545,  545,  545,  545,  545,  545,  545,  545,  545,  545,
      545,  545,  545,  545,  545,  545,  545,  545,  545,  545,

      545,  545,  545,  545,  545,  550,  896,  608,  550,  550,
      550,  550,  891,  887,  883,  878,  877,  574,  550,  550,
      550,  551,  551,  875,  551,  551,  870,  551,  551,  551,
      551,  551,  551,  551,  551,  551,  551,  551,  551,  551,
      551,  551,  551,  551,  551,  551,  551,  551,  551,  555,
      866,  862,  542,  860,  855,  853,  539,  518,  555,  555,
      555,  514,  512,  555,  555,  555,  555,  567,  567,  839,
      567,  567,  835,  497,  904,  904,  830,  567,  567,  567,
      826,  904,  567,  567,  567,  567,  570,  904,  570,  570,
      484,  821,  910,  910,  817,  570,  570,  570,  470,  910,

      570,  570,  570,  570,  581,  910,  816,  581,  945,  945,
      581,  581,  466,  581,  814,  945,  458,  581,  581,  581,
      812,  945,  581,  581,  581,  581,  585,  585,  810,  452,
      954,  954,  804,  585,  585,  585,  800,  954,  585,  585,
      585,  585,  592,  954,  425,  592,  969,  969,  592,  592,
      788,  592,  773,  969,  753,  592,  592,  592,  750,  969,
      592,  592,  592,  592,  594,  594,  741,  594,  594,  735,
      594,  594,  594,  594,  594,  594,  594,  594,  594,  594,
      594,  594,  594,  594,  594,  594,  594,  594,  594,  594,
      594,  594,  603,  603,  734,  730,  720,  719,  704,  603,

      603,  603,  702,  691,  603,  603,  603,  603,  609,  609,
      689,  609,  609,  688,  609,  609,  609,  609,  609,  609,
      609,  609,  609,  609,  609,  609,  609,  609,  609,  609,
      609,  609,  609,  609,  609,  609,  618,  618,  678,  677,
      669,  664,  539,  618,  618,  618,  531,  655,  618,  618,
      618,  618,  624,  654,  652,  644,  643,  640,  638,  622,
      622,  624,  624,  624,  621,  610,  624,  624,  624,  624,
      633,  633,  608,  633,  633,  595,  565,  563,  553,  552,
      633,  633,  633,  542,  539,  633,  633,  633,  633,  635,
      531,  635,  635,  524,  518,  514,  512,  499,  635,  635,

      635,  497,  486,  635,  635,  635,  635,  637,  637,  484,
      637,  637,  637,  473,  637,  637,  637,  637,  637,  637,
      637,  637,  637,  637,  637,  637,  637,  637,  637,  637,
      637,  637,  637,  637,  637,  639,  639,  471,  639,  639,
      639,  470,  639,  639,  639,  639,  639,  639,  639,  639,
      639,  639,  639,  639,  639,  639,  639,  639,  639,  639,
      639,  639,  639,  641,  641,  466,  458,  641,  641,  641,
      641,  641,  641,  641,  641,  641,  641,  641,  641,  641,
      641,  641,  641,  433,  641,  641,  641,  641,  641,  641,
      641,  642,  642,  642,  642,  642,  642,  642,  642,  642,

      642,  642,  642,  642,  642,  642,  642,  642,  642,  642,
      642,  642,  642,  642,  642,  642,  642,  642,  642,  649,
      649,  425, 1257, 1257, 1257, 1257,  649,  649,  649, 1257,
     1257,  649,  649,  649,  649,  653,  653, 1257, 1257, 1257,
     1257, 1257,  653,  653,  653, 1257, 1257,  653,  653,  653,
      653,  663,  663, 1257, 1257, 1257, 1257, 1257,  663,  663,
      663, 1257, 1257,  663,  663,  663,  663,  665,  665, 1257,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  668,  668, 1257,  668,  668,

     1257,  668,  668,  668,  668,  668,  668,  668,  668,  668,
      668,  668,  668,  668,  668,  668,  668,  668,  668,  668,
      668,  668,  668,  671, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257,  671,  671,  671, 1257, 1257,  671,  671,  671,
      671,  674,  674, 1257,  674,  674, 1257, 1257, 1257, 1257,
     1257,  674,  674,  674, 1257, 1257,  674,  674,  674,  674,
      685,  685, 1257, 1257, 1257, 1257, 1257,  685,  685,  685,
     1257, 1257,  685,  685,  685,  685,  690,  690, 1257,  690,
      690, 1257,  690,  690,  690,  690,  690,  690,  690,  690,
      690,  690,  690,  690,  690,  690,  690,  690,  690,  690,

      690,  690,  690,  690,  699,  699, 1257, 1257, 1257, 1257,
     1257,  699,  699,  699, 1257, 1257,  699,  699,  699,  699,
      703,  703, 1257,  703,  703, 1257,  703,  703,  703,  703,
      703,  703,  703,  703,  703,  703,  703,  703,  703,  703,
      703,  703,  703,  703,  703,  703,  703,  703,  712,  712,
     1257, 1257, 1257, 1257, 1257,  712,  712,  712, 1257, 1257,
      712,  712,  712,  712,  721,  721, 1257,  721,  721,  721,
      721,  721,  721,  721,  721,  721,  721,  721,  721,  721,
      721,  721,  721,  721,  721,  721,  721,  721,  721,  721,
      721,  721,  728, 1257, 1257,  728, 1257, 1257,  728,  728,

     1257,  728, 1257, 1257, 1257,  728,  728,  728, 1257, 1257,
      728,  728,  728,  728,  733,  733, 1257,  733,  733, 1257,
      733,  733,  733,  733,  733,  733,  733,  733,  733,  733,
      733,  733,  733,  733,  733,  733,  733,  733,  733,  733,
      733,  733,  763, 1257,  763,  763,  763, 1257,  763,  763,
     1257,  763,  763, 1257, 1257, 1257, 1257, 1257,  763,  763,
      763, 1257, 1257,  763,  763,  763,  763,  763,  763,  770,
      770, 1257, 1257, 1257, 1257, 1257,  770,  770,  770, 1257,
     1257,  770,  770,  770,  770,  784,  784, 1257,  784,  784,
      784,  784,  784,  784,  784,  784,  784,  784,  784,  784,

      784,  784,  784,  784,  784,  784,  784,  784,  784,  784,
      784,  784,  784,  787,  787, 1257,  787,  787, 1257,  787,
      787,  787,  787,  787,  787,  787,  787,  787,  787,  787,
      787,  787,  787,  787,  787,  787,  787,  787,  787,  787,
      787,  790, 1257,  790, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257,  790,  790,  790, 1257, 1257,  790,  790,  790,
      790,  794, 1257, 1257, 1257, 1257, 1257,  794,  794, 1257,
      794,  794, 1257, 1257, 1257, 1257, 1257,  794,  794,  794,
     1257, 1257,  794,  794,  794,  794,  795, 1257,  795,  795,
     1257, 1257, 1257, 1257, 1257,  795,  795,  795, 1257, 1257,

      795,  795,  795,  795,  426,  426, 1257,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  799, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257,  799,  799,  799,
      799,  432,  432, 1257,  432,  432,  432,  432,  432,  432,
      432,  432,  432,  432,  432,  432,  432,  432,  432,  432,
      432,  432,  432,  432,  432,  432,  432,  432,  432,  435,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,  435,  435,
      435, 1257, 1257,  435,  435,  435,  435,  444,  444, 1257,

      444,  444, 1257, 1257, 1257, 1257, 1257,  444,  444,  444,
     1257, 1257,  444,  444,  444,  444,  803,  803,  803,  803,
      803,  803,  803,  803,  803,  803,  803,  803,  803,  803,
      803,  803,  803,  803,  803,  803,  803,  803,  803,  803,
      803,  803,  803,  803,  445,  445, 1257,  445,  445, 1257,
     1257, 1257, 1257, 1257,  445,  445,  445, 1257, 1257,  445,
      445,  445,  445,  447,  447, 1257, 1257, 1257, 1257, 1257,
      447,  447,  447, 1257, 1257,  447,  447,  447,  447,  448,
     1257,  448,  448, 1257, 1257, 1257, 1257, 1257,  448,  448,
      448, 1257, 1257,  448,  448,  448,  448,  809,  809,  809,

      809,  809,  809,  809,  809,  809,  809,  809,  809,  809,
      809,  809,  809,  809,  809,  809,  809,  809,  809,  809,
      809,  809,  809,  809,  809,  454, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257,  454,  454,  454, 1257, 1257,  454,
      454,  454,  454,  457,  457, 1257,  457,  457, 1257, 1257,
     1257, 1257, 1257,  457,  457,  457, 1257, 1257,  457,  457,
      457,  457,  811,  811,  811,  811,  811,  811,  811,  811,
      811,  811,  811,  811,  811,  811,  811,  811,  811,  811,
      811,  811,  811,  811,  811,  811,  811,  811,  811,  811,
      813,  813, 1257,  813,  813,  813,  813,  813,  813,  813,

      813,  813,  813,  813,  813,  813,  813,  813,  813,  813,
      813,  813,  813,  813,  813,  813,  813,  813,  461,  461,
     1257, 1257, 1257, 1257, 1257,  461,  461,  461, 1257, 1257,
      461,  461,  461,  461,  815,  815, 1257,  815,  815,  815,
      815,  815,  815,  815,  815,  815,  815,  815,  815,  815,
      815,  815,  815,  815,  815,  815,  815,  815,  815,  815,
      815,  815,  469,  469, 1257, 1257, 1257, 1257, 1257,  469,
      469,  469, 1257, 1257,  469,  469,  469,  469,  472,  472,
     1257,  472,  472,  472,  472,  472,  472,  472,  472,  472,
      472,  472,  472,  472,  472,  472,  472,  472,  472,  472,

      472,  472,  472,  472,  472,  472,  820,  820, 1257,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  481,  481, 1257, 1257, 1257, 1257,
     1257,  481,  481,  481, 1257, 1257,  481,  481,  481,  481,
      485,  485, 1257,  485,  485,  485,  485,  485,  485,  485,
      485,  485,  485,  485,  485,  485,  485,  485,  485,  485,
      485,  485,  485,  485,  485,  485,  485,  485,  829,  829,
     1257,  829,  829,  829,  829,  829,  829,  829,  829,  829,
      829,  829,  829,  829,  829,  829,  829,  829,  829,  829,

      829,  829,  829,  829,  829,  829,  494,  494, 1257, 1257,
     1257, 1257, 1257,  494,  494,  494, 1257, 1257,  494,  494,
      494,  494,  498,  498, 1257,  498,  498,  498,  498,  498,
      498,  498,  498,  498,  498,  498,  498,  498,  498,  498,
      498,  498,  498,  498,  498,  498,  498,  498,  498,  498,
      838,  838, 1257,  838,  838,  838,  838,  838,  838,  838,
      838,  838,  838,  838,  838,  838,  838,  838,  838,  838,
      838,  838,  838,  838,  838,  838,  838,  838,  507,  507,
     1257, 1257, 1257, 1257, 1257,  507,  507,  507, 1257, 1257,
      507,  507,  507,  507,  515,  515, 1257,  515,  515,  515,

      515,  515,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  519,  519, 1257,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      522,  522, 1257,  522,  522, 1257, 1257, 1257, 1257, 1257,
      522,  522,  522, 1257, 1257,  522,  522,  522,  522,  525,
      525, 1257,  525,  525, 1257, 1257, 1257, 1257, 1257,  525,
      525,  525, 1257, 1257,  525,  525,  525,  525,  854,  854,
      854,  854,  854,  854,  854,  854,  854,  854,  854,  854,

      854,  854,  854,  854,  854,  854,  854,  854,  854,  854,
      854,  854,  854,  854,  854,  854,  861, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257,  861,  861,  861, 1257, 1257,  861,  861,  861,
      861,  541, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
      541,  541,  541, 1257, 1257, 1257, 1257,  541,  541,  541,
     1257, 1257,  541,  541,  541,  541,  545,  545, 1257,  545,
      545,  545,  545,  545,  545,  545,  545,  545,  545,  545,
      545,  545,  545,  545,  545,  545,  545,  545,  545,  545,
      545,  545,  545,  545,  865, 1257, 1257, 1257, 1257, 1257,

     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,  865,
      865,  865,  865,  551,  551, 1257,  551,  551,  551,  551,
      551,  551,  551,  551,  551,  551,  551,  551,  551,  551,
      551,  551,  551,  551,  551,  551,  551,  551,  551,  551,
      551,  555, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
      555,  555,  555, 1257, 1257,  555,  555,  555,  555,  566,
      566, 1257,  566,  566, 1257, 1257, 1257, 1257, 1257,  566,
      566,  566, 1257, 1257,  566,  566,  566,  566,  869,  869,
      869,  869,  869,  869,  869,  869,  869,  869,  869,  869,
      869,  869,  869,  869,  869,  869,  869,  869,  869,  869,

      869,  869,  869,  869,  869,  869,  567,  567, 1257,  567,
      567, 1257, 1257, 1257, 1257, 1257,  567,  567,  567, 1257,
     1257,  567,  567,  567,  567,  569,  569, 1257, 1257, 1257,
     1257, 1257,  569,  569,  569, 1257, 1257,  569,  569,  569,
      569,  570, 1257,  570,  570, 1257, 1257, 1257, 1257, 1257,
      570,  570,  570, 1257, 1257,  570,  570,  570,  570,  876,
      876,  876,  876,  876,  876,  876,  876,  876,  876,  876,
      876,  876,  876,  876,  876,  876,  876,  876,  876,  876,
      876,  876,  876,  876,  876,  876,  876,  879,  879,  879,
     1257, 1257,  879,  879,  879,  879,  880,  880, 1257, 1257,

     1257, 1257, 1257,  880,  880,  880, 1257, 1257,  880,  880,
      880,  880,  881,  881,  881, 1257, 1257,  881,  881,  881,
      881,  882,  882,  882,  882,  882,  882,  882,  882,  882,
      882,  882,  882,  882,  882,  882,  882,  882,  882,  882,
      882,  882,  882,  882,  882,  882,  882,  882,  882,  585,
      585, 1257, 1257, 1257, 1257, 1257,  585,  585,  585, 1257,
     1257,  585,  585,  585,  585,  884,  884,  884, 1257, 1257,
      884,  884,  884,  884,  885,  885, 1257, 1257, 1257, 1257,
     1257,  885,  885,  885, 1257, 1257,  885,  885,  885,  885,
      886,  886,  886, 1257, 1257,  886,  886,  886,  886,  594,

      594, 1257,  594,  594,  594,  594,  594,  594,  594,  594,
      594,  594,  594,  594,  594,  594,  594,  594,  594,  594,
      594,  594,  594,  594,  594,  594,  594,  890,  890, 1257,
      890,  890,  890,  890,  890,  890,  890,  890,  890,  890,
      890,  890,  890,  890,  890,  890,  890,  890,  890,  890,
      890,  890,  890,  890,  890,  603,  603, 1257, 1257, 1257,
     1257, 1257,  603,  603,  603, 1257, 1257,  603,  603,  603,
      603,  609,  609, 1257,  609,  609,  609,  609,  609,  609,
      609,  609,  609,  609,  609,  609,  609,  609,  609,  609,
      609,  609,  609,  609,  609,  609,  609,  609,  609,  899,

      899, 1257,  899,  899,  899,  899,  899,  899,  899,  899,
      899,  899,  899,  899,  899,  899,  899,  899,  899,  899,
      899,  899,  899,  899,  899,  899,  899,  618,  618, 1257,
     1257, 1257, 1257, 1257,  618,  618,  618, 1257, 1257,  618,
      618,  618,  618,  624, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257,  624,  624,  624, 1257, 1257,  624,  624,  624,
      624,  632,  632, 1257,  632,  632, 1257, 1257, 1257, 1257,
     1257,  632,  632,  632, 1257, 1257,  632,  632,  632,  632,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,

      905,  905,  905,  905,  905,  905,  905,  905,  633,  633,
     1257,  633,  633, 1257, 1257, 1257, 1257, 1257,  633,  633,
      633, 1257, 1257,  633,  633,  633,  633,  634,  634, 1257,
     1257, 1257, 1257, 1257,  634,  634,  634, 1257, 1257,  634,
      634,  634,  634,  635, 1257,  635,  635, 1257, 1257, 1257,
     1257, 1257,  635,  635,  635, 1257, 1257,  635,  635,  635,
      635,  637,  637, 1257,  637,  637,  637, 1257,  637,  637,
      637,  637,  637,  637,  637,  637,  637,  637,  637,  637,
      637,  637,  637,  637,  637,  637,  637,  637,  637,  639,
      639, 1257,  639,  639,  639, 1257,  639,  639,  639,  639,

      639,  639,  639,  639,  639,  639,  639,  639,  639,  639,
      639,  639,  639,  639,  639,  639,  639,  641,  641, 1257,
     1257,  641,  641,  641,  641,  641,  641,  641,  641,  641,
      641,  641,  641,  641,  641,  641,  641, 1257,  641,  641,
      641,  641,  641,  641,  641,  911,  911,  911,  911,  911,
      911,  911,  911,  911,  911,  911,  911,  911,  911,  911,
      911,  911,  911,  911,  911,  911,  911,  911,  911,  911,
      911,  911,  911,  649,  649, 1257, 1257, 1257, 1257, 1257,
      649,  649,  649, 1257, 1257,  649,  649,  649,  649,  913,
      913,  913,  913,  913,  913,  913,  913,  913,  913,  913,

      913,  913,  913,  913,  913,  913,  913,  913,  913,  913,
      913,  913,  913,  913,  913,  913,  913,  653,  653, 1257,
     1257, 1257, 1257, 1257,  653,  653,  653, 1257, 1257,  653,
      653,  653,  653,  921,  921,  921,  921,  921,  921,  921,
      921,  921,  921,  921,  921,  921,  921,  921,  921,  921,
      921,  921,  921,  921,  921,  921,  921,  921,  921,  921,
      921,  663,  663, 1257, 1257, 1257, 1257, 1257,  663,  663,
      663, 1257, 1257,  663,  663,  663,  663,  665,  665, 1257,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,

      665,  665,  665,  665,  665,  668,  668, 1257,  668,  668,
      668,  668,  668,  668,  668,  668,  668,  668,  668,  668,
      668,  668,  668,  668,  668,  668,  668,  668,  668,  668,
      668,  668,  668,  671, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257,  671,  671,  671, 1257, 1257,  671,  671,  671,
      671,  674,  674, 1257,  674,  674, 1257, 1257, 1257, 1257,
     1257,  674,  674,  674, 1257, 1257,  674,  674,  674,  674,
      928,  928, 1257,  928,  928,  928,  928,  928,  928,  928,
      928,  928,  928,  928,  928,  928,  928,  928,  928,  928,
      928,  928,  928,  928,  928,  928,  928,  928,  930,  930,

      930,  930,  930,  930,  930,  930,  930,  930,  930,  930,
      930,  930,  930,  930,  930,  930,  930,  930,  930,  930,
      930,  930,  930,  930,  930,  930,  685,  685, 1257, 1257,
     1257, 1257, 1257,  685,  685,  685, 1257, 1257,  685,  685,
      685,  685,  690,  690, 1257,  690,  690,  690,  690,  690,
      690,  690,  690,  690,  690,  690,  690,  690,  690,  690,
      690,  690,  690,  690,  690,  690,  690,  690,  690,  690,
      940,  940, 1257,  940,  940,  940,  940,  940,  940,  940,
      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
      940,  940,  940,  940,  940,  940,  940,  940,  699,  699,

     1257, 1257, 1257, 1257, 1257,  699,  699,  699, 1257, 1257,
      699,  699,  699,  699,  703,  703, 1257,  703,  703,  703,
      703,  703,  703,  703,  703,  703,  703,  703,  703,  703,
      703,  703,  703,  703,  703,  703,  703,  703,  703,  703,
      703,  703,  949,  949, 1257,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      712,  712, 1257, 1257, 1257, 1257, 1257,  712,  712,  712,
     1257, 1257,  712,  712,  712,  712,  721,  721, 1257,  721,
      721,  721,  721,  721,  721,  721,  721,  721,  721,  721,

      721,  721,  721,  721,  721,  721,  721,  721,  721,  721,
      721,  721,  721,  721,  957,  957,  957, 1257, 1257,  957,
      957,  957,  957,  958,  958, 1257, 1257, 1257, 1257, 1257,
      958,  958,  958, 1257, 1257,  958,  958,  958,  958,  959,
      959,  959, 1257, 1257,  959,  959,  959,  959,  733,  733,
     1257,  733,  733,  733,  733,  733,  733,  733,  733,  733,
      733,  733,  733,  733,  733,  733,  733,  733,  733,  733,
      733,  733,  733,  733,  733,  733,  964,  964, 1257,  964,
      964,  964,  964,  964,  964,  964,  964,  964,  964,  964,
      964,  964,  964,  964,  964,  964,  964,  964,  964,  964,

      964,  964,  964,  964,  972, 1257,  972, 1257,  972, 1257,
     1257,  972, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
      972,  972,  972, 1257, 1257,  972,  972,  972,  972,  973,
      973, 1257,  973,  973,  973,  973,  973,  973,  973,  973,
      973,  973,  973,  973,  973,  973,  973,  973,  973,  973,
      973,  973,  973,  973,  973,  973,  973,  976,  976, 1257,
      976,  976, 1257,  976,  976,  976,  976,  976,  976,  976,
      976,  976,  976,  976,  976,  976,  976,  976,  976,  976,
      976,  976,  976,  976,  976,  981, 1257, 1257, 1257, 1257,
     1257,  981,  981, 1257,  981,  981, 1257, 1257, 1257, 1257,

     1257,  981,  981,  981, 1257, 1257,  981,  981,  981,  981,
      982,  982,  982, 1257, 1257,  982,  982,  982,  982,  984,
     1257,  984,  984, 1257, 1257, 1257, 1257, 1257,  984,  984,
      984, 1257, 1257,  984,  984,  984,  984,  770,  770, 1257,
     1257, 1257, 1257, 1257,  770,  770,  770, 1257, 1257,  770,
      770,  770,  770,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  784,  784, 1257,  784,  784,  784,  784,  784,  784,
      784,  784,  784,  784,  784,  784,  784,  784,  784,  784,

      784,  784,  784,  784,  784,  784,  784,  784,  784,  787,
      787, 1257,  787,  787,  787,  787,  787,  787,  787,  787,
      787,  787,  787,  787,  787,  787,  787,  787,  787,  787,
      787,  787,  787,  787,  787,  787,  787,  790, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257,  790,  790,  790, 1257,
     1257,  790,  790,  790,  790,  792, 1257, 1257, 1257, 1257,
     1257,  792,  792, 1257,  792,  792, 1257, 1257, 1257, 1257,
     1257,  792,  792,  792, 1257, 1257,  792,  792,  792,  792,
     1002, 1257, 1257, 1257, 1257, 1257, 1002, 1002, 1257, 1002,
     1002, 1257, 1257, 1257, 1257, 1257, 1002, 1002, 1002, 1257,

     1257, 1002, 1002, 1002, 1002,  794, 1257, 1257, 1257, 1257,
     1257,  794,  794, 1257,  794,  794, 1257, 1257, 1257, 1257,
     1257,  794,  794,  794, 1257, 1257,  794,  794,  794,  794,
      795, 1257,  795,  795, 1257, 1257, 1257, 1257, 1257,  795,
      795,  795, 1257, 1257,  795,  795,  795,  795,  426,  426,
     1257,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  799, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257,  799,  799,  799,  799, 1006, 1257, 1257, 1257, 1257,

     1006, 1006, 1257, 1257, 1257, 1257, 1257, 1006, 1257, 1257,
     1257, 1257, 1257, 1006,  803,  803,  803,  803,  803,  803,
      803,  803,  803,  803,  803,  803,  803,  803,  803,  803,
      803,  803,  803,  803,  803,  803,  803,  803,  803,  803,
      803,  803,  808,  808, 1257, 1257, 1257, 1257, 1257,  808,
     1257,  808, 1257, 1257, 1257,  808, 1257,  808,  809,  809,
      809,  809,  809,  809,  809,  809,  809,  809,  809,  809,
      809,  809,  809,  809,  809,  809,  809,  809,  809,  809,
      809,  809,  809,  809,  809,  809,  811,  811,  811,  811,
      811,  811,  811,  811,  811,  811,  811,  811,  811,  811,

      811,  811,  811,  811,  811,  811,  811,  811,  811,  811,
      811,  811,  811,  811,  813,  813, 1257,  813,  813,  813,
      813,  813,  813,  813,  813,  813,  813,  813,  813,  813,
      813,  813,  813,  813,  813,  813,  813,  813,  813,  813,
      813,  813,  815,  815, 1257,  815,  815,  815,  815,  815,
      815,  815,  815,  815,  815,  815,  815,  815,  815,  815,
      815,  815,  815,  815,  815,  815,  815,  815,  815,  815,
     1009, 1257, 1257, 1257, 1257, 1009, 1009, 1257, 1257, 1257,
     1257, 1257, 1009, 1257, 1257, 1257, 1257, 1257, 1009,  820,
      820, 1257,  820,  820,  820,  820,  820,  820,  820,  820,

      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  825,  825, 1257,
     1257, 1257, 1257, 1257,  825, 1257,  825, 1257, 1257, 1257,
      825, 1257,  825, 1012, 1257, 1257, 1257, 1257, 1012, 1012,
     1257, 1257, 1257, 1257, 1257, 1012, 1257, 1257, 1257, 1257,
     1257, 1012,  829,  829, 1257,  829,  829,  829,  829,  829,
      829,  829,  829,  829,  829,  829,  829,  829,  829,  829,
      829,  829,  829,  829,  829,  829,  829,  829,  829,  829,
      834,  834, 1257, 1257, 1257, 1257, 1257,  834, 1257,  834,
     1257, 1257, 1257,  834, 1257,  834, 1015, 1257, 1257, 1257,

     1257, 1015, 1015, 1257, 1257, 1257, 1257, 1257, 1015, 1257,
     1257, 1257, 1257, 1257, 1015,  838,  838, 1257,  838,  838,
      838,  838,  838,  838,  838,  838,  838,  838,  838,  838,
      838,  838,  838,  838,  838,  838,  838,  838,  838,  838,
      838,  838,  838,  843,  843, 1257, 1257, 1257, 1257, 1257,
      843, 1257,  843, 1257, 1257, 1257,  843, 1257,  843,  515,
      515, 1257,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  519,  519, 1257,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,

      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  523,  523, 1257,  523,  523,
      523,  523,  523,  523,  523,  523,  523,  523,  523,  523,
      523,  523,  523,  523,  523,  523,  523,  523,  523,  523,
      523,  523,  523,  525,  525, 1257,  525,  525, 1257, 1257,
     1257, 1257, 1257,  525,  525,  525, 1257, 1257,  525,  525,
      525,  525,  854,  854,  854,  854,  854,  854,  854,  854,
      854,  854,  854,  854,  854,  854,  854,  854,  854,  854,
      854,  854,  854,  854,  854,  854,  854,  854,  854,  854,
      859,  859, 1257, 1257, 1257, 1257, 1257,  859, 1257,  859,

     1257, 1257, 1257,  859, 1257,  859,  861, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257,  861,  861,  861, 1257, 1257,  861,  861,  861,
      861, 1024, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1024, 1024, 1024, 1257, 1257, 1257, 1257, 1024, 1024, 1024,
     1257, 1257, 1024, 1024, 1024, 1024,  545,  545, 1257,  545,
      545,  545,  545,  545,  545,  545,  545,  545,  545,  545,
      545,  545,  545,  545,  545,  545,  545,  545,  545,  545,
      545,  545,  545,  545,  865, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,  865,

      865,  865,  865, 1028, 1257, 1257, 1257, 1257, 1028, 1028,
     1257, 1257, 1257, 1257, 1257, 1028, 1257, 1257, 1257, 1257,
     1257, 1028,  869,  869,  869,  869,  869,  869,  869,  869,
      869,  869,  869,  869,  869,  869,  869,  869,  869,  869,
      869,  869,  869,  869,  869,  869,  869,  869,  869,  869,
      874,  874, 1257, 1257, 1257, 1257, 1257,  874, 1257,  874,
     1257, 1257, 1257,  874, 1257,  874,  876,  876,  876,  876,
      876,  876,  876,  876,  876,  876,  876,  876,  876,  876,
      876,  876,  876,  876,  876,  876,  876,  876,  876,  876,
      876,  876,  876,  876, 1030, 1030, 1257, 1257, 1030, 1257,

     1257, 1030, 1030, 1030, 1257, 1257, 1030, 1030, 1030, 1030,
      880,  880, 1257, 1257, 1257, 1257, 1257,  880,  880,  880,
     1257, 1257,  880,  880,  880,  880, 1032, 1032, 1257, 1257,
     1257, 1257, 1257, 1032, 1032, 1032, 1257, 1032, 1032, 1032,
     1032, 1032,  882,  882,  882,  882,  882,  882,  882,  882,
      882,  882,  882,  882,  882,  882,  882,  882,  882,  882,
      882,  882,  882,  882,  882,  882,  882,  882,  882,  882,
     1033, 1033, 1257, 1257, 1033, 1257, 1257, 1033, 1033, 1033,
     1257, 1257, 1033, 1033, 1033, 1033,  885,  885, 1257, 1257,
     1257, 1257, 1257,  885,  885,  885, 1257, 1257,  885,  885,

      885,  885, 1035, 1035, 1257, 1257, 1257, 1257, 1257, 1035,
     1035, 1035, 1257, 1035, 1035, 1035, 1035, 1035, 1037, 1257,
     1257, 1257, 1257, 1037, 1037, 1257, 1257, 1257, 1257, 1257,
     1037, 1257, 1257, 1257, 1257, 1257, 1037,  890,  890, 1257,
      890,  890,  890,  890,  890,  890,  890,  890,  890,  890,
      890,  890,  890,  890,  890,  890,  890,  890,  890,  890,
      890,  890,  890,  890,  890,  895,  895, 1257, 1257, 1257,
     1257, 1257,  895, 1257,  895, 1257, 1257, 1257,  895, 1257,
      895, 1040, 1257, 1257, 1257, 1257, 1040, 1040, 1257, 1257,
     1257, 1257, 1257, 1040, 1257, 1257, 1257, 1257, 1257, 1040,

      899,  899, 1257,  899,  899,  899,  899,  899,  899,  899,
      899,  899,  899,  899,  899,  899,  899,  899,  899,  899,
      899,  899,  899,  899,  899,  899,  899,  899,  904,  904,
     1257, 1257, 1257, 1257, 1257,  904, 1257,  904, 1257, 1257,
     1257,  904, 1257,  904,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  910,  910, 1257, 1257, 1257, 1257, 1257,  910,
     1257,  910, 1257, 1257, 1257,  910, 1257,  910,  911,  911,
      911,  911,  911,  911,  911,  911,  911,  911,  911,  911,

      911,  911,  911,  911,  911,  911,  911,  911,  911,  911,
      911,  911,  911,  911,  911,  911,  913,  913,  913,  913,
      913,  913,  913,  913,  913,  913,  913,  913,  913,  913,
      913,  913,  913,  913,  913,  913,  913,  913,  913,  913,
      913,  913,  913,  913,  921,  921,  921,  921,  921,  921,
      921,  921,  921,  921,  921,  921,  921,  921,  921,  921,
      921,  921,  921,  921,  921,  921,  921,  921,  921,  921,
      921,  921,  665,  665, 1257,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,

     1052, 1257, 1257, 1257, 1257, 1052, 1052, 1257, 1257, 1257,
     1257, 1257, 1052, 1257, 1257, 1257, 1257, 1257, 1052,  928,
      928, 1257,  928,  928,  928,  928,  928,  928,  928,  928,
      928,  928,  928,  928,  928,  928,  928,  928,  928,  928,
      928,  928,  928,  928,  928,  928,  928,  930,  930,  930,
      930,  930,  930,  930,  930,  930,  930,  930,  930,  930,
      930,  930,  930,  930,  930,  930,  930,  930,  930,  930,
      930,  930,  930,  930,  930, 1059, 1257, 1257, 1257, 1257,
     1059, 1059, 1257, 1257, 1257, 1257, 1257, 1059, 1257, 1257,
     1257, 1257, 1257, 1059,  940,  940, 1257,  940,  940,  940,

      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
      940,  940,  945,  945, 1257, 1257, 1257, 1257, 1257,  945,
     1257,  945, 1257, 1257, 1257,  945, 1257,  945, 1062, 1257,
     1257, 1257, 1257, 1062, 1062, 1257, 1257, 1257, 1257, 1257,
     1062, 1257, 1257, 1257, 1257, 1257, 1062,  949,  949, 1257,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  954,  954, 1257, 1257, 1257,
     1257, 1257,  954, 1257,  954, 1257, 1257, 1257,  954, 1257,

      954,  721,  721, 1257,  721,  721,  721,  721,  721,  721,
      721,  721,  721,  721,  721,  721,  721,  721,  721,  721,
      721,  721,  721,  721,  721,  721,  721,  721,  721, 1066,
     1066, 1257, 1257, 1066, 1257, 1257, 1066, 1066, 1066, 1257,
     1257, 1066, 1066, 1066, 1066,  958,  958, 1257, 1257, 1257,
     1257, 1257,  958,  958,  958, 1257, 1257,  958,  958,  958,
      958, 1068, 1068, 1257, 1257, 1257, 1257, 1257, 1068, 1068,
     1068, 1257, 1068, 1068, 1068, 1068, 1068, 1070, 1257, 1257,
     1257, 1257, 1070, 1070, 1257, 1257, 1257, 1257, 1257, 1070,
     1257, 1257, 1257, 1257, 1257, 1070,  964,  964, 1257,  964,

      964,  964,  964,  964,  964,  964,  964,  964,  964,  964,
      964,  964,  964,  964,  964,  964,  964,  964,  964,  964,
      964,  964,  964,  964,  969,  969, 1257, 1257, 1257, 1257,
     1257,  969, 1257,  969, 1257, 1257, 1257,  969, 1257,  969,
      979, 1257, 1257, 1257, 1257, 1257,  979,  979, 1257,  979,
      979, 1257, 1257, 1257, 1257, 1257,  979,  979,  979, 1257,
     1257,  979,  979,  979,  979,  973,  973, 1257,  973,  973,
      973,  973,  973,  973,  973,  973,  973,  973,  973,  973,
      973,  973,  973,  973,  973,  973,  973,  973,  973,  973,
      973,  973,  973,  976,  976, 1257,  976,  976,  976,  976,

      976,  976,  976,  976,  976,  976,  976,  976,  976,  976,
      976,  976,  976,  976,  976,  976,  976,  976,  976,  976,
      976, 1079, 1257, 1257, 1257, 1257, 1257, 1079, 1079, 1257,
     1079, 1079, 1257, 1257, 1257, 1257, 1257, 1079, 1079, 1079,
     1257, 1257, 1079, 1079, 1079, 1079,  981, 1257, 1257, 1257,
     1257, 1257,  981,  981, 1257,  981,  981, 1257, 1257, 1257,
     1257, 1257,  981,  981,  981, 1257, 1257,  981,  981,  981,
      981, 1080, 1080, 1257, 1257, 1257, 1257, 1257, 1080, 1080,
     1080, 1257, 1080, 1080, 1080, 1080, 1080,  983,  983, 1257,
     1257, 1257, 1257, 1257,  983,  983,  983, 1257, 1257,  983,

      983,  983,  983,  984, 1257,  984,  984, 1257, 1257, 1257,
     1257, 1257,  984,  984,  984, 1257, 1257,  984,  984,  984,
      984, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
     1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
     1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992, 1093, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1093, 1093, 1257, 1257,
     1257, 1257, 1257, 1093, 1093, 1093, 1257, 1257, 1093, 1093,

     1093, 1093,  784,  784, 1257,  784,  784,  784,  784,  784,
      784,  784,  784,  784,  784,  784,  784,  784,  784,  784,
      784,  784,  784,  784,  784,  784,  784,  784,  784,  784,
     1097, 1257, 1257, 1257, 1257, 1097, 1097, 1257, 1257, 1257,
     1257, 1257, 1097, 1257, 1257, 1257, 1257, 1257, 1097,  792,
     1257, 1257, 1257, 1257, 1257,  792,  792, 1257,  792,  792,
     1257, 1257, 1257, 1257, 1257,  792,  792,  792, 1257, 1257,
      792,  792,  792,  792, 1099, 1257, 1257, 1257, 1257, 1257,
     1099, 1099, 1257, 1099, 1099, 1257, 1257, 1257, 1257, 1257,
     1099, 1099, 1099, 1257, 1257, 1099, 1099, 1099, 1099,  426,

      426, 1257,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426, 1102, 1257, 1257,
     1257, 1257, 1102, 1102, 1257, 1257, 1257, 1257, 1257, 1102,
     1257, 1257, 1257, 1257, 1257, 1102, 1103, 1257, 1257, 1257,
     1257, 1103, 1103, 1257, 1257, 1257, 1257, 1257, 1103, 1257,
     1257, 1257, 1257, 1257, 1103, 1104, 1257, 1257, 1257, 1257,
     1104, 1104, 1257, 1257, 1257, 1257, 1257, 1104, 1257, 1257,
     1257, 1257, 1257, 1104, 1105, 1257, 1257, 1257, 1257, 1105,
     1105, 1257, 1257, 1257, 1257, 1257, 1105, 1257, 1257, 1257,

     1257, 1257, 1105,  515,  515, 1257,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  519,  519, 1257,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  525,
      525, 1257,  525,  525, 1257, 1257, 1257, 1257, 1257,  525,
      525,  525, 1257, 1257,  525,  525,  525,  525, 1024, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1024, 1024, 1024,
     1257, 1257, 1257, 1257, 1024, 1024, 1024, 1257, 1257, 1024,

     1024, 1024, 1024,  545,  545, 1257,  545,  545,  545,  545,
      545,  545,  545,  545,  545,  545,  545,  545,  545,  545,
      545,  545,  545,  545,  545,  545,  545,  545,  545,  545,
      545, 1114, 1257, 1257, 1257, 1257, 1114, 1114, 1257, 1257,
     1257, 1257, 1257, 1114, 1257, 1257, 1257, 1257, 1257, 1114,
     1030, 1030, 1257, 1257, 1030, 1257, 1257, 1030, 1030, 1030,
     1257, 1257, 1030, 1030, 1030, 1030,  581, 1257, 1257,  581,
     1257, 1257,  581,  581, 1257, 1257, 1257, 1257, 1257,  581,
      581,  581, 1257, 1257,  581,  581,  581,  581, 1032, 1032,
     1257, 1257, 1257, 1257, 1257, 1032, 1032, 1032, 1257, 1032,

     1032, 1032, 1032, 1032, 1033, 1033, 1257, 1257, 1033, 1257,
     1257, 1033, 1033, 1033, 1257, 1257, 1033, 1033, 1033, 1033,
      592, 1257, 1257,  592, 1257, 1257,  592,  592, 1257, 1257,
     1257, 1257, 1257,  592,  592,  592, 1257, 1257,  592,  592,
      592,  592, 1035, 1035, 1257, 1257, 1257, 1257, 1257, 1035,
     1035, 1035, 1257, 1035, 1035, 1035, 1035, 1035, 1115, 1257,
     1257, 1257, 1257, 1115, 1115, 1257, 1257, 1257, 1257, 1257,
     1115, 1257, 1257, 1257, 1257, 1257, 1115, 1116, 1257, 1257,
     1257, 1257, 1116, 1116, 1257, 1257, 1257, 1257, 1257, 1116,
     1257, 1257, 1257, 1257, 1257, 1116,  665,  665, 1257,  665,

      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665, 1125, 1257, 1257, 1257, 1257, 1125,
     1125, 1257, 1257, 1257, 1257, 1257, 1125, 1257, 1257, 1257,
     1257, 1257, 1125, 1131, 1257, 1257, 1257, 1257, 1131, 1131,
     1257, 1257, 1257, 1257, 1257, 1131, 1257, 1257, 1257, 1257,
     1257, 1131, 1132, 1257, 1257, 1257, 1257, 1132, 1132, 1257,
     1257, 1257, 1257, 1257, 1132, 1257, 1257, 1257, 1257, 1257,
     1132,  721,  721, 1257,  721,  721,  721,  721,  721,  721,
      721,  721,  721,  721,  721,  721,  721,  721,  721,  721,

      721,  721,  721,  721,  721,  721,  721,  721,  721, 1066,
     1066, 1257, 1257, 1066, 1257, 1257, 1066, 1066, 1066, 1257,
     1257, 1066, 1066, 1066, 1066,  728, 1257, 1257,  728, 1257,
     1257,  728,  728, 1257, 1257, 1257, 1257, 1257,  728,  728,
      728, 1257, 1257,  728,  728,  728,  728, 1068, 1068, 1257,
     1257, 1257, 1257, 1257, 1068, 1068, 1068, 1257, 1068, 1068,
     1068, 1068, 1068, 1135, 1257, 1257, 1257, 1257, 1135, 1135,
     1257, 1257, 1257, 1257, 1257, 1135, 1257, 1257, 1257, 1257,
     1257, 1135, 1138, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1138, 1138, 1257, 1257, 1257, 1257, 1257, 1138, 1138,

     1138, 1257, 1257, 1138, 1138, 1138, 1138,  973,  973, 1257,
      973,  973,  973,  973,  973,  973,  973,  973,  973,  973,
      973,  973,  973,  973,  973,  973,  973,  973,  973,  973,
      973,  973,  973,  973,  973, 1142, 1257, 1257, 1257, 1257,
     1142, 1142, 1257, 1257, 1257, 1257, 1257, 1142, 1257, 1257,
     1257, 1257, 1257, 1142,  979, 1257, 1257, 1257, 1257, 1257,
      979,  979, 1257,  979,  979, 1257, 1257, 1257, 1257, 1257,
      979,  979,  979, 1257, 1257,  979,  979,  979,  979, 1145,
     1257, 1257, 1257, 1257, 1257, 1145, 1145, 1257, 1145, 1145,
     1257, 1257, 1257, 1257, 1145, 1145, 1145, 1145, 1257, 1257,

     1145, 1145, 1145, 1145, 1080, 1080, 1257, 1257, 1257, 1257,
     1257, 1080, 1080, 1080, 1257, 1080, 1080, 1080, 1080, 1080,
      981, 1257, 1257, 1257, 1257, 1257,  981,  981, 1257,  981,
      981, 1257, 1257, 1257, 1257, 1257,  981,  981,  981, 1257,
     1257,  981,  981,  981,  981, 1087, 1087, 1087, 1087, 1087,
     1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
     1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
     1087, 1087, 1087, 1093, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1093, 1093, 1257, 1257, 1257, 1257, 1257, 1093,
     1093, 1093, 1257, 1257, 1093, 1093, 1093, 1093, 1156, 1156,

     1257, 1257, 1257, 1257, 1257, 1156, 1156, 1156, 1257, 1257,
     1156, 1156, 1156, 1156,  784,  784, 1257,  784,  784,  784,
      784,  784,  784,  784,  784,  784,  784,  784,  784,  784,
      784,  784,  784,  784,  784,  784,  784,  784,  784,  784,
      784,  784, 1159, 1257, 1257, 1257, 1257, 1159, 1159, 1257,
     1257, 1257, 1257, 1257, 1159, 1257, 1257, 1257, 1257, 1257,
     1159,  792, 1257, 1257, 1257, 1257, 1257,  792,  792, 1257,
      792,  792, 1257, 1257, 1257, 1257, 1257,  792,  792,  792,
     1257, 1257,  792,  792,  792,  792, 1099, 1257, 1257, 1257,
     1257, 1257, 1099, 1099, 1257, 1099, 1099, 1257, 1257, 1257,

     1257, 1257, 1099, 1099, 1099, 1257, 1257, 1099, 1099, 1099,
     1099,  426,  426, 1257,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  515,
      515, 1257,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  519,  519, 1257,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  525,  525, 1257,  525,  525,

     1257, 1257, 1257, 1257, 1257,  525,  525,  525, 1257, 1257,
      525,  525,  525,  525,  545,  545, 1257,  545,  545,  545,
      545,  545,  545,  545,  545,  545,  545,  545,  545,  545,
      545,  545,  545,  545,  545,  545,  545,  545,  545,  545,
      545,  545, 1173, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1173, 1173, 1257, 1257, 1257, 1257, 1173, 1173, 1173,
     1173, 1257, 1257, 1173, 1173, 1173, 1173, 1176, 1257, 1257,
     1257, 1257, 1176, 1176, 1257, 1257, 1257, 1257, 1257, 1176,
     1257, 1257, 1257, 1257, 1257, 1176,  522,  522, 1257,  522,
      522, 1257, 1257, 1257, 1257, 1257,  522,  522,  522, 1257,

     1257,  522,  522,  522,  522, 1002, 1257, 1257, 1257, 1257,
     1257, 1002, 1002, 1257, 1002, 1002, 1257, 1257, 1257, 1257,
     1257, 1002, 1002, 1002, 1257, 1257, 1002, 1002, 1002, 1002,
     1079, 1257, 1257, 1257, 1257, 1257, 1079, 1079, 1257, 1079,
     1079, 1257, 1257, 1257, 1257, 1257, 1079, 1079, 1079, 1257,
     1257, 1079, 1079, 1079, 1079,   71, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,

     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257
    } ;

static const flex_int16_t yy_chk[11028] =
    {   0,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    4,   19,   19,  683,   19,  683,    4,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,

        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,

       15,   15,   15,   15,   17,   17,   28,   43,   18,   18,
       20,   20,   28,   20,   60,   89,   89,   43,  105,  105,
       60,   17,   17,   17,   17,   18,   18,   18,   18,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   25,   25,   44,   26,   26,   45,   46,   47,   48,
       47,   48,   49,   44,   50,   62,   45,   46,   68,   70,
       76,   62,   68,   70,   68,   70,   82,   83,   90,  523,

       97,   91,   83,   91,   91,   91,   91,   94,  523,   90,
       90,  106,  106,   94,   98,  346,   47,   48,  441,   98,
       49,  346,   50,   82,  103,  109,   76,   97,   91,  103,
      109,  119, 1256,  123,  147,  147,  119,   25,  123,   25,
       26,  441,   26,   27,   27,   27,   27,   27,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   27,   27,

       27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
       27,   27,   27,   27,   29,   29,   29,   29,   29,   29,
       29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
       29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
       29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
       29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
       29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
       29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
       29,   29,   29,   29,   29,   31,   31,   31,   31,   31,
       31,   31,   31,   31,   31,   31,   31,   31,   31,   31,

       31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
       31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
       31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
       31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
       31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
       31,   31,   31,   31,   31,   31,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,

       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   37,   38,   77,
      354,   77,  195,  130,  205,   77,  354,   77,  130,   77,
       84,   84,   84,   84,   85,   85,   85,   85,  224,  134,
      141,  145,  169,   84,  134,  141,  145,   85,   84,  195,
       84,  205,   85,  162,  162,   37,   38,   37,   38,  151,
      151,  151,  151,  169,  163,  224,   84,  177,   77,  781,
       85,  781,  177, 1254,   84,  163,  163,   84,   85,  214,
      214,  244,  244,   37,   38,   37,   38,   39,   39,   39,

       39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   41,   41,
       41,   41,   41,   41,   41,   41,   41,   41,   41,   41,
       41,   41,   41,   41,   41,   41,   41,   41,   41,   41,
       41,   41,   41,   41,   41,   41,   41,   41,   41,   41,

       41,   41,   41,   41,   41,   41,   41,   41,   41,   41,
       41,   41,   41,   41,   41,   41,   41,   41,   41,   41,
       41,   41,   41,   41,   41,   41,   41,   41,   41,   41,
       41,   41,   41,   41,   41,   41,   41,   41,   41,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   55,   55,   55,   55,   55,   55,   55,   55,   55,
       55,   55,   55,   55,   55,   55,   55,   55,   55,   55,

       55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
       55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
       55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
       55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
       55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
       55,   55,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,

       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   59,   59,   59,   59,   59,   59,   59,
       59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
       59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
       59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
       59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
       59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
       59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
       59,   59,   59,   59,   61,   61,   61,   61,   61,   61,

       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,

       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,

       65,   65,   65,   65,   65,   65,   65,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   69,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,

       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   95,
      155,  120,  120,  120,  120,  159,  165,  165, 1249,  184,
       95,  450,   95,  197,  120,  234,   95,  450,   95,  120,
       95,  120,  121,  121,  121,  121,  131,  131,  131,  131,
      184,  164,  164,  206,  263,  121,  155,  120,  206,  131,
      121,  159,  269,  269,  131,  120,  131,  165,  120,  197,

      132,  132,  132,  132,  142,  142,  142,  142,  121,   95,
      164,  263,  131,  132,  230, 1244,  121,  142,  132,  230,
      131,  418,  142,  131,  142,  143,  143,  143,  143,  178,
      178,  178,  178,  234,  215,  221,  132,  273,  143,  418,
      142,  221,  178,  143,  132,  215,  215,  178,  142,  178,
      388,  142,  483,  179,  179,  179,  179,  207,  207,  207,
      207,  143,  221,  238,  273,  178,  179,  388,  238,  143,
      207,  179,  198,  178,  198,  207,  178,  207,  198,  242,
      198,  198,  198,  483,  242,  208,  208,  208,  208,  179,
      250,  254, 1243,  207,  264,  250,  254,  179,  208,  264,

      393,  207, 1242,  208,  207,  218,  222,  218,  218,  218,
      218,  270,  393,  270,  270,  270,  270,  222,  675,  222,
      327,  208,  226,  222,  675,  222,  222,  222,  274,  208,
      236,  226,  218,  274,  226,  226,  226,  226,  270,  236,
      226,  327,  236,  236,  236,  236,  279,  279,  236,  239,
      239,  239,  239,  298,  298,  226,  341,  413,  240,  240,
      240,  240,  239,  236,  326,  300,  785,  239,  305,  239,
      300,  240,  586,  305,  343,  385,  240,  251,  251,  251,
      251,  785,  311,  326,  326,  239,  252,  252,  252,  252,
      251,  655,  341,  239,  240,  251,  239,  251,  655,  252,

      413,  343,  240,  311,  252,  265,  265,  265,  265,  395,
     1089,  385,  434,  251,  266,  266,  266,  266,  265,  395,
      395,  251,  252,  265,  251,  265,  319,  266,  402,  402,
      252,  319,  266,  275,  275,  275,  275,  404,  404,  434,
      586,  265,  276,  276,  276,  276,  275, 1241,  311,  265,
      266,  275,  265,  275,  335,  276, 1089,  344,  266,  335,
      276,  280,  344,  280,  280,  280,  280,  445,  445,  275,
      351,  320,  320,  320,  320,  351,  363,  275,  276,  416,
      275,  363,  367,  416,  320,  416,  276,  367,  280,  320,
      352,  320,  321,  321,  321,  321, 1237,  352,  375,  379,

      686,  352,  352,  375,  379,  321,  686,  320,  419,  426,
      321,  364,  364,  364,  364,  320,  448,  448,  320,  453,
      365,  365,  365,  365,  364, 1236,  417,  408,  321,  364,
      397,  364,  408,  365,  515,  397,  321,  479,  365,  376,
      376,  376,  376,  397,  419,  426,  453,  364,  377,  377,
      377,  377,  376,  462,  462,  364,  365,  376,  364,  376,
      479,  377,  464,  464,  365,  421,  377,  380,  380,  421,
      515,  380,  417,  417,  529,  376,  386,  417,  510,  510,
      428,  428,  428,  376,  377,  386,  376,  492,  386,  386,
      386,  386,  377,  422,  386,  529,  421,  380,  398,  398,

      398,  398,  399,  399,  399,  399,  543,  422,  422,  386,
      492,  398,  496,  509,  423,  399,  398,  423,  398, 1234,
      399,  424,  423,  424,  424,  424,  424,  428,  423,  423,
      433,  433,  433,  543,  398,  473,  473,  473,  399,  524,
      524, 1233,  398,  496,  509,  398,  399,  406,  424,  524,
      406,  519,  406,  525,  525,  406,  438,  438,  438,  438,
     1232,  406,  406,  440,  406,  406,  406,  406,  440,  438,
      439,  439,  439,  439,  438,  505,  449,  433,  449,  449,
      449,  449,  473,  439,  554,  406,  440,  519,  439,  406,
      526,  540,  438,  406,  440,  486,  486,  486,  505,  478,

      438,  537,  541,  449,  478,  406,  439,  476,  476,  476,
      476,  554,  540,  406,  439,  406,  477,  477,  477,  477,
      476, 1230,  478,  541,  537,  476,  526,  491,  861,  477,
      478,  561,  491, 1225,  477,  489,  489,  489,  489,  499,
      499,  499,  486,  476,  490,  490,  490,  490,  489,  861,
      491,  476,  477,  489,  561,  567,  567,  490,  491,  601,
      477,  616,  490,  502,  502,  502,  502,  513,  513,  513,
      513,  489,  503,  503,  503,  503,  502, 1090,  504,  489,
      490,  502,  601,  504,  616,  503,  499, 1224,  490,  545,
      503,  517,  517,  517,  521,  521,  521,  528,  528,  502,

      575,  504,  527,  527,  547,  547,  547,  502,  503,  504,
      534,  534,  534,  534,  570,  570,  503,  535,  535,  535,
      535,  536, 1090,  534,  605,  545,  536,  575,  534, 1222,
      535,  552,  552,  552,  528,  535,  606,  606,  517,  620,
      560,  521, 1154,  527,  536,  560,  534,  558,  558,  558,
      558,  547,  536,  535,  534,  605,  559,  559,  559,  559,
      558,  535,  572,  560, 1221,  558, 1220,  630,  572,  559,
      620,  560,  633,  633,  559,  635,  635,  571,  552,  571,
      571,  571,  571,  558,  578,  578,  578,  578, 1154,  572,
      630,  558,  559,  579,  579,  579,  579,  595,  595,  595,

      559,  610,  610,  610,  571,  589,  589,  589,  589,  590,
      590,  590,  590,  598,  598,  598,  598,  599,  599,  599,
      599,  645,  645,  600,  623, 1217,  598,  701,  600,  615,
      599,  598,  670,  697,  615,  599, 1153,  613,  613,  613,
      613, 1212,  665,  714,  595, 1211,  600,  710,  610,  598,
      613,  623,  615,  599,  600,  613,  697,  598,  701,  670,
      615,  599,  614,  614,  614,  614,  627,  627,  627,  627,
      710,  656,  629,  613,  714,  614,  763,  629,  665,  627,
      614,  613,  748, 1153,  627,  721,  628,  628,  628,  628,
      763,  763,  656,  756, 1210,  629,  756, 1209,  614,  628,

     1208,  756,  627,  629,  628,  748,  614,  757,  756,  636,
      627,  636,  636,  636,  636,  667,  667,  667,  669,  669,
      669,  721,  628,  691,  691,  691,  704,  704,  704, 1204,
      628,  694,  694,  694,  694,  756,  636,  656,  695,  695,
      695,  695,  789,  757,  694,  696,  723,  723,  723,  694,
      696,  695,  725,  725,  725,  725,  695,  772,  709,  734,
      734,  734,  667,  709,  989,  669, 1201,  694,  696,  789,
      691,  771,  989,  704,  695,  694,  696,  707,  707,  707,
      707,  709,  695,  708,  708,  708,  708,  747,  772,  709,
      707,  805,  747,  723,  790,  707,  708,  726,  726,  726,

      726,  708,  745,  745,  745,  745,  734,  771,  776,  790,
      747,  807,  776,  707,  776,  745,  777,  805,  747,  708,
      745,  707,  746,  746,  746,  746,  779,  708,  760,  760,
      760,  760,  784,  761,  807,  746,  761, 1196,  745,  766,
      746,  761,  762,  762,  762,  762,  745,  765,  761,  765,
      765,  765,  765,  766,  766,  767,  791,  822,  746,  786,
      786,  786,  777,  777,  831,  824,  746,  777,  784,  767,
      767,  791,  779,  779,  765,  761,  792,  779,  788,  788,
      788,  793, 1195,  822,  848,  848,  766,  808,  824,  794,
      831,  792,  808,  795, 1194,  793,  793,  840,  793,  793,

      793,  793,  767,  794,  794,  797,  786,  795,  795,  796,
      808,  796,  796,  796,  796,  833, 1193,  801,  808,  797,
      797,  797,  818,  840,  825,  788,  801,  801,  801,  825,
      834,  818,  818,  818,  827,  834,  796,  842,  833,  836,
      856,  797,  798,  827,  827,  827,  843,  825,  836,  836,
      836,  843,  858,  834, 1192,  825,  798,  798,  798,  798,
      842,  834,  851,  851, 1191,  844,  856,  798,  859,  843,
      852,  852,  871,  859,  846,  858,  994,  843,  798,  844,
      844,  844,  798,  798,  798,  798,  798,  798,  846,  846,
      846,  859,  863,  994,  994,  994,  994, 1190,  871,  859,

      873,  844,  845,  892,  851,  901,  863,  863,  863,  874,
      846,  867,  852,  894,  874,  888,  845,  845,  845,  845,
      867,  867,  867,  873,  888,  888,  888,  845,  863,  892,
      895,  901,  874,  903,  907,  895,  894, 1024,  845, 1189,
      874,  897,  845,  845,  845,  845,  845,  845,  847,  904,
      897,  897,  897,  895,  904,  909,  903, 1187, 1024,  926,
      907,  895,  847,  847,  847,  847,  938,  923,  926,  926,
      926, 1184,  904,  847,  910,  938,  938,  938,  909,  910,
      904,  923,  923,  923,  847, 1182,  942, 1181,  847,  847,
      847,  847,  847,  847,  864,  944,  951,  910,  953, 1176,

      966,  945,  954,  923,  947,  910,  945,  954,  864,  864,
      864,  864,  942,  947,  947,  947,  972,  973,  944,  864,
     1120,  953,  951,  968,  945,  954,  966,  955, 1120,  974,
      864,  972,  945,  954,  864,  864,  864,  864,  864,  864,
      924,  955,  955,  955,  974, 1171,  968,  969, 1138,  961,
     1111, 1111,  969,  973,  924,  924,  924,  924,  961,  961,
      961, 1170,  978,  955,  979,  924,  975,  975,  975, 1169,
      969,  977,  977,  977,  980, 1138,  924,  978,  969,  979,
      924,  924,  924,  924,  924,  924,  956,  991,  980,  980,
      981,  980,  980,  980,  980,  984, 1021, 1021, 1172, 1168,

      956,  956,  956,  956,  981,  981,  986, 1100,  997,  984,
      984,  956,  985,  975,  985,  985,  985,  985,  977,  987,
      986,  986,  956,  997, 1167, 1172,  956,  956,  956,  956,
      956,  956,  991,  987,  987,  998, 1173, 1021,  995,  985,
     1000,  991, 1166, 1100,  998,  998,  998, 1001, 1219, 1219,
     1165,  986,  995,  995,  995, 1000, 1002, 1000, 1000, 1000,
     1000, 1081, 1001, 1173, 1001, 1001, 1001, 1001, 1101, 1003,
     1002, 1002, 1022, 1022,  995, 1081, 1081, 1005, 1001, 1017,
     1008,  987,  996, 1003, 1003, 1003, 1005, 1005, 1005, 1008,
     1008, 1008, 1011, 1017, 1017, 1017,  996,  996,  996,  996,

     1014, 1011, 1011, 1011, 1101, 1003, 1099,  996, 1164, 1014,
     1014, 1014, 1106, 1022, 1163, 1017, 1019, 1081,  996, 1025,
     1099, 1099,  996,  996,  996,  996,  996,  996, 1004, 1027,
     1019, 1019, 1019, 1025, 1025, 1025, 1079, 1162, 1027, 1027,
     1027, 1159, 1004, 1004, 1004, 1004, 1155, 1031, 1106, 1107,
     1079, 1079, 1019, 1004, 1152, 1025, 1031, 1151, 1150, 1031,
     1031, 1031, 1031, 1079, 1004, 1142, 1036, 1049, 1004, 1004,
     1004, 1004, 1004, 1004, 1018, 1036, 1036, 1036, 1135, 1132,
     1031, 1049, 1049, 1049, 1039, 1107, 1183, 1051, 1018, 1018,
     1018, 1018, 1034, 1039, 1039, 1039, 1051, 1051, 1051, 1018,

     1131, 1034, 1058, 1049, 1034, 1034, 1034, 1034, 1064, 1072,
     1018, 1058, 1058, 1058, 1018, 1018, 1018, 1018, 1018, 1018,
     1020, 1061, 1064, 1064, 1064, 1034, 1072, 1072, 1072, 1072,
     1061, 1061, 1061, 1183, 1020, 1020, 1020, 1020, 1067, 1271,
     1271, 1271, 1130, 1129, 1064, 1020, 1128, 1067, 1069, 1108,
     1067, 1067, 1067, 1067, 1073, 1091, 1020, 1069, 1069, 1069,
     1020, 1020, 1020, 1020, 1020, 1020, 1026, 1075, 1073, 1073,
     1073, 1067, 1091, 1091, 1091, 1091, 1075, 1075, 1075, 1077,
     1026, 1026, 1026, 1026, 1127, 1108, 1340, 1340, 1340, 1082,
     1073, 1026, 1186, 1186, 1077, 1126, 1077, 1077, 1077, 1077,

     1078, 1098, 1026, 1082, 1082, 1125, 1026, 1026, 1026, 1026,
     1026, 1026, 1050, 1109, 1112, 1078, 1098, 1078, 1078, 1078,
     1078, 1186, 1092, 1092, 1092, 1092, 1050, 1050, 1050, 1050,
     1096, 1078, 1113, 1098, 1123, 1082, 1092, 1050, 1119, 1096,
     1096, 1096, 1110, 1110, 1124, 1082, 1094, 1136, 1050, 1109,
     1112, 1133, 1050, 1050, 1050, 1050, 1050, 1050, 1065, 1134,
     1094, 1094, 1094, 1148, 1136, 1136, 1136, 1136, 1113, 1218,
     1123, 1117, 1065, 1065, 1065, 1065, 1139, 1148, 1148, 1110,
     1124, 1157, 1094, 1065, 1218, 1161, 1161, 1133, 1158, 1174,
     1139, 1139, 1139, 1116, 1065, 1134, 1141, 1175, 1065, 1065,

     1065, 1065, 1065, 1065, 1074, 1141, 1141, 1141, 1137, 1137,
     1137, 1137, 1139, 1147, 1148, 1144, 1161, 1157, 1074, 1074,
     1074, 1074, 1137, 1143, 1158, 1174, 1160, 1147, 1147, 1074,
     1144, 1115, 1114, 1175, 1379, 1379, 1379, 1178, 1143, 1149,
     1074, 1160, 1144, 1145, 1074, 1074, 1074, 1074, 1074, 1074,
     1095, 1178, 1178, 1149, 1149, 1143, 1105, 1145, 1145, 1179,
     1160, 1104, 1180, 1185, 1095, 1095, 1095, 1095, 1177, 1197,
     1145, 1147, 1226, 1179, 1179, 1095, 1180, 1180, 1185, 1103,
     1178, 1203, 1203, 1177, 1197, 1102, 1095, 1226, 1097, 1198,
     1095, 1095, 1095, 1095, 1095, 1095, 1140, 1149, 1087, 1185,

     1199, 1202, 1177, 1198, 1198, 1197, 1086, 1085, 1180, 1200,
     1140, 1140, 1140, 1140, 1199, 1199, 1202, 1179, 1213, 1084,
     1203, 1140, 1083, 1200, 1200, 1080, 1076, 1070, 1214, 1068,
     1066, 1215, 1140, 1213, 1202, 1062, 1140, 1140, 1140, 1140,
     1140, 1140, 1214, 1214, 1216, 1215, 1215, 1199, 1227, 1198,
     1228, 1213, 1229, 1059, 1231, 1057, 1200, 1056, 1216, 1216,
     1055, 1240, 1227, 1227, 1228, 1228, 1229, 1229, 1231, 1231,
     1238, 1231, 1231, 1231, 1231, 1214, 1215, 1239, 1240, 1240,
     1240, 1240, 1246, 1054, 1238, 1238, 1245, 1238, 1238, 1238,
     1238, 1239, 1239, 1253, 1247, 1053, 1246, 1246, 1252, 1052,

     1048, 1047, 1216, 1245, 1245, 1245, 1245, 1253, 1253, 1255,
     1228, 1247, 1247, 1247, 1247, 1252, 1252, 1252, 1252, 1294,
     1294, 1294, 1294, 1255, 1255, 1046, 1339, 1339, 1239, 1354,
     1354, 1045, 1044, 1339, 1358, 1358, 1354, 1043, 1246, 1339,
     1040, 1358, 1354, 1037, 1035, 1033, 1032, 1358, 1253, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1259, 1259, 1259,
     1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259,
     1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259,

     1259, 1259, 1259, 1259, 1259, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1261, 1261, 1261, 1261, 1261, 1261, 1261,
     1261, 1261, 1261, 1261, 1261, 1261, 1261, 1261, 1261, 1261,
     1261, 1261, 1261, 1261, 1261, 1261, 1261, 1261, 1261, 1261,
     1261, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1263,
     1263, 1263, 1263, 1263, 1263, 1263, 1263, 1263, 1263, 1263,

     1263, 1263, 1263, 1263, 1263, 1263, 1263, 1263, 1263, 1263,
     1263, 1263, 1263, 1263, 1263, 1263, 1263, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,

     1266, 1267, 1267, 1030, 1267, 1267, 1267, 1267, 1267, 1267,
     1267, 1267, 1267, 1267, 1267, 1267, 1267, 1267, 1267, 1267,
     1267, 1267, 1267, 1267, 1267, 1267, 1267, 1267, 1267, 1268,
     1028, 1015, 1268, 1268, 1012, 1268, 1009, 1006,  999,  992,
      990,  988, 1268, 1268, 1268, 1268, 1269, 1269,  982, 1269,
     1269,  976, 1269, 1269, 1269, 1269, 1269, 1269, 1269, 1269,
     1269, 1269, 1269, 1269, 1269, 1269, 1269, 1269, 1269, 1269,
     1269, 1269, 1269, 1269, 1270,  965,  964,  962,  959,  957,
      950,  949,  948, 1270, 1270, 1270,  941,  940, 1270, 1270,
     1270, 1270, 1272, 1272,  939, 1272, 1272,  936,  935, 1362,

     1362,  934, 1272, 1272, 1272,  933, 1362, 1272, 1272, 1272,
     1272, 1273, 1362, 1273, 1273,  932,  930, 1369, 1369,  929,
     1273, 1273, 1273,  928, 1369, 1273, 1273, 1273, 1273, 1274,
     1369,  927,  921,  920,  919,  918,  917,  916, 1274, 1274,
     1274,  915,  913, 1274, 1274, 1274, 1274, 1275, 1275,  911,
     1275, 1275,  905,  900,  899,  898,  891, 1275, 1275, 1275,
      890,  889, 1275, 1275, 1275, 1275, 1276, 1276,  886,  884,
      882,  881,  879, 1276, 1276, 1276,  876,  869, 1276, 1276,
     1276, 1276, 1277, 1277,  868,  860,  854,  850,  839, 1277,
     1277, 1277,  838,  837, 1277, 1277, 1277, 1277, 1278, 1278,

      830, 1278, 1278,  829, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1279, 1279,  828,  821,
      820,  819,  816, 1279, 1279, 1279,  815,  814, 1279, 1279,
     1279, 1279, 1280, 1280,  813, 1280, 1280,  811, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1281, 1281,  809,  803,  802,  787,  783, 1281, 1281, 1281,
      782,  780, 1281, 1281, 1281, 1281, 1282, 1282,  778, 1282,
     1282,  759, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,

     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1283, 1283,  755,  751,  743,  740,
      733, 1283, 1283, 1283,  719,  706, 1283, 1283, 1283, 1283,
     1284, 1284,  703, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1285, 1285,
      702, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
     1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
     1285, 1285, 1285, 1285, 1285, 1285, 1286, 1286,  693, 1286,
     1286,  690,  689,  687,  684,  682, 1286, 1286, 1286,  681,

      680, 1286, 1286, 1286, 1286, 1287, 1287,  678, 1287, 1287,
     1287, 1287, 1287, 1287,  676, 1287, 1287, 1287, 1287, 1287,
     1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
     1287, 1287, 1287, 1288, 1288,  673, 1288, 1288,  668,  664,
     1378, 1378,  662, 1288, 1288, 1288,  660, 1378, 1288, 1288,
     1288, 1288, 1289, 1378,  659,  658,  652,  651, 1394, 1394,
      648, 1289, 1289, 1289,  644, 1394,  626,  622, 1289, 1289,
     1289, 1394,  621, 1289, 1289, 1289, 1289, 1290, 1290,  612,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,

     1290, 1290, 1290, 1290, 1290, 1291,  609,  608, 1291, 1291,
     1291, 1291,  597,  594,  584,  576,  574,  573, 1291, 1291,
     1291, 1292, 1292,  563, 1292, 1292,  557, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1293,
      551,  544,  542,  539,  533,  531,  530,  518, 1293, 1293,
     1293,  514,  512, 1293, 1293, 1293, 1293, 1295, 1295,  501,
     1295, 1295,  498,  497, 1398, 1398,  488, 1295, 1295, 1295,
      485, 1398, 1295, 1295, 1295, 1295, 1296, 1398, 1296, 1296,
      484,  475, 1403, 1403,  472, 1296, 1296, 1296,  470, 1403,

     1296, 1296, 1296, 1296, 1297, 1403,  468, 1297, 1425, 1425,
     1297, 1297,  466, 1297,  460, 1425,  458, 1297, 1297, 1297,
      456, 1425, 1297, 1297, 1297, 1297, 1298, 1298,  452,  451,
     1429, 1429,  437, 1298, 1298, 1298,  432, 1429, 1298, 1298,
     1298, 1298, 1299, 1429,  425, 1299, 1437, 1437, 1299, 1299,
      420, 1299,  411, 1437,  403, 1299, 1299, 1299,  400, 1437,
     1299, 1299, 1299, 1299, 1300, 1300,  396, 1300, 1300,  392,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1301, 1301,  389,  387,  384,  382,  371, 1301,

     1301, 1301,  369,  359, 1301, 1301, 1301, 1301, 1302, 1302,
      357, 1302, 1302,  355, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1303, 1303,  349,  347,
      342,  339,  322, 1303, 1303, 1303,  318,  309, 1303, 1303,
     1303, 1303, 1304,  308,  306,  295,  293,  286,  283,  272,
      261, 1304, 1304, 1304,  255,  249, 1304, 1304, 1304, 1304,
     1305, 1305,  247, 1305, 1305,  237,  213,  211,  204,  199,
     1305, 1305, 1305,  190,  180, 1305, 1305, 1305, 1305, 1306,
      176, 1306, 1306,  161,  157,  153,  149,  140, 1306, 1306,

     1306,  138,  129, 1306, 1306, 1306, 1306, 1307, 1307,  127,
     1307, 1307, 1307,  118, 1307, 1307, 1307, 1307, 1307, 1307,
     1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307,
     1307, 1307, 1307, 1307, 1307, 1308, 1308,  117, 1308, 1308,
     1308,  114, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1309, 1309,  108,  101, 1309, 1309, 1309,
     1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,
     1309, 1309, 1309,   78, 1309, 1309, 1309, 1309, 1309, 1309,
     1309, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,

     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1311,
     1311,   74,   71,    0,    0,    0, 1311, 1311, 1311,    0,
        0, 1311, 1311, 1311, 1311, 1312, 1312,    0,    0,    0,
        0,    0, 1312, 1312, 1312,    0,    0, 1312, 1312, 1312,
     1312, 1313, 1313,    0,    0,    0,    0,    0, 1313, 1313,
     1313,    0,    0, 1313, 1313, 1313, 1313, 1314, 1314,    0,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1315, 1315,    0, 1315, 1315,

        0, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315,
     1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315,
     1315, 1315, 1315, 1316,    0,    0,    0,    0,    0,    0,
        0,    0, 1316, 1316, 1316,    0,    0, 1316, 1316, 1316,
     1316, 1317, 1317,    0, 1317, 1317,    0,    0,    0,    0,
        0, 1317, 1317, 1317,    0,    0, 1317, 1317, 1317, 1317,
     1318, 1318,    0,    0,    0,    0,    0, 1318, 1318, 1318,
        0,    0, 1318, 1318, 1318, 1318, 1319, 1319,    0, 1319,
     1319,    0, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
     1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,

     1319, 1319, 1319, 1319, 1320, 1320,    0,    0,    0,    0,
        0, 1320, 1320, 1320,    0,    0, 1320, 1320, 1320, 1320,
     1321, 1321,    0, 1321, 1321,    0, 1321, 1321, 1321, 1321,
     1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
     1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1322, 1322,
        0,    0,    0,    0,    0, 1322, 1322, 1322,    0,    0,
     1322, 1322, 1322, 1322, 1323, 1323,    0, 1323, 1323, 1323,
     1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,
     1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,
     1323, 1323, 1324,    0,    0, 1324,    0,    0, 1324, 1324,

        0, 1324,    0,    0,    0, 1324, 1324, 1324,    0,    0,
     1324, 1324, 1324, 1324, 1325, 1325,    0, 1325, 1325,    0,
     1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325,
     1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325,
     1325, 1325, 1326,    0, 1326, 1326, 1326,    0, 1326, 1326,
        0, 1326, 1326,    0,    0,    0,    0,    0, 1326, 1326,
     1326,    0,    0, 1326, 1326, 1326, 1326, 1326, 1326, 1327,
     1327,    0,    0,    0,    0,    0, 1327, 1327, 1327,    0,
        0, 1327, 1327, 1327, 1327, 1328, 1328,    0, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,

     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1329, 1329,    0, 1329, 1329,    0, 1329,
     1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329,
     1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329,
     1329, 1330,    0, 1330,    0,    0,    0,    0,    0,    0,
        0,    0, 1330, 1330, 1330,    0,    0, 1330, 1330, 1330,
     1330, 1331,    0,    0,    0,    0,    0, 1331, 1331,    0,
     1331, 1331,    0,    0,    0,    0,    0, 1331, 1331, 1331,
        0,    0, 1331, 1331, 1331, 1331, 1332,    0, 1332, 1332,
        0,    0,    0,    0,    0, 1332, 1332, 1332,    0,    0,

     1332, 1332, 1332, 1332, 1333, 1333,    0, 1333, 1333, 1333,
     1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333,
     1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333,
     1333, 1333, 1334,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 1334, 1334, 1334,
     1334, 1335, 1335,    0, 1335, 1335, 1335, 1335, 1335, 1335,
     1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335,
     1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1336,
        0,    0,    0,    0,    0,    0,    0,    0, 1336, 1336,
     1336,    0,    0, 1336, 1336, 1336, 1336, 1337, 1337,    0,

     1337, 1337,    0,    0,    0,    0,    0, 1337, 1337, 1337,
        0,    0, 1337, 1337, 1337, 1337, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1341, 1341,    0, 1341, 1341,    0,
        0,    0,    0,    0, 1341, 1341, 1341,    0,    0, 1341,
     1341, 1341, 1341, 1342, 1342,    0,    0,    0,    0,    0,
     1342, 1342, 1342,    0,    0, 1342, 1342, 1342, 1342, 1343,
        0, 1343, 1343,    0,    0,    0,    0,    0, 1343, 1343,
     1343,    0,    0, 1343, 1343, 1343, 1343, 1344, 1344, 1344,

     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1345,    0,    0,    0,    0,
        0,    0,    0,    0, 1345, 1345, 1345,    0,    0, 1345,
     1345, 1345, 1345, 1346, 1346,    0, 1346, 1346,    0,    0,
        0,    0,    0, 1346, 1346, 1346,    0,    0, 1346, 1346,
     1346, 1346, 1347, 1347, 1347, 1347, 1347, 1347, 1347, 1347,
     1347, 1347, 1347, 1347, 1347, 1347, 1347, 1347, 1347, 1347,
     1347, 1347, 1347, 1347, 1347, 1347, 1347, 1347, 1347, 1347,
     1348, 1348,    0, 1348, 1348, 1348, 1348, 1348, 1348, 1348,

     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1349, 1349,
        0,    0,    0,    0,    0, 1349, 1349, 1349,    0,    0,
     1349, 1349, 1349, 1349, 1350, 1350,    0, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1351, 1351,    0,    0,    0,    0,    0, 1351,
     1351, 1351,    0,    0, 1351, 1351, 1351, 1351, 1352, 1352,
        0, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,

     1352, 1352, 1352, 1352, 1352, 1352, 1353, 1353,    0, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1355, 1355,    0,    0,    0,    0,
        0, 1355, 1355, 1355,    0,    0, 1355, 1355, 1355, 1355,
     1356, 1356,    0, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1357, 1357,
        0, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
     1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,

     1357, 1357, 1357, 1357, 1357, 1357, 1359, 1359,    0,    0,
        0,    0,    0, 1359, 1359, 1359,    0,    0, 1359, 1359,
     1359, 1359, 1360, 1360,    0, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1361, 1361,    0, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
     1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
     1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1363, 1363,
        0,    0,    0,    0,    0, 1363, 1363, 1363,    0,    0,
     1363, 1363, 1363, 1363, 1364, 1364,    0, 1364, 1364, 1364,

     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1365, 1365,    0, 1365, 1365, 1365, 1365, 1365,
     1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365,
     1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365,
     1366, 1366,    0, 1366, 1366,    0,    0,    0,    0,    0,
     1366, 1366, 1366,    0,    0, 1366, 1366, 1366, 1366, 1367,
     1367,    0, 1367, 1367,    0,    0,    0,    0,    0, 1367,
     1367, 1367,    0,    0, 1367, 1367, 1367, 1367, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,

     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1370,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 1370, 1370, 1370,    0,    0, 1370, 1370, 1370,
     1370, 1371,    0,    0,    0,    0,    0,    0,    0,    0,
     1371, 1371, 1371,    0,    0,    0,    0, 1371, 1371, 1371,
        0,    0, 1371, 1371, 1371, 1371, 1372, 1372,    0, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1373,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0, 1373,
     1373, 1373, 1373, 1374, 1374,    0, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1375,    0,    0,    0,    0,    0,    0,    0,    0,
     1375, 1375, 1375,    0,    0, 1375, 1375, 1375, 1375, 1376,
     1376,    0, 1376, 1376,    0,    0,    0,    0,    0, 1376,
     1376, 1376,    0,    0, 1376, 1376, 1376, 1376, 1377, 1377,
     1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,
     1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,

     1377, 1377, 1377, 1377, 1377, 1377, 1380, 1380,    0, 1380,
     1380,    0,    0,    0,    0,    0, 1380, 1380, 1380,    0,
        0, 1380, 1380, 1380, 1380, 1381, 1381,    0,    0,    0,
        0,    0, 1381, 1381, 1381,    0,    0, 1381, 1381, 1381,
     1381, 1382,    0, 1382, 1382,    0,    0,    0,    0,    0,
     1382, 1382, 1382,    0,    0, 1382, 1382, 1382, 1382, 1383,
     1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383,
     1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383,
     1383, 1383, 1383, 1383, 1383, 1383, 1383, 1384, 1384, 1384,
        0,    0, 1384, 1384, 1384, 1384, 1385, 1385,    0,    0,

        0,    0,    0, 1385, 1385, 1385,    0,    0, 1385, 1385,
     1385, 1385, 1386, 1386, 1386,    0,    0, 1386, 1386, 1386,
     1386, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387,
     1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387,
     1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1388,
     1388,    0,    0,    0,    0,    0, 1388, 1388, 1388,    0,
        0, 1388, 1388, 1388, 1388, 1389, 1389, 1389,    0,    0,
     1389, 1389, 1389, 1389, 1390, 1390,    0,    0,    0,    0,
        0, 1390, 1390, 1390,    0,    0, 1390, 1390, 1390, 1390,
     1391, 1391, 1391,    0,    0, 1391, 1391, 1391, 1391, 1392,

     1392,    0, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1393, 1393,    0,
     1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393,
     1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393,
     1393, 1393, 1393, 1393, 1393, 1395, 1395,    0,    0,    0,
        0,    0, 1395, 1395, 1395,    0,    0, 1395, 1395, 1395,
     1395, 1396, 1396,    0, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1397,

     1397,    0, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397,
     1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397,
     1397, 1397, 1397, 1397, 1397, 1397, 1397, 1399, 1399,    0,
        0,    0,    0,    0, 1399, 1399, 1399,    0,    0, 1399,
     1399, 1399, 1399, 1400,    0,    0,    0,    0,    0,    0,
        0,    0, 1400, 1400, 1400,    0,    0, 1400, 1400, 1400,
     1400, 1401, 1401,    0, 1401, 1401,    0,    0,    0,    0,
        0, 1401, 1401, 1401,    0,    0, 1401, 1401, 1401, 1401,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,

     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1404, 1404,
        0, 1404, 1404,    0,    0,    0,    0,    0, 1404, 1404,
     1404,    0,    0, 1404, 1404, 1404, 1404, 1405, 1405,    0,
        0,    0,    0,    0, 1405, 1405, 1405,    0,    0, 1405,
     1405, 1405, 1405, 1406,    0, 1406, 1406,    0,    0,    0,
        0,    0, 1406, 1406, 1406,    0,    0, 1406, 1406, 1406,
     1406, 1407, 1407,    0, 1407, 1407, 1407,    0, 1407, 1407,
     1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407,
     1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1408,
     1408,    0, 1408, 1408, 1408,    0, 1408, 1408, 1408, 1408,

     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1409, 1409,    0,
        0, 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409,
     1409, 1409, 1409, 1409, 1409, 1409, 1409,    0, 1409, 1409,
     1409, 1409, 1409, 1409, 1409, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1411, 1411,    0,    0,    0,    0,    0,
     1411, 1411, 1411,    0,    0, 1411, 1411, 1411, 1411, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,

     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1413, 1413,    0,
        0,    0,    0,    0, 1413, 1413, 1413,    0,    0, 1413,
     1413, 1413, 1413, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1415, 1415,    0,    0,    0,    0,    0, 1415, 1415,
     1415,    0,    0, 1415, 1415, 1415, 1415, 1416, 1416,    0,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,

     1416, 1416, 1416, 1416, 1416, 1417, 1417,    0, 1417, 1417,
     1417, 1417, 1417, 1417, 1417, 1417, 1417, 1417, 1417, 1417,
     1417, 1417, 1417, 1417, 1417, 1417, 1417, 1417, 1417, 1417,
     1417, 1417, 1417, 1418,    0,    0,    0,    0,    0,    0,
        0,    0, 1418, 1418, 1418,    0,    0, 1418, 1418, 1418,
     1418, 1419, 1419,    0, 1419, 1419,    0,    0,    0,    0,
        0, 1419, 1419, 1419,    0,    0, 1419, 1419, 1419, 1419,
     1420, 1420,    0, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1421, 1421,

     1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421,
     1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421,
     1421, 1421, 1421, 1421, 1421, 1421, 1422, 1422,    0,    0,
        0,    0,    0, 1422, 1422, 1422,    0,    0, 1422, 1422,
     1422, 1422, 1423, 1423,    0, 1423, 1423, 1423, 1423, 1423,
     1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423,
     1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423,
     1424, 1424,    0, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1426, 1426,

        0,    0,    0,    0,    0, 1426, 1426, 1426,    0,    0,
     1426, 1426, 1426, 1426, 1427, 1427,    0, 1427, 1427, 1427,
     1427, 1427, 1427, 1427, 1427, 1427, 1427, 1427, 1427, 1427,
     1427, 1427, 1427, 1427, 1427, 1427, 1427, 1427, 1427, 1427,
     1427, 1427, 1428, 1428,    0, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1430, 1430,    0,    0,    0,    0,    0, 1430, 1430, 1430,
        0,    0, 1430, 1430, 1430, 1430, 1431, 1431,    0, 1431,
     1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431,

     1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431,
     1431, 1431, 1431, 1431, 1432, 1432, 1432,    0,    0, 1432,
     1432, 1432, 1432, 1433, 1433,    0,    0,    0,    0,    0,
     1433, 1433, 1433,    0,    0, 1433, 1433, 1433, 1433, 1434,
     1434, 1434,    0,    0, 1434, 1434, 1434, 1434, 1435, 1435,
        0, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1436, 1436,    0, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,

     1436, 1436, 1436, 1436, 1438,    0, 1438,    0, 1438,    0,
        0, 1438,    0,    0,    0,    0,    0,    0,    0,    0,
     1438, 1438, 1438,    0,    0, 1438, 1438, 1438, 1438, 1439,
     1439,    0, 1439, 1439, 1439, 1439, 1439, 1439, 1439, 1439,
     1439, 1439, 1439, 1439, 1439, 1439, 1439, 1439, 1439, 1439,
     1439, 1439, 1439, 1439, 1439, 1439, 1439, 1440, 1440,    0,
     1440, 1440,    0, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1441,    0,    0,    0,    0,
        0, 1441, 1441,    0, 1441, 1441,    0,    0,    0,    0,

        0, 1441, 1441, 1441,    0,    0, 1441, 1441, 1441, 1441,
     1442, 1442, 1442,    0,    0, 1442, 1442, 1442, 1442, 1443,
        0, 1443, 1443,    0,    0,    0,    0,    0, 1443, 1443,
     1443,    0,    0, 1443, 1443, 1443, 1443, 1444, 1444,    0,
        0,    0,    0,    0, 1444, 1444, 1444,    0,    0, 1444,
     1444, 1444, 1444, 1445, 1445, 1445, 1445, 1445, 1445, 1445,
     1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445,
     1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445,
     1445, 1446, 1446,    0, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,

     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1447,
     1447,    0, 1447, 1447, 1447, 1447, 1447, 1447, 1447, 1447,
     1447, 1447, 1447, 1447, 1447, 1447, 1447, 1447, 1447, 1447,
     1447, 1447, 1447, 1447, 1447, 1447, 1447, 1448,    0,    0,
        0,    0,    0,    0,    0,    0, 1448, 1448, 1448,    0,
        0, 1448, 1448, 1448, 1448, 1449,    0,    0,    0,    0,
        0, 1449, 1449,    0, 1449, 1449,    0,    0,    0,    0,
        0, 1449, 1449, 1449,    0,    0, 1449, 1449, 1449, 1449,
     1450,    0,    0,    0,    0,    0, 1450, 1450,    0, 1450,
     1450,    0,    0,    0,    0,    0, 1450, 1450, 1450,    0,

        0, 1450, 1450, 1450, 1450, 1451,    0,    0,    0,    0,
        0, 1451, 1451,    0, 1451, 1451,    0,    0,    0,    0,
        0, 1451, 1451, 1451,    0,    0, 1451, 1451, 1451, 1451,
     1452,    0, 1452, 1452,    0,    0,    0,    0,    0, 1452,
     1452, 1452,    0,    0, 1452, 1452, 1452, 1452, 1453, 1453,
        0, 1453, 1453, 1453, 1453, 1453, 1453, 1453, 1453, 1453,
     1453, 1453, 1453, 1453, 1453, 1453, 1453, 1453, 1453, 1453,
     1453, 1453, 1453, 1453, 1453, 1453, 1454,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 1454, 1454, 1454, 1454, 1455,    0,    0,    0,    0,

     1455, 1455,    0,    0,    0,    0,    0, 1455,    0,    0,
        0,    0,    0, 1455, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1457, 1457,    0,    0,    0,    0,    0, 1457,
        0, 1457,    0,    0,    0, 1457,    0, 1457, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1459, 1459, 1459, 1459,
     1459, 1459, 1459, 1459, 1459, 1459, 1459, 1459, 1459, 1459,

     1459, 1459, 1459, 1459, 1459, 1459, 1459, 1459, 1459, 1459,
     1459, 1459, 1459, 1459, 1460, 1460,    0, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1461, 1461,    0, 1461, 1461, 1461, 1461, 1461,
     1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461,
     1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461,
     1462,    0,    0,    0,    0, 1462, 1462,    0,    0,    0,
        0,    0, 1462,    0,    0,    0,    0,    0, 1462, 1463,
     1463,    0, 1463, 1463, 1463, 1463, 1463, 1463, 1463, 1463,

     1463, 1463, 1463, 1463, 1463, 1463, 1463, 1463, 1463, 1463,
     1463, 1463, 1463, 1463, 1463, 1463, 1463, 1464, 1464,    0,
        0,    0,    0,    0, 1464,    0, 1464,    0,    0,    0,
     1464,    0, 1464, 1465,    0,    0,    0,    0, 1465, 1465,
        0,    0,    0,    0,    0, 1465,    0,    0,    0,    0,
        0, 1465, 1466, 1466,    0, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1467, 1467,    0,    0,    0,    0,    0, 1467,    0, 1467,
        0,    0,    0, 1467,    0, 1467, 1468,    0,    0,    0,

        0, 1468, 1468,    0,    0,    0,    0,    0, 1468,    0,
        0,    0,    0,    0, 1468, 1469, 1469,    0, 1469, 1469,
     1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469,
     1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469,
     1469, 1469, 1469, 1470, 1470,    0,    0,    0,    0,    0,
     1470,    0, 1470,    0,    0,    0, 1470,    0, 1470, 1471,
     1471,    0, 1471, 1471, 1471, 1471, 1471, 1471, 1471, 1471,
     1471, 1471, 1471, 1471, 1471, 1471, 1471, 1471, 1471, 1471,
     1471, 1471, 1471, 1471, 1471, 1471, 1471, 1472, 1472,    0,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,

     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1473, 1473,    0, 1473, 1473,
     1473, 1473, 1473, 1473, 1473, 1473, 1473, 1473, 1473, 1473,
     1473, 1473, 1473, 1473, 1473, 1473, 1473, 1473, 1473, 1473,
     1473, 1473, 1473, 1474, 1474,    0, 1474, 1474,    0,    0,
        0,    0,    0, 1474, 1474, 1474,    0,    0, 1474, 1474,
     1474, 1474, 1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475,
     1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475,
     1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475,
     1476, 1476,    0,    0,    0,    0,    0, 1476,    0, 1476,

        0,    0,    0, 1476,    0, 1476, 1477,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 1477, 1477, 1477,    0,    0, 1477, 1477, 1477,
     1477, 1478,    0,    0,    0,    0,    0,    0,    0,    0,
     1478, 1478, 1478,    0,    0,    0,    0, 1478, 1478, 1478,
        0,    0, 1478, 1478, 1478, 1478, 1479, 1479,    0, 1479,
     1479, 1479, 1479, 1479, 1479, 1479, 1479, 1479, 1479, 1479,
     1479, 1479, 1479, 1479, 1479, 1479, 1479, 1479, 1479, 1479,
     1479, 1479, 1479, 1479, 1480,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 1480,

     1480, 1480, 1480, 1481,    0,    0,    0,    0, 1481, 1481,
        0,    0,    0,    0,    0, 1481,    0,    0,    0,    0,
        0, 1481, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1483, 1483,    0,    0,    0,    0,    0, 1483,    0, 1483,
        0,    0,    0, 1483,    0, 1483, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1485, 1485,    0,    0, 1485,    0,

        0, 1485, 1485, 1485,    0,    0, 1485, 1485, 1485, 1485,
     1486, 1486,    0,    0,    0,    0,    0, 1486, 1486, 1486,
        0,    0, 1486, 1486, 1486, 1486, 1487, 1487,    0,    0,
        0,    0,    0, 1487, 1487, 1487,    0, 1487, 1487, 1487,
     1487, 1487, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1489, 1489,    0,    0, 1489,    0,    0, 1489, 1489, 1489,
        0,    0, 1489, 1489, 1489, 1489, 1490, 1490,    0,    0,
        0,    0,    0, 1490, 1490, 1490,    0,    0, 1490, 1490,

     1490, 1490, 1491, 1491,    0,    0,    0,    0,    0, 1491,
     1491, 1491,    0, 1491, 1491, 1491, 1491, 1491, 1492,    0,
        0,    0,    0, 1492, 1492,    0,    0,    0,    0,    0,
     1492,    0,    0,    0,    0,    0, 1492, 1493, 1493,    0,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1494, 1494,    0,    0,    0,
        0,    0, 1494,    0, 1494,    0,    0,    0, 1494,    0,
     1494, 1495,    0,    0,    0,    0, 1495, 1495,    0,    0,
        0,    0,    0, 1495,    0,    0,    0,    0,    0, 1495,

     1496, 1496,    0, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1497, 1497,
        0,    0,    0,    0,    0, 1497,    0, 1497,    0,    0,
        0, 1497,    0, 1497, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1499, 1499,    0,    0,    0,    0,    0, 1499,
        0, 1499,    0,    0,    0, 1499,    0, 1499, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,

     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1501, 1501, 1501, 1501,
     1501, 1501, 1501, 1501, 1501, 1501, 1501, 1501, 1501, 1501,
     1501, 1501, 1501, 1501, 1501, 1501, 1501, 1501, 1501, 1501,
     1501, 1501, 1501, 1501, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1503, 1503,    0, 1503, 1503, 1503, 1503, 1503,
     1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503,
     1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503,

     1504,    0,    0,    0,    0, 1504, 1504,    0,    0,    0,
        0,    0, 1504,    0,    0,    0,    0,    0, 1504, 1505,
     1505,    0, 1505, 1505, 1505, 1505, 1505, 1505, 1505, 1505,
     1505, 1505, 1505, 1505, 1505, 1505, 1505, 1505, 1505, 1505,
     1505, 1505, 1505, 1505, 1505, 1505, 1505, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1507,    0,    0,    0,    0,
     1507, 1507,    0,    0,    0,    0,    0, 1507,    0,    0,
        0,    0,    0, 1507, 1508, 1508,    0, 1508, 1508, 1508,

     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1509, 1509,    0,    0,    0,    0,    0, 1509,
        0, 1509,    0,    0,    0, 1509,    0, 1509, 1510,    0,
        0,    0,    0, 1510, 1510,    0,    0,    0,    0,    0,
     1510,    0,    0,    0,    0,    0, 1510, 1511, 1511,    0,
     1511, 1511, 1511, 1511, 1511, 1511, 1511, 1511, 1511, 1511,
     1511, 1511, 1511, 1511, 1511, 1511, 1511, 1511, 1511, 1511,
     1511, 1511, 1511, 1511, 1511, 1512, 1512,    0,    0,    0,
        0,    0, 1512,    0, 1512,    0,    0,    0, 1512,    0,

     1512, 1513, 1513,    0, 1513, 1513, 1513, 1513, 1513, 1513,
     1513, 1513, 1513, 1513, 1513, 1513, 1513, 1513, 1513, 1513,
     1513, 1513, 1513, 1513, 1513, 1513, 1513, 1513, 1513, 1514,
     1514,    0,    0, 1514,    0,    0, 1514, 1514, 1514,    0,
        0, 1514, 1514, 1514, 1514, 1515, 1515,    0,    0,    0,
        0,    0, 1515, 1515, 1515,    0,    0, 1515, 1515, 1515,
     1515, 1516, 1516,    0,    0,    0,    0,    0, 1516, 1516,
     1516,    0, 1516, 1516, 1516, 1516, 1516, 1517,    0,    0,
        0,    0, 1517, 1517,    0,    0,    0,    0,    0, 1517,
        0,    0,    0,    0,    0, 1517, 1518, 1518,    0, 1518,

     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1519, 1519,    0,    0,    0,    0,
        0, 1519,    0, 1519,    0,    0,    0, 1519,    0, 1519,
     1520,    0,    0,    0,    0,    0, 1520, 1520,    0, 1520,
     1520,    0,    0,    0,    0,    0, 1520, 1520, 1520,    0,
        0, 1520, 1520, 1520, 1520, 1521, 1521,    0, 1521, 1521,
     1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521,
     1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521,
     1521, 1521, 1521, 1522, 1522,    0, 1522, 1522, 1522, 1522,

     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1523,    0,    0,    0,    0,    0, 1523, 1523,    0,
     1523, 1523,    0,    0,    0,    0,    0, 1523, 1523, 1523,
        0,    0, 1523, 1523, 1523, 1523, 1524,    0,    0,    0,
        0,    0, 1524, 1524,    0, 1524, 1524,    0,    0,    0,
        0,    0, 1524, 1524, 1524,    0,    0, 1524, 1524, 1524,
     1524, 1525, 1525,    0,    0,    0,    0,    0, 1525, 1525,
     1525,    0, 1525, 1525, 1525, 1525, 1525, 1526, 1526,    0,
        0,    0,    0,    0, 1526, 1526, 1526,    0,    0, 1526,

     1526, 1526, 1526, 1527,    0, 1527, 1527,    0,    0,    0,
        0,    0, 1527, 1527, 1527,    0,    0, 1527, 1527, 1527,
     1527, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1529,
     1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529,
     1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529,
     1529, 1529, 1529, 1529, 1529, 1529, 1529, 1530,    0,    0,
        0,    0,    0,    0,    0,    0, 1530, 1530,    0,    0,
        0,    0,    0, 1530, 1530, 1530,    0,    0, 1530, 1530,

     1530, 1530, 1531, 1531,    0, 1531, 1531, 1531, 1531, 1531,
     1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531,
     1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531,
     1532,    0,    0,    0,    0, 1532, 1532,    0,    0,    0,
        0,    0, 1532,    0,    0,    0,    0,    0, 1532, 1533,
        0,    0,    0,    0,    0, 1533, 1533,    0, 1533, 1533,
        0,    0,    0,    0,    0, 1533, 1533, 1533,    0,    0,
     1533, 1533, 1533, 1533, 1534,    0,    0,    0,    0,    0,
     1534, 1534,    0, 1534, 1534,    0,    0,    0,    0,    0,
     1534, 1534, 1534,    0,    0, 1534, 1534, 1534, 1534, 1535,

     1535,    0, 1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535,
     1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535,
     1535, 1535, 1535, 1535, 1535, 1535, 1535, 1536,    0,    0,
        0,    0, 1536, 1536,    0,    0,    0,    0,    0, 1536,
        0,    0,    0,    0,    0, 1536, 1537,    0,    0,    0,
        0, 1537, 1537,    0,    0,    0,    0,    0, 1537,    0,
        0,    0,    0,    0, 1537, 1538,    0,    0,    0,    0,
     1538, 1538,    0,    0,    0,    0,    0, 1538,    0,    0,
        0,    0,    0, 1538, 1539,    0,    0,    0,    0, 1539,
     1539,    0,    0,    0,    0,    0, 1539,    0,    0,    0,

        0,    0, 1539, 1540, 1540,    0, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1541, 1541,    0, 1541, 1541, 1541, 1541, 1541, 1541,
     1541, 1541, 1541, 1541, 1541, 1541, 1541, 1541, 1541, 1541,
     1541, 1541, 1541, 1541, 1541, 1541, 1541, 1541, 1541, 1542,
     1542,    0, 1542, 1542,    0,    0,    0,    0,    0, 1542,
     1542, 1542,    0,    0, 1542, 1542, 1542, 1542, 1543,    0,
        0,    0,    0,    0,    0,    0,    0, 1543, 1543, 1543,
        0,    0,    0,    0, 1543, 1543, 1543,    0,    0, 1543,

     1543, 1543, 1543, 1544, 1544,    0, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1545,    0,    0,    0,    0, 1545, 1545,    0,    0,
        0,    0,    0, 1545,    0,    0,    0,    0,    0, 1545,
     1546, 1546,    0,    0, 1546,    0,    0, 1546, 1546, 1546,
        0,    0, 1546, 1546, 1546, 1546, 1547,    0,    0, 1547,
        0,    0, 1547, 1547,    0,    0,    0,    0,    0, 1547,
     1547, 1547,    0,    0, 1547, 1547, 1547, 1547, 1548, 1548,
        0,    0,    0,    0,    0, 1548, 1548, 1548,    0, 1548,

     1548, 1548, 1548, 1548, 1549, 1549,    0,    0, 1549,    0,
        0, 1549, 1549, 1549,    0,    0, 1549, 1549, 1549, 1549,
     1550,    0,    0, 1550,    0,    0, 1550, 1550,    0,    0,
        0,    0,    0, 1550, 1550, 1550,    0,    0, 1550, 1550,
     1550, 1550, 1551, 1551,    0,    0,    0,    0,    0, 1551,
     1551, 1551,    0, 1551, 1551, 1551, 1551, 1551, 1552,    0,
        0,    0,    0, 1552, 1552,    0,    0,    0,    0,    0,
     1552,    0,    0,    0,    0,    0, 1552, 1553,    0,    0,
        0,    0, 1553, 1553,    0,    0,    0,    0,    0, 1553,
        0,    0,    0,    0,    0, 1553, 1554, 1554,    0, 1554,

     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1555,    0,    0,    0,    0, 1555,
     1555,    0,    0,    0,    0,    0, 1555,    0,    0,    0,
        0,    0, 1555, 1556,    0,    0,    0,    0, 1556, 1556,
        0,    0,    0,    0,    0, 1556,    0,    0,    0,    0,
        0, 1556, 1557,    0,    0,    0,    0, 1557, 1557,    0,
        0,    0,    0,    0, 1557,    0,    0,    0,    0,    0,
     1557, 1558, 1558,    0, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1559,
     1559,    0,    0, 1559,    0,    0, 1559, 1559, 1559,    0,
        0, 1559, 1559, 1559, 1559, 1560,    0,    0, 1560,    0,
        0, 1560, 1560,    0,    0,    0,    0,    0, 1560, 1560,
     1560,    0,    0, 1560, 1560, 1560, 1560, 1561, 1561,    0,
        0,    0,    0,    0, 1561, 1561, 1561,    0, 1561, 1561,
     1561, 1561, 1561, 1562,    0,    0,    0,    0, 1562, 1562,
        0,    0,    0,    0,    0, 1562,    0,    0,    0,    0,
        0, 1562, 1563,    0,    0,    0,    0,    0,    0,    0,
        0, 1563, 1563,    0,    0,    0,    0,    0, 1563, 1563,

     1563,    0,    0, 1563, 1563, 1563, 1563, 1564, 1564,    0,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1565,    0,    0,    0,    0,
     1565, 1565,    0,    0,    0,    0,    0, 1565,    0,    0,
        0,    0,    0, 1565, 1566,    0,    0,    0,    0,    0,
     1566, 1566,    0, 1566, 1566,    0,    0,    0,    0,    0,
     1566, 1566, 1566,    0,    0, 1566, 1566, 1566, 1566, 1567,
        0,    0,    0,    0,    0, 1567, 1567,    0, 1567, 1567,
        0,    0,    0,    0, 1567, 1567, 1567, 1567,    0,    0,

     1567, 1567, 1567, 1567, 1568, 1568,    0,    0,    0,    0,
        0, 1568, 1568, 1568,    0, 1568, 1568, 1568, 1568, 1568,
     1569,    0,    0,    0,    0,    0, 1569, 1569,    0, 1569,
     1569,    0,    0,    0,    0,    0, 1569, 1569, 1569,    0,
        0, 1569, 1569, 1569, 1569, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1571,    0,    0,    0,    0,    0,    0,
        0,    0, 1571, 1571,    0,    0,    0,    0,    0, 1571,
     1571, 1571,    0,    0, 1571, 1571, 1571, 1571, 1572, 1572,

        0,    0,    0,    0,    0, 1572, 1572, 1572,    0,    0,
     1572, 1572, 1572, 1572, 1573, 1573,    0, 1573, 1573, 1573,
     1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573,
     1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573,
     1573, 1573, 1574,    0,    0,    0,    0, 1574, 1574,    0,
        0,    0,    0,    0, 1574,    0,    0,    0,    0,    0,
     1574, 1575,    0,    0,    0,    0,    0, 1575, 1575,    0,
     1575, 1575,    0,    0,    0,    0,    0, 1575, 1575, 1575,
        0,    0, 1575, 1575, 1575, 1575, 1576,    0,    0,    0,
        0,    0, 1576, 1576,    0, 1576, 1576,    0,    0,    0,

        0,    0, 1576, 1576, 1576,    0,    0, 1576, 1576, 1576,
     1576, 1577, 1577,    0, 1577, 1577, 1577, 1577, 1577, 1577,
     1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577,
     1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577, 1578,
     1578,    0, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1579, 1579,    0,
     1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579,
     1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579,
     1579, 1579, 1579, 1579, 1579, 1580, 1580,    0, 1580, 1580,

        0,    0,    0,    0,    0, 1580, 1580, 1580,    0,    0,
     1580, 1580, 1580, 1580, 1581, 1581,    0, 1581, 1581, 1581,
     1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581,
     1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581,
     1581, 1581, 1582,    0,    0,    0,    0,    0,    0,    0,
        0, 1582, 1582,    0,    0,    0,    0, 1582, 1582, 1582,
     1582,    0,    0, 1582, 1582, 1582, 1582, 1583,    0,    0,
        0,    0, 1583, 1583,    0,    0,    0,    0,    0, 1583,
        0,    0,    0,    0,    0, 1583, 1584, 1584,    0, 1584,
     1584,    0,    0,    0,    0,    0, 1584, 1584, 1584,    0,

        0, 1584, 1584, 1584, 1584, 1585,    0,    0,    0,    0,
        0, 1585, 1585,    0, 1585, 1585,    0,    0,    0,    0,
        0, 1585, 1585, 1585,    0,    0, 1585, 1585, 1585, 1585,
     1586,    0,    0,    0,    0,    0, 1586, 1586,    0, 1586,
     1586,    0,    0,    0,    0,    0, 1586, 1586, 1586,    0,
        0, 1586, 1586, 1586, 1586, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,

     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257
    } ;

static const flex_int16_t yy_rule_linenum[328] =
    {   0,
      136,  141,  149,  157,  162,  171,  180,  188,  334,  342,
      351,  360,  365,  370,  375,  380,  385,  390,  394,  398,
      402,  419,  424,  429,  435,  442,  446,  463,  468,  473,
      479,  487,  491,  508,  513,  519,  523,  535,  539,  544,
      559,  566,  580,  592,  597,  603,  613,  617,  633,  640,
      646,  653,  660,  669,  675,  679,  684,  697,  701,  715,
      721,  735,  739,  752,  758,  772,  781,  786,  790,  795,
      808,  821,  833,  855,  866,  874,  882,  890,  898,  906,
      914,  922,  930,  938,  946,  955,  972,  987,  993, 1007,
     1011, 1015, 1029, 1035, 1041, 1047, 1053, 1059, 1067, 1071,

     1076, 1092, 1097, 1101, 1105, 1109, 1113, 1117, 1122, 1126,
     1130, 1136, 1140, 1154, 1158, 1163, 1168, 1173, 1177, 1183,
     1187, 1201, 1214, 1227, 1235, 1243, 1252, 1259, 1265, 1284,
     1289, 1294, 1298, 1303, 1307, 1312, 1324, 1329, 1334, 1338,
     1342, 1355, 1359, 1363, 1367, 1379, 1384, 1389, 1393, 1398,
     1403, 1411, 1415, 1420, 1432, 1438, 1449, 1455, 1466, 1477,
     1485, 1497, 1516, 1535, 1601, 1612, 1630, 1648, 1656, 1664,
     1672, 1680, 1688, 1696, 1704, 1714, 1738, 1746, 1754, 1762,
     1770, 1778, 1786, 1794, 1800, 1804, 1809, 1814, 1830, 1835,
     1840, 1881, 1891, 1895, 1905, 1909, 1913, 1917, 1974, 1982,

     1988, 2003, 2007, 2015, 2023, 2032, 2039, 2044, 2049, 2054,
     2059, 2064, 2069, 2077, 2082, 2087, 2092, 2097, 2102, 2107,
     2112, 2117, 2122, 2127, 2132, 2137, 2142, 2147, 2152, 2157,
     2162, 2167, 2172, 2177, 2182, 2187, 2192, 2197, 2202, 2211,
     2216, 2221, 2226, 2231, 2236, 2241, 2246, 2251, 2256, 2261,
     2266, 2271, 2276, 2281, 2286, 2290, 2319, 2337, 2348, 2354,
     2371, 2378, 2386, 2401, 2421, 2425, 2430, 2435, 2459, 2465,
     2479, 2489, 2499, 2506, 2513, 2517, 2522, 2533, 2547, 2564,
     2570, 2575, 2598, 2604, 2611, 2616, 2631, 2636, 2641, 2647,
     2651, 2663, 2668, 2673, 2684, 2703, 2710, 2714, 2726, 2731,

     2736, 2746, 2758, 2770, 2774, 2778, 2782, 2786, 2790, 2794,
     2807, 2820, 2825, 2830, 2834, 2846, 2851, 2855, 2871, 2875,
     2891, 2898, 2902, 2907, 2923, 2928, 2933
    } ;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
#line 1 "flex/agc-Yfile-lexer.ll"















#line 27 "flex/agc-Yfile-lexer.ll"
/* $Id: agc-Yfile-lexer.cc 2845 2022-12-13 01:24:39Z teshields $ */

/* This file is part of Ox, an Attribute Grammar Compiling System
   that augments the specification functionality of Lex and Yacc, and
   input specification compatible lexer and parser generators.

   Copyright (C) 1992-1994  Kurt M. Bischoff
   Copyright (C) 2004-2022  Thomas E. Shields

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#include "config.h"

#include <string>

#include "depGs.hh"
#include "joinTabs.hh"
#include "lextypes.hh"
#include "symTrans.hh"
#include "trav.hh"
#include "type-keywords.hh"
#include "yox-directives.hh"

#include "YY_LOCATIONS.hh"
#line 3507 "flex/agc-Yfile-lexer.cc"

#line 84 "flex/agc-Yfile-lexer.ll"
#include "agc-Yfile-lexer.hh"
#line 3511 "flex/agc-Yfile-lexer.cc"
/* Bison: '%define' <api-name> */
#line 3513 "flex/agc-Yfile-lexer.cc"

#define INITIAL 0
#define YACC_DEFS 1
#define START_SYM 2
#define YACC_UNION_HD 3
#define YACC_UNION 4
#define YACC_CCODE 5
#define CCODE_BLOCK 6
#define CCODE_IMPORT 7
#define INT_ARG 8
#define STRING_ARG 9
#define BISONDEF 10
#define TYPESPEC 11
#define USER_ARGS 12
#define YACC_RULES 13
#define INHERIT_ATTR 14
#define YACC_ACT 15
#define YACC_USER 16
#define YACC_TRAILER 17
#define BTYACC_ACT 18
#define ACTIONCLOSER_DIRECTIVE 19
#define YOXOUTG_DIRECTIVE 20
#define COMMENT 21
#define SKIP_COMMENT 22
#define STRING 23
#define CPP_DIRECTIVE 24
#define MACRO_HEAD 25
#define MACRO_BODY 26
#define ATTR_DECL 27
#define OXVOID 28
#define ATTR_DECL_SYMS 29
#define TRAV_DECL 30
#define EXPAND_MACRO 31
#define MACRO_ARG 32
#define YATTR_REF 33
#define ATTR_DEPS 34

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
#include <unistd.h>
/* %endif */
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

/* %if-c-only Reentrant structure and macros (non-C++). */
/* %if-reentrant */
/* %if-c-only */
/* %endif */
/* %if-reentrant */
/* %endif */
/* %endif End reentrant structures and macros. */
/* %if-bison-bridge */
/* %endif */
/* %not-for-header */
/* %ok-for-header */

/* %endif */

#ifndef yytext_ptr
static void yy_flex_strncpy ( char *, const char *, int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen ( const char * );
#endif

#ifndef YY_NO_INPUT
/* %if-c-only Standard (non-C++) definition */
/* %not-for-header */
/* %ok-for-header */

/* %endif */
#endif

/* %if-c-only */
/* %endif */

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* %if-c-only Standard (non-C++) definition */
/* %endif */
/* %if-c++-only C++ definition */
#define ECHO LexerOutput( yytext, yyleng )
/* %endif */
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
/* %% [5.0] fread()/read() definition of YY_INPUT goes here unless we're doing C++ \ */\
\
/* %if-c++-only C++ definition \ */\
	if ( (int)(result = LexerInput( (char *) buf, max_size )) < 0 ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
/* %endif */

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
/* %if-c-only */
/* %endif */
/* %if-c++-only */
#define YY_FATAL_ERROR(msg) LexerError( msg )
/* %endif */
#endif

/* %if-tables-serialization structures and prototypes */
/* %not-for-header */
/* %ok-for-header */

/* %not-for-header */
/* %tables-yydmap generated elements */
/* %endif */
/* end tables serialization structures and prototypes */

/* %ok-for-header */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1
/* %if-c-only Standard (non-C++) definition */
/* %endif */
/* %if-c++-only C++ definition */
#define YY_DECL int yyFlexLexer::yylex()
/* %endif */
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

/* %% [6.0] YY_RULE_SETUP definition goes here */
#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/* %not-for-header */
/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    
	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
/* %if-c-only */
/* %endif */
/* %if-c++-only */
			yyin.rdbuf(std::cin.rdbuf());
/* %endif */

		if ( ! yyout )
/* %if-c-only */
/* %endif */
/* %if-c++-only */
			yyout.rdbuf(std::cout.rdbuf());
/* %endif */

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer( yyin, YY_BUF_SIZE );
		}

		yy_load_buffer_state(  );
		}

	{
/* %% [7.0] user's declarations go here */
#line 130 "flex/agc-Yfile-lexer.ll"


#line 3745 "flex/agc-Yfile-lexer.cc"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
/* %% [8.0] yymore()-related code goes here */
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

/* %% [9.0] code to set up and find next match goes here */
		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 1258 )
					yy_c = yy_meta[yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
			++yy_cp;
			}
		while ( yy_current_state != 1257 );
		yy_cp = (yy_last_accepting_cpos);
		yy_current_state = (yy_last_accepting_state);

yy_find_action:
/* %% [10.0] code to find the action number goes here */
		yy_act = yy_accept[yy_current_state];

		YY_DO_BEFORE_ACTION;

/* %% [11.0] code for yylineno update goes here */

do_action:	/* This label is used only to access EOF actions. */

/* %% [12.0] debug code goes here */
		if ( yy_flex_debug )
			{
			if ( yy_act == 0 )
				std::cerr << "--scanner backing up\n";
			else if ( yy_act < 328 )
				std::cerr << "--accepting rule at line " << yy_rule_linenum[yy_act] <<
				         "(\"" << yytext << "\")\n";
			else if ( yy_act == 328 )
				std::cerr << "--accepting default rule (\"" << yytext << "\")\n";
			else if ( yy_act == 329 )
				std::cerr << "--(end of buffer or a NUL)\n";
			else
				std::cerr << "--EOF (start condition " << YY_START << ")\n";
			}

		switch ( yy_act )
	{ /* beginning of action switch */
/* %% [13.0] actions go here */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

/* Y-file Definitions Section */
case 1:
YY_RULE_SETUP
#line 136 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  yox_push_state (COMMENT, yoxOutGdefs);
}
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 141 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<char_literal> (stringLookup (lexeme, true));
  return (parser::token::LITERAL_CHAR);
}
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 149 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<char_literal> (stringLookup (lexeme, true));
  return (parser::token::LITERAL_STRING);
}
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 157 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  yox_push_state (STRING, yoxOutGdefs);
}
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 162 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<numberRep> (
      numberRep (lexeme, std::stoll (lexeme, nullptr, 0)));
  return (parser::token::NUM);
}
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 171 "flex/agc-Yfile-lexer.ll"
{
  if (!ctrl.process_autoSynOrInh)
    yoxOutGdefs.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<name_literal> (stringLookup (lexeme, true));
  return (parser::token::ID);
}
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 180 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<name_literal> (stringLookup (lexeme, true));
  return (parser::token::GS_ID);
}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 188 "flex/agc-Yfile-lexer.ll"
{
  const struct yox_directive* directive =
      in_yox_directive_set (text (), (size_t)size ());
  if (directive == nullptr)
    {
      if ((char)chr () == '%') // found "%<directive>" not important to Ox
        yoxOutGdefs.lex ().put (text ()); // just pass it on through
      else if ((char)chr () == '@')
        {
          // found "@{ID}" -> will be a syntax error
          const std::string& lexeme (text ());
          yylval.emplace<name_literal> (stringLookup (lexeme.substr (1), true));
          return (parser::token::OX_ID);
        }
    }
  else
    {
      yylval.emplace<keyword> (directive->name);

      // special case directive processing

      // copy to output?
      switch (directive->token)
        {
        case parser::token::UNION:
        case parser::token::OX_ATTRIBUTES:
        case parser::token::OX_AUTOSYN:
        case parser::token::OX_AUTOINH:
        case parser::token::OX_WARN:
        case parser::token::OX_MACRO:
        case parser::token::OX_TRAV:
          break;
        case parser::token::IMPORT:
          yoxOutGimport.lex ().put (text ());
          break;
        default:
          yoxOutGdefs.lex ().put (text ());
          break;
        }

      // prep to count '{'?
      switch (directive->token)
        {
        case parser::token::DESTRUCTOR:
        case parser::token::PRINTER:
        case parser::token::CODE:
        case parser::token::EXPORT:
        case parser::token::LOCAL:
        case parser::token::LOCATION:
        case parser::token::IMPORT:
        case parser::token::UNION:
        case parser::token::OX_ATTRIBUTES:
        case parser::token::LEX_PARAM:
        case parser::token::PARSE_PARAM:
        case parser::token::PARAM:
          nLbraces = 0;
        default:
          break;
        }

      // change start condition?
      switch (directive->token)
        {
        case parser::token::DESTRUCTOR:
        case parser::token::PRINTER:
        case parser::token::CODE:
        case parser::token::EXPORT:
        case parser::token::LOCAL:
        case parser::token::LOCATION:
          push_state (yylloc, CCODE_BLOCK);
          break;
        case parser::token::IMPORT:
          // MSTA extension hack for '%import'
          push_state (yylloc, CCODE_IMPORT);
          break;
        case parser::token::START:
          push_state (yylloc, START_SYM);
          break;
        case parser::token::UNION:
          push_state (yylloc, YACC_UNION_HD);
          break;
        case parser::token::LEX_PARAM:
        case parser::token::PARSE_PARAM:
        case parser::token::PARAM:
          push_state (yylloc, USER_ARGS);
          break;
        case parser::token::OX_AUTOSYN:
        case parser::token::OX_AUTOINH:
        case parser::token::OX_WARN:
          break;
        case parser::token::OX_ATTRIBUTES:
          push_state (yylloc, ATTR_DECL);
          break;
        case parser::token::OX_MACRO:
          push_state (yylloc, MACRO_HEAD);
          break;
        case parser::token::OX_TRAV:
          push_state (yylloc, TRAV_DECL);
          break;
        case parser::token::DEFINE:
          push_state (yylloc, BISONDEF);
          break;
        case parser::token::YYEMPTY:
          switch (directive->param_type)
            {
            case C_int:
              push_state (yylloc, INT_ARG); // there should be an int argument
              pass2parser = false; // do not pass it to the parser
              break;
            case C_string:
              push_state (yylloc, STRING_ARG); // there may be a string argument
              pass2parser = false; // do not pass it to the parser
              break;
            case other:
              break;
            }
          break;
        default:
          switch (directive->param_type)
            {
            case C_int:
              push_state (yylloc, INT_ARG); // there should be an int argument
              pass2parser = true; // pass it to the parser
              break;
            case C_string:
              push_state (yylloc, STRING_ARG); // there may be a string argument
              pass2parser = true; // pass it to the parser
              break;
            case other:
              // no special handling for these
              break;
            }
          break;
        }

      // pass token to parser?
      switch (directive->token)
        {
        case parser::token::YYEMPTY:
          break;
        default:
          return (directive->token);
        }
    }
}
	YY_BREAK
case 9:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 334 "flex/agc-Yfile-lexer.ll"
{
  yylloc.begin += std::strcspn (text (), "%");
  yylloc.end = yylloc.begin + 2;
  separatorMARK.put (text ());
  start (YACC_RULES);
  return (parser::token::MARK);
}
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 342 "flex/agc-Yfile-lexer.ll"
{
  if (yaccUnionDefined != 0)
    yaccCODE.lex ().put (text ());
  else
    yoxOutGdefs.lex ().put (text ());
  push_state (yylloc, YACC_CCODE);
  return (parser::token::LCURL);
}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 351 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  push_state (yylloc, TYPESPEC);
  nLbraces = 0;
  nLTbraces = 1;
  // normal return from TYPESPEC when nLTbraces == 0, rescan ">"
  return (parser::token::LESSTHAN);
}
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 360 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  return (parser::token::GTRTHAN);
}
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 365 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  return (parser::token::LPAREN);
}
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 370 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  return (parser::token::RPAREN);
}
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 375 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  return (parser::token::COMMA);
}
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 380 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  return (parser::token::LBRACE);
}
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 385 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  return (parser::token::RBRACE);
}
	YY_BREAK
case 18:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 390 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
}
	YY_BREAK
case 19:
/* rule 19 can match eol */
YY_RULE_SETUP
#line 394 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
}
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 398 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.put (text ());
}
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 402 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(YACC_DEFS):
#line 406 "flex/agc-Yfile-lexer.ll"
{
  // EOF w/o finding the first "%%": the Y-file is corrupt, so just quit
  unexpectedEOF (yylloc);
}
	YY_BREAK


/* YACC_DEFS 'subroutine': echo "{ ... }" C code blocks */
case 22:
YY_RULE_SETUP
#line 419 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  yox_push_state (COMMENT, yoxOutGdefs);
}
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 424 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  yox_push_state (STRING, yoxOutGdefs);
}
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 429 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  nLbraces++;
  return (parser::token::LBRACE);
}
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 435 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  if (--nLbraces == 0)
    pop_state ();
  return (parser::token::RBRACE);
}
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 442 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.put (text ());
}
	YY_BREAK
case 27:
/* rule 27 can match eol */
YY_RULE_SETUP
#line 446 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(CCODE_BLOCK):
#line 450 "flex/agc-Yfile-lexer.ll"
{
  unterminatedCode (yylloc, startPos.top ());
}
	YY_BREAK


/* YACC_DEFS 'subroutine': echo "{ ... }" C code blocks for MSTA '%import'
     extension hack */
case 28:
YY_RULE_SETUP
#line 463 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGimport.lex ().put (text ());
  yox_push_state (COMMENT, yoxOutGimport);
}
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 468 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGimport.lex ().put (text ());
  yox_push_state (STRING, yoxOutGimport);
}
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 473 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGimport.lex ().put ((char)chr ());
  nLbraces++;
  return (parser::token::LBRACE);
}
	YY_BREAK
case 31:
/* rule 31 can match eol */
YY_RULE_SETUP
#line 479 "flex/agc-Yfile-lexer.ll"
{
  yylloc.end = yylloc.begin + 1;
  yoxOutGimport.lex ().put (text ());
  if (--nLbraces == 0)
    pop_state ();
  return (parser::token::RBRACE);
}
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 487 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGimport.put (text ());
}
	YY_BREAK
case 33:
/* rule 33 can match eol */
YY_RULE_SETUP
#line 491 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGimport.put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(CCODE_IMPORT):
#line 495 "flex/agc-Yfile-lexer.ll"
{
  unterminatedCode (yylloc, startPos.top ());
}
	YY_BREAK


/* YACC_DEFS 'subroutine': intercept symbol following '%start'; Ox adds a new
     start symbol w/ an action. */
case 34:
YY_RULE_SETUP
#line 508 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  yox_push_state (COMMENT, yoxOutGdefs);
}
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 513 "flex/agc-Yfile-lexer.ll"
{
  yylval.emplace<name_literal> (stringLookup (str (), true));
  pop_state ();
  return (parser::token::GS_ID);
}
	YY_BREAK
case 36:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 519 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
}
	YY_BREAK
case 37:
/* rule 37 can match eol */
YY_RULE_SETUP
#line 523 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK


/* YACC_DEFS 'subroutine': process text between '%union' & '{' */
case 38:
YY_RULE_SETUP
#line 535 "flex/agc-Yfile-lexer.ll"
{
  yox_push_state (SKIP_COMMENT, yoxOutGdefs);
}
	YY_BREAK
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 539 "flex/agc-Yfile-lexer.ll"
{
  // skip comments & whitespace between "%union" & "{"
  ; // no-op
}
	YY_BREAK
case 40:
/* rule 40 can match eol */
YY_RULE_SETUP
#line 544 "flex/agc-Yfile-lexer.ll"
{
  yylloc.end = yylloc.begin + 1;
  nLbraces++; // omit the first "{" in the LA buffer

  // starting position if EOF in '%union'
  push_state (startPos.top (), YACC_UNION);

  if (yaccUnionDefined > 1)
    unionBODY.gen ().put ("/* concatenated from `%union' #" +
                          std::to_string (yaccUnionDefined) +
                          " */\n");

  return (parser::token::LBRACE);
}
	YY_BREAK
case 41:
/* rule 41 can match eol */
YY_RULE_SETUP
#line 559 "flex/agc-Yfile-lexer.ll"
{
  yylloc.end = yylloc.begin + 1;
  pop_state ();
  // omit the last "}" in the unionBODY lookaheadBuf
  return (parser::token::RBRACE);
}
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 566 "flex/agc-Yfile-lexer.ll"
{
  // Bison extension: "%union TAG { ... }"
  if (ctrl.targetParserGen == bisonParserGen ||
      ctrl.targetParserGen == bisonParserGenOld)
    {
      const std::string& lexeme (text ());
      yylval.emplace<name_literal> (stringLookup (lexeme, true));
      return (parser::token::ID);
    }
  else
    yox_error (yylloc, "unexpected %union tag: \"" + str () + "\": "
                       "target parser is not bison.\n");
}
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 580 "flex/agc-Yfile-lexer.ll"
{
  unexpectedChar (yylloc, (char)chr (), "in `%union' declaration header");
}
	YY_BREAK


/* YACC_UNION_HD 'subroutine': accumulate the '%union' declaration body */
case 44:
YY_RULE_SETUP
#line 592 "flex/agc-Yfile-lexer.ll"
{
  unionBODY.lex ().put (text ());
  yox_push_state (COMMENT, unionBODY);
}
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 597 "flex/agc-Yfile-lexer.ll"
{
  nLbraces++;
  unionBODY.lex ().put ((char)chr ());
  return (parser::token::LBRACE);
}
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 603 "flex/agc-Yfile-lexer.ll"
{
  if (--nLbraces == 0)
    {
      yyless (0);
      pop_state ();
    }
  else
    unionBODY.lex ().put ((char)chr ());
}
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 613 "flex/agc-Yfile-lexer.ll"
{
  unionBODY.lex ().put (text ());
}
	YY_BREAK
case 48:
/* rule 48 can match eol */
YY_RULE_SETUP
#line 617 "flex/agc-Yfile-lexer.ll"
{
  unionBODY.put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(YACC_UNION):
#line 621 "flex/agc-Yfile-lexer.ll"
{
  unterminatedYaccUnion (yylloc, startPos.top ());
}
	YY_BREAK


/* YACC_DEFS 'subroutine': a Bison '%define' directive */
case 49:
YY_RULE_SETUP
#line 633 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  pop_state ();
  yylval.emplace<name_literal> (text ());
  return (parser::token::API_VALUE);
}
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 640 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  yylval.emplace<name_literal> (text ());
  return (parser::token::API_VARIABLE);
}
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 646 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  pop_state ();
  yylval.emplace<char_literal> (text ());
  return (parser::token::LITERAL_STRING);
}
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 653 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  pop_state ();
  yylval.emplace<char_literal> (text ());
  return (parser::token::LITERAL_PATH);
}
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 660 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  push_state (yylloc, TYPESPEC);
  nLbraces = 1;
  nLTbraces = 0;
  // normal return from TYPESPEC when nLbraces == 0, rescan "}"
  return (parser::token::LBRACE);
}
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 669 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  pop_state ();
  return (parser::token::RBRACE);
}
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 675 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
}
	YY_BREAK
case 56:
/* rule 56 can match eol */
YY_RULE_SETUP
#line 679 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  pop_state ();
}
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 684 "flex/agc-Yfile-lexer.ll"
{
  yyless (0);
  pop_state ();
}
	YY_BREAK


/* YACC_DEFS 'subroutine': look for an int */
case 58:
YY_RULE_SETUP
#line 697 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
}
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 701 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  pop_state ();
  if (pass2parser)
    {
      pass2parser = false;

      const std::string& lexeme (text ());
      yylval.emplace<numberRep> (
          numberRep (lexeme, std::stoll (lexeme, nullptr, 0)));
      return (parser::token::NUM);
    }
}
	YY_BREAK
case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 715 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  pop_state ();
  pass2parser = false;
}
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 721 "flex/agc-Yfile-lexer.ll"
{
  yyless (0);
  pop_state ();
  pass2parser = false;
}
	YY_BREAK


/* YACC_DEFS 'subroutine': look for a string */
case 62:
YY_RULE_SETUP
#line 735 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
}
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 739 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  pop_state ();
  if (pass2parser)
    {
      pass2parser = false;

      const std::string& lexeme (text ());
      yylval.emplace<char_literal> (stringLookup (lexeme, true));
      return (parser::token::LITERAL_STRING);
    }
}
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 752 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  pop_state ();
  pass2parser = false;
}
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 758 "flex/agc-Yfile-lexer.ll"
{
  yyless (0);
  pop_state ();
  pass2parser = false;
}
	YY_BREAK


/* YACC_DEFS 'subroutine': user-defined additional parser/lexer arguments */
case 66:
YY_RULE_SETUP
#line 772 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  push_state (yylloc, TYPESPEC);
  nLbraces = 1;
  nLTbraces = 0;
  // normal return from TYPESPEC when nLbraces == 0, rescan "}"
  return (parser::token::LBRACE);
}
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 781 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  return (parser::token::RBRACE);
}
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 786 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
}
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 790 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  pop_state ();
}
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 795 "flex/agc-Yfile-lexer.ll"
{
  yyless (0);
  pop_state ();
}
	YY_BREAK


/* C/C++ type specifier rules common to ATTR_DECL and TYPESPEC */
case 71:
YY_RULE_SETUP
#line 808 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    {
      yoxOutGdefs.lex ().put (text ());
      yox_push_state (COMMENT, yoxOutGdefs);
    }
  else if (start () == ATTR_DECL)
    {
      attrDECL.lex ().put (text ());
      yox_push_state (COMMENT, attrDECL);
    }
}
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 821 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put (text ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<numberRep> (
      numberRep (lexeme, std::stoll (lexeme, nullptr, 0)));
  return (parser::token::NUM);
}
	YY_BREAK
case 73:
YY_RULE_SETUP
#line 833 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put (text ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put (text ());

  const struct type_keyword* reserved =
      in_type_keyword_set (text (), (size_t)size ());

  if (reserved == nullptr)
    {
      const std::string& lexeme (text ());
      yylval.emplace<name_literal> (stringLookup (lexeme, true));
      return (parser::token::ID);
    }
  else
    {
      yylval.emplace<keyword> (reserved->name);
      return (reserved->token);
    }
}
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 855 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put (text ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<name_literal> (stringLookup (lexeme, true));
  return (parser::token::NAMESPACE_ID);
}
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 866 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put (text ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put (text ());
  return (parser::token::ELLIPSIS);
}
	YY_BREAK
case 76:
YY_RULE_SETUP
#line 874 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put ((char)chr ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put ((char)chr ());
  return (parser::token::COMMA);
}
	YY_BREAK
case 77:
YY_RULE_SETUP
#line 882 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put ((char)chr ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put ((char)chr ());
  return (parser::token::SEMICOLON);
}
	YY_BREAK
case 78:
YY_RULE_SETUP
#line 890 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put ((char)chr ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put ((char)chr ());
  return (parser::token::COLON);
}
	YY_BREAK
case 79:
YY_RULE_SETUP
#line 898 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put ((char)chr ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put ((char)chr ());
  return (parser::token::ASTERISK);
}
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 906 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put ((char)chr ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put ((char)chr ());
  return (parser::token::AMPERSAND);
}
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 914 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put ((char)chr ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put ((char)chr ());
  return (parser::token::LPAREN);
}
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 922 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put ((char)chr ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put ((char)chr ());
  return (parser::token::RPAREN);
}
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 930 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put ((char)chr ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put ((char)chr ());
  return (parser::token::LBRACKET);
}
	YY_BREAK
case 84:
YY_RULE_SETUP
#line 938 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put ((char)chr ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put ((char)chr ());
  return (parser::token::RBRACKET);
}
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 946 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put ((char)chr ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put ((char)chr ());
  nLTbraces++;
  return (parser::token::LESSTHAN);
}
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 955 "flex/agc-Yfile-lexer.ll"
{
  if (--nLTbraces == 0)
    {
      // entered following "<" in start condition YACC_DEFS
      yyless (0);
      pop_state ();
    }
  else
    {
      if (start () == TYPESPEC)
        yoxOutGdefs.lex ().put ((char)chr ());
      else if (start () == ATTR_DECL)
        attrDECL.lex ().put ((char)chr ());
      return (parser::token::GTRTHAN);
    }
}
	YY_BREAK
case 87:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 972 "flex/agc-Yfile-lexer.ll"
{
  if (start () == TYPESPEC)
    yoxOutGdefs.lex ().put (text ());
  else if (start () == ATTR_DECL)
    attrDECL.lex ().put (text ());
}
	YY_BREAK


/* YACC_DEFS, BISONDEF 'subroutine': C/C++ type specification */
case 88:
YY_RULE_SETUP
#line 987 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put ((char)chr ());
  nLbraces++;
  return (parser::token::LBRACE);
}
	YY_BREAK
case 89:
YY_RULE_SETUP
#line 993 "flex/agc-Yfile-lexer.ll"
{
  if (--nLbraces == 0)
    {
      // entered following "{" in start states BISONDEF & USER_ARGS
      yyless (0);
      pop_state ();
    }
  else
    {
      yoxOutGdefs.lex ().put ((char)chr ());
      return (parser::token::RBRACE);
    }
}
	YY_BREAK
case 90:
YY_RULE_SETUP
#line 1007 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
}
	YY_BREAK
case 91:
/* rule 91 can match eol */
YY_RULE_SETUP
#line 1011 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK
case 92:
YY_RULE_SETUP
#line 1015 "flex/agc-Yfile-lexer.ll"
{
  yyless (0);
  pop_state ();
}
	YY_BREAK


/* YACC_DEFS 'subroutine': process '@attributes' declaration; ended by a
     closing brace */
case 93:
YY_RULE_SETUP
#line 1029 "flex/agc-Yfile-lexer.ll"
{
  // omit generation of '@void' attribute declarations
  push_state (yylloc, OXVOID);
  return (parser::token::OX_VOID);
}
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 1035 "flex/agc-Yfile-lexer.ll"
{
  // yylval not used in this context
  yylval.emplace<keyword> (stringLookup (str (), true));
  return (parser::token::OX_AUTOSYN);
}
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 1041 "flex/agc-Yfile-lexer.ll"
{
  // yylval not used in this context
  yylval.emplace<keyword> (stringLookup (str (), true));
  return (parser::token::OX_AUTOINH);
}
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 1047 "flex/agc-Yfile-lexer.ll"
{
  // yylval not used in this context
  yylval.emplace<keyword> (stringLookup (str (), true));
  return (parser::token::OX_WARN);
}
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 1053 "flex/agc-Yfile-lexer.ll"
{
  if (nLbraces++ > 0)
    attrDECL.lex ().put (text ());
  return (parser::token::LBRACE);
}
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 1059 "flex/agc-Yfile-lexer.ll"
{
  if (--nLbraces == 0)
    start (ATTR_DECL_SYMS);
  else
    attrDECL.lex ().put ((char)chr ());
  return (parser::token::RBRACE);
}
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 1067 "flex/agc-Yfile-lexer.ll"
{
  attrDECL.lex ().put (text ());
}
	YY_BREAK
case 100:
/* rule 100 can match eol */
YY_RULE_SETUP
#line 1071 "flex/agc-Yfile-lexer.ll"
{
  attrDECL.put ((char)chr ());
  yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 1076 "flex/agc-Yfile-lexer.ll"
{
  unexpectedChar (yylloc, (char)chr (), "in @attribute declaration");
}
	YY_BREAK
case YY_STATE_EOF(ATTR_DECL):
#line 1080 "flex/agc-Yfile-lexer.ll"
{
  unterminatedAttrDeclaration (yylloc, startPos.top ());
}
	YY_BREAK


/* YACC_DEFS 'subroutine': traversal declaration */
case 102:
YY_RULE_SETUP
#line 1092 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  yox_push_state (COMMENT, yoxOutGdefs);
}
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 1097 "flex/agc-Yfile-lexer.ll"
{
  return (parser::token::OX_POSTORDER);
}
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 1101 "flex/agc-Yfile-lexer.ll"
{
  return (parser::token::OX_PREORDER);
}
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 1105 "flex/agc-Yfile-lexer.ll"
{
  return (parser::token::OX_LEFTTORIGHT);
}
	YY_BREAK
case 106:
YY_RULE_SETUP
#line 1109 "flex/agc-Yfile-lexer.ll"
{
  return (parser::token::OX_RIGHTTOLEFT);
}
	YY_BREAK
case 107:
YY_RULE_SETUP
#line 1113 "flex/agc-Yfile-lexer.ll"
{
  return (parser::token::OX_DISABLE);
}
	YY_BREAK
case 108:
YY_RULE_SETUP
#line 1117 "flex/agc-Yfile-lexer.ll"
{
  yylval.emplace<name_literal> (stringLookup (str (), true));
  return (parser::token::ID);
}
	YY_BREAK
case 109:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 1122 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
}
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 1126 "flex/agc-Yfile-lexer.ll"
{
  ; // no-op
}
	YY_BREAK
case 111:
YY_RULE_SETUP
#line 1130 "flex/agc-Yfile-lexer.ll"
{
  yyless (0);
  yy_set_bol (true); // rescan @ beginning of line
  pop_state ();
}
	YY_BREAK
case 112:
/* rule 112 can match eol */
YY_RULE_SETUP
#line 1136 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK
case 113:
YY_RULE_SETUP
#line 1140 "flex/agc-Yfile-lexer.ll"
{
  yyless (0);
  pop_state ();
}
	YY_BREAK


/* return from ATTR_DECL back to YACC_DEFS; avoid echoing grammar symbols
     in an attribute declaration symbol list */
case 114:
YY_RULE_SETUP
#line 1154 "flex/agc-Yfile-lexer.ll"
{
  yox_push_state (SKIP_COMMENT, yoxOutGdefs);
}
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 1158 "flex/agc-Yfile-lexer.ll"
{
  yylval.emplace<char_literal> (stringLookup (str (), true));
  return (parser::token::LITERAL_CHAR);
}
	YY_BREAK
case 116:
YY_RULE_SETUP
#line 1163 "flex/agc-Yfile-lexer.ll"
{
  yylval.emplace<char_literal> (stringLookup (str (), true));
  return (parser::token::LITERAL_STRING);
}
	YY_BREAK
case 117:
YY_RULE_SETUP
#line 1168 "flex/agc-Yfile-lexer.ll"
{
  yylval.emplace<name_literal> (stringLookup (str (), true));
  return (parser::token::GS_ID);
}
	YY_BREAK
case 118:
YY_RULE_SETUP
#line 1173 "flex/agc-Yfile-lexer.ll"
{
  ; // no-op
}
	YY_BREAK
case 119:
YY_RULE_SETUP
#line 1177 "flex/agc-Yfile-lexer.ll"
{
  yyless (0);
  yy_set_bol (true); // rescan @ beginning of line
  pop_state ();
}
	YY_BREAK
case 120:
/* rule 120 can match eol */
YY_RULE_SETUP
#line 1183 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK
case 121:
YY_RULE_SETUP
#line 1187 "flex/agc-Yfile-lexer.ll"
{
  yyless (0);
  pop_state ();
}
	YY_BREAK


/* YACC_DEFS 'subroutine': echo (or accumulate) C/C++ code between
     "%{" and "%}" */
case 122:
YY_RULE_SETUP
#line 1201 "flex/agc-Yfile-lexer.ll"
{
  if (yaccUnionDefined != 0)
    {
      yaccCODE.lex ().put (text ());
      yox_push_state (COMMENT, yaccCODE);
    }
  else
    {
      yoxOutGdefs.lex ().put (text ());
      yox_push_state (COMMENT, yoxOutGdefs);
    }
}
	YY_BREAK
case 123:
YY_RULE_SETUP
#line 1214 "flex/agc-Yfile-lexer.ll"
{
  if (yaccUnionDefined != 0)
    {
      yaccCODE.lex ().put (text ());
      yox_push_state (STRING, yaccCODE);
    }
  else
    {
      yoxOutGdefs.lex ().put (text ());
      yox_push_state (STRING, yoxOutGdefs);
    }
}
	YY_BREAK
case 124:
YY_RULE_SETUP
#line 1227 "flex/agc-Yfile-lexer.ll"
{
  if (yaccUnionDefined != 0)
    yaccCODE.lex ().put ((char)chr ());
  else
    yoxOutGdefs.lex ().put ((char)chr ());
  return (parser::token::LBRACE);
}
	YY_BREAK
case 125:
YY_RULE_SETUP
#line 1235 "flex/agc-Yfile-lexer.ll"
{
  if (yaccUnionDefined != 0)
    yaccCODE.lex ().put ((char)chr ());
  else
    yoxOutGdefs.lex ().put ((char)chr ());
  return (parser::token::RBRACE);
}
	YY_BREAK
case 126:
YY_RULE_SETUP
#line 1243 "flex/agc-Yfile-lexer.ll"
{
  if (yaccUnionDefined != 0)
    yaccCODE.lex ().put (text ());
  else
    yoxOutGdefs.lex ().put (text ());
  pop_state ();
  return (parser::token::RCURL);
}
	YY_BREAK
case 127:
YY_RULE_SETUP
#line 1252 "flex/agc-Yfile-lexer.ll"
{
  if (yaccUnionDefined != 0)
    yaccCODE.put (text ());
  else
    yoxOutGdefs.put (text ());
}
	YY_BREAK
case 128:
/* rule 128 can match eol */
YY_RULE_SETUP
#line 1259 "flex/agc-Yfile-lexer.ll"
{
  if (yaccUnionDefined != 0)
    yaccCODE.put ((char)chr ());
  yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK
case 129:
YY_RULE_SETUP
#line 1265 "flex/agc-Yfile-lexer.ll"
{
  if (yaccUnionDefined != 0)
    yaccCODE.put ((char)chr ());
  else
    yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(YACC_CCODE):
#line 1272 "flex/agc-Yfile-lexer.ll"
{
  unterminatedCode (yylloc, startPos.top ());
}
	YY_BREAK


/* ATTR_DECL 'subroutine': don't output '@void' attribute declarations */
case 130:
YY_RULE_SETUP
#line 1284 "flex/agc-Yfile-lexer.ll"
{
  attrDECL.lex ().put (text ());
  yox_push_state (COMMENT, attrDECL);
}
	YY_BREAK
case 131:
YY_RULE_SETUP
#line 1289 "flex/agc-Yfile-lexer.ll"
{
  yylval.emplace<name_literal> (stringLookup (str (), true));
  return (parser::token::ID);
}
	YY_BREAK
case 132:
YY_RULE_SETUP
#line 1294 "flex/agc-Yfile-lexer.ll"
{
  return (parser::token::COMMA);
}
	YY_BREAK
case 133:
YY_RULE_SETUP
#line 1298 "flex/agc-Yfile-lexer.ll"
{
  pop_state ();
  return (parser::token::SEMICOLON);
}
	YY_BREAK
case 134:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 1303 "flex/agc-Yfile-lexer.ll"
{
  attrDECL.lex ().put (text ());
}
	YY_BREAK
case 135:
/* rule 135 can match eol */
YY_RULE_SETUP
#line 1307 "flex/agc-Yfile-lexer.ll"
{
  attrDECL.put ((char)chr ());
  yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK
case 136:
YY_RULE_SETUP
#line 1312 "flex/agc-Yfile-lexer.ll"
{
  attrDECL.put ((char)chr ());
}
	YY_BREAK


/* macro formal(s): transition from YACC_DEFS to MACRO_BODY */
case 137:
YY_RULE_SETUP
#line 1324 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
  yox_push_state (COMMENT, yoxOutGdefs);
}
	YY_BREAK
case 138:
YY_RULE_SETUP
#line 1329 "flex/agc-Yfile-lexer.ll"
{
  yylval.emplace<name_literal> (stringLookup (str (), true));
  return (parser::token::ID);
}
	YY_BREAK
case 139:
YY_RULE_SETUP
#line 1334 "flex/agc-Yfile-lexer.ll"
{
  return (parser::token::LPAREN);
}
	YY_BREAK
case 140:
YY_RULE_SETUP
#line 1338 "flex/agc-Yfile-lexer.ll"
{
  return (parser::token::COMMA);
}
	YY_BREAK
case 141:
/* rule 141 can match eol */
YY_RULE_SETUP
#line 1342 "flex/agc-Yfile-lexer.ll"
{
  if (yylloc.end.column == 0)
    {
      // macro header ends with '\n': include it in the output Y-file
      yoxOutGdefs.lex ().put ('\n');
      yylloc.end.column = 1; // body starts on 'end' line @column 1
    }
  macro.setOrigin (yylloc.end);
  yylloc.end = yylloc.begin + 1;
  start (MACRO_BODY);
  return (parser::token::RPAREN);
}
	YY_BREAK
case 142:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 1355 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.lex ().put (text ());
}
	YY_BREAK
case 143:
YY_RULE_SETUP
#line 1359 "flex/agc-Yfile-lexer.ll"
{
  ; // no-op
}
	YY_BREAK
case 144:
/* rule 144 can match eol */
YY_RULE_SETUP
#line 1363 "flex/agc-Yfile-lexer.ll"
{
  yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK
case 145:
YY_RULE_SETUP
#line 1367 "flex/agc-Yfile-lexer.ll"
{
  unexpectedChar (yylloc, (char)chr (), "in macro heading");
}
	YY_BREAK


/* macro body: transition from MACRO_HEAD to YACC_DEFS */
case 146:
YY_RULE_SETUP
#line 1379 "flex/agc-Yfile-lexer.ll"
{
  macro.lex ().put (text ());
  yox_push_state (COMMENT, macro);
}
	YY_BREAK
case 147:
YY_RULE_SETUP
#line 1384 "flex/agc-Yfile-lexer.ll"
{
  macro.lex ().put (text ());
  yox_push_state (STRING, macro);
}
	YY_BREAK
case 148:
YY_RULE_SETUP
#line 1389 "flex/agc-Yfile-lexer.ll"
{
  macro.put (stringLookup (str (), true));
}
	YY_BREAK
case 149:
YY_RULE_SETUP
#line 1393 "flex/agc-Yfile-lexer.ll"
{
  // nested macro definition start
  macro.lex ().put ("@macro");
}
	YY_BREAK
case 150:
YY_RULE_SETUP
#line 1398 "flex/agc-Yfile-lexer.ll"
{
  // nested macro definition end
  macro.lex ().put ("@end");
}
	YY_BREAK
case 151:
YY_RULE_SETUP
#line 1403 "flex/agc-Yfile-lexer.ll"
{
  if (text ()[size () - 1] != 'd')
    yylloc.end = yylloc.begin + 4; // trim trailing whitespace
  pop_state (); // -> YACC_DEFS
  macro.close ();
  return (parser::token::OX_END);
}
	YY_BREAK
case 152:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 1411 "flex/agc-Yfile-lexer.ll"
{
  macro.lex ().put (text ());
}
	YY_BREAK
case 153:
/* rule 153 can match eol */
YY_RULE_SETUP
#line 1415 "flex/agc-Yfile-lexer.ll"
{
  macro.put ((char)chr ());
  yoxOutGdefs.put ((char)chr ());
}
	YY_BREAK
case 154:
YY_RULE_SETUP
#line 1420 "flex/agc-Yfile-lexer.ll"
{
  macro.put ((char)chr ());
}
	YY_BREAK


/* Y-file Rules Section */
case 155:
YY_RULE_SETUP
#line 1432 "flex/agc-Yfile-lexer.ll"
{
  // throw away whitespace preceding "@{" "}"<-balance lbrace
  yyless (size () - 2); // rescan "@{"
  notLHS ();
}
	YY_BREAK
case 156:
YY_RULE_SETUP
#line 1438 "flex/agc-Yfile-lexer.ll"
{
  flushWS (possibleLHS);
  if (nATLbraces++ > 0)
    unexpectedATLBRACE (yylloc);
  else
    {
      push_state (yylloc, YATTR_REF);
      return (parser::token::OX_LBRACE);
    }
}
	YY_BREAK
case 157:
YY_RULE_SETUP
#line 1449 "flex/agc-Yfile-lexer.ll"
{
  flushWS (possibleLHS);
  possibleLHS.lex ().put (text ());
  yox_push_state (COMMENT, possibleLHS);
}
	YY_BREAK
case 158:
YY_RULE_SETUP
#line 1455 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<char_literal> (stringLookup (lexeme, true));
  return (parser::token::LITERAL_CHAR);
}
	YY_BREAK
case 159:
YY_RULE_SETUP
#line 1466 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<char_literal> (stringLookup (lexeme, true));
  return (parser::token::LITERAL_STRING);
}
	YY_BREAK
case 160:
YY_RULE_SETUP
#line 1477 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put (text ());
  yox_push_state (STRING, yoxOutG);
}
	YY_BREAK
case 161:
YY_RULE_SETUP
#line 1485 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<numberRep> (
      numberRep (lexeme, std::stoll (lexeme, nullptr, 0)));
  return (parser::token::NUM);
}
	YY_BREAK
case 162:
YY_RULE_SETUP
#line 1497 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (possibleLHS);
  possibleLHS.lex ().put (text ());

  if (ctrl.targetParserGen == btyaccParserGen ||
      ctrl.targetParserGen == byaccParserGen)
    {
      // BtYacc & BYacc extension: possibly followed by inherited attributes
      nLparens = 0;
      push_state (yylloc, INHERIT_ATTR);
    }

  const std::string& lexeme (text ());
  yylval.emplace<name_literal> (stringLookup (lexeme, true));
  return (parser::token::ID);
}
	YY_BREAK
case 163:
YY_RULE_SETUP
#line 1516 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (possibleLHS);
  possibleLHS.lex ().put (text ());

  if (ctrl.targetParserGen == btyaccParserGen ||
      ctrl.targetParserGen == byaccParserGen)
    {
      // BtYacc & BYacc extension: possibly followed by inherited attributes
      nLparens = 0;
      push_state (yylloc, INHERIT_ATTR);
    }

  const std::string& lexeme (text ());
  yylval.emplace<name_literal> (stringLookup (lexeme, true));
  return (parser::token::GS_ID);
}
	YY_BREAK
case 164:
YY_RULE_SETUP
#line 1535 "flex/agc-Yfile-lexer.ll"
{
  const struct yox_directive* directive =
      in_yox_directive_set (text (), (size_t)size ());

  if (directive == nullptr)
    {
      // "%<directive>" not important to Ox, just pass it on through
      if ((char)chr () == '%')
        {
          notLastSemAction ();
          notLHS ();
          flushWS (yoxOutG);
          yoxOutG.lex ().put (text ());
        }
      else if ((char)chr () == '@')
        {
          // found "@{ID}" -> will be a syntax error
          const std::string& lexeme (text ());
          yylval.emplace<name_literal> (stringLookup (lexeme.substr (1), true));
          return (parser::token::OX_ID);
        }
    }
  else
    {
      yylval.emplace<keyword> (directive->name);

      switch (directive->token)
        {
        case parser::token::EMPTY:
          notLastSemAction ();
          notLHS ();
          flushWS (yoxOutG);
          yoxOutG.lex ().put (text ());
          return (parser::token::EMPTY);
        case parser::token::DPREC:
        case parser::token::EXPECT:
        case parser::token::EXPECT_RR:
        case parser::token::LOOKAHEAD:
        case parser::token::MERGE:
        case parser::token::PREC:
          if (!actionCLOSER.empty ())
            {
              push_state (yylloc, ACTIONCLOSER_DIRECTIVE);
              actionCLOSER.append (possibleLHS);
              possibleLHS.clear ();
              flushWS (actionCLOSER);
              actionCLOSER.lex ().put (text ());
            }
          else
            {
              notLHS ();
              push_state (yylloc, YOXOUTG_DIRECTIVE);
              flushWS (yoxOutG);
              yoxOutG.lex ().put (text ());
            }
          return (directive->token);
        default: // anything that makes it here will be a syntax error
          notLastSemAction ();
          notLHS ();
          flushWS (yoxOutG);
          yoxOutG.lex ().put (text ());
          return (directive->token);
        }
    }
}
	YY_BREAK
case 165:
/* rule 165 can match eol */
YY_RULE_SETUP
#line 1601 "flex/agc-Yfile-lexer.ll"
{
  yylloc.begin += std::strcspn (text (), "%");
  yylloc.end = yylloc.begin + 2;
  flushWS (possibleLHS);
  notLastSemAction ();
  notLHS ();
  separatorMARK.put (text ());
  start (YACC_USER);
  return (parser::token::MARK);
}
	YY_BREAK
case 166:
YY_RULE_SETUP
#line 1612 "flex/agc-Yfile-lexer.ll"
{
  // found the end a rule:

  if (!actionCLOSER.empty ())
    {
      // 'actionCLOSER' holds the closing '}' of the last Yacc rule action;
      // append whatever might be in 'possibleLHS' (s.b. empty)
      actionCLOSER.append (possibleLHS);
      possibleLHS.clear ();
    }
  else
    notLHS ();

  flushWS (possibleLHS);
  possibleLHS.lex ().put ((char)chr ());
  return (parser::token::VBAR);
}
	YY_BREAK
case 167:
YY_RULE_SETUP
#line 1630 "flex/agc-Yfile-lexer.ll"
{
  // found the end of a rule:

  if (!actionCLOSER.empty ())
    {
      // 'actionCLOSER' holds the closing '}' of the last Yacc rule action;
      // append whatever might be in 'possibleLHS' (s.b. empty)
      actionCLOSER.append (possibleLHS);
      possibleLHS.clear ();
    }
  else
    notLHS ();

  flushWS (possibleLHS);
  possibleLHS.lex ().put ((char)chr ());
  return (parser::token::SEMICOLON);
}
	YY_BREAK
case 168:
YY_RULE_SETUP
#line 1648 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::LPAREN);
}
	YY_BREAK
case 169:
YY_RULE_SETUP
#line 1656 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::RPAREN);
}
	YY_BREAK
case 170:
YY_RULE_SETUP
#line 1664 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::SLASH);
}
	YY_BREAK
case 171:
YY_RULE_SETUP
#line 1672 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::ASTERISK);
}
	YY_BREAK
case 172:
YY_RULE_SETUP
#line 1680 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::MINUS);
}
	YY_BREAK
case 173:
YY_RULE_SETUP
#line 1688 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::PLUS);
}
	YY_BREAK
case 174:
YY_RULE_SETUP
#line 1696 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::AT);
}
	YY_BREAK
case 175:
YY_RULE_SETUP
#line 1704 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  nLbraces = 1;
  push_state (yylloc, YACC_ACT);
  return (parser::token::LBRACE);
}
	YY_BREAK
case 176:
YY_RULE_SETUP
#line 1714 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  if (ctrl.targetParserGen == btyaccParserGen ||
      ctrl.targetParserGen == byaccParserGen)
    {
      // BtYacc & BYacc extension: start trial & normal mode action
      nLbrackets = 1;
      push_state (yylloc, BTYACC_ACT);
      return (parser::token::LBRACKET);
    }
  else if (ctrl.targetParserGen == bisonParserGen ||
           ctrl.targetParserGen == mstaParserGen)
    {
      // Bison extension: start explicit named reference definition
      // MSTA extension: start EBNF optional construct
      return (parser::token::LBRACKET);
    }
  else
    unexpectedChar (yylloc, (char)chr (), "in rules section");
}
	YY_BREAK
case 177:
YY_RULE_SETUP
#line 1738 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::RBRACKET);
}
	YY_BREAK
case 178:
YY_RULE_SETUP
#line 1746 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::LESSTHAN);
}
	YY_BREAK
case 179:
YY_RULE_SETUP
#line 1754 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::GTRTHAN);
}
	YY_BREAK
case 180:
YY_RULE_SETUP
#line 1762 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put (text ());
  return (parser::token::LTARROW);
}
	YY_BREAK
case 181:
YY_RULE_SETUP
#line 1770 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put (text ());
  return (parser::token::RTARROW);
}
	YY_BREAK
case 182:
YY_RULE_SETUP
#line 1778 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put (text ());
  return (parser::token::DBLARROW);
}
	YY_BREAK
case 183:
YY_RULE_SETUP
#line 1786 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  yoxOutG.lex ().put (text ());
  return (parser::token::PREDICATE);
}
	YY_BREAK
case 184:
YY_RULE_SETUP
#line 1794 "flex/agc-Yfile-lexer.ll"
{
  flushWS (possibleLHS);
  possibleLHS.lex ().put ((char)chr ());
  return (parser::token::COLON);
}
	YY_BREAK
case 185:
YY_RULE_SETUP
#line 1800 "flex/agc-Yfile-lexer.ll"
{
  bufferWS ();
}
	YY_BREAK
case 186:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 1804 "flex/agc-Yfile-lexer.ll"
{
  flushWS (possibleLHS);
  possibleLHS.lex ().put (text ());
}
	YY_BREAK
case 187:
/* rule 187 can match eol */
YY_RULE_SETUP
#line 1809 "flex/agc-Yfile-lexer.ll"
{
  flushWS (possibleLHS);
  possibleLHS.lex ().put ((char)chr ());
}
	YY_BREAK
case 188:
YY_RULE_SETUP
#line 1814 "flex/agc-Yfile-lexer.ll"
{
  notLastSemAction ();
  notLHS ();
  flushWS (yoxOutG);
  unexpectedChar (yylloc, (char)chr (), "in rules section");
}
	YY_BREAK


/* YATTR_REF: YACC_RULES 'subroutine': Y-file attribute reference section */
/* ATTR_DEPS: YATTR_REF 'subroutine': explicit/mixed attribute occurrences */
case 189:
YY_RULE_SETUP
#line 1830 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  yox_push_state (COMMENT, rsBuffer);
}
	YY_BREAK
case 190:
YY_RULE_SETUP
#line 1835 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  yox_push_state (STRING, rsBuffer);
}
	YY_BREAK
case 191:
YY_RULE_SETUP
#line 1840 "flex/agc-Yfile-lexer.ll"
{
  const std::string& lexeme (text ());
  const std::string& Name (stringLookup (lexeme, true));

  do
    {
      if (expandingMacro ())
        {
          // check to see if 'Name' is a macro formal parameter name
          int argIndex = getCurMacro ().macroFormalLookup (Name);
          if (argIndex != -1)
            {
              std::string substValue (substFormal (argIndex));
              position arg_origin (yylloc.begin);

              // setup new input buffer for macro argument
              YY_BUFFER_STATE newbuf =
                  yy_create_buffer (new std::istringstream (substValue),
                                    YY_BUF_SIZE);
              pushbuffer (newbuf, arg_origin); // make it current
              setupFormalExpansion (yylloc);
              break;
            }
        }

      if (macroLookup (Name))
        {
          nLparensM = 0;
          push_state (yylloc, EXPAND_MACRO);
          expandMacro (Name, yylloc.begin);
        }
      else
        {
          rsBuffer.lex ().put (Name);
          yylval.emplace<name_literal> (Name);
          return (parser::token::ID);
        }
    }
  while (false);
}
	YY_BREAK
case 192:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 1881 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());

  if (text ()[size () - 1] == '\\')
    {
      // multi-line directive; include the following '\n'
      rsBuffer.lex ().put ((char)yyinput ());
    }
}
	YY_BREAK
case 193:
YY_RULE_SETUP
#line 1891 "flex/agc-Yfile-lexer.ll"
{
  unexpectedATLBRACE (yylloc);
}
	YY_BREAK
case 194:
YY_RULE_SETUP
#line 1895 "flex/agc-Yfile-lexer.ll"
{
  --nATLbraces;

  if (start () == ATTR_DEPS)
    pop_state ();

  pop_state ();
  return (parser::token::OX_RBRACE);
}
	YY_BREAK
case 195:
YY_RULE_SETUP
#line 1905 "flex/agc-Yfile-lexer.ll"
{
  return (parser::token::OX_DECORATE);
}
	YY_BREAK
case 196:
YY_RULE_SETUP
#line 1909 "flex/agc-Yfile-lexer.ll"
{
  return (parser::token::OX_REVORDER);
}
	YY_BREAK
case 197:
YY_RULE_SETUP
#line 1913 "flex/agc-Yfile-lexer.ll"
{
  return (parser::token::OX_REVDIR);
}
	YY_BREAK
case 198:
YY_RULE_SETUP
#line 1917 "flex/agc-Yfile-lexer.ll"
{
  const std::string& lexeme (text ());
  std::string Name (stringLookup (lexeme.substr (1), true));

  if (start () == ATTR_DEPS)
    pop_state ();

  if (expandingMacro ())
    {
      // check to see if 'Name' is a macro formal parameter name
      int argIndex = getCurMacro ().macroFormalLookup (Name);
      if (argIndex != -1)
        Name = stringLookup (substFormal (argIndex), true);
    }

  if (Name.length () == 1)
    {
      // could be an attribute definition annunciator
      rsBuffer.init (yylloc.begin);
      switch (text ()[1])
        {
        case 'e':
          push_state (yylloc, ATTR_DEPS);
          return (parser::token::OX_E);
        case 'i':
          return (parser::token::OX_I);
        case 'm':
          push_state (yylloc, ATTR_DEPS);
          return (parser::token::OX_M);
        default:
          break; // nope
        }
    }

  // otherwise, this should be a traversal mode annunciator

  currentTrav = travLookup (Name);
  if (currentTrav == -1)
    {
      if (size () == 2)
        {
          // typo: corrupted "definition mode annunciator"?
          yox_error (yylloc, "unknown traversal: \"@" + Name + "\"\n"
                             "   assuming a corrupted `@i' definition"
                             " mode annunciator.\n");

          return (parser::token::OX_I);
        }
      else
        yox_error (yylloc, "unknown traversal: \"@" + Name + "\".\n");
    }

  // it is a traversal mode annunciator
  yylval.emplace<name_literal> (Name);
  return (parser::token::OX_ID);
}
	YY_BREAK
case 199:
YY_RULE_SETUP
#line 1974 "flex/agc-Yfile-lexer.ll"
{
  // does not check for macro formal parameter occurrences
  rsBuffer.lex ().put (text ());
  if (!unionDefined ())
    notSupported (yylloc, "Yacc pseudo variable with no '%union'");
  hasYaccPvarRefGlob = true;
}
	YY_BREAK
case 200:
YY_RULE_SETUP
#line 1982 "flex/agc-Yfile-lexer.ll"
{
  // does not check for macro formal parameter occurrences
  rsBuffer.lex ().put (text ());
  hasYaccPvarRefGlob = true;
}
	YY_BREAK
case 201:
YY_RULE_SETUP
#line 1988 "flex/agc-Yfile-lexer.ll"
{
  int nAt = 1; // # of '@'
  if (text ()[(int)size () - 1] == '@')
    ++nAt;
  else
    yox_warning (yylloc, "missing final '@': \"" + str () + "\".\n");

  std::string attrb_occur (text (), 1, size () - nAt);
  if (expandingMacro ())
    expandFormalsInAttrOccr (attrb_occur);

  yylval.emplace<attrbTriple> (scanAttrbName (yylloc, attrb_occur));
  return (parser::token::OX_ATTRB_REF);
}
	YY_BREAK
case 202:
YY_RULE_SETUP
#line 2003 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
}
	YY_BREAK
case 203:
YY_RULE_SETUP
#line 2007 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<char_literal> (stringLookup (lexeme, true));
  return (parser::token::LITERAL_CHAR);
}
	YY_BREAK
case 204:
YY_RULE_SETUP
#line 2015 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<char_literal> (stringLookup (lexeme, true));
  return (parser::token::LITERAL_STRING);
}
	YY_BREAK
case 205:
YY_RULE_SETUP
#line 2023 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<numberRep> (
      numberRep (lexeme, std::stoll (lexeme, nullptr, 0)));
  return (parser::token::NUM);
}
	YY_BREAK
case 206:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 2032 "flex/agc-Yfile-lexer.ll"
{
  yylloc.begin += std::strcspn (text (), "%");
  yylloc.end = yylloc.begin + 2;
  // "%%" -> will be a syntax error
  return (parser::token::MARK);
}
	YY_BREAK
case 207:
YY_RULE_SETUP
#line 2039 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::LPAREN);
}
	YY_BREAK
case 208:
YY_RULE_SETUP
#line 2044 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::RPAREN);
}
	YY_BREAK
case 209:
YY_RULE_SETUP
#line 2049 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::LBRACKET);
}
	YY_BREAK
case 210:
YY_RULE_SETUP
#line 2054 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::RBRACKET);
}
	YY_BREAK
case 211:
YY_RULE_SETUP
#line 2059 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::LBRACE);
}
	YY_BREAK
case 212:
YY_RULE_SETUP
#line 2064 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::RBRACE);
}
	YY_BREAK
case 213:
YY_RULE_SETUP
#line 2069 "flex/agc-Yfile-lexer.ll"
{
  if (start () == ATTR_DEPS)
    pop_state ();
  else
    rsBuffer.lex ().put ((char)chr ());
  return (parser::token::SEMICOLON);
}
	YY_BREAK
case 214:
YY_RULE_SETUP
#line 2077 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::PERIOD);
}
	YY_BREAK
case 215:
YY_RULE_SETUP
#line 2082 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::RTARROW);
}
	YY_BREAK
case 216:
YY_RULE_SETUP
#line 2087 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::PLUSPLUS);
}
	YY_BREAK
case 217:
YY_RULE_SETUP
#line 2092 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::MINUSMINUS);
}
	YY_BREAK
case 218:
YY_RULE_SETUP
#line 2097 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::TILDE);
}
	YY_BREAK
case 219:
YY_RULE_SETUP
#line 2102 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::EXCLAMATION);
}
	YY_BREAK
case 220:
YY_RULE_SETUP
#line 2107 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::MINUS);
}
	YY_BREAK
case 221:
YY_RULE_SETUP
#line 2112 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::PLUS);
}
	YY_BREAK
case 222:
YY_RULE_SETUP
#line 2117 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::AMPERSAND);
}
	YY_BREAK
case 223:
YY_RULE_SETUP
#line 2122 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::ASTERISK);
}
	YY_BREAK
case 224:
YY_RULE_SETUP
#line 2127 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::SLASH);
}
	YY_BREAK
case 225:
YY_RULE_SETUP
#line 2132 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::PERCENT);
}
	YY_BREAK
case 226:
YY_RULE_SETUP
#line 2137 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::LTSHIFT);
}
	YY_BREAK
case 227:
YY_RULE_SETUP
#line 2142 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::RTSHIFT);
}
	YY_BREAK
case 228:
YY_RULE_SETUP
#line 2147 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::LESSTHAN);
}
	YY_BREAK
case 229:
YY_RULE_SETUP
#line 2152 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::GTRTHAN);
}
	YY_BREAK
case 230:
YY_RULE_SETUP
#line 2157 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::LTOREQ);
}
	YY_BREAK
case 231:
YY_RULE_SETUP
#line 2162 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::GTOREQ);
}
	YY_BREAK
case 232:
YY_RULE_SETUP
#line 2167 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::EQUAL);
}
	YY_BREAK
case 233:
YY_RULE_SETUP
#line 2172 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::NOTEQUAL);
}
	YY_BREAK
case 234:
YY_RULE_SETUP
#line 2177 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::UPARROW);
}
	YY_BREAK
case 235:
YY_RULE_SETUP
#line 2182 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::VBAR);
}
	YY_BREAK
case 236:
YY_RULE_SETUP
#line 2187 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::LOGAND);
}
	YY_BREAK
case 237:
YY_RULE_SETUP
#line 2192 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::LOGOR);
}
	YY_BREAK
case 238:
YY_RULE_SETUP
#line 2197 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::QUESTION);
}
	YY_BREAK
case 239:
YY_RULE_SETUP
#line 2202 "flex/agc-Yfile-lexer.ll"
{
  if (start () != ATTR_DEPS)
    {
      // skip output of ':' in (explicit) attribute definition
      rsBuffer.lex ().put ((char)chr ());
    }
  return (parser::token::COLON);
}
	YY_BREAK
case 240:
YY_RULE_SETUP
#line 2211 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::ASSIGN);
}
	YY_BREAK
case 241:
YY_RULE_SETUP
#line 2216 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::PLUSEQ);
}
	YY_BREAK
case 242:
YY_RULE_SETUP
#line 2221 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::MINUSEQ);
}
	YY_BREAK
case 243:
YY_RULE_SETUP
#line 2226 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::TIMESEQ);
}
	YY_BREAK
case 244:
YY_RULE_SETUP
#line 2231 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::DIVEQ);
}
	YY_BREAK
case 245:
YY_RULE_SETUP
#line 2236 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::REMEQ);
}
	YY_BREAK
case 246:
YY_RULE_SETUP
#line 2241 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::LTSHIFTEQ);
}
	YY_BREAK
case 247:
YY_RULE_SETUP
#line 2246 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::RTSHIFTEQ);
}
	YY_BREAK
case 248:
YY_RULE_SETUP
#line 2251 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::BITANDEQ);
}
	YY_BREAK
case 249:
YY_RULE_SETUP
#line 2256 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::BITXOREQ);
}
	YY_BREAK
case 250:
YY_RULE_SETUP
#line 2261 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::BITOREQ);
}
	YY_BREAK
case 251:
YY_RULE_SETUP
#line 2266 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
  return (parser::token::COMMA);
}
	YY_BREAK
case 252:
YY_RULE_SETUP
#line 2271 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::PTRTOMEMBER);
}
	YY_BREAK
case 253:
YY_RULE_SETUP
#line 2276 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::MEMBERSELECT);
}
	YY_BREAK
case 254:
YY_RULE_SETUP
#line 2281 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  return (parser::token::SCOPE);
}
	YY_BREAK
case 255:
/* rule 255 can match eol */
YY_RULE_SETUP
#line 2286 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put ((char)chr ());
}
	YY_BREAK
case 256:
YY_RULE_SETUP
#line 2290 "flex/agc-Yfile-lexer.ll"
{
  unexpectedChar (yylloc, (char)chr (), "in attribute reference section");
}
	YY_BREAK
case YY_STATE_EOF(YATTR_REF):
case YY_STATE_EOF(ATTR_DEPS):
#line 2294 "flex/agc-Yfile-lexer.ll"
{
  if (replacingFormal ())
    {
      // current macro argument complete
      popbuffer; // revert to previous input buffer
      macroFormalDone ();
    }
  else if (expandingMacro ())
    {
      // current macro expansion complete
      popbuffer; // revert to previous input buffer
      macroDone ();
    }
  else
    unterminatedAttrRefSection (yylloc, startPos.top ());
}
	YY_BREAK


/* YATTR_REF 'subroutine': handle explicit and mixed attribute occurrences */
case 257:
YY_RULE_SETUP
#line 2319 "flex/agc-Yfile-lexer.ll"
{
  std::string attrb_occur (text ());
  if (expandingMacro ())
    expandFormalsInAttrOccr (attrb_occur);

  yylval.emplace<attrbTriple> (scanAttrbName (yylloc, attrb_occur));
  return (parser::token::OX_ATTRB_OCCUR);
}
	YY_BREAK


/* YACC_RULES 'subroutine': BtYacc inherited attribute(s) following a grammar
     symbol */
case 258:
YY_RULE_SETUP
#line 2337 "flex/agc-Yfile-lexer.ll"
{
  // grammar symbol, NOT action, precedes attribute reference section

  // throw away whitespace preceding "@{" "}"<-balance lbrace
  yyless (size () - 2); // rescan "@{"

  notLastSemAction ();
  notLHS ();
  pop_state ();
}
	YY_BREAK
case 259:
YY_RULE_SETUP
#line 2348 "flex/agc-Yfile-lexer.ll"
{
  flushWS (possibleLHS);
  possibleLHS.lex ().put (text ());
  yox_push_state (COMMENT, possibleLHS);
}
	YY_BREAK
case 260:
YY_RULE_SETUP
#line 2354 "flex/agc-Yfile-lexer.ll"
{
  if (nLparens == 0)
    {
      // ':' is the Yacc end of LHS indicator
      yyless (0);
      pop_state ();
    }
  else
    {
      // ':' is part of a C/C++ '?:' operator in a BtYacc RHS inherited
      // attribute expression
      flushWS (possibleLHS);
      possibleLHS.lex ().put ((char)chr ());
      return (parser::token::COLON);
    }
}
	YY_BREAK
case 261:
YY_RULE_SETUP
#line 2371 "flex/agc-Yfile-lexer.ll"
{
  flushWS (possibleLHS);
  possibleLHS.lex ().put ((char)chr ());
  ++nLparens;
  return (parser::token::LPAREN);
}
	YY_BREAK
case 262:
YY_RULE_SETUP
#line 2378 "flex/agc-Yfile-lexer.ll"
{
  flushWS (possibleLHS);
  possibleLHS.lex ().put ((char)chr ());
  if (--nLparens == 0)
    pop_state ();
  return (parser::token::RPAREN);
}
	YY_BREAK
case 263:
YY_RULE_SETUP
#line 2386 "flex/agc-Yfile-lexer.ll"
{
  if (nLparens == 0)
    {
      // ',' will be a syntax error
      yyless (0);
      pop_state ();
    }
  else
    {
      flushWS (possibleLHS);
      possibleLHS.lex ().put ((char)chr ());
      return (parser::token::COMMA);
    }
}
	YY_BREAK
case 264:
YY_RULE_SETUP
#line 2401 "flex/agc-Yfile-lexer.ll"
{
  if (nLparens == 0)
    {
      yyless (0);
      pop_state ();
    }
  else
    {
      flushWS (possibleLHS);
      possibleLHS.lex ().put (text ());

      const std::string& lexeme (text ());
      yylval.emplace<name_literal> (stringLookup (lexeme, true));
      if ((char)chr () == '$')
        return (parser::token::INHATTR_ID);
      else
        return (parser::token::ID);
    }
}
	YY_BREAK
case 265:
YY_RULE_SETUP
#line 2421 "flex/agc-Yfile-lexer.ll"
{
  bufferWS ();
}
	YY_BREAK
case 266:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 2425 "flex/agc-Yfile-lexer.ll"
{
  flushWS (possibleLHS);
  possibleLHS.lex ().put (text ());
}
	YY_BREAK
case 267:
/* rule 267 can match eol */
YY_RULE_SETUP
#line 2430 "flex/agc-Yfile-lexer.ll"
{
  flushWS (possibleLHS);
  possibleLHS.lex ().put ((char)chr ());
}
	YY_BREAK
case 268:
YY_RULE_SETUP
#line 2435 "flex/agc-Yfile-lexer.ll"
{
  if (nLparens == 0)
    {
      yyless (0);
      pop_state ();
    }
  else
    {
      // expression component of a BtYacc RHS inherited attribute value
      flushWS (possibleLHS);
      possibleLHS.put ((char)chr ());
    }
}
	YY_BREAK


/* YACC_RULES 'subroutine': ensure that any rule directives immediately
     following the last Yacc action in a RHS follow the closing brace of the
     modified action */
case 269:
YY_RULE_SETUP
#line 2459 "flex/agc-Yfile-lexer.ll"
{
  flushWS (ruleDIRECTIVE);
  ruleDIRECTIVE.lex ().put (text ());
  yox_push_state (COMMENT, ruleDIRECTIVE);
}
	YY_BREAK
case 270:
YY_RULE_SETUP
#line 2465 "flex/agc-Yfile-lexer.ll"
{
  // Bison, BYacc, MSTA: %expect N
  // Bison, BYacc: %expect-rr N
  // Bison: %dprec N
  // MSTA: %la N
  flushWS (ruleDIRECTIVE);
  ruleDIRECTIVE.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<numberRep> (
      numberRep (lexeme, std::stoll (lexeme, nullptr, 0)));
  return (parser::token::NUM);
}
	YY_BREAK
case 271:
YY_RULE_SETUP
#line 2479 "flex/agc-Yfile-lexer.ll"
{
  // Bison: %prec 'terminal grammar symbol'
  flushWS (ruleDIRECTIVE);
  ruleDIRECTIVE.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<name_literal> (stringLookup (lexeme, true));
  return (parser::token::ID);
}
	YY_BREAK
case 272:
YY_RULE_SETUP
#line 2489 "flex/agc-Yfile-lexer.ll"
{
  // Bison: %prec 'terminal grammar symbol'
  flushWS (ruleDIRECTIVE);
  ruleDIRECTIVE.lex ().put (text ());

  const std::string& lexeme (text ());
  yylval.emplace<name_literal> (stringLookup (lexeme, true));
  return (parser::token::GS_ID);
}
	YY_BREAK
case 273:
YY_RULE_SETUP
#line 2499 "flex/agc-Yfile-lexer.ll"
{
  // Bison: %merge < 'function name' >
  flushWS (ruleDIRECTIVE);
  ruleDIRECTIVE.lex ().put ((char)chr ());
  return (parser::token::LESSTHAN);
}
	YY_BREAK
case 274:
YY_RULE_SETUP
#line 2506 "flex/agc-Yfile-lexer.ll"
{
  // Bison: %merge < ... >
  flushWS (ruleDIRECTIVE);
  ruleDIRECTIVE.lex ().put ((char)chr ());
  return (parser::token::GTRTHAN);
}
	YY_BREAK
case 275:
YY_RULE_SETUP
#line 2513 "flex/agc-Yfile-lexer.ll"
{
  bufferWS ();
}
	YY_BREAK
case 276:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 2517 "flex/agc-Yfile-lexer.ll"
{
  flushWS (ruleDIRECTIVE);
  ruleDIRECTIVE.lex ().put (text ());
}
	YY_BREAK
case 277:
/* rule 277 can match eol */
YY_RULE_SETUP
#line 2522 "flex/agc-Yfile-lexer.ll"
{
  flushWS (ruleDIRECTIVE);
  ruleDIRECTIVE.lex ().put ((char)chr ());
}
	YY_BREAK


case 278:
YY_RULE_SETUP
#line 2533 "flex/agc-Yfile-lexer.ll"
{
  flushWS (ruleDIRECTIVE);
  actionCLOSER.append (ruleDIRECTIVE);
  ruleDIRECTIVE.clear ();
  yyless (0);
  pop_state ();
}
	YY_BREAK


case 279:
YY_RULE_SETUP
#line 2547 "flex/agc-Yfile-lexer.ll"
{
  flushWS (ruleDIRECTIVE);
  yoxOutG.append (ruleDIRECTIVE);
  ruleDIRECTIVE.clear ();
  yyless (0);
  pop_state ();
}
	YY_BREAK


/* YACC_RULES 'subroutine': copy a Yacc {}-action until the opening brace is
     paired, ignoring braces in comments, strings and character constants */
case 280:
YY_RULE_SETUP
#line 2564 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.lex ().put ((char)chr ());
  nLbraces++;
  return (parser::token::LBRACE);
}
	YY_BREAK
case 281:
YY_RULE_SETUP
#line 2570 "flex/agc-Yfile-lexer.ll"
{
  yyless (size () - 1); // rescan '}'
  actionCLOSER.lex ().put (text ()); // accumulate the whitespace
}
	YY_BREAK
case 282:
/* rule 282 can match eol */
YY_RULE_SETUP
#line 2575 "flex/agc-Yfile-lexer.ll"
{
  yylloc.end = yylloc.begin + 1;
  actionCLOSER.lex ().put (text ());
  if (--nLbraces == 0)
    pop_state ();
  else
    notLastSemAction ();
  return (parser::token::RBRACE);
}
	YY_BREAK
case YY_STATE_EOF(YACC_ACT):
#line 2585 "flex/agc-Yfile-lexer.ll"
{
  unterminatedAction (yylloc, startPos.top ());
}
	YY_BREAK


/* YACC_RULES 'subroutine': copy a BtYacc []-action until the opening bracket
     is paired, ignoring brackets in comments, strings & character constants */
case 283:
YY_RULE_SETUP
#line 2598 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.lex ().put ((char)chr ());
  nLbrackets++;
  return (parser::token::LBRACKET);
}
	YY_BREAK
case 284:
YY_RULE_SETUP
#line 2604 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.lex ().put ((char)chr ());
  if (--nLbrackets == 0)
    pop_state ();
  return (parser::token::RBRACKET);
}
	YY_BREAK
case 285:
YY_RULE_SETUP
#line 2611 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::LBRACE);
}
	YY_BREAK
case 286:
YY_RULE_SETUP
#line 2616 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.lex ().put ((char)chr ());
  return (parser::token::RBRACE);
}
	YY_BREAK
case YY_STATE_EOF(BTYACC_ACT):
#line 2621 "flex/agc-Yfile-lexer.ll"
{
  unterminatedAction (yylloc, startPos.top ());
}
	YY_BREAK


case 287:
YY_RULE_SETUP
#line 2631 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.lex ().put (text ());
  yox_push_state (COMMENT, yoxOutG);
}
	YY_BREAK
case 288:
YY_RULE_SETUP
#line 2636 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.lex ().put (text ());
  yox_push_state (STRING, yoxOutG);
}
	YY_BREAK
case 289:
YY_RULE_SETUP
#line 2641 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.lex ().put (text ());
  if (!unionDefined ())
    notSupported (yylloc, "Yacc pseudo variable with no `%union'");
}
	YY_BREAK
case 290:
YY_RULE_SETUP
#line 2647 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.put (text ());
}
	YY_BREAK
case 291:
/* rule 291 can match eol */
YY_RULE_SETUP
#line 2651 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.put ((char)chr ());
}
	YY_BREAK


/* YATTR_REF, ATTR_DEPS 'subroutine': expand a macro */
case 292:
YY_RULE_SETUP
#line 2663 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  yox_push_state (COMMENT, rsBuffer);
}
	YY_BREAK
case 293:
YY_RULE_SETUP
#line 2668 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
  yox_push_state (STRING, rsBuffer);
}
	YY_BREAK
case 294:
YY_RULE_SETUP
#line 2673 "flex/agc-Yfile-lexer.ll"
{
  if (++nLparensM == 1)
    {
      // start of a new argument
      macroARG = macroArg (yylloc.end); // -> parser output
      push_state (yylloc, MACRO_ARG);
    }
  else
    unbalancedParensInMacro (yylloc);
}
	YY_BREAK
case 295:
YY_RULE_SETUP
#line 2684 "flex/agc-Yfile-lexer.ll"
{
  if (nLparensM == 0)
    {
      macroARG.terminate ();

      std::string macroBody;
      position body_origin;
      setupMacroExpansion (yylloc, macroBody, body_origin);

      // setup new input buffer for macro body
      YY_BUFFER_STATE newbuf =
          yy_create_buffer (new std::istringstream (macroBody), YY_BUF_SIZE);
      pushbuffer (newbuf, body_origin); // make it current
      pop_state ();
    }
  else
    unbalancedParensInMacro (yylloc);
}
	YY_BREAK
case 296:
YY_RULE_SETUP
#line 2703 "flex/agc-Yfile-lexer.ll"
{
  macroARG.terminate ();
  // start of a new argument
  macroARG = macroArg (yylloc.end); // -> parser output
  push_state (yylloc, MACRO_ARG);
}
	YY_BREAK
case 297:
YY_RULE_SETUP
#line 2710 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.lex ().put (text ());
}
	YY_BREAK
case 298:
/* rule 298 can match eol */
YY_RULE_SETUP
#line 2714 "flex/agc-Yfile-lexer.ll"
{
  rsBuffer.put ((char)chr ());
}
	YY_BREAK


/* EXPAND_MACRO 'subroutine': process a macro argument */
case 299:
YY_RULE_SETUP
#line 2726 "flex/agc-Yfile-lexer.ll"
{
  macroARG.put (text ());
  yox_push_state (COMMENT, macroARG);
}
	YY_BREAK
case 300:
YY_RULE_SETUP
#line 2731 "flex/agc-Yfile-lexer.ll"
{
  macroARG.put (text ());
  yox_push_state (STRING, macroARG);
}
	YY_BREAK
case 301:
YY_RULE_SETUP
#line 2736 "flex/agc-Yfile-lexer.ll"
{
  if (++nLparensM > 1)
    {
      // nested expression in the argument
      macroARG.put ((char)chr ());
    }
  else
    unbalancedParensInMacro (yylloc);
}
	YY_BREAK
case 302:
YY_RULE_SETUP
#line 2746 "flex/agc-Yfile-lexer.ll"
{
  if (--nLparensM > 0)
    macroARG.put ((char)chr ());
  else if (nLparensM == 0)
    {
      yyless (0);
      pop_state ();
    }
  else
    unbalancedParensInMacro (yylloc);
}
	YY_BREAK
case 303:
YY_RULE_SETUP
#line 2758 "flex/agc-Yfile-lexer.ll"
{
  if (nLparensM > 1)
    macroARG.put ((char)chr ());
  else if (nLparensM == 1)
    {
      yyless (0);
      pop_state ();
    }
  else
    unbalancedParensInMacro (yylloc);
}
	YY_BREAK
case 304:
YY_RULE_SETUP
#line 2770 "flex/agc-Yfile-lexer.ll"
{
  macroARG.put ('\\');
}
	YY_BREAK
case 305:
YY_RULE_SETUP
#line 2774 "flex/agc-Yfile-lexer.ll"
{
  macroARG.put (',');
}
	YY_BREAK
case 306:
YY_RULE_SETUP
#line 2778 "flex/agc-Yfile-lexer.ll"
{
  macroARG.put ('(');
}
	YY_BREAK
case 307:
YY_RULE_SETUP
#line 2782 "flex/agc-Yfile-lexer.ll"
{
  macroARG.put (')');
}
	YY_BREAK
case 308:
YY_RULE_SETUP
#line 2786 "flex/agc-Yfile-lexer.ll"
{
  escapeCharMisuse (yylloc);
}
	YY_BREAK
case 309:
YY_RULE_SETUP
#line 2790 "flex/agc-Yfile-lexer.ll"
{
  macroARG.put (text ());
}
	YY_BREAK
case 310:
/* rule 310 can match eol */
YY_RULE_SETUP
#line 2794 "flex/agc-Yfile-lexer.ll"
{
  macroARG.put ((char)chr ());
}
	YY_BREAK


/* start of the optional user section following the second "%%" in the Y-file,
     if present */
case 311:
/* rule 311 can match eol */
YY_RULE_SETUP
#line 2807 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.lex ().put ((char)chr ());
  start (YACC_TRAILER);
}
	YY_BREAK


/* echo the optional user section */
case 312:
YY_RULE_SETUP
#line 2820 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.put (text ());
  yox_push_state (COMMENT, yoxOutG);
}
	YY_BREAK
case 313:
YY_RULE_SETUP
#line 2825 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.put (text ());
  yox_push_state (STRING, yoxOutG);
}
	YY_BREAK
case 314:
YY_RULE_SETUP
#line 2830 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.put (text ());
}
	YY_BREAK
case 315:
/* rule 315 can match eol */
YY_RULE_SETUP
#line 2834 "flex/agc-Yfile-lexer.ll"
{
  yoxOutG.put ((char)chr ());
}
	YY_BREAK


/* 'subroutine': handle multi-line C comments */
case 316:
YY_RULE_SETUP
#line 2846 "flex/agc-Yfile-lexer.ll"
{
  whereTo->put (text ());
  pop_state ();
}
	YY_BREAK
case 317:
YY_RULE_SETUP
#line 2851 "flex/agc-Yfile-lexer.ll"
{
  whereTo->put (text ());
}
	YY_BREAK
case 318:
/* rule 318 can match eol */
YY_RULE_SETUP
#line 2855 "flex/agc-Yfile-lexer.ll"
{
  whereTo->put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(COMMENT):
#line 2859 "flex/agc-Yfile-lexer.ll"
{
  unterminatedComment (yylloc, startPos.top ());
}
	YY_BREAK


/* 'subroutine': skip multi-line C comments */
case 319:
YY_RULE_SETUP
#line 2871 "flex/agc-Yfile-lexer.ll"
{
  pop_state ();
}
	YY_BREAK
case 320:
/* rule 320 can match eol */
YY_RULE_SETUP
#line 2875 "flex/agc-Yfile-lexer.ll"
{
  ; // no-op
}
	YY_BREAK
case YY_STATE_EOF(SKIP_COMMENT):
#line 2879 "flex/agc-Yfile-lexer.ll"
{
  unterminatedComment (yylloc, startPos.top ());
}
	YY_BREAK


/* 'subroutine': handle multi-line C/C++ string literals */
case 321:
YY_RULE_SETUP
#line 2891 "flex/agc-Yfile-lexer.ll"
{
  whereTo->put ((char)chr ());
  if (stringHasBareNewline)
    stringContainsNewline (yylloc, startPos.top ());
  pop_state ();
}
	YY_BREAK
case 322:
/* rule 322 can match eol */
YY_RULE_SETUP
#line 2898 "flex/agc-Yfile-lexer.ll"
{
  whereTo->put (text ());
}
	YY_BREAK
case 323:
/* rule 323 can match eol */
YY_RULE_SETUP
#line 2902 "flex/agc-Yfile-lexer.ll"
{
  stringHasBareNewline = true;
  whereTo->put ((char)chr ());
}
	YY_BREAK
case 324:
YY_RULE_SETUP
#line 2907 "flex/agc-Yfile-lexer.ll"
{
  whereTo->put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(STRING):
#line 2911 "flex/agc-Yfile-lexer.ll"
{
  unterminatedString (yylloc, startPos.top ());
}
	YY_BREAK


/* 'subroutine': handle C/C++ directives */
case 325:
/* rule 325 can match eol */
YY_RULE_SETUP
#line 2923 "flex/agc-Yfile-lexer.ll"
{
  // C/C++ directive spans multiple source lines
  whereTo->put (text ());
}
	YY_BREAK
case 326:
/* rule 326 can match eol */
YY_RULE_SETUP
#line 2928 "flex/agc-Yfile-lexer.ll"
{
  whereTo->put ((char)chr ());
  pop_state ();
}
	YY_BREAK
case 327:
YY_RULE_SETUP
#line 2933 "flex/agc-Yfile-lexer.ll"
{
  whereTo->put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(CPP_DIRECTIVE):
#line 2937 "flex/agc-Yfile-lexer.ll"
{
  unterminatedCPPdirective (yylloc, startPos.top ());
}
	YY_BREAK

case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(START_SYM):
case YY_STATE_EOF(YACC_UNION_HD):
case YY_STATE_EOF(INT_ARG):
case YY_STATE_EOF(STRING_ARG):
case YY_STATE_EOF(BISONDEF):
case YY_STATE_EOF(TYPESPEC):
case YY_STATE_EOF(USER_ARGS):
case YY_STATE_EOF(YACC_RULES):
case YY_STATE_EOF(INHERIT_ATTR):
case YY_STATE_EOF(YACC_USER):
case YY_STATE_EOF(YACC_TRAILER):
case YY_STATE_EOF(ACTIONCLOSER_DIRECTIVE):
case YY_STATE_EOF(YOXOUTG_DIRECTIVE):
case YY_STATE_EOF(MACRO_HEAD):
case YY_STATE_EOF(MACRO_BODY):
case YY_STATE_EOF(OXVOID):
case YY_STATE_EOF(ATTR_DECL_SYMS):
case YY_STATE_EOF(TRAV_DECL):
case YY_STATE_EOF(EXPAND_MACRO):
case YY_STATE_EOF(MACRO_ARG):
#line 2945 "flex/agc-Yfile-lexer.ll"
{
  return parser::token::END;
}
	YY_BREAK
case 328:
YY_RULE_SETUP
#line 2949 "flex/agc-Yfile-lexer.ll"
ECHO;
	YY_BREAK
#line 7568 "flex/agc-Yfile-lexer.cc"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
/* %if-c-only */
/* %endif */
/* %if-c++-only */
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin.rdbuf();
/* %endif */
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
/* %% [14.0] code to do back-up for compressed tables and set up yy_cp goes here */
				yy_cp = (yy_last_accepting_cpos);
				yy_current_state = (yy_last_accepting_state);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap(  ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of yylex */
/* %ok-for-header */

/* %if-c++-only */
/* %not-for-header */
/* The contents of this function are C++ specific, so the () macro is not used.
 * This constructor simply maintains backward compatibility.
 * DEPRECATED
 */
yyFlexLexer::yyFlexLexer( std::istream* arg_yyin, std::ostream* arg_yyout ):
	yyin(arg_yyin ? arg_yyin->rdbuf() : std::cin.rdbuf()),
	yyout(arg_yyout ? arg_yyout->rdbuf() : std::cout.rdbuf())
{
	ctor_common();
}

/* The contents of this function are C++ specific, so the () macro is not used.
 */
yyFlexLexer::yyFlexLexer( std::istream& arg_yyin, std::ostream& arg_yyout ):
	yyin(arg_yyin.rdbuf()),
	yyout(arg_yyout.rdbuf())
{
	ctor_common();
}

/* The contents of this function are C++ specific, so the () macro is not used.
 */
void yyFlexLexer::ctor_common()
{
	yy_c_buf_p = 0;
	yy_init = 0;
	yy_start = 0;
	yy_flex_debug = 0;
	yylineno = 1;	// this will only get updated if %option yylineno

	yy_did_buffer_switch_on_eof = 0;

	yy_looking_for_trail_begin = 0;
	yy_more_flag = 0;
	yy_more_len = 0;
	yy_more_offset = yy_prev_more_offset = 0;

	yy_start_stack_ptr = yy_start_stack_depth = 0;
	yy_start_stack = NULL;

	yy_buffer_stack = NULL;
	yy_buffer_stack_top = 0;
	yy_buffer_stack_max = 0;

	yy_state_buf = 0;

}

/* The contents of this function are C++ specific, so the () macro is not used.
 */
yyFlexLexer::~yyFlexLexer()
{
	delete [] yy_state_buf;
	yyfree( yy_start_stack  );
	yy_delete_buffer( YY_CURRENT_BUFFER );
	yyfree( yy_buffer_stack  );
}

/* The contents of this function are C++ specific, so the () macro is not used.
 */
void yyFlexLexer::switch_streams( std::istream& new_in, std::ostream& new_out )
{
	// was if( new_in )
	yy_delete_buffer( YY_CURRENT_BUFFER );
	yy_switch_to_buffer( yy_create_buffer( new_in, YY_BUF_SIZE  ) );

	// was if( new_out )
	yyout.rdbuf(new_out.rdbuf());
}

/* The contents of this function are C++ specific, so the () macro is not used.
 */
void yyFlexLexer::switch_streams( std::istream* new_in, std::ostream* new_out )
{
	if( ! new_in ) {
		new_in = &yyin;
	}

	if ( ! new_out ) {
		new_out = &yyout;
	}

	switch_streams(*new_in, *new_out);
}

#ifdef YY_INTERACTIVE
int yyFlexLexer::LexerInput( char* buf, int /* max_size */ )
#else
int yyFlexLexer::LexerInput( char* buf, int max_size )
#endif
{
	if ( yyin.eof() || yyin.fail() )
		return 0;

#ifdef YY_INTERACTIVE
	yyin.get( buf[0] );

	if ( yyin.eof() )
		return 0;

	if ( yyin.bad() )
		return -1;

	return 1;

#else
	(void) yyin.read( buf, max_size );

	if ( yyin.bad() )
		return -1;
	else
		return yyin.gcount();
#endif
}

void yyFlexLexer::LexerOutput( const char* buf, int size )
{
	(void) yyout.write( buf, size );
}
/* %ok-for-header */

/* %endif */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
int yyFlexLexer::yy_get_next_buffer()
/* %endif */
{
    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = (yytext_ptr);
	int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr) - 1);

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc( (void *) b->yy_ch_buf,
							 (yy_size_t) (b->yy_buf_size + 2)  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = NULL;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc(
			(void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf, (yy_size_t) new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
		/* "- 2" to take care of EOB's */
		YY_CURRENT_BUFFER_LVALUE->yy_buf_size = (int) (new_size - 2);
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

/* %if-c-only */
/* %not-for-header */
/* %endif */
/* %if-c++-only */
    yy_state_type yyFlexLexer::yy_get_previous_state()
/* %endif */
{
	yy_state_type yy_current_state;
	char *yy_cp;
    
/* %% [15.0] code to get the start state into yy_current_state goes here */
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
/* %% [16.0] code to find the next state goes here */
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 1258 )
				yy_c = yy_meta[yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    yy_state_type yyFlexLexer::yy_try_NUL_trans( yy_state_type yy_current_state )
/* %endif */
{
	int yy_is_jam;
    /* %% [17.0] code to find the next state, and perhaps do backing up, goes here */
	char *yy_cp = (yy_c_buf_p);

	YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 1258 )
			yy_c = yy_meta[yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	yy_is_jam = (yy_current_state == 1257);

		return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yyunput( int c, char* yy_bp)
/* %endif */
{
	char *yy_cp;
    
    yy_cp = (yy_c_buf_p);

	/* undo effects of setting up yytext */
	*yy_cp = (yy_hold_char);

	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		int number_to_move = (yy_n_chars) + 2;
		char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
		char *source =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
			(yy_n_chars) = (int) YY_CURRENT_BUFFER_LVALUE->yy_buf_size;

		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

/* %% [18.0] update yylineno here */

	(yytext_ptr) = yy_bp;
	(yy_hold_char) = *yy_cp;
	(yy_c_buf_p) = yy_cp;
}
/* %if-c-only */
/* %endif */
#endif

/* %if-c-only */
/* %endif */
/* %if-c++-only */
    int yyFlexLexer::yyinput()
/* %endif */
{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (int) ((yy_c_buf_p) - (yytext_ptr));
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap(  ) )
						return 0;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

/* %% [19.0] update BOL and yylineno */
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');

	return c;
}
/* %if-c-only */
/* %endif */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yyrestart( std::istream& input_file )
/* %endif */
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer( yyin, YY_BUF_SIZE );
	}

	yy_init_buffer( YY_CURRENT_BUFFER, input_file );
	yy_load_buffer_state(  );
}

/* %if-c++-only */
/** Delegate to the new version that takes an istream reference.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
void yyFlexLexer::yyrestart( std::istream* input_file )
{
	if( ! input_file ) {
		input_file = &yyin;
	}
	yyrestart( *input_file );
}
/* %endif */

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
/* %endif */
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state(  );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_load_buffer_state()
/* %endif */
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
/* %if-c-only */
/* %endif */
/* %if-c++-only */
	yyin.rdbuf(YY_CURRENT_BUFFER_LVALUE->yy_input_file);
/* %endif */
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    YY_BUFFER_STATE yyFlexLexer::yy_create_buffer( std::istream& file, int size )
/* %endif */
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc( (yy_size_t) (b->yy_buf_size + 2)  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
}

/* %if-c++-only */
/** Delegate creation of buffers to the new version that takes an istream reference.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
	YY_BUFFER_STATE yyFlexLexer::yy_create_buffer( std::istream* file, int size )
{
	return yy_create_buffer( *file, size );
}
/* %endif */

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_delete_buffer( YY_BUFFER_STATE b )
/* %endif */
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree( (void *) b->yy_ch_buf  );

	yyfree( (void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_init_buffer( YY_BUFFER_STATE b, std::istream& file )
/* %endif */

{
	int oerrno = errno;
    
	yy_flush_buffer( b );

/* %if-c-only */
/* %endif */
/* %if-c++-only */
	b->yy_input_file = file.rdbuf();
/* %endif */
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

/* %if-c-only */
/* %endif */
/* %if-c++-only */
	b->yy_is_interactive = 0;
/* %endif */
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_flush_buffer( YY_BUFFER_STATE b )
/* %endif */
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state(  );
}

/* %if-c-or-c++ */
/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
void yyFlexLexer::yypush_buffer_state (YY_BUFFER_STATE new_buffer)
/* %endif */
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state(  );
	(yy_did_buffer_switch_on_eof) = 1;
}
/* %endif */

/* %if-c-or-c++ */
/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
void yyFlexLexer::yypop_buffer_state (void)
/* %endif */
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state(  );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}
/* %endif */

/* %if-c-or-c++ */
/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
void yyFlexLexer::yyensure_buffer_stack(void)
/* %endif */
{
	yy_size_t num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));

		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}
/* %endif */

/* %if-c-only */
/* %endif */

/* %if-c-only */
/* %endif */

/* %if-c-only */
/* %endif */

/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_push_state( int _new_state )
/* %endif */
{
    	if ( (yy_start_stack_ptr) >= (yy_start_stack_depth) )
		{
		yy_size_t new_size;

		(yy_start_stack_depth) += YY_START_STACK_INCR;
		new_size = (yy_size_t) (yy_start_stack_depth) * sizeof( int );

		if ( ! (yy_start_stack) )
			(yy_start_stack) = (int *) yyalloc( new_size  );

		else
			(yy_start_stack) = (int *) yyrealloc(
					(void *) (yy_start_stack), new_size  );

		if ( ! (yy_start_stack) )
			YY_FATAL_ERROR( "out of memory expanding start-condition stack" );
		}

	(yy_start_stack)[(yy_start_stack_ptr)++] = YY_START;

	BEGIN(_new_state);
}

/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_pop_state()
/* %endif */
{
    	if ( --(yy_start_stack_ptr) < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN((yy_start_stack)[(yy_start_stack_ptr)]);
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

/* %if-c-only */
/* %endif */
/* %if-c++-only */
void yyFlexLexer::LexerError( const char* msg )
{
    	std::cerr << msg << std::endl;
	exit( YY_EXIT_FAILURE );
}
/* %endif */

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/* %if-c-only */
/* %if-reentrant */
/* %endif */
/* %if-reentrant */
/* %endif */
/* %endif */

/* %if-reentrant */
/* %if-bison-bridge */
/* %endif */
/* %endif if-c-only */

/* %if-c-only */
/* %endif */

/* %if-c-only SNIP! this currently causes conflicts with the c++ scanner */
/* %if-reentrant */
/* %endif */
/* %endif */

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, const char * s2, int n )
{
		
	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (const char * s )
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
			return malloc(size);
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
		
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return realloc(ptr, size);
}

void yyfree (void * ptr )
{
			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

/* %if-tables-serialization definitions */
/* %define-yytables   The name for this specific scanner's tables. */
#define YYTABLES_NAME "yytables"
/* %endif */

/* %ok-for-header */

#line 2949 "flex/agc-Yfile-lexer.ll"


// Y-file lexer constructor
AGC::YFILE::Lexer::Lexer (Yfile_specIO& fR, std::ifstream& yoxInG)
    : theFiles (fR),
      EOLstate (EOLctx (position (&fR.inName, 0, 0))),
      ctrl (outMgr::ctrl)
{
  yycolumn = 1;

  nLbraces = 0;
  nLTbraces = 0;
  nLbrackets = 0;
  nLparens = 0;
  nLparensM = 0;
  nATLbraces = 0;

  yyrestart (yoxInG);

  start (YACC_DEFS);
}

namespace AGC
{
namespace YFILE
{
#if defined(_WIN32)
#include "YY_INPUT.hh"
#endif

void
Lexer::yox_push_state (int lexState, outMgr& whTo)
{
  whereTo = &whTo;
  if (lexState == STRING)
    stringHasBareNewline = false;
  push_state (*whereTo->getCurPos (), lexState);
}

}
}

